program DBImpV3; {$APPTYPE CONSOLE}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
// DBIMPv3

// Author: f.schneider/f.benites/N.Gering/S.Voelke

// Die Schalter sollen auch noch in den Viewer eingebracht werden

// Datumsformat zum Importieren von Dateien  tt.mm.jjjj ohne Uhrzeit     incl Eintrag

// Erzeugt neue Dokumente in der Datenbank und kann diese auf Wiedervorlage legen
// indem eine Jobdatei ausgelesen wird

// Begin der Jobdatei ab der nchsten Zeile
// [Version]
// Version=3.0
// [Archiv]
// Profil=bitfarm
// ame=Lieferantenrechnungen
// Tabelle=27062005090546
// [Document]
// DOCID=
// Titel=Ingram_Rechnung
// Orginal=t:\dokuarch\Lieferantenrechnungen27062005090546\102006\610241527303584.tif
// Kopie=
// Benutzer=n.gering
// Volltext=t:\dokuarch\Lieferantenrechnungen27062005090546\102006\610241527303584.txt
// Status=0
// StatStr=Dokument indiziert und archiviert.
// OCR_QF=-1
// OCR_Typ=OMP
// Schlagworte=S:\bitfarm-archiv\garbage\temp27.swd
// Datum=2006-10-24 15:21:17
// Quelle=t:\dokuarch\Lieferantenrechnungen27062005090546\102006\610241527303584.pdf
// Filter=
// [Referenz]
// Anzahl=0
// [Zusatzfelder]
// Felder=5
// ZusTitel1=Rechnungsnummer
// ZusFeld1=add_17082005094816
// ZusWert1=andindocument=netto
// ZusTitel2=Auftragsnummer
// ZusFeld2=add_17082005094833
// ZusWert2=
// ZusTitel3=Bearbeiter
// ZusFeld3=add_17082005094902
// ZusWert3=
// ZusTitel4=Sachkonto
// ZusFeld4=add_17082005094909
// ZusWert4=
// ZusTitel5=Buchungsdatum
// ZusFeld5=add_17082005094914
// ZusWert5=
// ZusTitel6=Kd-Auftragsnummer
// ZusFeld6=add_07072005101430
// ZusWert6=
// [Tasks]
// Termin=24.10.2006
// Alarm=31.10.2006
// Bearbeiter=n.gering
// Notiz=TestNotiz

//  Remark zum obigen Job:
//  es wird ein neues Dokument in der Datenbank angelegt
//  mit Einer Wiedervorlage
//////////////////////////////////////////////////////////////////////////////////////////////////////
//  Modifikationen am Programm

uses
  u_dm_Main in 'u_dm_Main.pas' {dm_DBImp: TDataModule},
  DB,
  SysUtils,
  Windows,
  IniFiles,
  ievect,
  Classes,
  ActiveX,
  XMLIntf, XMLDoc,
  bfaCommonFiles,
  bfaBaseSocketConnection,
  bfaBaseObjects,
  bitfarm_enterprise,
  StrUtils,
  RegularExpressions,
  bfaBaseImageEN in '..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaBaseImageEN.pas',
  bfaCommonMethods in '..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaCommonMethods.pas',
  bfaCommonUtils in '..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaCommonUtils.pas',
  bfaParser in '..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaParser.pas';

{$R *.res}

var
  con, job: TIniFile;
  sVtxFile, sSlwFile, tglistsec: TStrings;
  iFieldCount, iField, iSvnID, iGblDocID, iArcID, iUsrIDWork, iUsrIDShed, iRefCount: integer;
  sUser, sPass, sGArcName, sGTblName, sDocID, sArcID, sDocTitel, sDocOrg, sDocKopie, sDocKopieENV, sDocUsr, sDocVTX, sDocState, sDocStateText, sDocStateText2, sDocOCR, sDocSLW, sDocDate, sDocQuelle, sSQLCMD, sProfil, fProfile, sTermin, sAlarm, sWorker, sNotiz, sIWvlID, sgVersion, sSha1, sDefDocname, sSAPDocid, sContRep, sCompDateC, sDocProt, sJobFile, sFiletype: string;
  sSvnLink, sSvnVersion, sSvnRevision, sSvnDatum, sSvnInfo, lcid, sMsg1, sMsg2, sMsg3, sMsg4, sMsg5, sMsg6, sMsg8: string;
  archive_rs, archive_nrs: Widestring;
  gigdocid, ioldStatus, iNewStatus, iDocID: int64;
  aZusFeld, aZusWert, aDocRef: array of string;
  iwvlid, giTimerOptionen, gTaskid, iDocUser, iPages : integer;
   //  Otionen Steuerfeld fur eine WVL, AFEM und EFAM = 1 oder 0

  bNewStatusIsAbsolute, bStatus36, bUpdatesql: Boolean;
  AFEM,              // 'Alle fuer einen Modus' in der Wiedervorlage fuer eine Gruppe
bIsWorkflow, boldStatus: boolean;
  formatSettings: TFormatSettings;
  img: TImageEnVect;
  MainSocket: TBaseSocketConnection;
  aOldStatus, aNewStatus: array of Int64;
////////////////////////////////////////////////////////////////////////////////////////

function RightStr(const Str: string; Size: Word): string;
begin
  if Size > Length(Str) then
    Size := Length(Str);
  RightStr := Copy(Str, Length(Str) - Size + 1, Size)
end;

function MidStr(const Str: string; From, Size: Word): string;
begin
  MidStr := Copy(Str, From, Size)
end;

function LeftStr(const Str: string; Size: Word): string;
begin
  LeftStr := Copy(Str, 1, Size)
end;

//Function WriteCmd(text: WideString): WideString;
//var
//  NumWritten: Cardinal;
//begin
////   text := text + #13#10;
////   WriteConsoleW(GetStdHandle(STD_OUTPUT_HANDLE), PChar(text), Length(text), NumWritten, nil);
////   WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), PChar(text), Length(text), NumWritten, nil);
//   SetConsoleOutputCP(CP_OEMCP);
////   Writeln(text);
//   WriteLn(UTF8String(text));
////   WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), PChar(Text+ #13#10), Length(Text+ #13#10), NumWritten, nil);
//End;

// from http://www.delphipraxis.net/topic27196_splitfunktion.html

function Split(const fText: string; const fSep: char; fTrim: boolean = False; fQuotes: boolean = False): TStringList;
var
  vI: integer;
  vBuffer: string;
  vOn: boolean;
begin
  Result := TStringList.Create;
  vBuffer := '';
  vOn := True;
  for vI := 1 to Length(fText) do
  begin
    if (fQuotes and (fText[vI] = fSep) and vOn) or (not (fQuotes) and (fText[vI] = fSep)) then
    begin
      if fTrim then
        vBuffer := Trim(vBuffer);
      if vBuffer = '' then
        vBuffer := fSep; // !!! sonst luft z.B. split(',**',',') auf einen Hammer...
      if vBuffer[1] = fSep then
        vBuffer := Copy(vBuffer, 2, Length(vBuffer));
      Result.Add(vBuffer);
      vBuffer := '';
    end;
    if fQuotes then
    begin
      if fText[vI] = '"' then
      begin
        vOn := not (vOn);
        Continue;
      end;
      if (fText[vI] <> fSep) or ((fText[vI] = fSep) and (vOn = False)) then
        vBuffer := vBuffer + fText[vI];
    end
    else if fText[vI] <> fSep then
      vBuffer := vBuffer + fText[vI];
  end;
  if vBuffer <> '' then
  begin
    if fTrim then
      vBuffer := Trim(vBuffer);
    Result.Add(vBuffer);
  end;
end;

function ParserMySQLString(InputStr: string): string;
begin
   // 3.5.0.5  fr Zusatzfeldwerte kann Semikolon bergeben werden, der Rest wird geparst
   // von ParserSemiColonusebackspace bernommen
   //be sure of no \'
  Result := StringReplace(InputStr, '\' + #39 + '', '' + #39 + '', [rfReplaceAll]);
   // change ' to \' for mysql
  Result := StringReplace(Result, '' + #39 + '', '\' + #39, [rfReplaceAll]);
end;

procedure Get_OldStatus;
// wir holen uns den in Bearbeitung-Status bei schon vorhandenen Dokumenten
var
  iCount, i, idx: integer;
  sIArcID, sIDocID, soldStatus: string;
begin
  iCount := Pos('.', sDocID);
  sIArcID := copy(sDocID, 1, iCount - 1);
  sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
  if sIArcID <> '' then
    iArcID := StrToInt(sIArcID);
  if sIDocID <> '' then
    iDocID := StrToInt64(sIDocID);
  boldStatus := False;
  try
    with dm_DBImp.my_q_Tmp do
    begin
      SQL.Text := 'show columns from sys_doc where Field like ' + #39 + 'docstate_%' + #39;
      Execute;
      idx := RecordCount;
      SetLength(aOldStatus, idx);
      SetLength(aNewStatus, idx);

      if sIDocID <> '' then
      begin
        SQL.Text := 'Select * from sys_doc where gdocid = ' + sIDocID;
        Execute;
        if RecordCount > 0 then
        begin
          ioldStatus := FieldByName('docstate_0').AsLargeInt;

         //uns interessiert nur der In Bearbeitung-Status, da andere Stati durchaus
         //whrend eines UpdateSQL gesetzt werden knnen (unabhngig zur Wiedervorlage)
          boldStatus := ioldStatus and 1 = 1;
          for i := 0 to idx - 1 do
          begin
            soldStatus := FieldByName('docstate_' + IntToStr(i)).AsString;
            if not TryStrToInt64(soldStatus, aOldStatus[i]) then
            begin
              WriteCMD(Format('Fehler: Status %s ist kein gltiger Integer. Wird bersprungen... ',[soldStatus]));
              Continue;
            end;
//            aOldStatus[i] := strtoint(soldStatus);
          end;
        end;
      end;
    end;
  except
    on e: exception do
    begin
      WriteCmd('Fehler bei Get_OldStatus: ' + e.Message);
    end;
  end;
end;

procedure SetDocState(state: string; arcid: Integer);
var
  lstDocState: TStringList;
  i, j, posmask: Integer;
  indexcolumnid, op, idx, bitmask: string;
begin
  lstDocState := TStringList.Create;
  lstDocState.Delimiter := ';';
  lstDocState.DelimitedText := state;
  try
    for i := 0 to lstDocState.Count - 1 do
    begin
      bStatus36 := False;
      state := lstDocState[i];
      idx := '0';
      if Pos(':', sDocstate) > 0 then
      begin
        idx := LeftStr(state, Pos(':', state) - 1);
        state := RightStr(state, Length(state) - Pos(':', state));
        bStatus36 := True;
      end;

      if state <> '' then
      begin
        if Pos('+', state) = 1 then
        begin
          state := Copy(state, 2, Length(state));
          op := '|';
        end
        else if Pos('-', state) = 1 then
        begin
          state := Copy(state, 2, Length(state));
          op := '& ~';
        end
        else if Pos('#', state) = 1 then
        begin // Bits ersetzen:
          state := Copy(state, 2, Length(state));
          op := '=';
          bNewStatusIsAbsolute := True;
        end
        else
        begin
          if aNewStatus[StrToInt(idx)] = 0 then    // der erste Wert fr diese StatusColumn wird direkt gesetzt (berschreibt ggf vorhandene Stati)
            op := '='
          else                                    // sollten wir schon einen Wert in dieser Status Column gesetzt haben
            op := '|';                            // so werden die folgenden Werte verodert
          bNewStatusIsAbsolute := True;
        end;

        if not TryStrToInt64(state, iNewStatus) then
        begin
          WriteCMD(Format('Fehler: Status %s ist kein gltiger Integer. Wird bersprungen... ',[state]));
          Continue;
        end;

        if bStatus36 or ((idx = '0') and (state = '1')) then   // Status 1 machen wir hier, weil es dafr keine zugeordnetes Stausfeld gibt,
        begin                                                  // welches im else Zweig gefunden wrden knnte
          if op = '=' then
            sSQLCMD := 'update sys_doc set docstate_' + idx + ' = ' + state + ' where gdocid = ' + IntToStr(iDocID)
          else
            sSQLCMD := 'update sys_doc set docstate_' + idx + ' = (docstate_' + idx + op + ' ' + state + ')' + ' where gdocid = ' + IntToStr(iDocID);
          WriteCMD('Setzte Status (v36) idx:' + idx + ' state:' + state);
          dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
          try
            dm_DBImp.my_Cmd.Execute;
          except
            on e: exception do
            begin
              WriteCMD('Fehler: Beim Schreiben des Status des Dokuments ' + e.Message);
            end;
          end;

          aNewStatus[StrToInt(idx)] := aNewStatus[StrToInt(idx)] or StrToInt64(state);
        end
        else
        begin
          dm_DBImp.my_q_Tmp.SQL.Text := 'select * from sys_statefieldxs as xs left join sys_statefields as s on xs.fieldid = s.stateid where arcid = ' + IntToStr(arcid) + ' group by fieldid, pos, xsid order by pos';
          dm_DBImp.my_q_Tmp.Execute;
          if dm_DBImp.my_q_Tmp.RecordCount > 0 then
          begin
            dm_DBImp.my_q_Tmp.First;
            for j := 0 to dm_DBImp.my_q_Tmp.RecordCount - 1 do
            begin
              posmask := 2 shl j;  // wir zhlen ab dem zweite status (erste bit = auf Wiedervorlage)
              if (StrToInt64(state) and posmask > 0) then
              begin
                idx := dm_DBImp.my_q_Tmp.FieldByName('indexcolumnid').AsString;
                bitmask := dm_DBImp.my_q_Tmp.FieldByName('bitmask').AsString;
                WriteCMD('Statusfeld:' + dm_DBImp.my_q_Tmp.FieldByName('displayname').AsString);
                if op = '=' then
                begin
                  sSQLCMD := 'update sys_doc set docstate_' + idx + ' = ' + bitmask + ' where gdocid = ' + IntToStr(iDocID);
                  op := '|';    // da im Status mehrere Bits gesetzt sein knnen, wird im ersten Durchlauf
                                // das erste zusetzende Bit direkt gesetzt, danach alle anderen verodert
                end
                else
                  sSQLCMD := 'update sys_doc set docstate_' + idx + ' = (docstate_' + idx + op + ' ' + bitmask + ')' + ' where gdocid = ' + IntToStr(iDocID);

                WriteCMD('Setzte Status (v35) idx:' + idx + ' state:' + bitmask);
                dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
                try
                  dm_DBImp.my_Cmd.Execute;
                except
                  on e: exception do
                  begin
                    WriteCMD('Fehler: Beim Schreiben des Status des Dokuments ' + e.Message);
                  end;
                end;

                aNewStatus[StrToInt(idx)] := aNewStatus[StrToInt(idx)] or StrToInt64(bitmask);

              end;
              dm_DBImp.my_q_Tmp.Next;
            end;
          end;
        end;
      end;
    end;
  finally
    FreeAndNil(lstDocState);
  end;
end;

function trim_vtx_for_mysql(vtx: WideString): string;
var
  max_allowed: Int64;
begin
  try
    try
      dm_DBImp.my_q_tmp4.SQL.Text := 'SHOW VARIABLES LIKE ' + #39 + 'max_allowed_packet' + #39;
      dm_DBImp.my_q_tmp4.Execute;
      max_allowed := dm_DBImp.my_q_tmp4.FieldByName('value').asInteger;
    except
      WriteCmd('Konnte max_allowed_packet nicht ermitteln. Setzte Volltext auf Standardgre');
      max_allowed := 1048576;
    end;

    if length(vtx) > max_allowed then
      vtx := LeftStr(vtx, max_allowed - 1);
    Result := vtx;
  except
    on e: Exception do
      WriteCmd('Fehler bei trim_vtx_for_mysql: ' + e.Message);
  end;
end;

procedure WriteHistory;
var
  sDate, sIDocID, sql: string;
begin
  if iDocID <> 0 then
  begin
    DateTimeToString(sDate, 'yyyy-mm-dd hh:nn:ss', Now);
    sIDocID := IntToStr(iDocID);

    if Length(sDocStateText) > 255 then
      sDocStateText := LeftStr(sDocStateText,249) + ' {...}';

    sql := 'Insert into sys_history (gdocid, userid, tstamp, taskid, value1, value2) Values (' + sIDocID + ', 1, ' + #39 + sDate + #39 + ', ' + inttostr(gTaskid) + ', ' + #39 + ParseSemicolonUseBackslash(sDocStateText) + #39 + ', ' + #39 + ParseSemicolonUseBackslash(sDocStateText2) + #39 + ')';
    dm_DBImp.my_cmd3.SQL.Text := sql;
    try
//        WriteCmd(sql);
      dm_DBImp.my_cmd3.Execute;
    except
      on e: exception do
      begin
        WriteCMD('Fehler: beim Schreiben in der History-Tabelle! ' + e.Message);
      end;
    end;
  end
  else
  begin
    WriteCMD('Fehler: WriteHistory - Es kann kein Eintrag fr Docid 0 erzeugt werden!');
  end;
end;

procedure WriteHistoryText(Text: string);
var
  sDate, sIDocID, sql: string;
begin
  if iDocID <> 0 then
  begin
    DateTimeToString(sDate, 'yyyy-mm-dd hh:nn:ss', Now);
    sIDocID := IntToStr(iDocID);
    sql := 'Insert into sys_history (gdocid, userid, tstamp, taskid, value1) Values (' + sIDocID + ', 1, ' + #39 + sDate + #39 + ', 0, ' + #39 + ParseSemicolonUseBackslash(Text) + #39 + ')';
    dm_DBImp.my_cmd3.SQL.Text := sql;
    try
//        WriteCmd(sql);
      dm_DBImp.my_cmd3.Execute;
    except
      on e: exception do
      begin
        WriteCMD('Fehler: beim Schreiben in der History-Tabelle! ' + e.Message);
      end;
    end;
  end
  else
  begin
    WriteCMD('Fehler: WriteHistory - Es kann kein Eintrag fr Docid 0 erzeugt werden!');
  end;
end;

procedure SetAddFieldsByState;
var
  xormask, setmask, deletemask: Int64;
  i, iCount, iFunc, iIndexColumnid: Integer;
  svalue, sIndexTableid, sFieldName, sSQLCMD: string;
  bitmask: Int64;
begin
  if not bNewStatusIsAbsolute then
    Exit;

  for i := 0 to High(aOldStatus) do
  begin
    xormask := aOldStatus[i] xor aNewStatus[i];

    if xormask > 0 then
    begin
      setmask := xormask and aNewStatus[i];
      deletemask := xormask and aOldStatus[i];

      if setmask > 0 then
      begin
        dm_DBImp.my_q_tmp6.SQL.Text := 'select * from sys_statefields st left join sys_addfields ad using(addfieldid) where st.flags & 2 = 0 and indexcolumnid = ' + IntToStr(i) + ' order by stateid';
        dm_DBImp.my_q_tmp6.Execute;
        if dm_DBImp.my_q_tmp6.RecordCount = 0 then	  // da will jemand einen Status setzen in einem Archiv wo es keine Statusbuttons gibt?
          Exit;													            // warum? egal, einfach raus hier....

        for iCount := 1 to dm_DBImp.my_q_tmp6.RecordCount do
        begin
          svalue := '';
          sIndexTableid := dm_DBImp.my_q_tmp6.FieldByName('indextableid').AsString;
          sFieldName := dm_DBImp.my_q_tmp6.FieldByName('fieldname').AsString;
          bitmask := StrToInt64(dm_DBImp.my_q_tmp6.FieldByName('bitmask').AsString);
          if (setmask and bitmask) > 0 then
          begin
            iFunc := dm_DBImp.my_q_tmp6.FieldByName('function').AsInteger;
            case iFunc of
              1:
                svalue := TimeToStr(Time);
              2:
                svalue := DateToStr(Date);
              3:
                svalue := DateTimeToStr(now);
              4:
                svalue := sDocUsr;
              5:
                svalue := sDocUsr + #32 + DateTimeToStr(now);
            else
              svalue := '';
            end;

            if (svalue <> '') and (sIndexTableid <> '') then
            begin
              if (iFunc in [2, 3]) and (dm_DBImp.my_q_tmp6.FieldByName('type').AsInteger in [1, 12]) then  // Datumsfeld
                svalue := 'str_to_date(' + #39 + svalue + #39 + ',' + #39 + sysDateformat + #39 + ')'
              else
                svalue := #39 + svalue + #39;

              try
//                dm_DBImp.my_cmd2.SQL.Text := 'Update sys_docidx_' + sIndexTableid + ' Set ' + sFieldName + ' = ' + svalue + ' where gdocid = ' + inttostr(iDocID);

                sSQLCMD := sFieldName + ' = ' + svalue;
                dm_DBImp.my_cmd2.SQL.Text := Format('insert into sys_docidx_%s set %s, gdocid = %s' + ' on duplicate key update %s', [sIndexTableid, sSQLCMD, IntToStr(iDocID), sSQLCMD]);

                dm_DBImp.my_cmd2.Execute;
              except
                on e: Exception do
                begin
                  WriteCmd('Fehler beim Setzen der statusabhngigen Zusatzfelder' + e.Message);
                end;
              end
            end;
          end;
          dm_DBImp.my_q_tmp6.Next;
        end;
      end;

      if deletemask > 0 then
      begin
        dm_DBImp.my_q_tmp6.SQL.Text := 'select * from sys_statefields st left join sys_addfields ad using(addfieldid) where st.flags & 2 = 0 ' + 'and indexcolumnid = ' + IntToStr(i) + ' order by stateid';

        dm_DBImp.my_q_tmp6.Execute;
        if dm_DBImp.my_q_tmp6.RecordCount = 0 then	// da will jemand einen Status setzen in einem Archiv wo es keine Statusbuttons gibt?
          Exit;													// warum? egal, einfach raus hier....

        for iCount := 1 to dm_DBImp.my_q_tmp6.RecordCount do
        begin
          sIndexTableid := dm_DBImp.my_q_tmp6.FieldByName('indextableid').AsString;
          sFieldName := dm_DBImp.my_q_tmp6.FieldByName('fieldname').AsString;
          bitmask := StrToInt64(dm_DBImp.my_q_tmp6.FieldByName('bitmask').AsString);
          if (deletemask and bitmask) > 0 then
          begin
            iFunc := dm_DBImp.my_q_tmp6.FieldByName('function').AsInteger;
            if (iFunc <> 0) and (sIndexTableid <> '') then
            begin
              try
                dm_DBImp.my_cmd2.SQL.Text := 'Update sys_docidx_' + sIndexTableid + '  Set ' + sFieldName + ' = NULL where gdocid = ' + inttostr(iDocID);

                dm_DBImp.my_cmd2.Execute;
              except
                on e: Exception do
                begin
                  WriteCmd('Fehler beim Leeren der statusabhngigen Zusatzfelder' + e.Message);
                end;
              end
            end;
          end;
          dm_DBImp.my_q_tmp6.Next;
        end;
      end;
    end;
  end;
end;

function StrToWords7(const InputStr: string): TStringList;
const
  sTrennZeichen = ';';
var
  iCount, iWortStart, iWortEnde: integer;
  bPhrase: boolean;
  sWort, slStr: string;
begin
  Result := TStringList.Create;
  Result.Clear;
  iWortStart := 1;
  iWortEnde := 0;
  iCount := 0;
  bPhrase := False;
   // trim the input!
  slStr := trim(InputStr);
  while iCount <= Length(slStr) do
  begin
    if IsDelimiter(sTrennZeichen, slStr, iCount) and not bPhrase then
    begin
      if iWortStart <= iWortEnde then
      begin
        iWortEnde := iCount;
        sWort := Trim(Copy(slStr, iWortStart, iWortEnde - iWortStart));
        if (Length(sWort) >= 1) then
          Result.Add(sWort);
        iWortStart := iWortEnde + 1;
      end;
    end;
    iWortEnde := iCount;
    Inc(iCount);
  end;
  if iWortStart <= iWortEnde then
  begin
    sWort := Trim(Copy(slStr, iWortStart, maxint));
    Result.Add(sWort);
  end;
end;

function DeleteLink(iDocid: Int64; link: string): Boolean;
var
  slLink: TStringList;
  iCount: Integer;
begin
  slLink := StrToWords7(link);
  for iCount := 0 to slLink.Count - 1 do
  begin
    dm_DBImp.my_q_tmp5.SQL.Text := 'Delete from sys_doclink where gdocid = ' + inttostr(iDocid) + ' and refname = ' + #39 + slLink[iCount] + #39;
    dm_DBImp.my_q_tmp5.Execute;
  end;
end;

function InsertLink(iDocid: Int64; link: string): Boolean;
var
  slLink: TStringList;
  iCount, iInsertID: Integer;
begin

  sDocid := inttostr(iDocid);
   //link := Copy(link, 2, length(link) -2);
  slLink := StrToWords7(link);
  if sDocStateText <> '' then
  begin
    gTaskid := 4;
    WriteHistory;
  end;
  for iCount := 0 to slLink.Count - 1 do
  begin
    dm_DBImp.my_q_tmp5.SQL.Text := 'Select * from sys_doclink where gdocid = ' + inttostr(iDocid) + ' and refname =' + #39 + slLink[iCount] + #39;
    dm_DBImp.my_q_tmp5.Execute;
    if dm_DBImp.my_q_tmp5.RecordCount > 0 then
      continue;

    dm_DBImp.my_q_tmp5.SQL.Text := 'Insert into sys_doclink set refname =' + #39 + slLink[iCount] + #39 + ', gdocid = ' + inttostr(iDocid);
    dm_DBImp.my_q_tmp5.Execute;
    iInsertID := dm_DBImp.my_q_tmp5.LastInsertId;
    dm_DBImp.my_q_tmp5.SQL.Text := 'Update sys_doclink set reflink = ' + inttostr(iInsertID) + ' where refid = ' + inttostr(iInsertID);
    dm_DBImp.my_q_tmp5.Execute;
    gTaskid := 13;
    sDocStateText := slLink[iCount];
    WriteHistory;
  end;
  sDocStateText := '';
end;

function CreateLinkByAddfield(addfield, link: string): Boolean;
var
  iCount: integer;
  sIArcID, sIDocID, svalue, lsjunk, indexttableid: string;
begin
  result := false;
  if (sDocID <> '') and (Pos('.', sDocID) > 0) then   // wenn wir ber UpdateSQL kommen haben wir sDocID, bei InsertSQL haben wir
  begin
    iCount := Pos('.', sDocID);
    sIArcID := copy(sDocID, 1, iCount - 1);
    sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
    iArcID := StrToInt(sIArcID);
    iDocid := StrToInt64(sIDocID);
  end;
  try
    if iDocid > 0 then
    begin
      dm_DBImp.my_q_tmp5.SQL.Text := 'select * from sys_addfields where fieldname = ' + #39 + addfield + #39;
      dm_DBImp.my_q_tmp5.Execute;
      if dm_DBImp.my_q_tmp5.RecordCount > 0 then
      begin
        indexttableid := dm_DBImp.my_q_tmp5.FieldByName('indextableid').AsString;
        dm_DBImp.my_q_tmp5.SQL.Text := Format('select * from sys_docidx_%s where gdocid = %d', [indexttableid, iDocid]);
        dm_DBImp.my_q_tmp5.Execute;
        if dm_DBImp.my_q_tmp5.RecordCount > 0 then
        begin
          if (dm_DBImp.my_q_tmp5.FieldByName(addfield).AsString <> '') and (dm_DBImp.my_q_tmp5.FieldByName(addfield).AsString <> link) then
            DeleteLink(iDocid, dm_DBImp.my_q_tmp5.FieldByName(addfield).AsString);
        end;
      end;
    end;

    InsertLink(iDocid, link);
  except
    on e: Exception do
    begin
      WriteCmd('Fehler beim Erzeugen einer Zusatzfeldverknpfung' + e.Message);

    end;
  end;
end;

function AddValueToSelection(addfield, value: string; typ: Integer): Boolean;
var
  iCount, i, j: integer;
  sIArcID, sIDocID, svalue, lsjunk, indexttableid, delimited: string;
  items, values: TStringList;
begin
  result := false;
  if (sDocID <> '') and (Pos('.', sDocID) > 0) then   // wenn wir ber UpdateSQL kommen haben wir sDocID, bei InsertSQL haben wir
  begin
    iCount := Pos('.', sDocID);
    sIArcID := copy(sDocID, 1, iCount - 1);
    sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
    iArcID := StrToInt(sIArcID);
    iDocid := StrToInt64(sIDocID);
  end;
  try
    if iDocid > 0 then
    begin
      dm_DBImp.my_q_tmp5.SQL.Text := 'select * from sys_addfields where fieldname = ' + #39 + addfield + #39;
      dm_DBImp.my_q_tmp5.Execute;
      if dm_DBImp.my_q_tmp5.RecordCount > 0 then
      begin
        items := TStringList.Create;
        items.Delimiter := ';';
        items.StrictDelimiter := True;
//        items.Sorted := True;
        items.DelimitedText := dm_DBImp.my_q_tmp5.FieldByName('items').AsString;

        values := TStringList.Create;
//        values.Sorted := True;

        if typ in [2, 11] then              // Auswahl
        begin
          values.Add(value);
        end else                            // Mehrfachauswahl
        begin
          values.Delimiter := ';';
          values.StrictDelimiter := True;
          values.DelimitedText := value;
        end;

        for i := 0 to values.Count - 1 do
        begin
          if items.IndexOf(values[i]) = -1 then
          begin
            items.Add(values[i]);
            dm_DBImp.my_q_tmp5.SQL.Text := 'update sys_addfields set items = :items where fieldname = ' + #39 + addfield + #39;
            dm_DBImp.my_q_tmp5.ParamByName('items').AsString := items.DelimitedText;
            dm_DBImp.my_q_tmp5.Execute;
          end;
        end;
        FreeAndNil(items);
        FreeAndNil(values);
      end;
    end;

  except
    on e: Exception do
    begin
      WriteCmd('Fehler beim Hinzufgen eines Wertes zur Auswahl des Feldes ' + addfield + ': ' + e.Message);

    end;
  end;
end;

// wenn unter den Zusatzfeldern ein GridFeld vorhanden ist, werden die Werte auf die entsprechenden
// Zusatzfelder verteilt (ggf mssen diese noch hinzugefgt werden)
procedure InsertGridFieldValues;
var
  i, j, k, iCount : Integer;
  indextableid: string;
  Config: TbfaGridConfig;
  XML : IXMLDocument;
  found: Boolean;
  lstKeys, lstRows, lstValues: TStringList;
begin
  for iCount := 1 to iFieldCount do
  begin
    indextableid := '0';
    sSQLCMD := '';
    if Trim(aZusWert[iCount]) <> '' then
    begin
      dm_DBImp.my_q_tmp5.SQL.Text := 'Select * from sys_addfields where fieldname = ' + #39 + aZusFeld[iCount] + #39;
      dm_DBImp.my_q_tmp5.Execute;

      if dm_DBImp.my_q_tmp5.RecordCount > 0 then
      begin
        indextableid := dm_DBImp.my_q_tmp5.FieldByName('indextableid').AsString;
        if (dm_DBImp.my_q_tmp5.FieldByName('type').AsInteger = 13) and
            (dm_DBImp.my_q_tmp5.FieldByName('values_query').AsString <> '') then     // GridFeld gefunden
        begin
          CoInitialize(nil);
          XML := NewXMLDocument;
          try
            try
              XML.Encoding := 'us-ascii';
              XML.Options := [doNodeAutoIndent];
              XML.LoadFromXML(dm_DBImp.my_q_tmp5.FieldByName('values_query').AsString);
              Config := bfaParser.XMLToGridConfig(XML.DocumentElement);

              // Config geladen, schauen, ob wir schon alle Zusatzfelder im Array haben
              for i := 0 to Config.Columns.Count -1 do
              begin
                found := False;
                for j := 0 to High(aZusFeld) do
                begin
                  if TbfaColumnConfig(Config.Columns[i]).Fieldname = aZusFeld[j] then
                  begin
                    found := True;
                    Break;
                  end;
                end;
                if not found then
                begin
                  SetLength(aZusFeld, length(aZusFeld) +1);
                  SetLength(aZusWert, length(aZusWert) +1);
                  aZusFeld[length(aZusFeld) -1] := TbfaColumnConfig(Config.Columns[i]).Fieldname;
                end;
              end;

              // wenn das GridFeld gelscht werden soll, dann #delete# auf die GridSpalten verteilen
              // ansonsten Value CSV auseinanderschneiden und auf die Spalten verteilen
              if Trim(aZusWert[iCount]) = '#delete#' then
              begin
                for i := 0 to Config.Columns.Count -1 do
                begin
                  for j := 0 to High(aZusFeld) do
                  begin
                    if TbfaColumnConfig(Config.Columns[i]).Fieldname = aZusFeld[j] then
                    begin
                      aZusWert[j] := '#delete#'
                    end;
                  end;
                end;
              end else
              begin
                lstKeys := TStringList.Create('"', ';', [soStrictDelimiter]);
                lstRows := TStringList.Create('"', '|', [soStrictDelimiter]);
                lstValues := TStringList.Create('"', ';', [soStrictDelimiter]);
                lstRows.DelimitedText := Trim(aZusWert[iCount]);

                if lstRows.Count > 0 then
                begin
                  lstValues.DelimitedText := lstRows[0];
                  for i := 0 to lstValues.Count -1 do
                    lstKeys.Add(lstValues[i]);

                  if lstRows.Count > 1 then   // nur bei mehr als einen Eintrag (Spaltenbezeichner)
                  begin                       // haben wir wirklich einen Value
                    for i := 1 to lstRows.Count -1 do
                    begin
                      if lstRows[i] = '' then
                        Continue;
                      lstValues.DelimitedText := lstRows[i];
                      for j := 0 to lstKeys.Count -1 do
                      begin
                        for k := 0 to High(aZusFeld) do
                        begin
                          if lstKeys[j] = aZusFeld[k] then
                          begin
                            if lstValues[j] = '' then
                            begin
                              if aZusWert[k] = '' then
                                aZusWert[k] :=  ';'
                              else
                                aZusWert[k] := aZusWert[k] +  ';';
                            end else
                            begin
                              if aZusWert[k] = '' then
                                aZusWert[k] := lstValues[j]
                              else
                                aZusWert[k] := aZusWert[k] + ';' + lstValues[j];
                            end;
                          end;
                        end;
                      end;
                    end;
                  end;
                end;
              end;
              aZusWert[iCount] := '';   // das Gridfeld selbst setzen wir nach erfolgreicher Verarbeitung leer
                                        // gespeichert werden die Werte aus dem aZusFeld Array
            except
              WriteCmd('Es hat einen Fehler beim Lesen des Gridfeldes ' + aZusFeld[iCount] + ' gegeben');
            end;
          finally
            CoUnInitialize;
          end;
        end;
      end;
    end;
  end;
end;

procedure Calculate_ExpiredDate;
var
  req: TbfaRequest;
begin
  try
    if MainSocket.Connect then
    begin
      req := TbfaRequest.Create;
      req.ReqType := 'reqCalculateExpiredDate';
      req.Gdocid := iDocid;
      req.Profile := fProfile;
      MainSocket.SendRequestToServer(req);

      req := MainSocket.ReceiveResponse;
      if req = nil then
      begin
        WriteCmd('Fehler: keine Antwort vom Server auf CalculateExpiredDate');

      end
      else if req.ReqType = 'respError' then
        WriteCMD('Fehler: der Server konnte kein Lschdatum setzen, oder es wurde keins definiert.');

    end else
      WriteCmd('Fehler: es konnte keine Verbindung zum bfaServer aufgebaut werden, Lschdatum kann nicht berechnet werden.');
  finally
    if Assigned(req) then
      FreeAndNil(req);
    MainSocket.Disconnect;
  end;
end;




// Neue Wiedervorlage Aufgabe einfgen
procedure InsertTask;
var
  iCount, licounter, iGrpID, iInsID: integer;
  sIArcID, sIDocID, lsWorker, sBearbeiterText, sName, sTime: string;
  bIsGrp: boolean;
  ltsworkers: TStringList;
  lscripts: TIniFile;
  lDateFormat: string;
begin
  iUsrIDShed := -1;
  if ((iArcID = -1) or (iDocid = -1)) then
  begin
    iCount := Pos('.', sDocID);
    sIArcID := copy(sDocID, 1, iCount - 1);
    sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
    iArcID := StrToInt(sIArcID);
    iDocid := StrToInt64(sIDocID);
  end;

   // Erzeugung einer Gruppen Wiedervorlage nach dem Szenario EFAM (Einer fuer Alle)
   // ist der Name eine Gruppe oder ein Benutzer

  if sDocTitel = '' then
  begin
    if lcid = '1031' then
      sDocTitel := 'Dokument'
    else
      sDocTitel := 'Document';
  end;

  sTime := TimeToStr(Time);
  lDateFormat := CheckDateFormat(sTermin, sysDateformat);
  sTermin := sTermin + ' ' + sTime;
  sAlarm := sAlarm + ' ' + sTime;

   // falls wir Meldungen in der Jobdatei haben (SVNInfo) dann
   // schreiben wir die in die Historie
  if sDocStateText <> '' then
  begin
    gTaskid := 4;
    WriteHistory;
  end;

  sDocStateText := '';
  iInsID := 0;
  with dm_DBImp.my_q_Tmp do
  begin
      // Archiv des Dokumentes suchen....
    Close;
    sql.Text := 'Select * from sys_arc where arcid = ' + IntToStr(iArcID);
    Open;
    First;
    if RecordCount > 0 then
    begin
      sGArcName := FieldByName('arcname').AsString;
      sGTblName := FieldByName('tblName').AsString;
    end
    else
    begin
      WriteCMD('Fehler: Die ArcID:=' + IntToStr(iArcID) + 'referenziert ein Archiv das nicht existiert. sdocid ' + sDocID + 'idocid:=' + IntToStr(iDocid));
      ExitCode := 7; // Archiv nicht gefunden;
      exit;
    end;
    Close;
      // Vergebenden Benutzer suchen....
    if iDocUser = -1 then
    begin
      if sDocUsr <> '' then
      begin
        sql.Text := 'Select * from sys_user where username = ' + #39 + sDocUsr + #39 + ' and flags & 2 = 0';
        try
          Open;
          First;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei InserTask: ' + e.Message);
          end;
        end;

        if RecordCount > 0 then
        begin
          iUsrIDShed := FieldByName('userid').AsInteger;
        end
        else
        begin
          WriteCMD('Fehler: Der vergebende Benutzer ' + sDocUsr + ' wurde nicht gefunden und durch System ersetzt.');
          if fileexists(extractfilepath(ParamStr(0)) + '\scripts.ini') then
          begin
            try
              lscripts := TIniFile.Create(extractfilepath(ParamStr(0)) + '\scripts.ini');

              sql.Text := 'Select * from sys_user where username = ' + #39 + lscripts.ReadString('Scripts', 'admin', 'system') + #39 + ' and flags & 2 = 0';
              try
                Open;
              except
                on e: exception do
                begin
                  WriteCMD('Fehler bei der Abfrage von "admin": ' + e.message);
                end;
              end;
              First;
            finally
              if Assigned(lscripts) then
                FreeAndNil(lscripts);
              iUsrIDShed := FieldByName('userid').AsInteger;
            end;
          end
          else
          begin
            iUsrIDShed := 1;
          end;
          ExitCode := 6; // User nicht gefunden;
             //      exit;
        end;
        Close;
      end;
    end
    else
      iUsrIDShed := iDocUser;

      // als Trennzeichen fr Bearbeiterlisten nehmen wir das Semikolon
    ltsworkers := TStringList.Create;
    ltsworkers := Split(sWorker, ';', True, False);

    if ltsworkers.Count > 0 then
    begin
      WriteCMD('Wiedervorlage bergeben: Die Liste der Benutzer war:');
      WriteCMD(ltsworkers.Text);
    end;

    for licounter := 0 to ltsworkers.Count - 1 do
    begin

      if copy(ltsworkers[licounter], 1, 1) = '#' then
      begin
        bIsGrp := True;
            // EFAM:= TRUE;  // mul
        AFEM := False;
        lsWorker := copy(ltsworkers[licounter], 2, Length(ltsworkers[licounter]) - 1);
            // Achtug ggf mssend die Timeroptionen erstmal ausgelesen werden
            // so long set the first bit to 0 and not substract -1 ( -1 could be more efficient (since not 1 = -1 )
            // but this is clearer and should be
            // by optimizing also transformed to -1.)
            // Optionen := bigint(20) UNSIGNED!
        giTimerOptionen := giTimerOptionen and (not 1); //  (2^0)
      end
      else if copy(ltsworkers[licounter], 1, 1) = '' then
      begin
        bIsGrp := True;
            // EFAM:= False;
        AFEM := True;
        lsWorker := copy(ltsworkers[licounter], 2, Length(ltsworkers[licounter]) - 1);
            // Hier muss der Eintrag rein um die JE WVL zu kennzeichnen
        giTimerOptionen := giTimerOptionen or 1;
      end
      else
      begin
        lsWorker := copy(ltsworkers[licounter], 1, Length(ltsworkers[licounter]));
        bIsGrp := False;
      end;

      if bIsGrp then // Wenn es sich um eine Gruppewiedervorlage handelt , dann
      begin
        if iUsrIDShed = -1 then   // wurde beim anlegen von Gruppenwiedervorlagen kein Bearbeiter
          iUsrIDShed := 1;        // definiert, dann wirds System (Bearbeiter wird von Benutzer= in der Jobdatei gelesen

            //WriteCMD('Das Dokument wird der Gruppe ' + lsWorker +
            //  ' auf Wiedervorlage gelegt');
        sql.Text := 'Select * from sys_group where groupname = ' + #39 + lsWorker + #39 + ' and flags & 2 = 0';
        try
          Open;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei InsertTask(1): ' + e.Message);
            ExitCode := 12;
          end;
        end;
        First;
        if RecordCount > 0 then
        begin
          iGrpID := FieldByName('groupid').AsInteger;
          Close;
          sql.Text := 'Select * from sys_groupuser left join sys_user using (userid) where groupid = ' + IntToStr(iGrpID) + ' and sys_user.flags & 3 = 1 group by userid';    // enabled, nicht deleted
          try
            Open;
          except
            on e: exception do
            begin
              WriteCmd('Fehler bei InsertTask(2): ' + e.Message);
              ExitCode := 12;
            end;
          end;
          First;
               //todo check if count  > 0 !!!
          if RecordCount > 0 then
          begin
                  //wenigstens eine WVL wird gesetzt, daher
            bIsWorkflow := True;
            WriteCMD('Das Dokument wird der Gruppe ' + lsWorker + ' auf Wiedervorlage gelegt');
            if sBearbeiterText <> '' then
              sBearbeiterText := sBearbeiterText + ',';

            sBearbeiterText := sBearbeiterText + sMsg8 + lsWorker + ' (';
            iUsrIDWork := FieldByName('userid').AsInteger;
            sName := FieldByName('username').AsString;
            WriteCMD('Gruppen-Wvl fr Benutzer ' + sName + ' angelegt');

            dm_DBImp.my_Cmd.SQL.Text :=
//                     'Insert into sys_timer (grp_id, arc_id, doc_id, doc_titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
//                     + 'Values (:grpid, :arcid, :docid, :titel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';
              'Insert into sys_timer (groupid, gdocid, userid_work, userid_shed, date, alarm, options, info) ' + 'Values (:groupid, :gdocid, :uwork, :ushed, str_to_date(' + #39 + sTermin + #39 + ',' + #39 + lDateFormat + ' %H:%i:%s' + #39 + '), str_to_date(' + #39 + sAlarm + #39 + ',' + #39 + lDateFormat + ' %H:%i:%s' + #39 + '), :options, :info)';

            dm_DBImp.my_Cmd.ParamByName('groupid').AsInteger := iGrpID;
            dm_DBImp.my_Cmd.ParamByName('gdocid').AsInteger := iDocid;
            dm_DBImp.my_Cmd.ParamByName('uwork').AsInteger := iUsrIDWork;
            dm_DBImp.my_Cmd.ParamByName('ushed').AsInteger := iUsrIDShed;
            dm_DBImp.my_Cmd.ParamByName('options').AsInteger := giTimerOptionen;
            dm_DBImp.my_Cmd.ParamByName('info').AsString := sNotiz;
            try
//                     WriteCmd(dm_DBImp.my_Cmd.SQL.Text);
              dm_DBImp.my_Cmd.Execute;
            except
              on e: exception do
              begin
                WriteCmd('Fehler bei InsertTask(3): ' + e.Message);
                ExitCode := 12;
              end;
            end;
            iInsID := dm_DBImp.my_Cmd.LastInsertId;
            dm_DBImp.my_Cmd.SQL.Text := 'Update sys_timer set timref = ' + IntToStr(iInsID) + ' where timid = ' + IntToStr(iInsID);
            try
//                     WriteCmd(dm_DBImp.my_Cmd.SQL.Text);
              dm_DBImp.my_Cmd.Execute;
            except
              on e: exception do
              begin
                WriteCmd('Fehler bei InsertTask(4): ' + e.Message);
                ExitCode := 12;
              end;
            end;
                  // this was the first, so now do with the next ppl
            sBearbeiterText := sBearbeiterText + ' ' + FieldByName('username').AsString;
            Next;
            while not EOF do
            begin
              iUsrIDWork := FieldByName('userid').AsInteger;
              sName := FieldByName('username').AsString;
              WriteCMD('Gruppen-Wvl fr Benutzer ' + sName + ' angelegt');

              dm_DBImp.my_Cmd.SQL.Text :=
//                        'Insert into sys_timer (tim_ref, grp_id, arc_id, doc_id, doc_titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
//                        + 'Values (:timref, :grpid, :arcid, :docid, :titel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';
                'Insert into sys_timer (timref, groupid, gdocid, userid_work, userid_shed, date, alarm, options, info) ' +
                'Values (:timref, :groupid, :gdocid, :uwork, :ushed, str_to_date(' + #39 + sTermin + #39 + ',' + #39 +
                lDateFormat + ' %H:%i:%s' + #39 + '), str_to_date(' + #39 + sAlarm + #39 + ',' + #39 +
                lDateFormat + ' %H:%i:%s' + #39 + '), :options, :info)';

              dm_DBImp.my_Cmd.ParamByName('timref').AsInteger := iInsID;
              dm_DBImp.my_Cmd.ParamByName('groupid').AsInteger := iGrpID;
              dm_DBImp.my_Cmd.ParamByName('gdocid').AsInteger := iDocid;
              dm_DBImp.my_Cmd.ParamByName('uwork').AsInteger := iUsrIDWork;
              dm_DBImp.my_Cmd.ParamByName('ushed').AsInteger := iUsrIDShed;
//                     dm_DBImp.my_Cmd.ParamByName('termin').AsDateTime := StrToDateTime(sTermin);
//                     dm_DBImp.my_Cmd.ParamByName('alarm').AsDateTime := StrToDateTime(sAlarm);
              dm_DBImp.my_Cmd.ParamByName('options').AsInteger := giTimerOptionen;
              dm_DBImp.my_Cmd.ParamByName('info').AsString := sNotiz;
              try
//                        WriteCmd(dm_DBImp.my_Cmd.SQL.Text);
                dm_DBImp.my_Cmd.Execute;

              except
                on e: exception do
                begin
                  WriteCMD('Fehler beim Anlegen einer WV fr die Gruppe ' + lsWorker);
                  WriteCMD(e.Message);
                end;
              end;
              sBearbeiterText := sBearbeiterText + ' ' + FieldByName('username').AsString;
              Next;
            end;
          end
          else
          begin
            WriteCMD('Fehler: Leere Gruppe ausgewhlt: ' + lsWorker + ' (' + IntToStr(licounter + 1) + ' von ' + IntToStr(ltsworkers.Count) + ')');
            ExitCode := 6;    // User nicht gefunden;
            continue;
          end;
        end
        else
        begin
          WriteCMD('Fehler: Die Benutzergruppe ' + lsWorker + ' wurde nicht gefunden. (' + IntToStr(licounter + 1) + ' von ' + IntToStr(ltsworkers.Count) + ')');
          ExitCode := 6;    // User nicht gefunden;
          continue;
        end;
        sBearbeiterText := sBearbeiterText + ')';
        IWvlID := iInsID;
        Close;
      end
      else
      begin       // Einzelbenutzer
        sql.Text := 'Select * from sys_user where (username = ' + #39 + lsWorker + #39 + ' or displayname = ' + #39 + lsWorker + #39 + ') and flags & 3 = 1';      // enabled, nicht deleted
        try
          Open;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei InsertTask(5): ' + e.Message);
            ExitCode := 12;
          end;
        end;
        First;
        if RecordCount > 0 then
        begin
          if FieldByName('userid').AsString <> '' then
          begin
            iUsrIDWork := FieldByName('userid').AsInteger;
          end;
        end
        else
        begin
          WriteCMD('Fehler: Der Bearbeiter - ' + lsWorker + ' wurde nicht gefunden. (' + IntToStr(licounter + 1) + ' von ' + IntToStr(ltsworkers.Count) + ')');
          ExitCode := 6; // User nicht gefunden;
               //exit;
          continue;
        end;
            //wenigstens eine WVL wird gesetzt, daher
        bIsWorkflow := True;

        if iUsrIDShed = -1 then   // wurde beim anlegen von Wiedervorlagen kein Bearbeiter
          iUsrIDShed := iUsrIDWork; // definiert, dann wird der Worker selbst Controller (Bearbeiter wird von Benutzer= in der Jobdatei gelesen)

        WriteCMD('Wvl wird fr Benutzer ' + lsWorker + ' angelegt');
            // Optionen for one single user not needed!
        dm_DBImp.my_Cmd.SQL.Text :=
//               'Insert into sys_timer (grp_id, arc_id, doc_id, doc_titel, usr_id_work, usr_id_shed, termin, erinnerung, info, optionen) '
//               + 'Values (0, :arcid, :docid, :titel, :uwork, :ushed, :termin, :alarm, :info, :optionen)';
          'Insert into sys_timer (groupid, gdocid, userid_work, userid_shed, date, alarm, options, info) ' + 'Values (0, :gdocid, :uwork, :ushed, str_to_date(' + #39 + sTermin + #39 + ',' + #39 + lDateFormat + ' %H:%i:%s' + #39 + '), str_to_date(' + #39 + sAlarm + #39 + ',' + #39 + lDateFormat + ' %H:%i:%s' + #39 + '), :options, :info)';

        dm_DBImp.my_Cmd.ParamByName('gdocid').AsInteger := iDocid;
        dm_DBImp.my_Cmd.ParamByName('uwork').AsInteger := iUsrIDWork;
        dm_DBImp.my_Cmd.ParamByName('ushed').AsInteger := iUsrIDShed;
//            dm_DBImp.my_Cmd.ParamByName('termin').AsDateTime := StrToDateTime(sTermin);
//            dm_DBImp.my_Cmd.ParamByName('alarm').AsDateTime := StrToDateTime(sAlarm);
        dm_DBImp.my_Cmd.ParamByName('options').AsInteger := giTimerOptionen;
        dm_DBImp.my_Cmd.ParamByName('info').AsString := sNotiz;
        try
//               WriteCmd(dm_DBImp.my_Cmd.SQL.Text);
          dm_DBImp.my_Cmd.Execute;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei InsertTask(6): ' + e.Message);
            ExitCode := 12;
          end;
        end;

            // hier muss die Time ID abgefragt werden
        iInsID := dm_DBImp.my_Cmd.LastInsertId;
        dm_DBImp.my_Cmd.SQL.Text := 'Update sys_timer set timref = ' + IntToStr(iInsID) + ' where timid = ' + IntToStr(iInsID);
        try
//               WriteCmd(dm_DBImp.my_Cmd.SQL.Text);
          dm_DBImp.my_Cmd.Execute;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei InsertTask(7): ' + e.Message);
            ExitCode := 12;
          end;
        end;

        if sBearbeiterText <> '' then
          sBearbeiterText := sBearbeiterText + ', ';

        sBearbeiterText := sBearbeiterText + sMsg3 + lsWorker;
      end;
      Close;
    end;
  end;
   //just be sure sidocid was set!
   //no bearbeiter set no wvl so dont set in worked it!
  if sIDocID = '' then
  begin
      //exit;
  end;
  sIArcID := IntToStr(iArcID);
  sIDocID := IntToStr(iDocid);

  if bIsWorkflow then
  begin
    dm_DBImp.my_q_Tmp.SQL.Text := 'update sys_doc set docstate_0 = (docstate_0 | 1) where gdocid = ' + sIDocID;
    dm_DBImp.my_q_Tmp.Execute;

    gTaskid := 16;
    sDocStateText := '';
    WriteHistory;

    IWvlID := iInsID;

    gTaskid := 415;
    sDocStateText := sNotiz;
    if (giTimerOptionen and 1) = 0 then
      sDocStateText2 := sMsg1
    else
      sDocStateText2 := sMsg2;

    if (giTimerOptionen and 2) = 2 then
      sDocStateText2 := sDocStateText2 + ', ' + sMsg4;
    if (giTimerOptionen and 4) = 4 then
      sDocStateText2 := sDocStateText2 + ', ' + sMsg5;
    if (giTimerOptionen and 64) = 64 then
      sDocStateText2 := sDocStateText2 + ', ' + sMsg6;
    WriteHistory;

    gTaskid := 17;
    sDocStateText := sBearbeiterText;
    sDocStateText2 := sTermin;
    WriteHistory;
  end
  else
      //  ToDO : Eine Behandlung fr ExitCode 12 in Archivierung und Workflow.vbs
      //ExitCode:=12;  // Es konnte keine Wiedervorlage angelegt werden (User,Gruppen und Konfiguration berprfen)

  begin    //Status zurcksetzen
    if boldStatus then
    begin
      dm_DBImp.my_q_Tmp.SQL.Text := 'update sys_doc set docstate_0 = (docstate_0 | 1) where' + ' gdocid = ' + sIDocID;
      dm_DBImp.my_q_Tmp.Execute;
    end
    else
    begin
      dm_DBImp.my_q_Tmp.SQL.Text := 'update sys_doc set docstate_0 = (docstate_0 | 1) ^ 1  where' + ' gdocid = ' + sIDocID;
      dm_DBImp.my_q_Tmp.Execute;
    end;
  end;

end;

procedure WriteRef;
var
  iCount, iRefID: integer;
begin
  if sDocStateText <> '' then
  begin
    gTaskid := 4;
    WriteHistory;
  end;

  for iCount := 1 to iRefCount do
  begin
      // entry does exists?
    dm_DBImp.my_q_Tmp.sql.Text := 'select * from sys_doclink where gdocid = ' + IntToStr(iDocid) + ' and refname = ' + #39 + aDocRef[iCount] + #39 + ' order by reflink desc';
    try
      dm_DBImp.my_q_Tmp.Execute;
    except
      on e: exception do
      begin
        WriteCmd('Fehler bei WriteRef: ' + e.Message);
      end;
    end;

    if dm_DBImp.my_q_Tmp.RecordCount > 0 then
    begin
      continue;
    end;
    with dm_DBImp.my_q_Tmp do
    begin
         //      SQL.Text := 'Select * from sys_doclnk where Ref_Type = 1 and Ref_ID = Ref_LNK and Ref_Name = ' + #39 + aDocRef[iCount] + #39;
      sql.Text := 'Select * from sys_doclink where refid = reflink and refname = ' + #39 + ParseSemicolonUseBackslash(aDocRef[iCount]) + #39;

      try
        Open;
      except
        on e: exception do
        begin
          WriteCmd('Fehler bei WriteRef: ' + e.Message);
        end;
      end;
      First;
      if RecordCount = 0 then
      begin
        try
          Insert;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei WriteRef: ' + e.Message);
          end;
        end;

        FieldByName('reftype').AsInteger := 1;
        FieldByName('gdocid').AsInteger := iDocid;
        FieldByName('userid').AsInteger := 1;
        FieldByName('refname').AsString := aDocRef[iCount];
        try
          Post;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei WriteRef: ' + e.Message);
          end;
        end;
        iRefID := FieldByName('refid').AsInteger;
        edit;
        FieldByName('reflink').AsInteger := iRefID;
        try
          Post;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei WriteRef: ' + e.Message);
          end;
        end;

        if length(aDocRef[iCount]) > 50 then
        begin
          gTaskid := 18;
          sDocStateText := LeftStr(aDocRef[iCount], 50) + '...';
        end
        else
        begin
          gTaskid := 18;
          sDocStateText := aDocRef[iCount];
        end;
      end
      else
      begin
        iRefID := FieldByName('refid').AsInteger;
        try
          Insert;
          FieldByName('reftype').AsInteger := 1;
          FieldByName('reflink').AsInteger := iRefID;
          FieldByName('gdocid').AsInteger := iDocid;
          FieldByName('userid').AsInteger := 1;
          FieldByName('refname').AsString := aDocRef[iCount];
          Post;
        except
          on e: exception do
          begin
            WriteCmd('Fehler bei WriteRef: ' + e.Message);
          end;
        end;

        if length(aDocRef[iCount]) > 50 then
        begin
          gTaskid := 18;
          sDocStateText := LeftStr(aDocRef[iCount], 50) + '...';
        end
        else
        begin
          gTaskid := 18;
          sDocStateText := aDocRef[iCount];
        end;
      end;
      WriteHistory;
    end;
  end;
  sDocStateText := '';
end;

//insert job data into mysql database
function InsertSQL: boolean;
var
  iCount, litmp, lit, i, j, page, layer: integer;
  bnulldate, found: boolean;
  lfloat: Double;
  lsjunk, svalue, sPath, sContType, indextableid, indexcolumnid, state: string;
  vtx, doctags, fieldtxt, annotxt, annopath: WideString;
  lDateFormat, sDate, fname, fpart: string;
  sFiles: TStringList;
  lsItems, values: TStringList;
begin
  result := false;
  ioldStatus := 0;
  boldStatus := False;
  bNewStatusIsAbsolute := False;
  vtx := '';
  doctags := '';
  fieldtxt := '';
  annotxt := '';

  try
      //get arc table name
    with dm_DBImp.my_q_Tmp do
    begin
      if iArcID = -1 then
        sql.Text := 'Select * from sys_arc where tblname = ' + #39 + sGTblName + #39
      else
        sql.Text := 'Select * from sys_arc where arcid = ' + IntToStr(iArcid);
      Open;
      First;
      iArcID := FieldByName('arcid').AsInteger;
      sGArcName := FieldByName('arcname').AsString;
      sGTblName := FieldByName('tblname').AsString;
      sDefDocname := FieldByName('defdocname').AsString;
      if (FieldByName('options').AsInteger and 2) = 2 then
      begin
        sDefDocname := sGArcName;
        sSlwFile.Add(sGArcName); //22.01.2019 Ticket 17627
      end;
    end;

      //start mysql query
    sSQLCMD := 'Insert into sys_doc (arcid, userid,';
    lsjunk := '';
    if sDocTitel <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + 'docname';
      lsjunk := ',';
    end;
    if sDocOrg <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + 'docloc';
      lsjunk := ',';
    end;
    if sDocKopie <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + 'extloc';
      lsjunk := ',';
    end;
    if sDocQuelle <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + 'oriloc';
      lsjunk := ',';
    end;
//      if sDocUsr <> '' then
//      begin
//         sSQLCMD := sSQLCMD + lsjunk + 'userid';
//         lsjunk := ',';
//      end;
    if sDocDate <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + 'docdate';
      lsjunk := ',';
    end
    else
    begin
      sSQLCMD := sSQLCMD + lsjunk + 'docdate';
      lsjunk := ',';
    end;
//      if sDocVtx <> '' then
//      begin
//         sSQLCMD := sSQLCMD + lsjunk + 'DOC_TXT';
//         lsjunk := ',';
//      end;
//      if sDocState <> '' then
//      begin
//         sSQLCMD := sSQLCMD + lsjunk + 'docstate_0 ';
//         lsjunk := ',';
//      end;
//      if sDocOCR <> '' then
//      begin
//         sSQLCMD := sSQLCMD + lsjunk + 'OCR_QF';
//         lsjunk := ',';
//      end;
    if sFiletype <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + 'filetype';
      lsjunk := ',';
    end;

    if sSha1 <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + 'sha1';
      lsjunk := ',';
    end;

//      if iFieldCount > 0 then
//      begin
//         //check if default NULL is valid to datefield
//         bnulldate := True;
//
//         for iCount := 1 to iFieldCount do
//         begin
//            if trim(aZusWert[iCount]) <> '' then
//            begin
//               sSQLCMD := sSQLCMD + ', ' + aZusFeld[iCount];
//               with dm_DBImp.my_q_Tmp do
//               begin
//                  SQL.Text := 'Select * from sys_addfields where fieldname = ' +
//                     #39 + ParseSemicolonUseBackslash(aZusFeld[iCount]) + #39;
//
//                  try
//                     Open;
//                     First;
//                  except
//                     on e: exception do
//                     begin
//                        WriteCmd('Fehler bei InsertSQL: ' + e.Message);
//                     end;
//                  end;
//                  //set datefield as database allow
//                  if FieldByName('type').AsInteger = 1 then
//                  begin
//                     if aZusWert[iCount] <> '' then
//                     begin
//                        lDateFormat := CheckDateFormat(aZusWert[iCount]);
//                         aZusWert[iCount] :=
//                            'str_to_date(' + #39 + aZusWert[iCount] + #39 +
//                            ',' + #39 + lDateFormat + #39 + ')';
//
//                     end
//                     else
//                     begin
//                           aZusWert[iCount] := 'NULL';
//                     end;
//                  end
//                  else
//                  begin
//                     //for number we check for , and 2 last number if so convert to .
//                     if ((FieldByName('Typ').AsInteger = 6) or
//                        (FieldByName('Typ').AsInteger = 7) or
//                        (FieldByName('Typ').AsInteger = 8)) then
//                     begin
//                        svalue := ParseSemicolonUseBackslash(aZusWert[iCount]);
//                        if Pos(',',svalue) > 0 then
//                        begin
//                           if (TryStrToInt(svalue, lit)) or (TryStrToFloat(svalue, lfloat)) then
//                           begin
//                              svalue:= StringReplace(svalue,',','.', [rfReplaceAll]);
//
//                           end;
//                        end;
//                        aZusWert[iCount] := #39 + ParseSemicolonUseBackslash(svalue) + #39;
//                     end
//                     else
//                     begin
//                        aZusWert[iCount] := #39 + ParserMySQLString(aZusWert[iCount]) + #39;
//                     end;
//                  end;
//               end;
//            end;
//         end;
//      end;

    sSQLCMD := sSQLCMD + lsjunk + 'modified_userid' + lsjunk + 'pagecount';
    lsjunk := ',';

    lsjunk := ' ';
    sSQLCMD := sSQLCMD + ') Values (' + inttostr(iArcID) + ',';

    sSQLCMD := sSQLCMD + lsjunk + Inttostr(iDocUser);
    lsjunk := ',';

    if sDocTitel <> '' then
    begin
      if ((sDocTitel = 'Dokument') or (sDocTitel = 'Document')) and (sDefDocname <> '') then
        sSQLCMD := sSQLCMD + lsjunk + #39 + sDefDocname + #39
      else
        sSQLCMD := sSQLCMD + lsjunk + #39 + ParseSQLString(sDocTitel) + #39;
      lsjunk := ',';
    end;
    if sDocOrg <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + #39 + sDocOrg + #39;
      lsjunk := ',';
    end;
    if sDocKopie <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + #39 + sDocKopie + #39;
      lsjunk := ',';
    end;
    if sDocQuelle <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + #39 + sDocQuelle + #39;
      lsjunk := ',';
    end;

    if sDocDate <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + #39 + sDocDate + #39;
      lsjunk := ',';
    end
    else
    begin
      sSQLCMD := sSQLCMD + lsjunk + ' now() ';
      lsjunk := ',';
    end;
//      if sDocVtx <> '' then
//      begin
//         sSQLCMD := sSQLCMD + lsjunk + ':doctxt';
//         lsjunk := ',';
//      end;

//      if sDocOCR <> '' then
//      begin
//         sSQLCMD := sSQLCMD + lsjunk + sDocOCR;
//         lsjunk := ',';
//      end;

    if sFiletype <> '' then
    begin
      if Length(sFiletype) > 15 then
        sFiletype := LeftStr(sFiletype,15);
      sSQLCMD := sSQLCMD + lsjunk + #39 + sFiletype + #39;
      lsjunk := ',';
    end;

    if sSha1 <> '' then
    begin
      sSQLCMD := sSQLCMD + lsjunk + #39 + sSha1 + #39;
      lsjunk := ',';
    end;
//      if iFieldCount > 0 then
//         for iCount := 1 to iFieldCount do
//         begin
//
//            if trim(aZusWert[iCount]) <> '' then
//            begin
//               sSQLCMD := sSQLCMD + ', ' + aZusWert[iCount];
//		 //          sSQLCMD := sSQLCMD + ', ' + StringReplace(aZusWert[iCount],#39,#39+'/',[rfReplaceAll]); //08.07.2011 b.takacs 3.5.1.1
//            	//CreateLinkByAddfield(aZusFeld[iCount], aZusWert[iCount]);
//            end;
//         end;

    sSQLCMD := sSQLCMD + lsjunk + Inttostr(iDocUser) + lsjunk + Inttostr(iPages);
    lsjunk := ',';

    sSQLCMD := sSQLCMD + ')';
    dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
      //only now is the query ready to set the parameter doctxt if sDoctxt isnt empty

    try
      dm_DBImp.my_Cmd.Prepare;
//         WriteCmd(sSQLCMD);
      dm_DBImp.my_Cmd.Execute;
    except
      on e: exception do
      begin
        WriteCMD('Fehler: Beim Einfgen in die Archiv tabelle! ' + e.Message);
        WriteCMD('Fehler: SQL-Command! ' + dm_DBImp.my_Cmd.SQL.Text);
      end;
    end;
    iDocid := dm_DBImp.my_Cmd.LastInsertId;

//      for iCount := 1 to iFieldCount do
//      begin
//         if trim(aZusWert[iCount]) <> '' then
//         begin
//            with dm_DBImp.my_q_Tmp do
//            begin
//               SQL.Text := 'Select * from sys_addfields where fieldname = ' +
//                  #39 + ParseSemicolonUseBackslash(aZusFeld[iCount]) + #39;
//               try
//                  Open;
//                  First;
//               except
//                  on e: exception do
//                  begin
//                     WriteCmd('Fehler bei InsertSQL: ' + e.Message);
//                  end;
//               end;
//               //set datefield as database allow
//					    if (FieldByName('options').AsInteger and 2) = 2 then
//               	CreateLinkByAddfield(aZusFeld[iCount], aZusWert[iCount]);
//            end;
//         end;
//      end;

      // Zusatzfelder updaten
    if iFieldCount > 0 then
    begin
      lsItems := TStringList.Create;
      lsItems.Delimiter := ';';
      lsItems.StrictDelimiter := True;
      values := TStringList.Create;

      InsertGridFieldValues;

      bnulldate := True;
      for iCount := 1 to High(aZusWert) do
      begin
        indextableid := '0';
        sSQLCMD := '';
        if trim(aZusWert[iCount]) <> '' then
        begin
          with dm_DBImp.my_q_Tmp do
          begin
            sql.Text := 'Select * from sys_addfields where fieldname = ' + #39 + aZusFeld[iCount] + #39;
            Open;
            First;
            indextableid := FieldByName('indextableid').AsString;
            if FieldByName('type').AsInteger in [1, 12] then
            begin
              aZusWert[iCount] := Trim(ParseGridfields(aZusWert[iCount]));
              if (aZusWert[iCount] <> '') and (aZusWert[iCount] <> '#delete#') then
              begin
                sDate := aZusWert[iCount];
                if Length(sDate) > 10 then
                  sDate := LeftStr(sDate, 10);
                lDateFormat := CheckDateFormat(sDate, sysDateformat);
                aZusWert[iCount] := 'str_to_date(' + #39 + sDate + #39 + ',' + #39 + lDateFormat + #39 + ')';
              end else
              begin
                aZusWert[iCount] := 'NULL';
              end;
            end
            else if FieldByName('type').AsInteger in  [6, 7, 8] then
            begin
              aZusWert[iCount] := Trim(ParseGridfields(aZusWert[iCount]));
              svalue := ParseSemicolonUseBackslash(aZusWert[iCount]);
              if Pos(',', svalue) > 0 then
              begin
                if (TryStrToInt(svalue, lit)) or (TryStrToFloat(svalue, lfloat)) then
                begin
                  svalue := StringReplace(svalue, ',', '.', [rfReplaceAll]);

                end;
              end;

              if (aZusWert[iCount] = '#delete#') or (aZusWert[iCount] = '') then
                aZusWert[iCount] := 'NULL'
              else
                aZusWert[iCount] := #39 + ParseSemicolonUseBackslash(svalue) + #39;
            end
            else if ((FieldByName('type').AsInteger in [2, 3, 11]) and ((FieldByName('options').AsInteger and 8) = 8)) then    //strict Feld? Wert nur bernehmen, wenn in der Auswahl vorhanden
            begin
              aZusWert[iCount] := Trim(ParseGridfields(aZusWert[iCount]));
              lsItems.Clear;
              lsItems.DelimitedText := FieldByName('items').AsWideString;

              values.Clear;
              if FieldByName('type').AsInteger in [2, 11] then   // Auswahlfeld
              begin
                aZusWert[iCount] := LeftStr(aZusWert[iCount], 255);
                values.Add(aZusWert[iCount]);
              end else                                          // Mehrfachauswahl
              begin
                aZusWert[iCount] := LeftStr(aZusWert[iCount], 1024);
                values.Delimiter := ';';
                values.StrictDelimiter := True;
                values.DelimitedText := aZusWert[iCount];
              end;
              aZusWert[iCount] := '';

              for i := 0 to values.Count - 1 do
              begin
                if lsItems.IndexOf(ParserMySQLString(values[i])) > -1 then
                begin
                  if aZusWert[iCount] = '' then
                    aZusWert[iCount] := ParserMySQLString(values[i])
                  else
                    aZusWert[iCount] := aZusWert[iCount] + ';' + ParserMySQLString(values[i]);
                end;
              end;

              if (aZusWert[iCount] = '#delete#') or (aZusWert[iCount] = '') then
                aZusWert[iCount] := 'NULL'
              else begin
                //  f.schneider Ticket 22826
                if FieldByName('type').AsInteger in [0, 2, 11] then
                  aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 255)) + #39
                else if FieldByName('type').AsInteger in [4, 5] then
                  aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 12)) + #39
                else
                  aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 1024)) + #39;
              end;
            end
            else
            begin
              if FieldByName('type').AsInteger = 14 then    // Gridspalte
              begin
                aZusWert[iCount] := Trim(ParseGridfields(aZusWert[iCount]));
                aZusWert[iCount] := LeftStr(aZusWert[iCount], 4096);
              end else
              begin
                aZusWert[iCount] := Trim(ParseAddfields(aZusWert[iCount]));
                aZusWert[iCount] := LeftStr(aZusWert[iCount], 255);
              end;

              if aZusWert[iCount] = '#delete#' then
                aZusWert[iCount] := 'NULL'
              else begin
                //  f.schneider Ticket 22826
                if FieldByName('type').AsInteger in [0, 2, 11] then
                  aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 255)) + #39
                else if FieldByName('type').AsInteger in [4, 5] then
                  aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 12)) + #39
                else
                  aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 1024)) + #39;
              end;
            end;

            if (FieldByName('options').AsInteger and 2) = 2 then
            begin
              if FieldByName('type').AsInteger in [1, 12] then
                CreateLinkByAddfield(aZusFeld[iCount], sDate)
              else
                CreateLinkByAddfield(aZusFeld[iCount], Copy(aZusWert[iCount], 2, length(aZusWert[iCount]) - 2));
            end;
            if ((FieldByName('type').AsInteger in [2, 3, 11]) and ((FieldByName('options').AsInteger and 8) = 0)) then
              AddValueToSelection(aZusFeld[iCount], Copy(aZusWert[iCount], 2, length(aZusWert[iCount]) - 2), FieldByName('type').AsInteger);
          end;
          sSQLCMD := sSQLCMD + aZusFeld[iCount] + ' = ' + aZusWert[iCount];
          if fieldtxt = '' then
            fieldtxt := Copy(aZusWert[iCount], 2, length(aZusWert[iCount]) - 2)
          else
            fieldtxt := fieldtxt + #13#10 + Copy(aZusWert[iCount], 2, length(aZusWert[iCount]) - 2);
          dm_DBImp.my_Cmd.SQL.Text := Format('insert into sys_docidx_%s set %s, gdocid = %s' + ' on duplicate key update %s', [indextableid, sSQLCMD, IntToStr(iDocid), sSQLCMD]);
          try
            dm_DBImp.my_Cmd.Execute;
          except
            on e: Exception do
            begin
              WriteCmd(Format('Fehler beim Insert von %s: ', [sSQLCMD]) + e.Message)
            end;
          end;
        end;
      end;
    end;
  except
    on e: exception do
    begin
      WriteCMD('Error in Insertsql: ' + e.message);
      WriteCMD('SQL Befehl: ' + dm_DBImp.my_Cmd.SQL.Text);
      Result := false;
    end;
  end;

  try
       // jetzt statusfelder updaten
    sSQLCMD := '';
    lsjunk := '';
    if sDocstate <> '' then
    begin
      SetDocState(sDocState, iArcID);

//        lstDocState := TStringList.Create;
//        lstDocState.Delimiter := ';';
//        lstDocState.DelimitedText := sDocstate;
//
//        for i := 0 to lstDocState.Count -1 do
//        begin
//          bStatus36 := False;
//          sDocstate := lstDocState[i];
//          indexcolumnid := '0';
//          if Pos(':', sDocstate) > 0 then
//          begin
//            indexcolumnid := LeftStr(sDocstate, Pos(':', sDocstate) -1);
//            sDocstate := RightStr(sDocstate, Length(sDocstate) - Pos(':', sDocstate));
//            bStatus36 := True;
//          end;
//
//          if sDocState <> '' then
//          begin
//             if Pos('+', sDocState) = 1 then
//             begin  // Bits setzten: ([alterWert] or [zuSetztendeBits])
//                state := Copy(sDocState, 2, Length(sDocState));
//                if not bStatus36 then
//                  sSQLCMD := sSQLCMD + lsjunk + RelativeState(indexcolumnid, state, iArcid, '|')
//                else
//                  sSQLCMD := sSQLCMD + lsjunk + 'docstate_' + indexcolumnid +' = (docstate_' + indexcolumnid +' | ' + state  + ')';
//                TryStrToInt(state, iNewStatus);
//             end
//             else
//             if Pos('-', sDocState) = 1 then
//             begin // Bits lschen: ([AlterWert] or [zuLschendeBits]) xor [zuLschendeBits]
//                state := Copy(sDocState, 2, Length(sDocState));
//                if not bStatus36 then
//                  sSQLCMD := sSQLCMD + lsjunk + RelativeState(indexcolumnid, state, iArcid, '& ~')
//                else
//                  sSQLCMD := sSQLCMD + lsjunk + 'docstate_' + indexcolumnid +' = (docstate_' + indexcolumnid +' & ~ ' + state + ') ' ;
//                TryStrToInt(state, iNewStatus);
//             end
//             else
//             if Pos('#', sDocState) = 1 then
//             begin // Bits ersetzen:
//                state := Copy(sDocState, 2, Length(sDocState));
//                if not bStatus36 then
//                  sSQLCMD := sSQLCMD + lsjunk + RelativeState(indexcolumnid, state, iArcid, '=')
//                else
//                  sSQLCMD := sSQLCMD + lsjunk + ' docstate_' + indexcolumnid +' = ' + state;
//                TryStrToInt(state, iNewStatus);
//                bNewStatusIsAbsolute := True;
//             end
//             else
//             begin
//                try
//                   iNewStatus := strtoint(sDocState);
//                   if not bStatus36 then
//                     sSQLCMD := sSQLCMD + lsjunk + RelativeState(indexcolumnid, sDocState, iArcid, '=')
//                   else
//                     sSQLCMD := sSQLCMD + lsjunk + 'docstate_' + indexcolumnid +' = ' + sDocState;
//                   bNewStatusIsAbsolute := True;
//                except
//                   on e: Exception do
//                   begin
//                      sSQLCMD := sSQLCMD + lsjunk + ' 0';
//
//                   end;
//                end;
//             end;
//             lsjunk := ',';
//          end;
//        end;
//
//        sSQLCMD := 'update sys_doc set '+ sSQLCMD + ' where gdocid = ' + IntToStr(iDocID);
//
//         dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
//         try
//            dm_DBImp.my_Cmd.Execute;
//         except on e: exception do
//            begin
//               WriteCMD('Fehler: Beim Schreiben des Status des Dokuments ' + e.Message);
//            end;
//         end;
    end;

    if sDocVtx <> '' then
    begin
      vtx := trim_vtx_for_mysql(sVtxFile.Text);
//         dm_DBImp.my_Cmd.ParamByName('doctxt').AsString := vtx;
    end;

    if sSlwFile.Count > 0 then
    begin
      for iCount := 0 to (sSlwFile.Count - 1) do
        if sSlwFile.Strings[iCount] <> '' then
          if doctags = '' then
            doctags := ParseSemicolonUseBackslash(sSlwFile.Strings[iCount])
          else
            doctags := doctags + #10 + ParseSemicolonUseBackslash(sSlwFile.Strings[iCount]);
    end;

    if sDocKopie <> '' then
      annopath := sDocKopie
    else
      annopath := ReplaceStr(Lowercase(sDocOrg), Lowercase(archive_rs), Lowercase(archive_nrs));

    sFiles := TStringList.Create;
    try
      img := TImageEnVect.Create(nil);
      img.Visible := False;
    except
      on e: exception do
      begin
        WriteCmd('Fehler beim Erstellen der grafischen Komponente zum Lesen von Annotations: ' + e.Message);
        Exit;
      end;
    end;

    try
      annopath := ReplaceStr(annopath, '\\', '\');
      sDocKopieENV := ExpandEnvStrings(annopath);
      FindAllFiles(TStrings(sFiles), ExtractFilePath(sDocKopieENV), '*.iev', False);
      fname := ChangeFileExt(ExtractFileName(sDocKopieENV), '');
      for i := 0 to (sFiles.Count - 1) do
      begin
      if LowerCase(LeftStr(fname, Length(fname))) = LowerCase(LeftStr(ExtractFileName(sFiles[i]), Length(fname))) then
        begin
          page := 0;
          layer := 0;
          fpart := ChangeFileExt(ExtractFileName(sFiles[i]), '');
          fpart := RightStr(fpart, Length(fpart) - Length(fname));
          if fpart = '' then
            Continue;
//              page := StrToInt(fpart);
          fpart := StringReplace(fpart, '_', '', [rfReplaceAll]);
          if TryStrToInt(fpart, page) then
          begin
            try
              img.RemoveAllObjects;
              img.LoadFromFileIEV(sFiles[i]);

              WriteCMD('img.ObjectsCount: ' + IntToStr(img.ObjectsCount));
              for j := 0 to img.ObjectsCount - 1 do
              begin
                if img.ObjText[j] <> '' then
                begin
                  if annotxt = '' then
                    annotxt := ParseSQLString(img.ObjText[j])
                  else
                    annotxt := annotxt + #13#10 + ParseSQLString(img.ObjText[j])
                end;
              end;
              WriteCMD('annotxt: ' + annotxt);
            except
              on e: exception do
              begin
                WriteCMD('Fehler: Beim Lesen einer Annotation: ' + e.Message);
                Continue;
              end;
            end;

            dm_DBImp.my_Cmd.SQL.Text := 'insert into sys_annotations (gdocid, layer, page, iev) values (:gdocid, 0, :page, :iev)';
            dm_DBImp.my_Cmd.ParamByName('gdocid').AsInteger := iDocid;
            dm_DBImp.my_Cmd.ParamByName('page').AsInteger := page;
            dm_DBImp.my_Cmd.ParamByName('iev').LoadFromFile(sFiles[i], ftBlob);
            try
              dm_DBImp.my_Cmd.Execute;
            except
              on e: exception do
              begin
                WriteCMD('Fehler: Beim Einfgen in die Annotation-Tabelle! ' + e.Message);
              end;
            end;
            WriteCmd('Annotation eingefgt, Seite:' + IntToStr(page));
          end;
        end;
      end;
    finally
      FreeAndNil(sFiles);
      img.RemoveAllObjects;
      img.Free;
    end;

    if (vtx <> '') or (doctags <> '') or (fieldtxt <> '') or (annotxt <> '') then
    begin
//        sSQLCMD := 'Insert into sys_doctxt (gdocid, doctxt, doctags, annotxt) Values (' + IntToStr(iDocID) + ', ' + #39 +
//                 vtx + #39 + ', ' +#39 + doctags + #39+ ', ' +#39 + annotxt + #39 +') on duplicate key update doctxt = ' + #39 +
//                 vtx + #39 + ', doctags = ' +#39 + doctags + #39+ ', annotxt = ' +#39 + annotxt + #39;
//         dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;

//30.10.2018 Ticket 16612       sSQLCMD := 'insert into sys_doctxt set doctxt = :vtx, doctags = :tags, fieldtxt = :field, annotxt = :anno, gdocid = :gdocid ' +


      sSQLCMD := 'update sys_doc set doctxt = :vtx, doctags = :tags, fieldtxt = :field, annotxt = :anno where gdocid = :gdocid';
      dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
      dm_DBImp.my_Cmd.ParamByName('vtx').DataType := ftString;
      dm_DBImp.my_Cmd.ParamByName('tags').DataType := ftString;
      dm_DBImp.my_Cmd.ParamByName('field').DataType := ftString;
      dm_DBImp.my_Cmd.ParamByName('anno').DataType := ftString;
      if vtx = '' then
        dm_DBImp.my_Cmd.ParamByName('vtx').Clear
      else
        dm_DBImp.my_Cmd.ParamByName('vtx').AsString := vtx;
      if doctags = '' then
        dm_DBImp.my_Cmd.ParamByName('tags').Clear
      else
        dm_DBImp.my_Cmd.ParamByName('tags').AsString := doctags;
      if fieldtxt = '' then
        dm_DBImp.my_Cmd.ParamByName('field').Clear
      else
        dm_DBImp.my_Cmd.ParamByName('field').AsString := fieldtxt;
      if annotxt = '' then
        dm_DBImp.my_Cmd.ParamByName('anno').Clear
      else
        dm_DBImp.my_Cmd.ParamByName('anno').AsString := annotxt;
      dm_DBImp.my_Cmd.ParamByName('gdocid').AsString := IntToStr(iDocid);

      try
        //            WriteCmd(sSQLCMD);
        dm_DBImp.my_Cmd.Execute;
      except
        on e: exception do
        begin
          WriteCMD('Fehler: Beim Einfgen in die Volltext-Tabelle! ' + e.Message);
        end;
      end;
    end;

    if sSAPDocid <> '' then
    begin
      if sDocQuelle <> '' then
        sPath := sDocQuelle
      else
        sPath := sDocOrg;
      if LowerCase(RightStr(sPath, 3)) = 'tif' then
        sContType := 'image/tiff';
      if LowerCase(RightStr(sPath, 3)) = 'pdf' then
        sContType := 'application/pdf';

         // Header schreiben
      dm_DBImp.my_Cmd.SQL.Text := 'insert into sys_sap (gdocid, contrep, docid, compid, docprot, docstatus, tstampc, tstampm) ' + 'Values(' + IntToStr(iDocid) + ',' + #39 + sContRep + #39 + ',' + #39 + sSAPDocid + #39 + ',' + #39 + 'header' + #39 + ',' + #39 + sDocProt + #39 + ',' + #39 + 'online' + #39 + ',' + #39 + sCompDateC + #39 + ',' + #39 + sCompDateC + #39 + ')';
      try
        dm_DBImp.my_Cmd.Execute;
      except
        on e: exception do
        begin
          WriteCmd('Fehler bei InsertSQL (Insert into Sys_SAP): ' + e.Message);
        end;
      end;

         // Data schreiben
      dm_DBImp.my_Cmd.SQL.Text := 'insert into sys_sap (gdocid, contrep, docid, compid, docprot, docstatus, tstampc, tstampm, content_path, content_type) ' + 'Values(' + IntToStr(iDocid) + ',' + #39 + sContRep + #39 + ',' + #39 + sSAPDocid + #39 + ',' + #39 + 'data' + #39 + ',' + #39 + sDocProt + #39 + ',' + #39 + 'online' + #39 + ',' + #39 + sCompDateC + #39 + ',' + #39 + sCompDateC + #39 + ',' + #39 + sPath + #39 + ',' + #39 + sContType + #39 + ')';
      try
        dm_DBImp.my_Cmd.Execute;
      except
        on e: exception do
        begin
          WriteCmd('Fehler bei InsertSQL (Insert into Sys_SAP): ' + e.Message);
        end;
      end;
      gTaskid := 19;
      WriteHistory;
    end;

    if sDocStateText <> '' then
    begin
      gTaskid := 4;
      WriteHistory;
    end;

    gTaskid := 8;
    sDocStateText := sGArcName;
    WriteHistory;
    sDocStateText := '';

    if iRefCount > 0 then
      for iCount := 1 to iRefCount do
        InsertLink(iDocid, aDocRef[iCount]);

    if sTermin <> '' then
      InsertTask;

    SetAddFieldsByState;

    result := true;

  except
    on e: exception do
    begin
      WriteCmd('Allgemeiner Fehler: ' + e.Message);
    end;
  end;
  if Assigned(lsItems) then
    FreeAndNil(lsItems);
  if Assigned(values) then
    FreeAndNil(values);
end;

function ConnectDB: boolean;
var
  bfaServer: string;
  bfaServerPort: Integer;
  bfaServerNoSSL: Integer;
  gpl: Boolean;
  key : string;
begin
   // Auslesen der Connection
  con := TIniFile.Create(sProfil);
  Result := True;
  bfaServerNoSSL := 0;
  gpl := False;
  try
    try
      with con do
      begin
        dm_DBImp.my_Con.ProviderName := 'MySQL';
        sUser := ReadString('Connection', 'User', '');
        sPass := ReadString('Connection', 'Pass', '');
        bfaServer := ReadString('Server', 'server', 'localhost');
        bfaServerPort := ReadInteger('Server', 'port', 50001);
        bfaServerNoSSL := ((LowerCase(ReadString(sSysServerSection, sSysNoSSL, 'false')) = 'true') or (ReadString(sSysServerSection, sSysNoSSL, 'false') = '1')).ToInteger;
        archive_rs := ReadString('Scripts', 'archive_rs','');
        archive_nrs := ReadString('Scripts', 'archive_nrs','');
        gpl := LowerCase(ReadString(sSysServerSection, 'edition', 'enterprise')) = 'gpl';

        if gpl then
          key := 'b17fa300900b421333de672c41a00d'
        else
          key := GlobalKey;

        with dm_DBImp.my_Con do
        begin
          Username := Decrypt(sUser, key);
          Password := Decrypt(sPass, key);
          Server := ReadString('Connection', 'Server', '');
          Port := ReadInteger('Connection', 'Port', 3306);
          Database := ReadString('Connection', 'DB', '');
          WriteCMD('Connection to Server ' + Server + ' with DB ' + Database);
          Connect; // Anmelden an der Datenbank
          if not Connected then // Wenn keine Verbindung dann Tool verlassen
          begin
            ExitCode := 2;  //keine Connection zur Datenbank mglich
            WriteCMD('Fehler: Keine Verbindung zur Datenbank!');
            Result := False;
            exit;
          end;
        end;

        MainSocket := TBaseSocketConnection.Create(bfaServerNoSSL, bfaServer, bfaServerPort, '');

        MainSocket.CreateComponents;
        MainSocket.ServerReadTimeout := 10000; //10 Sekunden bei der Anmeldung

      end;
    except
      on e: Exception do
      begin
        ExitCode := 4;   // Fehler beim Auslesen der .CON Datei
        WriteCMD('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
        Result := False;
        exit;
      end;
    end;
  finally
    if Assigned(con) then
      FreeAndNil(con);
  end;
end;


//change values in the sql database
function UpdateSQL: boolean;
var
  iCount, litmp, lit, i: integer;
  lfloat: Double;
  lcur: Currency;
  sIArcID, sIDocID, svalue, lsjunk, sPath, sContType, sDate, indextableid, indexcolumnid, state: string;
  bnulldate, binresub: boolean;
  vtx, doctags, fieldtxt: WideString;
  lDateFormat: string;
  lstDocState, lsItems, values, tags: TStringList;
begin
  result := false;
  iCount := Pos('.', sDocID);
  sIArcID := copy(sDocID, 1, iCount - 1);
  sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
  iArcID := StrToInt(sIArcID);
  iDocid := StrToInt64(sIDocID);
  vtx := '';
  doctags := '';
  fieldtxt := '';
  tags := TStringList.Create;
  tags.Delimiter := #10;
  tags.StrictDelimiter := True;

  if sDocStateText <> '' then
  begin
    gTaskid := 4;
    WriteHistory;
  end;

  if iDocid <> 0 then
  begin
    try
      with dm_DBImp.my_q_Tmp do
      begin
        sql.Text := 'Select * from sys_arc where arcid = ' + sIArcID;
        Open;
        First;
        sGArcName := FieldByName('arcname').AsString;
        sGTblName := FieldByName('tblname').AsString;
        sDefDocname := FieldByName('defdocname').AsString;

        if (FieldByName('options').AsInteger and 2) = 2 then
        begin
          sDefDocname := sGArcName;
          sSlwFile.Add(sGArcName);  //22.01.2019 Ticket 17627
        end;

        // Time_id des Dokumentes holen
        sql.Text := 'Select * from sys_timer where gdocid = ' + sIDocID;
        Open;
        First;
        sIWvlID := FieldByName('timref').AsString;

        if sIWvlID <> '' then
          iWvlID := StrToInt(sIWvlID)
        else
          iWvlID := 0;

        Close;

        sql.Text := 'Select * from sys_doc where gdocid = ' + sIDocID;
        Open;
        First;

        ioldStatus := FieldByName('docstate_0').AsLargeInt;
        tags.DelimitedText := FieldByName('doctags').AsString;
        for i := 0 to sSlwFile.Count -1 do
          if (sSlwFile.Strings[i] <> '') and (tags.IndexOf(ParseSemicolonUseBackslash(sSlwFile.Strings[i])) = -1) then
            tags.Add(ParseSemicolonUseBackslash(sSlwFile.Strings[i]));
      end;

      sSQLCMD := 'Update sys_doc Set ';
      if sDocTitel <> '' then
      begin
        if ((sDocTitel = 'Dokument') or (sDocTitel = 'Document')) and (sDefDocname <> '') then
          sSQLCMD := sSQLCMD + 'docname = ' + #39 + sDefDocname + #39 + ','
        else
          sSQLCMD := sSQLCMD + 'docname = ' + #39 + ParseSQLString(sDocTitel) + #39 + ',';
      end;

      if sDocOrg <> '' then
        sSQLCMD := sSQLCMD + 'docloc = ' + #39 + sDocOrg + #39 + ',';
      if sDocKopie <> '' then
        sSQLCMD := sSQLCMD + 'extloc = ' + #39 + sDocKopie + #39 + ',';
      if sDocQuelle <> '' then
        sSQLCMD := sSQLCMD + 'oriloc = ' + #39 + sDocQuelle + #39 + ',';
      if sDocUsr <> '' then
        sSQLCMD := sSQLCMD + 'userid = ' + inttostr(iDocUser) + ',';
      if sDocDate <> '' then
        sSQLCMD := sSQLCMD + 'docdate = ' + #39 + sDocDate + #39 + ',';
      if sFiletype <> '' then
      begin
        if Length(sFiletype) > 15 then
          sFiletype := LeftStr(sFiletype,15);
        sSQLCMD := sSQLCMD + 'filetype = ' + #39 + sFiletype + #39 + ',';
      end;
      if sSha1 <> '' then
        sSQLCMD := sSQLCMD + 'sha1 = ' + #39 + sSha1 + #39 + ',';

      sSQLCMD := sSQLCMD + 'modified_userid = ' + inttostr(iDocUser) + ',' + 'pagecount = ' + inttostr(iPages) + ',';

      dm_DBImp.my_q_tmp7.SQL.Text := 'select * from sys_timer where gdocid = ' + IntToStr(iDocid) + ' and status & 4 = 0';
      dm_DBImp.my_q_tmp7.Execute;
      binresub := dm_DBImp.my_q_tmp7.RecordCount > 0;

      if RightStr(sSQLCMD, 1) = ',' then
        sSQLCMD := LeftStr(sSQLCMD, Length(sSQLCMD) - 1);

      sSQLCMD := sSQLCMD + ' where gdocid = ' + sIDocID;
      dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;

      dm_DBImp.my_Cmd.Execute;

      if sDocState <> '' then
        SetDocState(sDocState, iArcID);

      if sDocVtx <> '' then
      begin
        vtx := trim_vtx_for_mysql(sVtxFile.Text);
      end;

      if tags.Count > 0 then
      begin
        doctags := tags.DelimitedText;
      end;

      if iFieldCount > 0 then
      begin
        lsItems := TStringList.Create;
        lsItems.Delimiter := ';';
        lsItems.StrictDelimiter := True;
        values := TStringList.Create;

        InsertGridFieldValues;

        bnulldate := True;
        for iCount := 1 to High(aZusWert) do
        begin
          indextableid := '0';
          sSQLCMD := '';
          if trim(aZusWert[iCount]) <> '' then
          begin
            with dm_DBImp.my_q_Tmp do
            begin
              sql.Text := 'Select * from sys_addfields where fieldname = ' + #39 + aZusFeld[iCount] + #39;
              Open;
              First;
              indextableid := FieldByName('indextableid').AsString;
              if FieldByName('type').AsInteger in [1, 12] then
              begin
                aZusWert[iCount] := Trim(ParseAddfields(aZusWert[iCount]));
                if (aZusWert[iCount] <> '') and (aZusWert[iCount] <> '#delete#') then
                begin
                  sDate := aZusWert[iCount];
                  if Length(sDate) > 10 then
                    sDate := LeftStr(sDate, 10);
                  lDateFormat := CheckDateFormat(sDate, sysDateformat);
                  aZusWert[iCount] := 'str_to_date(' + #39 + sDate + #39 + ',' + #39 + lDateFormat + #39 + ')';
                end else
                begin
                  aZusWert[iCount] := 'NULL';
                end;
              end
              else if FieldByName('type').AsInteger in [6, 7, 8] then
              begin
                aZusWert[iCount] := Trim(ParseAddfields(aZusWert[iCount]));
                svalue := ParseSemicolonUseBackslash(aZusWert[iCount]);
                if Pos(',', svalue) > 0 then
                begin
                  if (TryStrToInt(svalue, lit)) or (TryStrToFloat(svalue, lfloat)) then
                  begin
                    svalue := StringReplace(svalue, ',', '.', [rfReplaceAll]);
                  end;
                end;

                if (aZusWert[iCount] = '#delete#') or (aZusWert[iCount] = '') then
                  aZusWert[iCount] := 'NULL'
                else
                  aZusWert[iCount] := #39 + ParseSemicolonUseBackslash(svalue) + #39;
              end
              else if ((FieldByName('type').AsInteger in [2, 3, 11]) and ((FieldByName('options').AsInteger and 8) = 8)) then    //strict Feld? Wert nur bernehmen, wenn in der Auswahl vorhanden
              begin
                aZusWert[iCount] := Trim(ParseAddfields(aZusWert[iCount]));
                lsItems.Clear;
                lsItems.DelimitedText := FieldByName('items').AsWideString;

                values.Clear;
                if FieldByName('type').AsInteger in [2, 11] then   // Auswahl
                begin
                  aZusWert[iCount] := LeftStr(aZusWert[iCount], 255);
                  values.Add(aZusWert[iCount]);
                end else                                           // Mehrfachauswahl
                begin
                  aZusWert[iCount] := LeftStr(aZusWert[iCount], 1024);
                  values.Delimiter := ';';
                  values.StrictDelimiter := True;
                  values.DelimitedText := aZusWert[iCount];
                end;
                aZusWert[iCount] := '';

                for i := 0 to values.Count - 1 do
                begin
                  if lsItems.IndexOf(ParserMySQLString(values[i])) > -1 then
                  begin
                    if aZusWert[iCount] = '' then
                      aZusWert[iCount] := ParserMySQLString(values[i])
                    else
                      aZusWert[iCount] := aZusWert[iCount] + ';' + ParserMySQLString(values[i]);
                  end;
                end;

                if (aZusWert[iCount] = '#delete#') or (aZusWert[iCount] = '') then
                  aZusWert[iCount] := 'NULL'
                else begin
                  //  f.schneider Ticket 22826
                  if FieldByName('type').AsInteger in [0, 2, 11] then
                    aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 255)) + #39
                  else if FieldByName('type').AsInteger in [4, 5] then
                    aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 12)) + #39
                  else
                    aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 1024)) + #39;
                end;
              end else
              begin
                if FieldByName('type').AsInteger = 14 then    // Gridspalte
                begin
                  aZusWert[iCount] := Trim(ParseGridfields(aZusWert[iCount]));
                  aZusWert[iCount] := LeftStr(aZusWert[iCount], 4096);
                end else
                begin
                  aZusWert[iCount] := Trim(ParseAddfields(aZusWert[iCount]));
                  aZusWert[iCount] := LeftStr(aZusWert[iCount], 255);
                end;

                if aZusWert[iCount] = '#delete#' then
                  aZusWert[iCount] := 'NULL'
                else begin
                  //  f.schneider Ticket 22826
                  if FieldByName('type').AsInteger in [0, 2, 11] then
                    aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 255)) + #39
                  else if FieldByName('type').AsInteger in [4, 5] then
                    aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 12)) + #39
                  else
                    aZusWert[iCount] := #39 + ParserMySQLString(LeftStr(aZusWert[iCount], 1024)) + #39;
                end;
              end;

              if (FieldByName('options').AsInteger and 2) = 2 then
              begin
                if FieldByName('type').AsInteger in [1, 12] then
                  CreateLinkByAddfield(aZusFeld[iCount], sDate)
                else
                  CreateLinkByAddfield(aZusFeld[iCount], Copy(aZusWert[iCount], 2, length(aZusWert[iCount]) - 2));
              end;

              if ((FieldByName('type').AsInteger in [2, 3, 11]) and ((FieldByName('options').AsInteger and 8) = 0)) then
                AddValueToSelection(aZusFeld[iCount], Copy(aZusWert[iCount], 2, length(aZusWert[iCount]) - 2), FieldByName('type').AsInteger);
            end;
            sSQLCMD := sSQLCMD + aZusFeld[iCount] + ' = ' + aZusWert[iCount];
            if fieldtxt = '' then
              fieldtxt := Copy(aZusWert[iCount], 2, length(aZusWert[iCount]) - 2)
            else
              fieldtxt := fieldtxt + #13#10 + Copy(aZusWert[iCount], 2, length(aZusWert[iCount]) - 2);
             //dm_DBImp.my_Cmd.SQL.Text := Format('Update sys_docidx_%s set %s where gdocid = %d', [indextableid, sSQLCMD, iDocID]);
            dm_DBImp.my_Cmd.SQL.Text := Format('insert into sys_docidx_%s set %s, gdocid = %s' + ' on duplicate key update %s', [indextableid, sSQLCMD, IntToStr(iDocid), sSQLCMD]);
            try
              dm_DBImp.my_Cmd.Execute;
            except
              on e: Exception do
              begin
                WriteCmd(Format('Fehler beim Update von %s: ', [sSQLCMD]) + e.Message)
              end;
            end;
          end;
        end;
      end;

      if (vtx <> '') then
      begin
//         sSQLCMD := 'update sys_doctxt set doctxt = :vtx, doctags = :tags where gdocid = ' + IntToStr(iDocID);
//30.10.2018 Ticket 16612      sSQLCMD := 'insert into sys_doctxt set doctxt = :vtx, gdocid = :gdocid ' +
        sSQLCMD := 'update sys_doc set doctxt = :vtx where gdocid = :gdocid';
        dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
        dm_DBImp.my_Cmd.ParamByName('vtx').AsString := vtx;
        dm_DBImp.my_Cmd.ParamByName('gdocid').AsString := IntToStr(iDocid);

        try
          dm_DBImp.my_Cmd.Execute;
        except
          on e: Exception do
          begin
            WriteCMD('Fehler: Beim Update in der Volltext-Tabelle! (Volltext)' + e.Message);
          end;
        end;
      end;

      if (doctags <> '') then
      begin
//         sSQLCMD := 'update sys_doctxt set doctxt = :vtx, doctags = :tags where gdocid = ' + IntToStr(iDocID);
//30.10.2018 Ticket 16612        sSQLCMD := 'insert into sys_doctxt set doctags = :tags, gdocid = :gdocid ' +
//         sSQLCMD := 'insert into sys_doc set doctags = :tags, gdocid = :gdocid, userid = :userid ' +
//                    'on duplicate key update doctags = :tags';
        sSQLCMD := 'update sys_doc set doctags = :tags where gdocid = :gdocid';
        dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
        dm_DBImp.my_Cmd.ParamByName('tags').AsString := doctags;
        dm_DBImp.my_Cmd.ParamByName('gdocid').AsString := IntToStr(iDocid);
//         dm_DBImp.my_Cmd.ParamByName('userid').AsString := IntToStr(iDocUser);
        try
          dm_DBImp.my_Cmd.Execute;
        except
          on e: Exception do
          begin
            WriteCMD('Fehler: Beim Update in der Volltext-Tabelle! (Schlagworte)' + e.Message);
          end;
        end;
      end;

      if (fieldtxt <> '') then
      begin
//         sSQLCMD := 'update sys_doctxt set doctxt = :vtx, doctags = :tags where gdocid = ' + IntToStr(iDocID);
//30.10.2018 Ticket 16612         sSQLCMD := 'insert into sys_doctxt set fieldtxt = :field, gdocid = :gdocid ' +
//         sSQLCMD := 'insert into sys_doc set fieldtxt = :field, gdocid = :gdocid, userid = :userid  ' +
//                    'on duplicate key update fieldtxt = :field';
        sSQLCMD := 'update sys_doc set fieldtxt = :field where gdocid = :gdocid';
        dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
        dm_DBImp.my_Cmd.ParamByName('field').AsString := fieldtxt;
        dm_DBImp.my_Cmd.ParamByName('gdocid').AsString := IntToStr(iDocid);
//         dm_DBImp.my_Cmd.ParamByName('userid').AsString := IntToStr(iDocUser);
        try
          dm_DBImp.my_Cmd.Execute;
        except
          on e: Exception do
          begin
            WriteCMD('Fehler: Beim Update in der Volltext-Tabelle! (Zusatzfelder)' + e.Message);
          end;
        end;
      end;

      gTaskid := 20;
      WriteHistory;
      sDocStateText := '';

      sSQLCMD := '';
      lsjunk := '';

      if sSAPDocid <> '' then
      begin
         // erst prfen ob es schon einen Eintrag gibt. Gibt es einen, wird der aktualisiert,
         // gibt es keinen dann legen wir einen neuen an. So kann der Change-Mechanismus ein SAP-Dokument
         // in die sys_sap schreiben (zB ber ein Mainplugin erzeugt)

        dm_DBImp.my_q_Tmp.SQL.Text := 'select * from sys_sap where gdocid = ' + IntToStr(iDocid);
        dm_DBImp.my_q_Tmp.Execute;
        if dm_DBImp.my_q_Tmp.RecordCount = 0 then
        begin
          if sDocQuelle <> '' then
            sPath := sDocQuelle
          else
            sPath := sDocOrg;
          if LowerCase(RightStr(sPath, 3)) = 'tif' then
            sContType := 'image/tiff';
          if LowerCase(RightStr(sPath, 3)) = 'pdf' then
            sContType := 'application/pdf';

             // Header schreiben
          dm_DBImp.my_Cmd.SQL.Text := 'insert into sys_sap (gdocid, contrep, docid, compid, docprot, docstatus, tstampc, tstampm) ' + 'Values(' + IntToStr(iDocid) + ',' + #39 + sContRep + #39 + ',' + #39 + sSAPDocid + #39 + ',' + #39 + 'header' + #39 + ',' + #39 + sDocProt + #39 + ',' + #39 + 'online' + #39 + ',' + #39 + sCompDateC + #39 + ',' + #39 + sCompDateC + #39 + ')';
          try
            dm_DBImp.my_Cmd.Execute;
          except
            on e: exception do
            begin
              WriteCmd('Fehler bei UpdateSQL (Insert into Sys_SAP, Header): ' + e.Message);
            end;
          end;

             // Data schreiben
          dm_DBImp.my_Cmd.SQL.Text := 'insert into sys_sap (gdocid, contrep, docid, compid, docprot, docstatus, tstampc, tstampm, content_path, content_type) ' + 'Values(' + IntToStr(iDocid) + ',' + #39 + sContRep + #39 + ',' + #39 + sSAPDocid + #39 + ',' + #39 + 'data' + #39 + ',' + #39 + sDocProt + #39 + ',' + #39 + 'online' + #39 + ',' + #39 + sCompDateC + #39 + ',' + #39 + sCompDateC + #39 + ',' + #39 + sPath + #39 + ',' + #39 + sContType + #39 + ')';
          try
            dm_DBImp.my_Cmd.Execute;
          except
            on e: exception do
            begin
              WriteCmd('Fehler bei UpdateSQL (Insert into Sys_SAP, Data): ' + e.Message);
            end;
          end;

          gTaskid := 19;
          WriteHistory;
        end else
        begin
          if sDocQuelle <> '' then
            sPath := sDocQuelle
          else
            sPath := sDocOrg;
          if LowerCase(RightStr(sPath, 3)) = 'tif' then
            sContType := 'image/tiff';
          if LowerCase(RightStr(sPath, 3)) = 'pdf' then
            sContType := 'application/pdf';
          DateTimeToString(sDate, 'yyyy-mm-dd hh:nn:ss', Now);
          dm_DBImp.my_Cmd.SQL.Text := 'update sys_sap set contrep = ' + #39 + sContRep + #39 + ', docid = ' + #39 + sSAPDocid + #39 + ', docprot = ' + #39 + sDocProt + #39 + ', tstampm = ' + #39 + sDate + #39 + ' where gdocid = ' + IntToStr(iDocid);

          try
            dm_DBImp.my_Cmd.Execute;
          except
            on e: exception do
            begin
              WriteCmd('Fehler bei UpdateSQL (Update Sys_SAP, Header): ' + e.Message);
            end;
          end;

          dm_DBImp.my_Cmd.SQL.Text := 'update sys_sap set content_path = ' + #39 + sPath + #39 + ' where gdocid = ' + IntToStr(iDocid) + ' and compid = ' + #39 + 'data' + #39;
          try
            dm_DBImp.my_Cmd.Execute;
          except
            on e: exception do
            begin
              WriteCmd('Fehler bei UpdateSQL (Update Sys_SAP, Data): ' + e.Message);
            end;
          end;

          gTaskid := 21;
          WriteHistory;
        end;
      end;

      if iRefCount > 0 then
        for iCount := 1 to iRefCount do
          InsertLink(iDocid, aDocRef[iCount]);

      SetAddFieldsByState;

      result := true;
    except
      on e: exception do
      begin
        WriteCMD('Error in Updatesql ' + e.message);
        result := false;
      end;
    end;
  end else
  begin
    WriteCMD('Fehler: Es kann kein Dokument mit gdocid 0 aktualisiert werden.');
  end;
  if Assigned(lsItems) then
    FreeAndNil(lsItems);
  if Assigned(values) then
    FreeAndNil(values);
  if Assigned(tags) then
    FreeAndNil(tags);

end;

function FileAccessable(FileName: string): boolean;
   //////////////////////////////////////////////////////////////////
   ///  15.05.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Prft, ob auf eine Datei lesend zugegriffen werden kann    ///
   ///  oder nicht.                                               ///
   ///                                                            ///
   ///  Parameter: FileName    String mit Pfad und Dateiname      ///
   ///                                                            ///
   ///  Ausgabe:   True       bei Erfolg                          ///
   ///             False      bei Fehlschlag                      ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
  iFile: integer;
begin
  iFile := -1;
  try
    iFile := FileOpen(FileName, fmOpenRead);
    if iFile > 0 then
      Result := True
    else
      Result := False;
  finally
    FileClose(iFile);
  end;
end;


//svn

function InsertSVN: boolean;
begin
  result := False;
  try
    dm_DBImp.my_q_Tmp.SQL.Text := 'SHOW TABLEs  LIKE  ' + #39 + 'sys_svn' + #39;
    dm_DBImp.my_q_Tmp.Execute;
    if dm_DBImp.my_q_Tmp.RecordCount <> 0 then
    begin
      sSQLCMD := 'Insert into sys_svn (gdocid, svn_link, svn_version, svn_revision, svn_date, svn_info) ' + ' Values (' + #39 + inttostr(iDocid) + #39 + ', ' + #39 + sSvnLink + #39 + ', ' + #39 + sSvnVersion + #39 + ', ' + #39 + sSvnRevision + #39 + ', ' + #39 + sSvnDatum + #39 + ', ' + #39 + sSvnInfo + #39 + ')';

      dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
//         WriteCmd(sSQLCMD);
      dm_DBImp.my_Cmd.Execute;
      iSvnID := dm_DBImp.my_Cmd.LastInsertId;

    end;

    result := true;
  except
    on e: exception do
    begin
      WriteCMD('Error in InsertSVN ' + e.message);
      result := false;
    end;
  end;
end;

function GetVersionInfo: string;
var
  VerInfoSize: DWord;
  VerInfo: Pointer;
  VerValueSize: DWord;
  VerValue: PVSFixedFileInfo;
  Dummy: DWord;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    Result := IntToStr(dwFileVersionMS shr 16);
    Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
    Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
    Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;


// Start of MAIN
begin
   { TODO -oUser -cConsole Main : Hier Code einfgen }
   // Prfen ob alle Parameter angegeben wurden.
  iArcID := -1;
  iDocid := -1;
//   SetConsoleOutputCP(CP_UTF8);
  bIsWorkflow := False;   //sobald eine WVL angelegt werden kann auf True setzen
  WriteCMD('bitfarm Archiv V3 -  Datenbank Import Tool');
  WriteCMD('(c) 2004 - ' + cCurYear + ' bitfarm Informationssysteme GmbH');
  if ParamCount <> 1 then
  begin
    ExitCode := 1; //  Nicht genuegend Parameter angegeben
    WriteCMD('Version: ' + GetVersionInfo);
    WriteCMD('Fehler: Nicht genuegend Parameter angegeben!');
    WriteCMD('        Aufrufen mit: dbimpv3 <job-datei>');
    exit;
  end;

   // Initalisieren der Objekte
  sJobFile := ParamStr(1);
  if ExtractFileName(sJobFile) = sJobFile then
    sJobFile := ExtractFilePath(ParamStr(0)) + ParamStr(1);

  if not FileExists(sJobFile) then
  begin
    ExitCode := 5;   //  Kann Jobdatei nicht finden
    WriteCMD('Fehler: Kann Jobdatei <' + ParamStr(1) + '> nicht finden.');
    exit;

  end;
  if not FileAccessable(sJobFile) then
  begin
    exit;
  end;

  WriteCmd('DateFormat:' + sysDateformat);
//   WriteCmd('DateSeparator:'+formatSettings.DateSeparator);
  lcid := inttostr(SysLocale.DefaultLCID);
  WriteCmd('LanguageID:' + lcid);
  if lcid = '1031' then
  begin
    sMsg1 := 'Einer fr Alle';
    sMsg2 := 'Jeder einzeln';
    sMsg3 := ' Bearbeiter: ';
    sMsg4 := 'nach Erledigung zurck';
    sMsg5 := 'Erinnerungsmail senden';
    sMsg6 := 'Benachrichtigung versenden';
    sMsg8 := ' Gruppe: ';
  end
  else
  begin
    sMsg1 := 'One for all';
    sMsg2 := 'Every single one';
    sMsg3 := ' Editor: ';
    sMsg4 := 'return to sender';
    sMsg5 := 'send email reminder';
    sMsg6 := 'notification via email';
    sMsg8 := ' Group: ';
  end;

  job := TIniFile.Create(sJobFile);
  sVtxFile := TStringList.Create;
  sSlwFile := TStringList.Create;
  dm_DBImp := Tdm_DBImp.Create(nil);
   // Try-Finally Try-Except starten
  try
    try
         // Auslesen der JOB Datei
      tglistsec := TStringList.Create;
      job.readsections(tglistsec);

      with job do
      begin
            // Auf Version 3.0 berprfen
        sgVersion := ReadString('Version', 'Version', '');
        if sgVersion <> '36' then
        begin
          ExitCode := 3;  // Falsche Version der JOB Datei
          WriteCMD('Fehler: Falsche Version der JOB Datei! Bentigt werden Jobdateien der Version 36');
          exit;
        end;
        sProfil := ExtractFilePath(ParamStr(0)) + ReadString('Archiv', 'Profil', '') + '.con';
        fProfile := ReadString('Archiv', 'Profil', '');
        sGArcName := ReadString('Archiv', 'Name', '');
        sGTblName := ReadString('Archiv', 'Tabelle', '');
        iArcid := ReadInteger('Archiv', 'Arcid', -1);
        sDocID := ReadString('Document', 'DocID', '');
//            gigdocid := Readinteger('Document', 'gdoc_id', 0);
        sDocTitel := ReadString('Document', 'Titel', '');
        sDocOrg := StringReplace(ReadString('Document', 'Orginal', ''), '\', '\\', [rfReplaceAll]);
        sDocKopie := StringReplace(ReadString('Document', 'Kopie', ''), '\', '\\', [rfReplaceAll]);
        if ValueExists('Document', 'Quelle') then
          sDocQuelle := StringReplace(ReadString('Document', 'Quelle', ''), '\', '\\', [rfReplaceAll])
        else
          sDocQuelle := '';

        if sDocQuelle <> '' then
          sFileType := ExtractFileExt(sDocQuelle)
        else
          sFileType := ExtractFileExt(sDocOrg);

        sDocUsr := ReadString('Document', 'Benutzer', '');
        if ValueExists('Document', 'userid') then
          iDocUser := ReadInteger('Document', 'userid', -1)
        else
          iDocUser := -1;
        sDocVTX := ReadString('Document', 'Volltext', '');
        sDocState := ReadString('Document', 'Status', '0');
        sDocStateText := ReadString('Document', 'StatStr', '');
        sDocOCR := ReadString('Document', 'OCR_QF', '0');
        sDocSLW := ReadString('Document', 'Schlagworte', '');
        sDocDate := ReadString('Document', 'Datum', '');
        iPages := ReadInteger('Document', 'pages', 0);
            //svn
        sSvnLink := ReadString('SVN', 'SVN_Link', '');
        sSvnVersion := ReadString('SVN', 'SVN_Version', '');
        sSvnRevision := ReadString('SVN', 'SVN_Revision', '');
        sSvnDatum := ReadString('SVN', 'SVN_Datum', '');
        sSvnInfo := ReadString('SVN', 'SVN_Info', '');

        sSha1 := ReadString('Hash', 'SHA1', '');
        sSAPDocid := ReadString('SAP', 'docid', '');
        if sSapDocid = '' then
          sSAPDocid := ReadString('SAP', 'sapid', '');
        sContRep := ReadString('SAP', 'contrep', '');
        sCompDateC := ReadString('SAP', 'compdatec', '');
        sDocProt := ReadString('SAP', 'sdocprot', 'rcud');

        sTermin := ReadString('Tasks', 'Termin', '');
        sAlarm := ReadString('Tasks', 'Alarm', '');
        if Length(sTermin) > 10 then
          sTermin := LeftStr(sTermin, 10);
        if Length(sAlarm) > 10 then
          sAlarm := LeftStr(sAlarm, 10);
        sWorker := ReadString('Tasks', 'Bearbeiter', '');
        sNotiz := ReadString('Tasks', 'Notiz', '');
        giTimerOptionen := ReadInteger('Tasks', 'TimerOptionen', 0);
            // Zusatz Felder einlesen...
        iFieldCount := ReadInteger('Zusatzfelder', 'Felder', 0);
        if iFieldCount > 0 then
        begin
          SetLength(aZusFeld, iFieldCount + 1);
          SetLength(aZusWert, iFieldCount + 1);
          for iField := 1 to iFieldCount do
          begin
            aZusFeld[iField] := ReadString('Zusatzfelder', 'ZusFeld' + IntToStr(iField), '');
            aZusWert[iField] := ReadString('Zusatzfelder', 'ZusWert' + IntToStr(iField), '');
          end;
        end;
            // Referenzen einlesen
        iRefCount := ReadInteger('Referenz', 'Anzahl', 0);
        if iRefCount > 0 then
        begin
          SetLength(aDocRef, iRefCount + 1);
          for iField := 1 to iRefCount do
            aDocRef[iField] := ReadString('Referenz', 'Referenz' + IntToStr(iField), '');
        end;

            // keine Text oder SLW Datei ? dann mit leerem Inhalt weiter
        if sDocVtx <> '' then
        begin
          sDocVtx := ExpandEnvStrings(sDocVtx);
          if FileExists(sDocVtx) and FileAccessable(sDocVtx) then
            sVtxFile.LoadFromFile(sDocVtx)
          else
            sVtxFile.Text := '';
        end;

        if sDocSLW <> '' then
        begin
          if FileExists(sDocSLW) and FileAccessable(sDocSLW) then
            sSlwFile.LoadFromFile(sDocSLW)
          else
            sSlwFile.Text := '';
        end;
        sVtxFile.Text := StringReplace(sVtxFile.Text, '\', '\\', [rfReplaceAll]);
        sSlwFile.Text := StringReplace(sSlwFile.Text, '\', '\\', [rfReplaceAll]);

            // hier noch parsen und auf die lngen einzelner variabeln achten

//11.10.2017 Ticket 12158           sDocTitel := LeftStr(sDocTitel, 255);
        sDocTitel := StringReplace(LeftStr(sDocTitel, 255), #39, '', [rfReplaceAll]);

        //  f.schneider Ticket 22826 -->>
//        if iFieldCount > 0 then
//        begin
//          for iField := 1 to iFieldCount do
//          begin
//            aZusWert[iField] := Trim(ParseAddfields(aZusWert[iField]));
//            aZusWert[iField] := LeftStr(aZusWert[iField], 255);
//          end;
//        end;
        //  <<-- f.schneider Ticket 22826
        if iRefCount > 0 then
        begin
//11.10.2017 Ticket 12158 das erste ist immer leer!              for iField := 0 to iRefCount -1 do
          for iField := 1 to iRefCount do
          begin
            aDocRef[iField] := Trim(ParseAddfields(aDocRef[iField]));
            aDocRef[iField] := LeftStr(aDocRef[iField], 255)
          end;
        end;

        if (Length(sDocOrg) > 255) or (Length(sDocKopie) > 255) or (Length(sDocQuelle) > 255) then
        begin
               //
          ExitCode := 11; //Fehler: Pfadlnge berschritten
          WriteCMD('Fehler: Pfadlnge berschritten (255)');
          exit;
        end;

            // wenn wir schon eine gdocid ausgelesen haben, dann sollten wir diese
            // auch behalten
        iGblDocID := gigdocid;

            // Datenbank Import
        if not ConnectDB then
          exit;

        if iDocUser = -1 then
        begin
          if sDocUsr <> '' then
          begin
            with dm_DBImp.my_q_Tmp do
            begin
                  // Vergebenden Benutzer suchen....
              sql.Text := 'Select * from sys_user where username = ' + #39 + sDocUsr + #39 + ' and flags & 2 = 0';
              try
                Open;
                First;
              except
                on e: exception do
                begin
                  WriteCmd('Fehler beim Lesen der Userid: ' + e.Message);
                end;
              end;

              if RecordCount > 0 then
              begin
                iDocUser := FieldByName('userid').AsInteger;
              end
              else
                iDocUser := 1;    // kann die Userid nicht ermittelt werden setzen wir auf System
              Close;
            end;
          end
          else
            iDocUser := 1;         // kann die Userid nicht ermittelt werden setzen wir auf System
        end;

        if sCompDateC = '' then
          sCompDateC := FormatDateTime('yyyy-mm-dd hh:nn:ss', Now());

        bUpdatesql := False;
            // when is docid set before insertsql?
        Get_OldStatus();
        if ((sTermin <> '') and (sDocID <> '')) then
        begin
          InsertTask();
        end else if sDocID <> '' then
        begin
          if not UpdateSQL then
          begin
            ExitCode := 8; //Update der Datenbank fehlgeschlagen
            WriteCMD('Fehler: Update der Datenbank fehlgeschlagen');
          end else
            bUpdatesql := True;
          Calculate_ExpiredDate;
        end else
        begin
          if not InsertSQL then
          begin
            ExitCode := 9; //Es konnte kein neuer Eintrag erzeugt werden
            WriteCMD('Fehler: Es konnte kein neuer Eintrag erzeugt werden');
          end;
          Calculate_ExpiredDate;
        end;

            //svn
        if sSvnRevision <> '' then
        begin
          if not InsertSVN then
          begin
            ExitCode := 10; //Es konnte kein SVN-Eintrag erzeugt werden
            WriteCMD('Fehler: Es konnte kein SVN-Eintrag erzeugt werden');
          end;
        end;

        WriteCMD('DocID:' + IntToStr(iArcID) + '.' + IntToStr(iDocid));
        WriteCMD('WfID:' + IntToStr(iWvlID));
        WriteCMD('gdoc_id:' + IntToStr(iDocid));

        if iDocid > 0 then
        begin
          job.WriteString('Document', 'DocID', IntToStr(iArcID) + '.' + IntToStr(iDocid));
          job.WriteString('Document', 'gdoc_id', IntToStr(iDocid));
          job.UpdateFile;
          sVtxFile.Clear;
          if ExitCode = 0 then
          begin
            if bUpdatesql then
              WriteCMD('Das Dokument wurde erfolgreich aktualisiert.')
            else
              WriteCMD('Das Dokument wurde erfolgreich archiviert.');
          end;
        end else
        begin
          WriteCMD('Bei der Archivierung in die Datenbank trat ein Fehler auf.');
          ExitCode := 8;  //Update der Datenbank fehlgeschlagen
        end;
      end;
    except
      on e: Exception do
      begin
        ExitCode := 255;
        WriteCMD('Fehler: Folgender Fehler ist aufgetreten: ' + e.Message);
      end;
    end;
  finally
    dm_DBImp.my_Con.Disconnect;
    if Assigned(job) then
      FreeAndNil(job);
    if Assigned(sVtxFile) then
      FreeAndNil(sVtxFile);
    if Assigned(sSlwFile) then
      FreeAndNil(sSlwFile);
    if Assigned(dm_DBImp) then
      dm_DBImp.Free;
  end;
end.

