unit bfaCommonMethods;

interface

uses
  Windows,
  Classes,
  VCL.ComCtrls,
  VCL.StdCtrls,
  VCL.Graphics,
  System.Win.Registry,
  System.IOUtils,
  TlHelp32,
  JclDateTime, // SJ Abschlussprojekt
  bfaCommonUtils;

type
  TSearchOption = (soIgnoreCase, soFromStart, soWrap);
  TSearchOptions = set of TSearchOption;

var
   sysDateFormat : string;
   sysEmptyDate : TDateTime;  //24.05.2019 Ticket 17987

//  _UNICODE_STRING = record
//    Length: Word;
//    MaximumLength: Word;
//    Buffer: LPWSTR;
//  end;
//  UNICODE_STRING = _UNICODE_STRING;

//  PROCESS_BASIC_INFORMATION = packed record
//    ExitStatus: DWORD;
//    PebBaseAddress: Pointer;
//    AffinityMask: DWORD;
//    BasePriority: DWORD;
//    UniqueProcessId: DWORD;
//    InheritedUniquePID:DWORD;
//  end;

//type
//  THandleArray = array of THandle;

//function  NtQueryInformationProcess(ProcessHandle : THandle; ProcessInformationClass : DWORD; ProcessInformation : Pointer; ProcessInformationLength : ULONG; ReturnLength : PULONG ): LongInt; stdcall; external 'ntdll.dll';

//procedure CopyDirectoryToClient(SrvrDir, ClntDir: WideString);
//function BfaGetVersion(sFileName:string): string;
//function BfaGetPath(sIniFile: string; sSection, sKey, sTitel: WideString; Updater: Boolean = false): WideString;
//function CopyBfaFile(ServerDir, ClientDir, FName: WideString) : Boolean;
//function GetCounter(Hdl: THandle; var MinInstance: Integer): Integer;
function SwitchToPrevInst(Wdw: HWND): Boolean;
//function MStreamToOleVariant(MStream: TMemoryStream): OleVariant;
//function SetProvider(Provider: integer): WideString;
function SendParamsToPrevInst(Wdw: HWND): boolean;
function bfaPower(Value: Integer): UInt64;
function bfaAbs(Value: Int64): UInt64;

function SetScrollStepByID(ID: Integer): Integer;
function SetZoomStepByID(ID: Integer): Integer;
function SetDPIByID(ID: Integer): Integer;
function SetIDByDPI(DPI: Integer): Integer;
function SetCompressionByName(Name: String): Integer;
function SetCompressionName(ID: Integer): String;
//procedure DeleteDirectory(const DirName: string);
function Strip(Value: WideString): WideString;
function SplitLeft(Value, Delimiter: WideString): WideString;
function SplitRight(Value, Delimiter: WideString): WideString;
procedure Split(Delimiter : Char; Str : string; ListOfStrings : TStrings);
function Split2(InStr, SplitAt: WideString): TStringList;
function GetRootNode(ANode : TTreeNode) : TTreeNode;
function GetParentNode(ANode : TTreeNode) : TTreeNode;
function SearchText(Control: TCustomEdit; Search: string; SearchOptions: TSearchOptions): Boolean;
//function MarkText(RichEdit : TRichEdit; const AWord: string; AOptions: TSearchTypes): Boolean;
//function SelectNextRichText(RichEdit : TRichEdit; const AWord: string; StartPos: Integer; AOptions: TSearchTypes): Integer;
//function SelectPreviousRichText(RichEdit : TRichEdit; const AWord: string; EndPos: Integer; AOptions: TSearchTypes): Integer;
//procedure CopyFilesToClipboard(FileList : string);
//procedure CopyLinkToClipboard(const str, htmlStr : AnsiString);
//function GetFileModDate(filename : string) : TDateTime;
function SortCompareDesc(List: TStringList; Index1, Index2: Integer): Integer;
function SortCompareASC(List: TStringList; Index1, Index2: Integer): Integer;
function ParseDateToStr_to_date(value: WideString): WideString;
function CheckDateFormat(fieldvalue: string; sDateFormat: string): string;
function ParseNonAscii(const s: widestring): widestring;
function ParseNonPrintable(const s: widestring): widestring;
function IsEmptyDate(date: TDateTime): boolean;
function IsEmptyVariant(value : Variant): Boolean;
function MySQLDateToDate(datestring: string): TDateTime; // SJ Abschlussprojekt
function GetModifiedUTCEx(filename: string): TDateTime;
function GetPathFromPID(const PID: cardinal): string; // SJ Abschlussprojekt
//function processExists(exeFileName: string): Boolean;
//function GetCommandLineFromPid(PID: THandle): string;
//function getProcessHandle(exeFileName: string): THandle;
//function getProcessHandles(exeFileName: string): THandleArray;
function FileSize(const aFilename: String): Int64;
function SortSListAsInt(List: TStringList; Index1, Index2: Integer): Integer;

procedure SplitVersionString(const fsversion: String; var fversion: TVersion);
function compareversions(var fversion, fversion1: TVersion): boolean;
//function ShellExecute_AndWait(Operation, FileName, Parameter, Directory: string;
//   Show: word; bWait: boolean): longint;

function GetSystemVariable(const name : string): string;
function GetVersionInfo: string;
function appversion(): String;

function EnCrypt_old(InputStr, HexKeyStr: string): string;
function EnCrypt(InputStr, HexKeyStr: string): string;
function DeCrypt_old(HexInputStr, HexKeyStr: string): string;
function DeCrypt(HexInputStr, HexKeyStr: string): string;
function WindowsUserName: String;
function GetBitfarmURL : WideString;
function ArcDocId(ArcId, DocId: int64): TArcDocId;
function CreateNewPid(id : Int64):PPID;

//Registry
procedure RegIfNotExistWriteString(Reg:TRegistry; Key, Value:string);
function RegReadBool(Reg: TRegistry; Key: string; DefValue: Boolean):Boolean;
function RegReadInteger(Reg: TRegistry; Key: string; DefValue: Integer):Integer;


//Unsortiert
function RefToCell(ARow, ACol: Integer): string;
function ParseSQLString(InputStr: string): string;
function ParseSemicolonUseBackslash(InputStr: string): string;
function ParseSemicolonWithoutBackslash(InputStr: string): string;
function ParseMultipleDelimiters(Delimiter: Char; InputStr: string): string;
function ParseAddfields(InputStr: string): string;
function ParseGridfields(InputStr: string): string;
function ParseSearchfield(InputStr: string): string;
function ParseFilename(S: string): string;
function ParseFilepath(S: Widestring): Widestring;
function ParseNotAllowedChars(S: Widestring): Widestring; overload;
function ParseNotAllowedChars(S: string): Widestring; overload;
function ParseNotAllowedChars(S, NotAllowed: string): Widestring; overload;
function ParseAlphanumeric(AValue: AnsiString):string;
function StrToHtml(s: string): string;
procedure AddfieldType0KeyPress(var Key: Char);
procedure RemoveMultipleSpaces(var s: String); overload;
procedure RemoveMultipleSpaces(var s: WideString); overload;

function FileAccessable(FileName: string): boolean;
function IsDirWriteable(const dir: string):Boolean;
function CheckFileAccess(const FileName: string; const CheckedAccess: Cardinal): Cardinal;
function GetFileSizeStr(FileName : string) : string;
function GetStreamSizeStr(str : TMemoryStream) : string;
function KeyPressed(key: integer): boolean;
function GetCharFromVirtualKey(Key: Word): string;
function IndexOfCaseSensitive(SL: TStrings; const Item: string): Integer;

function RunWaitAndCaptureOutput(CommandLine:string; var Output:string; LogLevel:integer):DWord;

function StrToInt0(const S: string): Integer;
function CalcNonExistingFilename(Path, Name, Ext: string): string; //3.5.0.38 [2364]

//procedure StringToFile(const Dateiname:Ansistring; const Data:Ansistring);
//procedure SaveToFile(const Dateiname:Ansistring; const Buffer; Count: Longint);
function IstZahl(S:string):Boolean; //[2487]
function IsUserAdmin : boolean;
function Windows64Bit: Boolean; // SJ Abschlussprojekt
function ShellExecToString(ErrCode: Integer): string; // SJ Abschlussprojekt
//procedure FindAllFiles(var FileList: TStrings; RootFolder: string;
//   Mask: string = '*.*'; Recurse: boolean = True; CheckExt : Boolean = True);
//function BfDeleteFile(const AFile: string): boolean;
//function IsDirectoryEmpty(const directory : string) : boolean; //07.06.2011 b.takacs 3.5.1.19 [3069]
//function EmptyDirectory(const ADir: string): boolean;
//function BfCopyDir(const fromDir, toDir: string; ARename: boolean = false): Boolean;
//function BfMoveDir(const fromDir, toDir: string): Boolean;
//function BfDelDir(dir: string): Boolean;
//function ReadDir(Path, Mask: string; ShowPath: boolean): TStringlist;
//procedure KillFile(FileName: string);
function KillTask(ExeFileName: string): Integer; // SJ Abschlussprojekt

procedure ClearRights(var RightData : TRData);
Function WriteCmd(text: WideString): WideString;
function ExpandEnvStrings(const AString: String): String;
function GetStringFromResource(Name: string): string;

(*
  Zweck:
    Ersetzt die Funktion 'indexOf' aus 'TStrings', denn
    diese originale Funktion findet nicht den leeren Eintrag ''.
*)
function indexOf (text: string;
                  list: TStrings): Integer;

// sucht nach einem Wortbestandteil in einer Liste
function ListContains(list: TStrings; text: string): Boolean;
function StrToWords(const InputStr: string): TStringList;
function StrToWords4(const InputStr: string): TStringList;
function StrToWords7(const InputStr: string): TStringList;
function StrToWordsLF(const InputStr: string): TStringList;
function ListToParams(const list: TStrings): WideString;

function GetLDAPClass(AValue: WideString): WideString;
function GetLDAPName(AValue: WideString): WideString;
function GetLDAPDisplayname(AValue: WideString): WideString;
function GetLDAPObjectname(AValue: WideString): WideString;
function EscapeDNName(AValue: WideString): WideString;
function EscapeLDAPPath(AValue: WideString): WideString;
procedure DisableBeep(var Key: Char); //11.03.2024 bfacrm:ticket__show__38134

function CreateHighlightColor(AColor: TColorRef): TColor;

implementation

uses
  RegularExpressions, System.DateUtils, System.StrUtils, psapi,
  gnugettext, SysUtils, Variants, Messages;

procedure DisableBeep(var Key: Char);
begin
  if key = #13 then // #13 = Return
  begin
    key := #0;
  end;
end;

//function GetCommandLineFromPid(PID: THandle): string;
//const
//  STATUS_SUCCESS             = $00000000;
//  SE_DEBUG_NAME              = 'SeDebugPrivilege';
//  OffsetProcessParametersx32 = $10;//16
//  OffsetCommandLinex32       = $40;//64
//var
//  ProcessHandle        : THandle;
//  rtlUserProcAddress   : Pointer;
//  CommandLine          : UNICODE_STRING;
//  CommandLineContents  : WideString;
//  ProcessBasicInfo     : PROCESS_BASIC_INFORMATION;
//  ReturnLength         : Cardinal;
//  TokenHandle          : THandle;
//  lpLuid               : TOKEN_PRIVILEGES;
//  OldlpLuid            : TOKEN_PRIVILEGES;
//begin
//  Result:='';
//  if OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, TokenHandle) then
//  begin
//    try
//      if not LookupPrivilegeValue(nil, SE_DEBUG_NAME, lpLuid.Privileges[0].Luid) then
//        RaiseLastOSError
//      else
//      begin
//        lpLuid.PrivilegeCount := 1;
//        lpLuid.Privileges[0].Attributes  := SE_PRIVILEGE_ENABLED;
//        ReturnLength := 0;
//        OldlpLuid    := lpLuid;
//        //Set the SeDebugPrivilege privilege
//        if not AdjustTokenPrivileges(TokenHandle, False, lpLuid, SizeOf(OldlpLuid), OldlpLuid, ReturnLength) then RaiseLastOSError;
//      end;
//
//      ProcessHandle := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, false, PID);
//      if ProcessHandle=0 then RaiseLastOSError
//      else
//      try
//        // get the PROCESS_BASIC_INFORMATION to access to the PEB Address
//        if (NtQueryInformationProcess(ProcessHandle,0{=>ProcessBasicInformation},@ProcessBasicInfo, sizeof(ProcessBasicInfo), @ReturnLength)=STATUS_SUCCESS) and (ReturnLength=SizeOf(ProcessBasicInfo)) then
//        begin
//          //get the address of the RTL_USER_PROCESS_PARAMETERS struture
//          if not ReadProcessMemory(ProcessHandle, Pointer(Longint(ProcessBasicInfo.PEBBaseAddress) + OffsetProcessParametersx32), @rtlUserProcAddress, sizeof(Pointer), ReturnLength) then
//            RaiseLastOSError
//          else
//          if ReadProcessMemory(ProcessHandle, Pointer(Longint(rtlUserProcAddress) + OffsetCommandLinex32), @CommandLine, sizeof(CommandLine), ReturnLength) then
//          begin
//            SetLength(CommandLineContents, CommandLine.length);
//            //get the CommandLine field
//            if ReadProcessMemory(ProcessHandle, CommandLine.Buffer, @CommandLineContents[1], CommandLine.Length, ReturnLength) then
//             Result := WideCharLenToString(PWideChar(CommandLineContents), CommandLine.length div 2)
//            else
//            RaiseLastOSError;
//          end;
//        end
//        else
//        RaiseLastOSError;
//      finally
//        CloseHandle(ProcessHandle);
//      end;
//    finally
//      CloseHandle(TokenHandle);
//    end;
//  end
//  else
//    RaiseLastOSError;
//end;

//function processExists(exeFileName: string): Boolean;
//var
//  ContinueLoop: BOOL;
//  FSnapshotHandle: THandle;
//  FProcessEntry32: TProcessEntry32;
//begin
//  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
//  FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
//  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
//  Result := False;
//  while Integer(ContinueLoop) <> 0 do
//  begin
//    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
//      UpperCase(ExeFileName)) or (UpperCase(FProcessEntry32.szExeFile) =
//      UpperCase(ExeFileName))) then
//    begin
//      Result := True;
//    end;
//    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
//  end;
//  CloseHandle(FSnapshotHandle);
//end;
//
//function getProcessHandle(exeFileName: string): THandle;
//var
//  ContinueLoop: BOOL;
//  FSnapshotHandle: THandle;
//  FProcessEntry32: TProcessEntry32;
//begin
//  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
//  FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
//  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
//  Result := 0;
//  while Integer(ContinueLoop) <> 0 do
//  begin
//    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
//      UpperCase(ExeFileName)) or (UpperCase(FProcessEntry32.szExeFile) =
//      UpperCase(ExeFileName))) then
//    begin
//      Result := FProcessEntry32.th32ProcessID;
//    end;
//    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
//  end;
//  CloseHandle(FSnapshotHandle);
//end;
//
//function getProcessHandles(exeFileName: string): THandleArray;
//var
//  ContinueLoop: BOOL;
//  FSnapshotHandle: THandle;
//  FProcessEntry32: TProcessEntry32;
//begin
//  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
//  FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
//  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
//  SetLength(result,0);
//  while Integer(ContinueLoop) <> 0 do
//  begin
//    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
//      UpperCase(ExeFileName)) or (UpperCase(FProcessEntry32.szExeFile) =
//      UpperCase(ExeFileName))) then
//    begin
//      SetLength(Result,Length(Result) +1);
//      Result[High(Result)] := FProcessEntry32.th32ProcessID;
//    end;
//    ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
//  end;
//  CloseHandle(FSnapshotHandle);
//end;

function SortCompareDesc(List: TStringList; Index1, Index2: Integer): Integer;
begin
  if List.CaseSensitive
    then Result := AnsiCompareStr(List[Index2], List[Index1])
    else Result := AnsiCompareText(List[Index2], List[Index1]);
end;

function SortCompareASC(List: TStringList; Index1, Index2: Integer): Integer;
begin
  if List.CaseSensitive
    then Result := AnsiCompareStr(List[Index1], List[Index2])
    else Result := AnsiCompareText(List[Index1], List[Index2]);
end;

//procedure CopyDirectoryToClient(SrvrDir, ClntDir: WideString);
//var
//  sts: Integer ;
//  SR: TSearchRec;
//begin
//  sts:= FindFirst(SrvrDir + '*.*' , faAnyFile , SR );
//  if sts = 0 then
//  begin
//    while FindNext( SR ) = 0 do
//    begin
//      if (SR.Name <> '.' ) and ( SR.Name <> '..' ) then
//      begin
//        if Pos('.', SR.Name) = 0 then
//        begin
//          ForceDirectories( ClntDir + SR.Name );
//          CopyDirectoryToClient(SrvrDir + SR.Name + '\', ClntDir + SR.Name
//                              + '\' ) ;
//        end
//        else
//          copyfile( pchar(SrvrDir + SR.Name), pchar(ClntDir + sr.name), true );
//      end;
//    end;
//    FindClose( SR ) ;
//  end;
//end;

//function BfaGetVersion(sFileName:string): string;
//var
//  VerInfoSize : DWORD;
//  VerInfo : Pointer;
//  VerValueSize : DWORD;
//  VerValue : PVSFixedFileInfo;
//  Dummy : DWORD;
//begin
//  try
//    VerInfo := nil;
//    VerInfoSize := GetFileVersionInfoSize(PChar(sFileName), Dummy);
//    if VerInfoSize > 0 then
//    begin
//      GetMem(VerInfo, VerInfoSize);
//      GetFileVersionInfo(PChar(sFileName), 0, VerInfoSize, VerInfo);
//      VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
//      with VerValue^ do
//      begin
//        Result := IntToStr(dwFileVersionMS shr 16);
//        Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
//        Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
//        Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
//      end;
//    end
//    else
//    begin
//      Result:= '0.0.0.0';
//    end;
//    FreeMem(VerInfo, VerInfoSize);
//  except
//    Result:= '0.0.0.0';
//  end;
//end;

//function BfaGetPath(sIniFile: string; sSection, sKey, sTitel: WideString; Updater: Boolean = false): WideString;
//var
//  ini: TIniFile;
//begin
//  ini:= TIniFile.Create(sIniFile);
//  try
//    Result:= ini.ReadString(sSection, sKey, '');
//
//    if (Result = '' ) and (Updater) then
//    begin
//      with TFileOpenDialog.Create(nil) do
//      begin
//        Title:= sTitel;
//        Options:= [fdoPickFolders];
//        if Execute then
//        begin
//          Result:= FileName;
//          ini.WriteString(sSection, sKey, Result);
//        end;
//      end;
//    end;
//  finally
//    ini.Free;
//  end;
//end;

//function CopyBfaFile(ServerDir, ClientDir, FName: WideString) : Boolean;
//var
//  ServerFn, ClientFn: WideString;
//  ServerVer, ClientVer: string;
//begin
//  Result := False;
//  try
//    ServerFn:= ServerDir + '\' + FName;
//    if FileExists(ServerFn) then
//      ServerVer:= BfaGetVersion(ServerFn)
//    else
//      ServerVer:= '';
//
//    ClientFn:= ClientDir + '\' + FName;
//    if FileExists(ClientFn) then
//      ClientVer:= BfaGetVersion(ClientFn)
//    else
//      ClientVer:= '';
//
//    if (ServerVer <> '') then
//    begin
//      if (ServerVer > ClientVer) or (ClientVer = '') then
//        Result := CopyFile(PWideChar(ServerFn), pWideChar(ClientFn), False);
//    end;
//  except
//    Result := False;
//  end;
//end;

//function GetCounter(Hdl: THandle; var MinInstance: Integer): Integer;
//var
//  i: integer;
//  WndHDL: HWND;
//  WndText, ClsName: PWideChar;
//begin
//  Result:= 0;
//  WndHDL:= GetWindow(Hdl, GW_HWNDFIRST);
//  while ( WndHDL <> GetWindow(Hdl, GW_HWNDLAST) ) do
//  begin
//    if IsWindowEnabled(WndHDL) then
//    begin
//      i := GetWindowTextLength(WndHDL);
//      GetMem(WndText, i + 1);
//      GetMem(ClsName, 255);
//      GetClassName(WndHDL, ClsName, 255);
//      if (StrPos(ClsName, sSysWinClassName) <> nil) then
//      begin
//        GetWindowText(WndHDL, WndText, i + 1);
//        if WndText <> '' then
//        begin
//          if StrToInt(WndText) > Result then
//            Result:= StrToInt(WndText);
//          if StrToInt(WndText) < MinInstance then
//            MinInstance:= StrToInt(WndText);
//        end;
//      end;
//      FreeMem(WndText);
//    end;
//    WndHDL:= GetWindow(WndHDL, GW_HWNDNEXT);
//  end;
//  Result:= Result + 1;
//end;

function SwitchToPrevInst(Wdw: HWND): Boolean;
begin
  Assert(Wdw <> 0);
  if ParamCount > 0 then
    Result := SendParamsToPrevInst(Wdw)
  else
    Result := True;
  if Result then
    SendMessage(Wdw, UM_ENSURERESTORED, 0, 0);
end;

//function MStreamToOleVariant(MStream: TMemoryStream): OleVariant;
//var
//  MyBuffer: Pointer;
//begin
//  MStream.Position:= 0;
//  Result:= VarArrayCreate([0, MStream.Size - 1], VarByte);
//  MyBuffer:= VarArrayLock(Result);
//  MStream.ReadBuffer(MyBuffer^, MStream.Size);
//  VarArrayUnlock(Result);
//end;

//function SetProvider(Provider: integer): WideString;
//begin
//  if Provider = providerMySQL then
//    Result:= sSysMySQL
//  else if Provider = providerMsSQL then
//    Result:= sSysSQLServer
//  else if Provider = providerPostgreSQL then
//    Result:= sSysPostgreSQL
//  else if Provider = providerOracleSQL then
//    Result:= sSysOracle;
//end;

function SendParamsToPrevInst(Wdw: HWND): boolean;
var
  CopyData: TCopyDataStruct;
  I: integer;
  DataSize: integer;
  Data: PChar;
  PData: PChar;
begin
  DataSize:= 0;
  for I:= 1 to ParamCount do
    Inc(DataSize, Length(ParamStr(I)) + 1);
  Inc(DataSize);
  Data:= StrAlloc(DataSize);
  try
    PData:= Data;
    for I:= 1 to ParamCount do
    begin
      StrPCopy(PData, ParamStr(I));
      Inc(PData, Length(ParamStr(I)) + 1);
    end;
    PData^ := #0;
    CopyData.lpData:= Data;
    CopyData.cbData:= DataSize;
    CopyData.dwData:= $DDED;
    Result:= SendMessage(Wdw, WM_COPYDATA, 0, LPARAM(@CopyData)) = 1;
  finally
    StrDispose(Data);
  end;
end;

function bfaPower(Value: Integer): UInt64;
var
  i: Integer;
begin
  Result:= 1;
  if Value > 0 then
  begin
    for i:=1 to Value do
      Result:= Result * 2;
  end;
end;

function bfaAbs(Value: Int64): UInt64;
var
  i: Integer;
begin
  if Value >= 0 then
    Result:= Value
  else
    Result:= -1 * Value;
end;

function SetScrollStepByID(ID: Integer): Integer;
begin
  try
    case ID of
      scr10: Result:= 10;
      scr20: Result:= 20;
      scr30: Result:= 30;
      scr40: Result:= 40;
      scr50: Result:= 50;
      scr60: Result:= 60;
      scr70: Result:= 70;
      scr80: Result:= 80;
      scr90: Result:= 90;
      scr100: Result:= 100;
      scr110: Result:= 110;
      scr120: Result:= 120;
      scr130: Result:= 130;
      scr140: Result:= 140;
      scr150: Result:= 150;
      else Result:= scrDefault;
    end;
  except
    Result:= scrDefault;
  end;
end;

function SetZoomStepByID(ID: Integer): Integer;
begin
  try
    case ID of
      zms1: Result:= 1;
      zms2: Result:= 2;
      zms3: Result:= 3;
      zms4: Result:= 4;
      zms5: Result:= 5;
      zms10: Result:= 10;
      zms15: Result:= 15;
      zms20: Result:= 20;
      zms25: Result:= 25;
      zms30: Result:= 30;
      zms35: Result:= 35;
      zms40: Result:= 40;
      zms50: Result:= 50;
      zms100: Result:= 100;
      else Result:= zmsDefault;
    end;
  except
    Result:= zmsDefault;
  end;
end;

function SetDPIByID(ID: Integer): Integer;
begin
  try
    case ID of
      dpi50: Result:= 50;
      dpi75: Result:= 75;
      dpi100: Result:= 100;
      dpi150: Result:= 150;
      dpi200: Result:= 200;
      dpi300: Result:= 300;
      dpi400: Result:= 400;
      dpi600: Result:= 600;
      dpi1200: Result:= 1200;
      else Result:= dpiDefault;
    end;
  except
    Result:= dpiDefault;
  end;
end;

function SetIDByDPI(DPI: Integer): Integer;
begin
  try
    case DPI of
      50: Result:= dpi50;
      75: Result:= dpi75;
      100: Result:= dpi100;
      150: Result:= dpi150;
      200: Result:= dpi200;
      300: Result:= dpi300;
      400: Result:= dpi400;
      600: Result:= dpi600;
      1200: Result:= dpi1200;
      else Result:= dpi300;
    end;
  except
    Result:= dpi300;
  end;
end;

function SetCompressionByName(Name: String): Integer;
begin
  try
    if (Name = sCaptionJPG) then
      Result := cmpJPG
    else if (Name = sCaptionPackBits) then
      Result := cmpPackBits
    else if (Name = sCaptionLZW) then
      Result := cmpLZW
    else if (Name = sCaptionCCITT4) then
      Result := cmpCCITT4
    else if (Name = sCaptionNoComprerssion) then
      Result := cmpLZW
    else
      Result := cmpLZW;
  except
    Result := cmpLZW;
  end;
end;

function SetCompressionName(ID: Integer): String;
begin
  try
    if (ID = cmpJPG) then
      Result:= sCaptionJPG
    else if (ID = cmpPackBits) then
      Result:= sCaptionPackBits
    else if (ID = cmpLZW) then
      Result:= sCaptionLZW
    else if (ID = cmpCCITT4) then
      Result:= sCaptionCCITT4
    else if (ID = cmpNoCompression) then
      Result:= sCaptionLZW
    else
      Result:= sCaptionLZW;
  except
    Result:= sCaptionLZW;
  end;
end;

//procedure DeleteDirectory(const DirName: string);
//var
//  FileOp: TSHFileOpStruct;
//begin
//  FillChar(FileOp, SizeOf(FileOp), 0);
//  FileOp.wFunc := FO_DELETE;
//  FileOp.pFrom := PChar(DirName + #0);
//  FileOp.fFlags := FOF_SILENT or FOF_NOERRORUI or FOF_NOCONFIRMATION;
//  SHFileOperation(FileOp);
//end;
function Strip(Value: WideString): WideString;
begin
  Result := Trim(Value);
  try
    if ((LeftStr(Value,1) = '"') or (LeftStr(Value,1) = #39)) and
        ((RightStr(Value,1) = '"') or (RightStr(Value,1) = #39)) then
    Result := Copy(Value, 2, length(value) -2);
  except

  end;
end;



function SplitLeft(Value, Delimiter: WideString): WideString;
begin
  Result := Value;
  try
    Result := Copy(Value, 1, Pos(Delimiter, Value) -1);
  except

  end;
end;

function SplitRight(Value, Delimiter: WideString): WideString;
begin
  Result := Value;
  try
    Result := Copy(Value, Pos(Delimiter, Value) +1, length(value) - Pos(Delimiter, Value));
  except

  end;
end;
procedure Split(Delimiter : Char; Str : string; ListOfStrings : TStrings);
begin
  ListOfStrings.Clear;
  ListOfStrings.Delimiter := Delimiter;
  ListOfStrings.StrictDelimiter := True;
  ListOfStrings.DelimitedText := Str;
end;

function Split2(InStr, SplitAt: WideString): TStringList;
var
  I, L: Integer;
begin
  Result := TStringList.Create;
  if InStr = '' then
    Exit;
  I := Pos(SplitAt, InStr);
  L := Length(SplitAt);
  while I > 0 do
  begin
    Result.Add(Copy(InStr, 1, Pred(I)));
    Delete(InStr, 1, Pred(I + L));
    I := Pos(SplitAt, InStr);
  end;
end;

function GetRootNode(ANode : TTreeNode) : TTreeNode;
begin
  Result := nil;
  if ANode = nil then
    Exit;

  while (ANode <> nil) do
  begin
    if (ANode.Parent = nil) then
    begin
      Result := ANode;
      Break;
    end;
    ANode := ANode.Parent;
  end;
end;

function GetParentNode(ANode : TTreeNode) : TTreeNode;    // holt den obersten Parent unterhalb von Root
var
  RootNode : TTreeNode;
begin
  Result := nil;
  if ANode = nil then
    Exit;

  RootNode := GetRootNode(ANode);
  while (ANode <> nil) do
  begin
    if (ANode.Parent = RootNode) then
    begin
      Result := ANode;
      Break;
    end;
    ANode := ANode.Parent;
  end;
end;

function SearchText(
    Control: TCustomEdit;
    Search: string;
    SearchOptions: TSearchOptions): Boolean;
var
  Text: string;
  Index: Integer;
begin
  if soIgnoreCase in SearchOptions then
  begin
    Search := UpperCase(Search);
    Text := UpperCase(Control.Text);
  end
  else
    Text := Control.Text;

  Index := 0;
  if not (soFromStart in SearchOptions) then
    Index := PosEx(Search, Text,
         Control.SelStart + Control.SelLength + 1);

  if (Index = 0) and
      ((soFromStart in SearchOptions) or
       (soWrap in SearchOptions)) then
    Index := PosEx(Search, Text, 1);

  Result := Index > 0;
  if Result then
  begin
    Control.SelStart := Index - 1;
    Control.SelLength := Length(Search);
  end;
end;

function ParseDateToStr_to_date(value: WideString): WideString;
begin
  Result := value;
end;

function CheckDateFormat(fieldvalue: string; sDateFormat: string): string;
var
  RegExpr: TRegEx;
begin
  // in der Hauptsache haben wir es mit den Foprmaten dd.mm.yyyy (de) dd/mm/yyyy (en uk)
  // oder mm/dd/yyyy (en us) zu tun. Sollte der Server auf en us eingestellt sein versuchen wir
  // auch in den zusatzfeldern zwischen dd.mm.yyyy (de) und  mm/dd/yyyy (en us) zu unterscheiden.
  // ansonsten prfen wir auf dd.mm.yyyy und dd/mm/yyyy
  Result := sDateformat;

//  RegExpr := TRegEx.Create;
//  TRegEx.Subject := fieldvalue;

//  RegExpr.RegEx := '\d{1,2}\.\d{1,2}\.\d{4}';  // de
  if TRegEx.IsMatch(fieldvalue, '\d{1,2}\.\d{1,2}\.\d{4}') then
  begin
    Result := '%d.%m.%Y';
    Exit;
  end;

  if SysLocale.DefaultLCID = 1033 then    //us
  begin
//    RegExpr.RegEx := '\d{1,2}\/\d{1,2}\/\d{4}';  // en us
    if TRegEx.IsMatch(fieldvalue, '\d{1,2}\/\d{1,2}\/\d{4}') then
    begin
      Result := '%m/%d/%Y';
      Exit;
    end;
  end else
  begin
//    RegExpr.RegEx := '\d{1,2}\/\d{1,2}\/\d{4}';  // en uk
    if TRegEx.IsMatch(fieldvalue, '\d{1,2}\/\d{1,2}\/\d{4}') then
    begin
      Result := '%d/%m/%Y';
      Exit;
    end;
  end;
  // wenn wir bis hier nichts gefunden haben, dann testen wir noch das mysql format

//  RegExpr.RegEx := '\d{4}-\d{2}-\d{2}';  // en us
  if TRegEx.IsMatch(fieldvalue, '\d{4}-\d{2}-\d{2}') then
  begin
    Result := '%Y-%m-%d';
    Exit;
  end;


end;

function ParseNonAscii(const s: widestring): widestring;
var
  i, Count: Integer;
begin
  SetLength(Result, Length(s));
  Count := 0;
  for i := 1 to Length(s) do begin
    if ((s[i] >= #32) and (s[i] <= #127)) or (s[i] in [#10, #13]) then begin
      inc(Count);
      Result[Count] := s[i];
    end;
  end;
  SetLength(Result, Count);
end;

function ParseNonPrintable(const s: widestring): widestring;
var
  i, Count: Integer;
begin
  SetLength(Result, Length(s));
  Count := 0;
  for i := 1 to Length(s) do begin
    if ((s[i] >= #32) and (s[i] <> #127)) or (s[i] in [#10, #13]) then begin
      inc(Count);
      Result[Count] := s[i];
    end;
  end;
  SetLength(Result, Count);
end;

function IsEmptyDate(date: TDateTime): boolean;
begin
  //24.05.2019 Ticket 17987
  Result := {(DateOf(date) = (sysEmptyDate)) or} (date = cUnassignedDate) or (Trunc(date) = -700000);
end;

function IsEmptyVariant(value : Variant): Boolean;
begin
 Result := VarIsNull(Value) or
            ((VarIsType(Value, varUString)) and (Value = '')) or
            ((VarIsType(Value, varDate)) and (IsEmptyDate(Value)));
end;

function MySQLDateToDate(datestring: string): TDateTime;
var
  fs: TFormatSettings;
begin
  fs := TFormatSettings.Create;
  fs.DateSeparator := '-';
  fs.ShortDateFormat := 'yyyy-MM-dd';
  fs.TimeSeparator := ':';
  fs.ShortTimeFormat := 'hh:mm';
  fs.LongTimeFormat := 'hh:mm:ss';

  Result := StrToDateTime(datestring, fs);
end;
// SJ Abschlussprojekt

function GetModifiedUTCEx(filename: string): TDateTime;
begin
  if FileExists(filename) then
  begin
    Result := TFile.GetLastWriteTimeUtc(filename);
    if Result.GetSecond mod 2 <> 0 then
      Result := IncSecond(Result, -1);
  end;
end;

// SJ Abschlussprojekt
function GetPathFromPID(const PID: cardinal): string;
var
  hProcess: THandle;
  path: array[0..MAX_PATH - 1] of char;
begin
  hProcess := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, false, PID);
  if hProcess <> 0 then
    try
      if GetModuleFileNameEx(hProcess, 0, path, MAX_PATH) = 0 then
        RaiseLastOSError;
      result := path;
    finally
      CloseHandle(hProcess)
    end
  else
    RaiseLastOSError;
end;
// SJ Abschlussprojekt

function FileSize(const aFilename: String): Int64;
var
  info: TWin32FileAttributeData;
begin
  result := -1;

  if not GetFileAttributesEx(PWideChar(aFileName), GetFileExInfoStandard, @info) then
    Exit;

  result := Int64(info.nFileSizeLow) or Int64(info.nFileSizeHigh shl 32);
end;

function SortSListAsInt(List: TStringList; Index1, Index2: Integer): Integer;
var
  Value1, Value2: Integer;
begin
  Value1 := StrToInt(List[Index1]);
  Value2 := StrToInt(List[Index2]);
  if Value1 < Value2 then
    Result := -1
  else if Value2 < Value1 then
    Result := 1
  else
    Result := 0;
end;

procedure SplitVersionString(const fsversion: String; var fversion: Tversion);
var
   li, li1: integer;
begin
   li1 := posex('.', fsversion);
   trystrtoint(copy(fsversion, 1, li1 - 1), fversion.major);
   li := li1;
   li1 := posex('.', fsversion, li + 1);
   trystrtoint(copy(fsversion, li + 1, li1 - li - 1), fversion.minor);
   li := li1;
   li1 := posex('.', fsversion, li + 1);
   trystrtoint(copy(fsversion, li + 1, li1 - li - 1), fversion.compile);
   li := li1;
   trystrtoint(copy(fsversion, li + 1, length(fsversion) - li), fversion.revision);
end;

//-----------------------------------------------------------------------------
//compare if fversion is bigger than version1
function compareversions(var fversion, fversion1: Tversion): boolean;
begin
   Result := true;
   if fversion.major < fversion1.major then
   begin
      Result := false;
   end
   else
   begin
      if (fversion.minor < fversion1.minor) and (fversion.major = fversion1.major) then
      begin
         Result := false;
      end
      else
      begin
         if (fversion.compile < fversion1.compile) and ((fversion.minor = fversion1.minor) and (fversion.major = fversion1.major)) then
         begin
            Result := false;
         end
         else
         begin
            if (fversion.revision < fversion1.revision) and (fversion.compile = fversion1.compile) and ((fversion.minor = fversion1.minor) and (fversion.major = fversion1.major)) then
            begin
               Result := false;
            end
            else
            begin
            end;
         end;
      end;
   end;
end;

//function ShellExecute_AndWait(Operation, FileName,
//   Parameter, Directory: string; Show: word; bWait: boolean): longint;
//var
//   bOK : boolean;
//   Info : TShellExecuteInfo;
//   rtn : Integer;
//{
//  ****** Parameters ******
//  Operation:
//
//  edit  Launches an editor and opens the document for editing.
//  explore Explores the folder specified by lpFile.
//  find Initiates a search starting from the specified directory.
//  open Opens the file, folder specified by the lpFile parameter.
//  print Prints the document file specified by lpFile.
//  properties Displays the file or folder's properties.
//
//  FileName:
//
//  Specifies the name of the file or object on which
//  ShellExecuteEx will perform the action specified by the lpVerb parameter.
//
//  Parameter:
//
//  String that contains the application parameters.
//  The parameters must be separated by spaces.
//
//  Directory:
//
//  specifies the name of the working directory.
//  If this member is not specified, the current directory is used as the working directory.
//
//  Show:
//
//  Flags that specify how an application is to be shown when it is opened.
//  It can be one of the SW_ values
//
//  bWait:
//
//  If true, the function waits for the process to terminate
//}
//begin
//   FillChar(Info, SizeOf(Info), Chr(0));
//   Info.cbSize := SizeOf(Info);
//   Info.fMask := SEE_MASK_NOCLOSEPROCESS;
//   Info.lpVerb := PChar(Operation);
//   Info.lpFile := PChar(FileName);
//   Info.lpParameters := PChar(Parameter);
//   Info.lpDirectory := PChar(Directory);
//   Info.nShow := Show;
//   bOK := boolean(ShellExecuteEx(@Info));
//   if bOK then
//   begin
//      if bWait then
//      begin
//         while WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
//         begin
////         	 Application.ProcessMessages;
//           Sleep(2);
//         end;
//
//         bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
//      end
//      else
//         Result := 0;
//   end;
//   if not bOK then
//      Result := -1;
//end;

function GetSystemVariable(const name : string): string;
begin
   try
     Result := Sysutils.GetEnvironmentVariable(Name);
   except
     Result := '';
   end;
end;

function GetVersionInfo: string;
var
  VerInfoSize, VerValueSize, Dummy: DWord;
  VerInfo: Pointer;
  VerValue: PVSFixedFileInfo;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    result := IntTostr(dwFileVersionMS shr 16);
    result := result + '.' + IntTostr(dwFileVersionMS and $FFFF);
    result := result + '.' + IntTostr(dwFileVersionLS shr 16);
    result := result + '.' + IntTostr(dwFileVersionLS and $FFFF);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;

function appversion(): String;
var
  verblock: PVSFIXEDFILEINFO;
  versionMS, versionLS, verlen: cardinal;
  rs: TResourceStream;
  m: TMemoryStream;
  AppVersionString: string;
begin
  // wenn "resource 1 not found" dann gibt es Probleme bei der Versionsnummer in der Build-Konfiguration
  // jede Buil-Config muss eine Versionsnummer haben. Vererbung funktioniert da wohl nicht...
  m := TMemoryStream.Create;
  try
    rs := TResourceStream.CreateFromID(HInstance, 1, RT_VERSION);
    try
      m.CopyFrom(rs, rs.Size);
    finally
      rs.Free;
    end;
    m.Position := 0;
    if VerQueryValue(m.Memory, '\', pointer(verblock), verlen) then
      begin
        VersionMS := verblock.dwFileVersionMS;
        VersionLS := verblock.dwFileVersionLS;
        AppVersionString := //Application.Title+' '+
          IntToStr(versionMS shr 16)+'.'+
          IntToStr(versionMS and $FFFF)+'.'+
          IntToStr(VersionLS shr 16)+'.'+
          IntToStr(VersionLS and $FFFF);
      end;
  finally
    m.Free;
  end;
  Result := AppVersionString;
end;

function EnCrypt_old(InputStr, HexKeyStr: string): string;
var
   iCntIStr, iCntKStr: integer;
begin
   iCntIStr := 1;
   iCntKStr := 1;
   Result := '';
   while iCntIStr < (Length(InputStr) + 1) do
   begin
      try
         Result := Result + IntToHex(
            (Ord(InputStr[iCntIStr]) xor StrToInt('$' +
            copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1), 2))), 2);
      except
         on e: Exception do
         begin
            Result := '';
            exit;
         end;
      end;
      Inc(iCntIStr, 1);
      Inc(iCntKStr, 2);
   end;
end;

function EnCrypt(InputStr, HexKeyStr: string): string;
var
  iCntIStr, iCntKStr, i: integer;
  B: array of Byte;
  bytes, bom: TBytes;
  multibyte: Boolean;
begin
  Result := '';
  multibyte := False;
  bytes := WideBytesOf(InputStr);
  for i := Low(bytes) to High(bytes) do
  begin
    if (i mod 2 > 0) and (Int(bytes[i]) > 0) then
    begin
      multibyte := True;
      break;
    end;
  end;

  if multibyte then
  begin
    bom := TBytes.Create(255,254);  // BOM fr utf-16-le
    Insert(bom,bytes,0);
    iCntIStr := 0;
    iCntKStr := 1;
    while iCntIStr < (Length(bytes)) do
    begin
      try
        Result := Result + IntToHex(
          (bytes[iCntIStr] xor StrToInt('$' +
          copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr)), 2))), 2);
      except
        on e: Exception do
        begin
          Result := '';
          exit;
        end;
      end;
      Inc(iCntIStr, 1);
      Inc(iCntKStr, 2);
    end;
  end else  // alte Methode fr Zeichen bis 0xFF
  begin
    iCntIStr := 1;
    iCntKStr := 1;
    while iCntIStr < (Length(InputStr) + 1) do
    begin
      try
        Result := Result + IntToHex(
          (Ord(InputStr[iCntIStr]) xor StrToInt('$' +
          copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr)), 2))), 2);
      except
        on e: Exception do
        begin
          Result := '';
          exit;
        end;
      end;
      Inc(iCntIStr, 1);
      Inc(iCntKStr, 2);
    end;
  end;
end;

//-----------------------------------------------------------------------------
function DeCrypt_old(HexInputStr, HexKeyStr: string): string;
var
   iCntIStr, iCntKStr: integer;
begin
   iCntIStr := 1;
   iCntKStr := 1;
   Result := '';
   while iCntIStr < (Length(HexInputStr) + 1) do
   begin
      try
         Result := Result + chr((StrToInt('$' + copy(HexInputStr, iCntIStr, 2)) xor
            StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1), 2))));
      except
         on e: Exception do
         begin
            Result := '';
            exit;
         end;
      end;
      Inc(iCntIStr, 2);
      Inc(iCntKStr, 2);
   end;
end;
//-----------------------------------------------------------------------------
function DeCrypt(HexInputStr, HexKeyStr: string): string;
var
   iCntIStr, idx: integer;
   bytes: TBytes;
begin
   iCntIStr := 1;
   idx := 0;
   Result := '';
   bytes := TBytes.Create();
   SetLength(bytes, (length(HexInputStr) div 2));
   while iCntIStr < (length(HexInputStr) + 1) do
   begin
      try
         bytes[idx] := StrToInt('$' + copy(HexInputStr, iCntIStr, 2)) xor
            StrToInt('$' + copy(HexKeyStr, iCntIStr mod (length(HexKeyStr)), 2));
      except
         on e: Exception do
         begin
            Result := '';
            exit;
         end;
      end;
      Inc(iCntIStr, 2);
      Inc(idx);
   end;

   if (length(bytes) > 0) and (bytes[0] = 255) and (bytes[1] = 254) then
     Result := WideStringOf(Copy(bytes,2, length(bytes) -2))
   else
     Result := StringOf(bytes);
end;

function WindowsUserName: String;
var
  nSize : DWord;
  UserName : string;
begin
  try
    nSize := 1024;
    SetLength(Result, nSize);
    if GetUserName(PChar(Result), nSize) then
      SetLength(Result, nSize - 1)
    else
      Result := '';
  except
    Result := '';
  end;
end;

function GetBitfarmURL : WideString;
begin
  Result := '(c) 2004 - ' + cCurYear + ' bitfarm GmbH';
end;


function ArcDocId(ArcId, DocId: int64): TArcDocId;
begin
  Result.ArcId := ArcId;
  Result.DocId := DocId;
end;

function CreateNewPid(id : Int64):PPID;
begin
  New(Result);
  Result^.id := id;
end;

procedure RegIfNotExistWriteString(Reg:TRegistry; Key, Value:string);
begin
   if not Reg.ValueExists(Key) then
      Reg.WriteString(Key, Value);
end;

//-----------------------------------------------------------------------------
function RegReadBool(Reg: TRegistry; Key: string; DefValue: Boolean):Boolean;
begin
   if Reg.ValueExists(Key) then
      Result := Reg.ReadBool(Key)
   else
      Result := DefValue;
end;

function RegReadInteger(Reg: TRegistry; Key: string; DefValue: Integer):Integer;
begin
   if Reg.ValueExists(Key) then
      Result := Reg.ReadInteger(Key)
   else
      Result := DefValue;
end;

//-----------------------------------------------------------------------------
function RefToCell(ARow, ACol: Integer): string;
var
  ACount, APos: Integer;
begin
// 	b.takacs 31.08.2010 [2686]

//   Result := Chr(Ord('A') + ACol - 1) + IntToStr(ARow);
//  Wenn ACol=27 (AA), kann nicht schreiben, fehlermeldung. Nur bis ACol=26 (Z) kann schreiben

  ACount := ACol div 26;
  APos := ACol mod 26;
  if APos = 0 then
  begin
    ACount := ACount - 1;
    APos := 26;
  end;

  if ACount = 0 then
    Result := Chr(Ord('A') + ACol - 1) + IntToStr(ARow);

  if ACount = 1 then
    Result := 'A' + Chr(Ord('A') + APos - 1) + IntToStr(ARow);

  if ACount > 1 then
    Result := Chr(Ord('A') + ACount - 1) + Chr(Ord('A') + APos - 1) + IntToStr(ARow);
end;

// Semikolon raus; \ und ' werden escaped ( \\ und \' )
function ParseSQLString(InputStr: string): string;
begin
   Result := Trim(InputStr);
   Result := StringReplace(Result, ';', '', [rfReplaceAll]);
   Result := StringReplace(Result, '\', '\\', [rfReplaceAll]);
//   Result := StringReplace(Result, #39 , '\' + #39, [rfReplaceAll]);
end;

// ; wird entfernt, ' wird escaped zu \'
function ParseSemicolonUseBackslash(InputStr: string): string;
begin
   Result := Trim(InputStr);
   Result := StringReplace(Result, ';', '', [rfReplaceAll]);
   //change ' to \' for mysql
   Result := StringReplace(Result, #39 , '\' + #39, [rfReplaceAll]);
end;

function ParseMultipleDelimiters(Delimiter: Char; InputStr: string): string;
begin
  Result := Trim(InputStr);
  while Pos(Delimiter + Delimiter, Result) > 0 do
    Result := StringReplace(Result, Delimiter + Delimiter, Delimiter, [rfReplaceAll]);
end;

// ; ' und \' werden entfernt
function ParseSemicolonWithoutBackslash(InputStr: string): string;
begin
   Result := Trim(InputStr);
   Result := StringReplace(Result, ';', '', [rfReplaceAll]);
   //be sure there is no \' already
   Result := StringReplace(Result, '\' + #39 + '', '' + #39 + '', [rfReplaceAll]);
   Result := StringReplace(Result, #39 , '', [rfReplaceAll]);
end;

// Sonderzeichen raus ' " \ ! * ? ` { | } , aber Semikolon darf bleiben
function ParseAddfields(InputStr: string): string;
begin
   Result := Trim(InputStr);
   Result := StringReplace(Result, #39, '', [rfReplaceAll]);
   Result := StringReplace(Result, #34, '', [rfReplaceAll]);
   Result := StringReplace(Result, '\', '', [rfReplaceAll]);
	 Result := StringReplace(Result, '!', '', [rfReplaceAll]);
//   Result := StringReplace(Result, '(', '', [rfReplaceAll]);
//   Result := StringReplace(Result, ')', '', [rfReplaceAll]);
   Result := StringReplace(Result, '*', '', [rfReplaceAll]);
   Result := StringReplace(Result, '?', '', [rfReplaceAll]);
   Result := StringReplace(Result, '`', '', [rfReplaceAll]);
   Result := StringReplace(Result, '{', '', [rfReplaceAll]);
   Result := StringReplace(Result, '|', '', [rfReplaceAll]);
   Result := StringReplace(Result, '}', '', [rfReplaceAll]);
   Result := StringReplace(Result, #160, '', [rfReplaceAll]);
   while Pos('--', Result) > 0 do
	   Result := StringReplace(Result, '--', '-', [rfReplaceAll]); //MySQL Kommentarzeichen
   while Pos(';;', Result) > 0 do
	   Result := StringReplace(Result, ';;', ';', [rfReplaceAll]); //doppelte Semikolon zusammenfassen, um beim Trennen Leereintrge zu vermeiden
   if RightStr(Result, 1) = ';' then
    Result := LeftStr(Result, Length(Result) -1);                //endstndige Semikolon vermeiden, um beim Trennen Leereintrge zu vermeiden

end;

// Sonderzeichen raus ' " \ ! * ? ` {} , aber Semikolon und Pipe darf bleiben
function ParseGridfields(InputStr: string): string;
begin
   Result := Trim(InputStr);
   Result := StringReplace(Result, #39, '', [rfReplaceAll]);
   Result := StringReplace(Result, #34, '', [rfReplaceAll]);
   Result := StringReplace(Result, '\', '', [rfReplaceAll]);
	 Result := StringReplace(Result, '!', '', [rfReplaceAll]);
//   Result := StringReplace(Result, '(', '', [rfReplaceAll]);
//   Result := StringReplace(Result, ')', '', [rfReplaceAll]);
   Result := StringReplace(Result, '*', '', [rfReplaceAll]);
   Result := StringReplace(Result, '?', '', [rfReplaceAll]);
   Result := StringReplace(Result, '`', '', [rfReplaceAll]);
   Result := StringReplace(Result, '{', '', [rfReplaceAll]);
//   Result := StringReplace(Result, '|', '', [rfReplaceAll]);
   Result := StringReplace(Result, '}', '', [rfReplaceAll]);
   Result := StringReplace(Result, #160, '', [rfReplaceAll]);
   while Pos('--', Result) > 0 do
	   Result := StringReplace(Result, '--', '-', [rfReplaceAll]); //MySQL Kommentarzeichen

end;

// Sonderzeichen raus ' \ ! ( ) * ? ` { | } , aber Semikolon und Anfhrungszeichen darf bleiben
// wegen der Suche nach Leer und nicht Leer
function ParseSearchfield(InputStr: string): string;
begin
    Result := Trim(InputStr);
   Result := StringReplace(Result, #39, '', [rfReplaceAll]);
   Result := StringReplace(Result, '\', '', [rfReplaceAll]);
   Result := StringReplace(Result, '!', '', [rfReplaceAll]);
//   Result := StringReplace(Result, '(', '', [rfReplaceAll]);
//   Result := StringReplace(Result, ')', '', [rfReplaceAll]);
   Result := StringReplace(Result, '*', '', [rfReplaceAll]);
   Result := StringReplace(Result, '?', '', [rfReplaceAll]);
   Result := StringReplace(Result, '`', '', [rfReplaceAll]);
   Result := StringReplace(Result, '{', '', [rfReplaceAll]);
   Result := StringReplace(Result, '|', '', [rfReplaceAll]);
   Result := StringReplace(Result, '}', '', [rfReplaceAll]);
   Result := StringReplace(Result, #160, '', [rfReplaceAll]);
   while Pos('--', Result) > 0 do
	   Result := StringReplace(Result, '--', '-', [rfReplaceAll]); //MySQL Kommentarzeichen
   while Pos(';;', Result) > 0 do
	   Result := StringReplace(Result, ';;', ';', [rfReplaceAll]); //doppelte Semikolon zusammenfassen, um beim Trennen Leereinträge zu vermeiden
   if RightStr(Result, 1) = ';' then
    Result := LeftStr(Result, Length(Result) -1);                //endstndige Semikolon vermeiden, um beim Trennen Leereinträge zu vermeiden

end;


procedure AddfieldType0KeyPress(var Key: Char);
begin
   if Key in [
      '!', 		// Trenner
      //'"', 	// Anfhrungszeichen, reserviert als Quote und auch SQL //3.5.0.46 [2414]
      //  '%', // wegen SQL mit like //3.5.0.71 wieder dazu
      #39, 		// Apostroph, wegen SQL
//      '(', 		// wegen SQL
//      ')', 		// wegen SQL
      '\', 		// wegen SQL
      '*', 		// vielleicht mal Platzhalter
      // ',', // Trenner //3.5.0.31 wegen Thomas, Herr Pi(e)tsch?
      '?', 		// vielleicht mal Platzhalter
      '`', 		// wegen SQL
      '{', 		// wegen - rein vorsichtshalber
      '|', 		// wegen - rein vorsichtshalber
      '}', 		// wegen - rein vorsichtshalber
      #160 		// geschtztes Leerzeichen
      ]
   then
   	Key := #0;
   if Key = #13 then    // die Windows-Bell unterdrcken
   	Key := #0;
end;


function ParseFilename(S: string): string;   // Windows unzulssige Zeichen im FileName
var                                          // inkl & Zeichen, weil das Probleme auf der Kommandozeile macht
   i : Integer;
begin
   Result := '';
   for i := 1 to length(S) do
      if not (S[i] in ['\','/',':','*','?','"','<','>','|','&']) then
         Result := Result + S[i];
end;

function ParseFilepath(S: Widestring): Widestring;   // Windows unzulssige Zeichen FilePath (\/ sind erlaubt)
var                                                  // inkl & Zeichen, weil das Probleme auf der Kommandozeile macht
   i : Integer;
begin
   Result := '';
   for i := 1 to length(S) do
      if not (S[i] in ['*','?','"','<','>','|','&']) then
         Result := Result + S[i];
end;

function ParseNotAllowedChars(S: Widestring): Widestring; overload;  // Windows unzulssige Zeichen
var
   i : Integer;
begin
   Result := '';
   for i := 1 to length(S) do
      if (Pos(S[i], sNotAllowedChar) = 0) and not (S[i] in [#0..#31]) then
         Result := Result + S[i];
end;

// Die Funktion wurde hinzugefgt, weil sie bei groen Strings um ein Vielfaches schneller ist als
// die obige Funktion. Concatenation von WideString dauert sehr lange.
function ParseNotAllowedChars(S: string): Widestring; overload;// Windows unzulssige Zeichen
var
   i : Integer;
   sTemp: string;
begin
   sTemp := '';
   for i := 1 to length(S) do
//      if not (S[i] in ['\','/',':',';','*','?','"','<','>','|','+','=']) then
      if (Pos(S[i], sNotAllowedChar) = 0) and not (S[i] in [#0..#31]) then
         sTemp := sTemp + S[i];
   Result := sTemp;
end;

function ParseNotAllowedChars(S, NotAllowed: string): Widestring; overload;
var
   i : Integer;
   sTemp: string;
begin
   sTemp := '';
   for i := 1 to length(S) do
      if (Pos(S[i], NotAllowed) = 0) and not (S[i] in [#0..#31]) then
         sTemp := sTemp + S[i];
   Result := sTemp;
end;

procedure RemoveMultipleSpaces(var s: String); overload;
begin
  s := StringReplace(s, #32#32, #32, [rfReplaceAll]);
end;

procedure RemoveMultipleSpaces(var s: WideString); overload;
begin
  s := StringReplace(s, #32#32, #32, [rfReplaceAll]);
end;

function ParseAlphanumeric(AValue: AnsiString):string;
var
  SrcPtr, DestPtr: PChar;
  i : Integer;
begin
  AValue := Trim(AValue);
  for i := 1 to Length(AValue) do
  begin
    if AValue[i] in ['a'..'z', 'A'..'Z', '0'..'9', '_'] then begin
      Result:= Result + AValue[i];
    end;
  end;

end;

function StrToHtml(s: string): string;
const
  EntityChars = '"&<>''';
  EntityStrings: array [1..5] of string
    = ('&quot;', '&amp;', '<', '>', '&apos;');
var
  i, j: integer;
  c : Char;
begin
  for i := Length(s) downto 1 do begin
    j := Pos(s[i], EntityChars);
    if j > 0 then begin
      Delete(s, i, 1);
      Insert(EntityStrings[j], s, i);
    end else
    if not (s[i] in [#32..#127]) then begin
    	c := s[i];
      Delete(s, i, 1);
      Insert('&#' + IntToStr(Ord(c)) + ';', s, i);
    end;
  end;
  Result := s;
end;

function FileAccessable(FileName: string): boolean;
var
   iFile: integer;
begin
   iFile := -1;
   result:= False; //22.09.2010 b.takacs
   try
      iFile := FileOpen(FileName, fmOpenRead);
      FileClose(iFile);

      if iFile >= 0 then
         Result := True
      else
         Result := False;
//   finally
	 except
      FileClose(iFile);
   end;
end;

function IsDirWriteable(const dir: string):Boolean;
var
  Handle:Integer;
begin
  try

    Handle:=filecreate(dir + '~bfatest');
    if (Handle) > 0 then
    begin
      IsDirWriteable:=True;
      FileClose(Handle);
      DeleteFile(dir + '~bfatest')
    end
    else
    begin
      IsDirWriteable:=False
    end;
  except
     IsDirWriteable:=False
  end;
end;

function CheckFileAccess(const FileName: string; const CheckedAccess: Cardinal): Cardinal;
var
//01.03.2019 XE2 Token: Cardinal;
    Token : NativeUInt;
    Status: LongBool;
    Access: Cardinal;
    SecDescSize: Cardinal;
    PrivSetSize: Cardinal;
    PrivSet: PRIVILEGE_SET;
    Mapping: GENERIC_MAPPING;
    SecDesc: PSECURITY_DESCRIPTOR;
begin
  Result := 0;
  GetFileSecurity(PChar(Filename), OWNER_SECURITY_INFORMATION or GROUP_SECURITY_INFORMATION or DACL_SECURITY_INFORMATION, nil, 0, SecDescSize);
  SecDesc := GetMemory(SecDescSize);

  if GetFileSecurity(PChar(Filename), OWNER_SECURITY_INFORMATION or GROUP_SECURITY_INFORMATION or DACL_SECURITY_INFORMATION, SecDesc, SecDescSize, SecDescSize) then
  begin
    ImpersonateSelf(SecurityImpersonation);
    OpenThreadToken(GetCurrentThread, TOKEN_QUERY, False, Token);
    if Token <> 0 then
    begin
      Mapping.GenericRead := FILE_GENERIC_READ;
      Mapping.GenericWrite := FILE_GENERIC_WRITE;
      Mapping.GenericExecute := FILE_GENERIC_EXECUTE;
      Mapping.GenericAll := FILE_ALL_ACCESS;

      MapGenericMask(Access, Mapping);
      PrivSetSize := SizeOf(PrivSet);
      AccessCheck(SecDesc, Token, CheckedAccess, Mapping, PrivSet, PrivSetSize, Access, Status);
      CloseHandle(Token);
      if Status then
        Result := Access;
    end;
  end;

  FreeMem(SecDesc, SecDescSize);
end;

// Dateigroesse ermitteln
// Parameter: Filename   String mit Pfad und Dateiname
// Ausgabe: Dateigroesse
function GetFileSizeStr(FileName : string) : string;
var
   hFile, iSize: cardinal;
begin
   hFile := CreateFile(PChar(FileName), 0, FILE_SHARE_READ, nil,
      OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
   if hFile <> INVALID_HANDLE_VALUE then
   begin
      iSize := GetFileSize(hFile, nil);
      CloseHandle(hFile);
      if iSize = $0 then
         Result := _('Unbekannt')
      else
      if iSize < $400 then
         Result := IntToStr(iSize) + ' Byte'
      else
      if iSize < $100000 then
         Result := IntToStr(Round(iSize / $400)) + ' KB'
      else
      if iSize < $40000000 then
         Result := IntToStr(Round(iSize / $100000)) + ' MB'
      else
      if iSize < $10000000000 then
         Result := IntToStr(Round(iSize / $40000000)) + ' GB'
      else
         Result := IntToStr(iSize) + ' Byte';
   end
   else
      Result := _('Unbekannt');
end;

function GetStreamSizeStr(str : TMemoryStream) : string;
var
   iSize: cardinal;
begin
  if str = nil then
  begin
    Result := '0 Byte';
    Exit;
  end;

  iSize := str.Size;
  if iSize = $0 then
     Result := _('Unbekannt')
  else
  if iSize < $400 then
     Result := IntToStr(iSize) + ' Byte'
  else
  if iSize < $100000 then
     Result := IntToStr(Round(iSize / $400)) + ' KB'
  else
  if iSize < $40000000 then
     Result := IntToStr(Round(iSize / $100000)) + ' MB'
  else
  if iSize < $10000000000 then
     Result := IntToStr(Round(iSize / $40000000)) + ' GB'
  else
     Result := IntToStr(iSize) + ' Byte';
end;

//-----------------------------------------------------------------------------
function KeyPressed(key: integer): boolean;
begin
   case GetKeyState(key) of
      -127, -128:
         Result := True;
   else
      Result := False;
   end;
end;


function GetCharFromVirtualKey(Key: Word): string;
 var
    keyboardState: TKeyboardState;
    asciiResult: Integer;
 begin
    GetKeyboardState(keyboardState) ;

    SetLength(Result, 2) ;
    asciiResult := ToAscii(key, MapVirtualKey(key, 0), keyboardState, @Result[1], 0) ;
    case asciiResult of
      0: Result := '';
      1: SetLength(Result, 1) ;
      2:;
      else
        Result := '';
    end;
 end;


function IndexOfCaseSensitive(SL:TStrings;const Item:string):integer;
begin
  for Result := 0 to SL.Count-1 do
    if SL[Result]=Item then Exit;
  Result := -1;
end;


function RunWaitAndCaptureOutput(CommandLine:string; var Output:string; LogLevel:integer):DWord;
const BufSize=1024;
var
  buf:array[0..BufSize-1] of char;

  si:STARTUPINFOA;
  sa:SECURITY_ATTRIBUTES;
  sd:SECURITY_DESCRIPTOR;               //security information for pipes
  pi:PROCESS_INFORMATION;

  // newstdin,
  newstdout,
  read_stdout:THandle;
  // write_stdin:THandle;  //pipe handles

  bytes_read:cardinal;
  bytes_available:cardinal;

  procedure ZeroBuffer;
  begin
    FillChar(Buf,SizeOf(Buf),0);
  end;

  procedure RaiseError(str:string);
  var n:DWord;
  begin
    n:=GetLastError;
    raise ERedirectorError.CreateFmt('%s: %d/0x%x - %s',[Str,n,n,SysErrorMessage(n)]);
  end;

  procedure GetData;
  begin
     PeekNamedPipe(read_stdout,@buf,BufSize-1,@bytes_read,@bytes_available,NIL);

    //check to see if there is any data to read from stdout
    if (bytes_read<>0) then
      begin
        ZeroBuffer;
        if (bytes_available>BufSize-1)
          then
            while (bytes_read>=BufSize-1) do
              begin
                ReadFile(read_stdout,buf,BufSize-1,bytes_read,NIL);  //read the stdout pipe
                Output:=Output+Buf;
                ZeroBuffer;
              end
          else
            begin
              ReadFile(read_stdout,buf,BufSize-1,bytes_read,NIL);
              Output:=Output+Buf;
            end;
     end;
  end;
  procedure WriteOutput;
  begin
     write(Output); Output:='';
  end;
begin
  Output:='';
  Result:=255; // indicate some error

  //if IsNT
  if true
    then       //initialize security descriptor (Windows NT)
      begin
        InitializeSecurityDescriptor(@sd,SECURITY_DESCRIPTOR_REVISION);
        SetSecurityDescriptorDacl(@sd,true,NIL,False);
        sa.lpSecurityDescriptor:=@sd;
      end
    else sa.lpSecurityDescriptor:=NIL;


  sa.nLength:=sizeof(SECURITY_ATTRIBUTES);
  sa.bInheritHandle:=true;         //allow inheritable handles
  (*
  if not(CreatePipe(newstdin,write_stdin,@sa,0))   //create stdin pipe
    then RaiseError('CreatePipe');
  *)
  if not(CreatePipe(read_stdout,newstdout,@sa,0))  //create stdout pipe
    then
      begin
        // CloseHandle(newstdin);
        // CloseHandle(write_stdin);
        RaiseError('CreatePipe');
      end;

  GetStartupInfoA(si);      //set startupinfo for the spawned process
  {
  The dwFlags member tells CreateProcess how to make the process.
  STARTF_USESTDHANDLES validates the hStd* members. STARTF_USESHOWWINDOW
  validates the wShowWindow member.
  }

  si.dwFlags:=STARTF_USESTDHANDLES or STARTF_USESHOWWINDOW;
  si.wShowWindow:=SW_HIDE;
  si.hStdOutput:=newstdout;
  si.hStdError:=newstdout;     //set the new handles for the child process
  // si.hStdInput:=newstdin;

  //spawn the child process
  if not
       (CreateProcessA(NIL,PAnsiChar(CommandLine),NIL,NIL,TRUE,CREATE_NEW_CONSOLE,
                        NIL,NIL,si,pi))
    then
      begin
        // CloseHandle(newstdin);
        CloseHandle(newstdout);
        CloseHandle(read_stdout);
        // CloseHandle(write_stdin);
        RaiseError('CreateProcess');
      end;
  ZeroBuffer;
  while True do
    begin
      GetExitCodeProcess(pi.hProcess,Result);      //while the process is running
      if (Result<>STILL_ACTIVE) then break;
      GetData;
      //Yield;  //frey
      sleep(200); //frey
      if LogLevel>0
      then WriteOutput;
    end;
  GetData;

  CloseHandle(pi.hThread);
  CloseHandle(pi.hProcess);
  // CloseHandle(newstdin);            //clean stuff up
  CloseHandle(newstdout);
  CloseHandle(read_stdout);
  // CloseHandle(write_stdin);
end;

function StrToInt0(const S: string): Integer;
begin
   try
      Result := StrToInt(S);
   except
      on e: EConvertError do
      begin
         Result := 0;
      end;
   end;
end;

function ExistentFilesInDir(fsPath: string): integer;
var
   sr: TSearchRec;
   RowCount: integer;
begin
   RowCount := 0;
   Result := 0;
   if FindFirst(fsPath, faAnyFile, sr) = 0 then
   begin
      repeat
         RowCount := RowCount + 1;
      until FindNext(sr) <> 0;

      FindClose(sr);
      Result := RowCount;
   end;
end;

function CalcNonExistingFilename(Path, Name, Ext: string): string;
var
  linfiles: integer;
  snamFile1: string;
begin
   Result := Name;
   linfiles := ExistentFilesInDir(Path + '\' + Name + Ext);
   if linfiles <> 0 then
   begin
      snamFile1 := Name + '_' + IntToStr(linfiles);
      while FileExists(Path + '\' + snamFile1 + Ext) do
      begin
         Inc(linfiles);
         snamFile1 := Name + '_' + IntToStr(linfiles);
      end;
      Result := snamFile1;
   end;
end;

//procedure StringToFile(const Dateiname:Ansistring; const Data:Ansistring);
//begin
//	if Data <> '' then    //18.07.2011 b.takacs 3.5.1.30 [3117]
//	   SaveToFile(Dateiname,Data[1],length(Data))
//   else
//	   SaveToFile(Dateiname,Data,length(Data)); //18.07.2011 b.takacs 3.5.1.30 [3117]
//end;
//{>3.6}
//
////-----------------------------------------------------------------------------
//procedure SaveToFile(const Dateiname:Ansistring; const Buffer; Count: Longint);
//var FS:TFileStream; // w:integer; f:file;
//begin
//   FS:=TFileStream.Create(Dateiname, fmCreate);
//   try
//      FS.Write(Buffer, Count);
//   finally
//      FS.Free;
//   end;
//end;

//-----------------------------------------------------------------------------
// true, wenn String nur aus Ziffern, Komma und/oder Punkt besteht
function IstZahl(S:string):Boolean; //[2487]
var i:integer;
begin
   Result := False;
   if S='' then
      Exit;
   for i := 1 to length(S) do
      if not (S[i] in ['0'..'9',',','.'])
      then Exit;
   Result := True;
end;

//-----------------------------------------------------------------------------
//returns true if a given directory is empty, false otherwise [3069]
//function IsDirectoryEmpty(const directory : string) : boolean;
//var
//   searchRec :TSearchRec;
//begin
//  try
//    result := (FindFirst(directory + '\*.*', faAnyFile, SearchRec) = 0) AND
//              (FindNext(searchRec) = 0) AND
//              (FindNext(searchRec) <> 0) ;
//  finally
//     FindClose(searchRec) ;
//  end;
//end;
//
//
//function EmptyDirectory(const ADir: string): boolean;
//var
//   searchRec :TSearchRec;
//begin
//   Result := True;
//   try
//      if (FindFirst(ADir + '\*.*', faAnyfile - faDirectory, SearchRec) = 0) then
//      begin
//         repeat
//            DeleteFile(ADir + '\' + SearchRec.Name);
//         until (FindNext(SearchRec) <> 0);
//         FindClose(SearchRec);
//      end;
//   except
//       Result := False;
//   end;
//end;
//
//function BFDeleteFile(const AFile: string): boolean;
//var
//   sh: SHFileOpStruct;
//begin
//  try
//   ZeroMemory(@sh, sizeof(sh));
//   with sh do
//   begin
//      Wnd := Application.Handle;
//      wFunc := fo_Delete;
//      pFrom := PChar(AFile + #0);
//      fFlags := fof_Silent or fof_NoConfirmation;
//   end;
//   Result := SHFileOperation(sh) = 0;
//  except
//  	result:= false; //30.05.2011 b.takacs 3.5.1.16
//  end;
//end;
//
//function BfCopyDir(const fromDir, toDir: string; ARename: boolean = false): Boolean;
//var
//  fos: TSHFileOpStruct;
//begin
//  ZeroMemory(@fos, SizeOf(fos));
//  with fos do
//  begin
//    wFunc  := FO_COPY;
//    fFlags := FOF_FILESONLY;
//    pFrom  := PChar(fromDir + #0);
//    pTo    := PChar(toDir);
//    if ARename then
//    	 fFlags := fFlags or fof_RenameOnCollision;
//  end;
//  Result := (0 = ShFileOperation(fos));
//end;
//
//function BfMoveDir(const fromDir, toDir: string): Boolean;
//var
//  fos: TSHFileOpStruct;
//begin
//  ZeroMemory(@fos, SizeOf(fos));
//  with fos do
//  begin
//    wFunc  := FO_MOVE;
//    fFlags := FOF_FILESONLY;
//    pFrom  := PChar(fromDir + #0);
//    pTo    := PChar(toDir);
//  end;
//  Result := (0 = ShFileOperation(fos));
//end;
//
//function BfDelDir(dir: string): Boolean;
//var
//  fos: TSHFileOpStruct;
//begin
//  ZeroMemory(@fos, SizeOf(fos));
//  with fos do
//  begin
//    wFunc  := FO_DELETE;
//    fFlags := FOF_SILENT or FOF_NOCONFIRMATION;
//    pFrom  := PChar(dir + #0);
//  end;
//  Result := (0 = ShFileOperation(fos));
//end;
//
//function ReadDir(Path, Mask: string; ShowPath: boolean): TStringlist;
//var SRec: TSearchRec;
//begin
//   //Path := IncludeTrailingBackslash(Path);
//   Path := IncludeTrailingPathDelimiter(Path);
//   Result := TStringList.Create;
//   try
//      if FindFirst(Path + Mask, not faDirectory, SRec) <> 0 then
//         Exit;
//      repeat
//         case ShowPath of
//            True:
//               result.Add(Path + SRec.Name);
//            False:
//               result.Add(SRec.Name);
//         end;
//      until FindNext(SRec) <> 0;
//   finally
//      FindClose(SRec);
//   end;
//end;

function IsUserAdmin : boolean;
const CAdminSia : TSidIdentifierAuthority = (value: (0, 0, 0, 0, 0, 5));
var sid : PSid;
    ctm : function (token: dword; sid: pointer; var isMember: bool) : bool; stdcall;
    b1  : bool;
begin
  result := false;
  ctm := GetProcAddress(LoadLibrary('advapi32.dll'), 'CheckTokenMembership');
  if (@ctm <> nil) and AllocateAndInitializeSid(CAdminSia, 2, $20, $220, 0, 0, 0, 0, 0, 0, sid) then begin
    result := ctm(0, sid, b1) and b1;
    FreeSid(sid);
  end;
end;

// SJ Abschlussprojekt
function Windows64Bit: Boolean;
type
  TIsWow64Process = function( // Type of IsWow64Process API fn
    Handle: Windows.THandle; var Res: Windows.BOOL
  ): Windows.BOOL; stdcall;
var
  IsWow64Result: Windows.BOOL; // Result from IsWow64Process
  IsWow64Process: TIsWow64Process; // IsWow64Process fn reference
begin
  // https://www.delphipraxis.net/810806-post3.html
  // Try to load required function from kernel32
  IsWow64Process := Windows.GetProcAddress(
    Windows.GetModuleHandle('kernel32'), 'IsWow64Process'
  );
  if Assigned(IsWow64Process) then
  begin
    // Function is implemented: call it
    if not IsWow64Process(
      Windows.GetCurrentProcess, IsWow64Result
    ) then
      raise SysUtils.Exception.Create('IsWindows64: bad process handle');
    // Return result of function
    Result := IsWow64Result;
  end
  else
    // Function not implemented: can't be running on Wow64
    Result := False;
end;
// SJ Abschlussprojekt

// SJ Abschlussprojekt
function ShellExecToString(ErrCode: Integer): string;
begin
  // http://www.oehive.org/node/528.html
  // https://docs.microsoft.com/en-us/windows/win32/api/shellapi/nf-shellapi-shellexecuteexa
  case ErrCode of
    0:  Result := 'The operating system is out of memory or resources.';
    2:  Result := 'The specified file was not found.'; {ERROR_FILE_NOT_FOUND}
    3:  Result := 'The specified path was not found.'; {ERROR_PATH_NOT_FOUND}
    5:  Result := 'The operating system denied access to the specified file. UAC possible'; {SE_ERR_ACCESSDENIED}
    8:  Result := 'There was not enough memory to complete the operation.'; {SE_ERR_OOM}
    10: Result := 'Wrong Windows version';
    11: Result := 'The .exe file is invalid (non-Win32 .exe or error in .exe image).'; {ERROR_BAD_FORMAT}
    12: Result := 'Application was designed for a different operating system';
    13: Result := 'Application was designed for MS-DOS 4.0';
    15: Result := 'Attempt to load a real-mode program';
    16: Result := 'Attempt to load a second instance of an application with non-readonly data segments';
    19: Result := 'Attempt to load a compressed application file';
    20: Result := 'Dynamic-link library (DLL) file failure';
    26: Result := 'A sharing violation occurred.'; {SE_ERR_SHARE}
    27: Result := 'The file name association is incomplete or invalid.'; {SE_ERR_ASSOCINCOMPLETE}
    28: Result := 'The DDE transaction could not be completed because the request timed out.'; {SE_ERR_DDETIMEOUT}
    29: Result := 'The DDE transaction failed.'; {SE_ERR_DDEFAIL}
    30: Result := 'The DDE transaction could not be completed because other DDE transactions were being processed.'; {SE_ERR_DDEBUSY}
    31: Result := 'There is no application associated with the given file name extension. This error will also be returned if you attempt to print a file that is not printable.'; {SE_ERR_NOASSOC}
    32: Result := 'The specified DLL was not found.'; {SE_ERR_DLLNOTFOUND}
  else
    Result := 'ResultCode: ' + IntToStr(ErrCode);
//    Result := 'unknown error occurred - ErrorCode: ' + IntToStr(ErrCode);
  end;
end;
// SJ Abschlussprojekt

//procedure FindAllFiles(var FileList: TStrings; RootFolder: string;
//   Mask: string = '*.*'; Recurse: boolean = True; CheckExt : Boolean = True);
//var
//   SR: TSearchRec;
//begin
//   IncludeTrailingPathDelimiter(RootFolder);
//
//   if Recurse then
//      if FindFirst(RootFolder + '*.*', faAnyFile, SR) = 0 then
//         try
//            repeat
//               if SR.Attr and faDirectory = faDirectory then
//                  // --> ein Verzeichnis wurde gefunden
//                  //   der Verzeichnisname steht in SR.Name
//                  //   der vollstndige Verzeichnisname (inkl. darberliegender Pfade) ist
//                  //       RootFolder + SR.Name
//                  if (SR.Name <> '.') and (SR.Name <> '..') then
//                     FindAllFiles(FileList, RootFolder + SR.Name, Mask, Recurse);
//            until FindNext(SR) <> 0;
//         finally
//            FindClose(SR);
//         end;
//   if FindFirst(RootFolder + Mask, faAnyFile, SR) = 0 then
//      try
//         repeat
//            if SR.Attr and faDirectory <> faDirectory then
//            begin
//               // --> eine Datei wurde gefunden
//               //   der Dateiname steht in SR.Name
//               //   der vollstndige Dateiname (inkl. Pfadangabe) ist
//               //       RootFolder + SR.Name
//               // sonst findet *.con auch .conf
//               if CheckExt then
//               begin
//                  if (lowercase(ExtractFileExt(SR.Name)) = lowercase(ExtractFileExt(mask))) then
//    	               FileList.Add(RootFolder + SR.Name);
//               end else
//                  FileList.Add(RootFolder + SR.Name);
//            end;
//         until FindNext(SR) <> 0;
//      finally
//         FindClose(SR);
//      end;
//end;
//
//procedure KillFile(FileName: string);
//var
//   f: file;
//begin
////   GgfLogEvnt('KillFile:' + FileName);
//
//   if FileExists(FileName) then
//   begin
//      assignfile(f, FileName);
//{$I-}
//      Erase(f);
//{$I+}
//   end
//   else
//   begin
//      exit;
//   end;
//end;

// SJ Abschlussprojekt
// https://stackoverflow.com/questions/43774320/how-to-kill-a-process-by-name/43775788#43775788
function KillTask(ExeFileName: string): Integer;
const
  PROCESS_TERMINATE = $0001;
var
  ContinueLoop: BOOL;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  Result := 0;
  FSnapshotHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := SizeOf(FProcessEntry32);
  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);

  while Integer(ContinueLoop) <> 0 do
  begin
    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
      UpperCase(ExeFileName)) or (UpperCase(FProcessEntry32.szExeFile) =
      UpperCase(ExeFileName))) then
      Result := Integer(TerminateProcess(
                        OpenProcess(PROCESS_TERMINATE,
                                    BOOL(0),
                                    FProcessEntry32.th32ProcessID),
                                    0));
     ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
  end;
  CloseHandle(FSnapshotHandle);
end;
// SJ Abschlussprojekt

procedure ClearRights(var RightData : TRData);
begin
	RightData.list := False;
  RightData.print := False;
  RightData.Read := False;
  RightData.link := False;
  RightData.modify := False;
  RightData.import := False;
  RightData.Write := False;
  RightData.history := False;
  RightData.mail := False;
  RightData.move := False;
  RightData.Aread := False;
  RightData.Awrite := False;
  RightData.AModify := False;
  RightData.ApRead := False;
  RightData.ApWrite := False;
  RightData.hstprotoread := False;
  RightData.suanno := False;
  RightData.docdel := False;
  RightData.docexport := False;
  RightData.revsave := False;
end;

function ConsoleRedirected: Boolean;
var
  FileType : DWORD;
begin
  FileType:= GetFileType(GetStdHandle(STD_OUTPUT_HANDLE));
  Result  := (FileType=FILE_TYPE_PIPE) or (FileType=FILE_TYPE_DISK);
end;


Function WriteCmd(text: WideString): WideString;
var
  NumWritten: Cardinal;
  isfile: Boolean;
begin
   SetConsoleOutputCP(CP_OEMCP);

   if ConsoleRedirected then
      WriteLn(UTF8String(text))
   else
     WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), PChar(Text+ #13#10), Length(Text+ #13#10), NumWritten, nil);
End;

function ExpandEnvStrings(const AString: String): String;
var
  bufsize: Integer;
begin
  bufsize := ExpandEnvironmentStrings(PChar(AString), nil, 0);
  SetLength(result, bufsize);
  ExpandEnvironmentStrings(PChar(AString), PChar(result), bufsize);
  result := TrimRight(result);
end;

function GetStringFromResource(Name: string): string;
begin
   with TResourceStream.Create(HInstance, Name, RT_RCDATA) do
      try
         SetLength(Result, Size);
         Read(Result[1], Size);
      finally
         Free;
      end;
end;

procedure determineNumberAreas (var   istZahl: array of Boolean;
                                const Text   : string          );
  type
    eZust = (zustBlank,            //  Leerzeichen vor der Zahl = Start
             zustErsteZiffer,
             zustZahlTeil01,       //  Der Teil der Zahl vor dem Komma
             zustKomma,            //  Komma oder Punkt, genau ein Zeichen
             zustZahlTeil02 );     //  Der Teil der Zahl nach dem Komma
  var
    xZust    : eZust;
    xCh      : Char;
    xIdx     : Integer;
    xIdxMax  : Integer;
    xIdxFirst: Integer;
  begin
    xZust     := zustErsteZiffer;  //  Die Zahl knnte mit dem 1. Zeichen beginnen
    xIdxMax   := Length (Text);
    xIdx      := 1;
    xIdxFirst := 1;

    while xIdx <= xIdxMax do
    begin
      xCh := Text [xIdx];

      case xZust of
      zustBlank:
        begin
          istZahl [xIdx] := False;

          if xCh = ' ' then
            xZust := zustErsteZiffer;

          Inc (xIdx);
        end;

      zustErsteZiffer:
        begin
          if xCh in ['0'..'9'] then
          begin
            xIdxFirst      := xIdx;
            istZahl [xIdx] := True;
            Inc     (xIdx);
            xZust          := zustZahlTeil01;
          end
          else
            xZust          := zustBlank;
        end;

      zustZahlTeil01:
        begin
          if xCh in ['0'..'9'] then
          begin
            istZahl [xIdx] := True;
            Inc     (xIdx);
          end
          else
          if    (xCh = ',')
             or (xCh = '.')
          then begin
            istZahl [xIdx] := True;
            Inc     (xIdx);
            xZust := zustKomma;
          end
          else
          begin
            xIdx  := xIdxFirst;
            xZust := zustBlank;
          end;
        end;

      zustKomma:
        begin
          if xCh in ['0'..'9'] then
          begin
            istZahl [xIdx] := True;
            Inc     (xIdx);

            if xIdx > xIdxMax then     //  Text-Ende erreicht
              xIdxFirst := xIdx;       //  Die Zahl ist fertig!

            xZust := zustZahlTeil02;
          end
          else
          begin
            xIdx  := xIdxFirst;
            xZust := zustBlank;
          end;
        end;

      zustZahlTeil02:
        begin
          if xCh in ['0'..'9'] then
          begin
            istZahl [xIdx] := True;
            Inc     (xIdx);

            if xIdx > xIdxMax then     //  Text-Ende erreicht
              xIdxFirst := xIdx;       //  Die Zahl ist fertig!
          end
          else
          if xCh = ' ' then
          begin
            xZust     := zustBlank;
            xIdxFirst := xIdx;         //  Die Zahl ist fertig!
          end
          else
          begin
            xIdx      := xIdxFirst;
            xZust     := zustBlank;
          end;
        end;
      end;
    end;

    //  nicht vollstndige Zahlen de-markieren
    //
    for xIdx := xIdxFirst to xIdxMax do
      istZahl [xIdx] := False;
  end;  //  determineNumberAreas


function indexOf (text: string;
                  list: TStrings): Integer;
var
    xIdx   : Integer;
    xIdxMax: Integer;

begin
   Result  := -1;
//   xIdxMax := list.Count;
   xIdxMax := list.Count - 1;

   for xIdx := 0 to xIdxMax do
   begin
      if text = list [xIdx] then
      begin
         Result := xIdx;
         Break;
      end;
   end;
end;


function ListContains(list: TStrings; text: string): Boolean;
var
  i, cnt : Integer;
begin
  Result := False;
  cnt := list.Count;

  for i := 0 to cnt -1 do
    begin
      if ContainsText(list[i], text) then
      begin
        Result := True;
        Exit;
      end;
    end;
end;

function StrToWords(const InputStr: string): TStringList;
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
   ///  30.09.2006 modifiziert by NG.
   ///
   ///  Diese Function zerlegt einen String in einzelne Worte
   ///  bzw Phrasen und listet diese in einer Stringlist auf.
   ///                                                                                                                        //
   ///  Parameter: InputStr        String mit Suchbegriffen
   ///
   ///  Ausgabe: StringList mit einzelnen Worten und Phrasen
   ///
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
const
   sTrennZeichen = ' .,!?';
var
   iCount, iWortStart, iWortEnde: integer;
   bPhrase: boolean;
   sOP, sWort, slStr: string;
begin
   Result := TStringList.Create;
   Result.Clear;
   iWortStart := 0;
   iWortEnde := 0;
   iCount := 0;
   bPhrase := False;
   sOP := '';
   // trim the input!
   slStr := trim(InputStr);
   while iCount <= Length(slStr) do
   begin
      if IsDelimiter('"', slStr, iCount) then
      begin
         if not bPhrase then
         begin
            bPhrase := True;
            iWortStart := iCount + 1;
            if IsDelimiter('+-*', slStr, iCount - 1) then
               sOp := slStr[iCount - 1]
            else
               sOp := '';
         end
         else
            bPhrase := False;
      end;
      if IsDelimiter(sTrennZeichen, slStr, iCount) and not bPhrase then
      begin
         if iWortStart <= iWortEnde then
         begin
            iWortEnde := iCount;
            sWort := Trim(StringReplace(Copy(slStr, iWortStart,
               iWortEnde - iWortStart), '"', '', [rfReplaceAll]));
            if ((Length(trim(sWort)) >= 1) and (not IsDelimiter('+-*', sWort, 1) or
               (Length(trim(sWort)) > 1))) then
               Result.Add(sOP + sWort);
            iWortStart := iWortEnde + 1;
         end;
      end;
      iWortEnde := iCount;
      Inc(iCount);
   end;
   if iWortStart <= iWortEnde then
      Result.Add(sOP + Trim(StringReplace(Copy(slStr, iWortStart, 1 +
         iWortEnde - iWortStart), '"', '', [rfReplaceAll])));
end;

function StrToWords4(const InputStr: string): TStringList;

   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
   ///  In dieser Fassung werden Zahlen mit Nachkommastellen bercksichtigt
   ///  Solche Zahlen sind definiert als Zahlen, die ein Komma oder einen Punkt
   ///  enthalten mssen, und von Leerzeichen begrenzt sind.
   ///
   ///  30.09.2006 modifiziert by NG.
   ///
   ///  Diese Function zerlegt einen String in einzelne Worte
   ///  bzw Phrasen und listet diese in einer Stringlist auf.
   ///                                                                                                                        //
   ///  Parameter: InputStr        String mit Suchbegriffen
   ///
   ///  Ausgabe: StringList mit einzelnen Worten und Phrasen
   ///
   ///  f.schneider: in dieser Funktion bleiben " erhalten
   ///
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////

const
   // v.3.5.0.89 f.schneider Was sollen all diese Trennzeichen bei der Suche ?
   //sTrennZeichen = ' .,!?';
   sTrennZeichen = ' ';

var
   iCount,
   iWortStart,
   iWortEnde,
   istatus   : integer;
   bPhrase   : boolean;
   sOP,
   sWort,
   slStr     : string;
   xIstZahl  : array of Boolean;

begin
   Result := TStringList.Create;
   Result.Clear;
   iWortStart := 1;
   iWortEnde := 0;
   iCount := 0;
   istatus := 0;
   bPhrase := False;
   sOP := '';
   // trim the input!
   slStr := trim(InputStr);

   SetLength            (xIstZahl, Length (slStr) +1);
   determineNumberAreas (xIstZahl,         slStr    );

   while iCount <= Length(slStr) do
   begin
      if IsDelimiter('"', slStr, iCount) then
      begin
         if not bPhrase then
         begin
            bPhrase := True;
            iWortStart := iCount;
            istatus := 1;
            if IsDelimiter('+-*', slStr, iCount - 1) then
               sOp := slStr[iCount - 1]
            else
               sOp := '';
         end
         else
         begin
            bPhrase := False;
            if istatus = 1 then
            begin
               istatus := 2;
            end;
         end;
      end;
      if        IsDelimiter(sTrennZeichen, slStr, iCount)
        and not bPhrase
        and not xIstZahl [iCount]
      then begin
         if iWortStart <= iWortEnde then
         begin
            iWortEnde := iCount;
            if istatus = 2 then
            begin
               sWort := Trim(Copy(slStr, iWortStart, iWortEnde - iWortStart));

            end
            else
            begin
               sWort := Trim(StringReplace(Copy(slStr, iWortStart,
                  iWortEnde - iWortStart), '"', '', [rfReplaceAll]));
            end;
            if ((Length(trim(sWort)) >= 1) and (not IsDelimiter('+-*', sWort, 1) or
               (Length(trim(sWort)) > 1))) then
               Result.Add(sOP + sWort);
            iWortStart := iWortEnde + 1;
         end;
      end;
      iWortEnde := iCount;
      Inc(iCount);
   end;
   if iWortStart <= iWortEnde then
   begin
      if istatus = 2 then
      begin
         Result.Add(sOP + Trim(Copy(slStr, iWortStart, 1 + iWortEnde - iWortStart)));
      end
      else
      begin
         Result.Add(sOP + Trim(StringReplace(Copy(slStr, iWortStart, 1 +
            iWortEnde - iWortStart), '"', '', [rfReplaceAll])));
      end;
   end;
end;

function StrToWords7(const InputStr: string): TStringList;
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
   ///  24.09.2009 by MF
   ///
   ///  Diese Function zerlegt einen String in einzelne Worte
   ///  und listet diese in einer Stringlist auf.
   ///
   /// nachdem die anderne Funktionen nicht ausreichend dokumentiert sind, blieb
   /// mir nichts anders brig als eine eigene neue zu machen.
   /// Die hier hat als Trennzeichen nur ein Komma. Es gibt kein Quote (Anfhrungszeichen)
   /// Sie ist dafr einfacher und schneller
   ///
   ///  Parameter: InputStr        String mit Suchbegriffen
   ///
   ///  Ausgabe: StringList mit einzelnen Worten und Phrasen
   ///
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////

const
   sTrennZeichen = globalDelimiter;
var
   iCount, iWortStart, iWortEnde: integer;  bPhrase: boolean;
   sWort, slStr: string;
begin
   Result := TStringList.Create;
   Result.Clear;
   iWortStart := 1;
   iWortEnde := 0;
   iCount := 0;
   bPhrase := False;
   // trim the input!
   slStr := trim(InputStr);
   while iCount <= Length(slStr) do
   begin
      if IsDelimiter(sTrennZeichen, slStr, iCount) and not bPhrase then
      begin
         if iWortStart <= iWortEnde then
         begin
            iWortEnde := iCount;
            sWort := Trim(Copy(slStr, iWortStart, iWortEnde - iWortStart));
            if (Length(sWort) >= 1) then
               Result.Add(sWort);
            iWortStart := iWortEnde + 1;
         end;
      end;
      iWortEnde := iCount;
      Inc(iCount);
   end;
   if iWortStart <= iWortEnde then
   begin
      sWort := Trim(Copy(slStr, iWortStart, maxint));
      Result.Add(sWort);
   end;
end;

function StrToWordsLF(const InputStr: string): TStringList;
   //////////////////////////////////////////////////////////////////
   ///  24.11.2009 by MF
   ///
   ///  Diese Function zerlegt einen String in einzelne Worte
   ///  und listet diese in einer Stringlist auf.
   ///
   /// Die Variante hier hat als Trennzeichen nur ein LineFeed #10
   /// Es gibt kein Quote (Anfhrungszeichen)
   ///
   ///  Parameter: InputStr        String mit Suchbegriffen
   ///
   ///  Ausgabe: StringList mit einzelnen Worten und Phrasen

   ///  wird fr die Grenermittlung der Textannos bentigt, Leerzeilen bleiben daher bestehen
   ///  und es wird auch nicht getrimmt

const
   sTrennZeichen = #10;
var
   iCount, iWortStart, iWortEnde: integer;  bPhrase: boolean;
   sWort, slStr: string;
begin
   Result := TStringList.Create;
   Result.Clear;
   iWortStart := 1;
   iWortEnde := 0;
   iCount := 0;
   bPhrase := False;
   slStr := InputStr;
   while iCount <= Length(slStr) do
   begin
      if IsDelimiter(sTrennZeichen, slStr, iCount) and not bPhrase then
      begin
         if iWortStart <= iWortEnde then
         begin
            iWortEnde := iCount;
            sWort := Copy(slStr, iWortStart, iWortEnde - iWortStart);
            //if (Length(sWort) >= 1) then   //Leerzeilen mssen wir behalten
            Result.Add(sWort);
            iWortStart := iWortEnde + 1;
         end
         else
            Result.Add('');
      end;
      iWortEnde := iCount;
      Inc(iCount);
   end;
   if iWortStart <= iWortEnde then
   begin
      sWort := Copy(slStr, iWortStart, maxint);
      Result.Add(sWort);
   end;
end;

// packt alle Strings einer TStringList in einen kommagetrennten String
function ListToParams(const list: TStrings): WideString;
var
  i : Integer;
begin
  Result := '';
  for i := 0 to list.Count-1 do
  begin
    if Result = '' then
      Result := list.Strings[i]
    else
      Result := Result + ',' + list.Strings[i]
  end;
end;

function GetLDAPClass(AValue: WideString): WideString;
var
  p : Integer;
begin
  Result := AValue;
  if (LeftStr(AValue,2) = '+ ') or (LeftStr(AValue,2) = '  ') then
    AValue := Copy(AValue,3, Length(AValue)-2);

  p := Pos(':',AValue);
  if p=0 then Exit;

  Result := Copy(AValue,1,p-1);
end;

function GetLDAPDisplayname(AValue: WideString): WideString;
var
  p : Integer;
begin
  Result := AValue;
  p := Pos('=',AValue);
  if p=0 then Exit;

  Result := RightStr(AValue,length(AValue) - p);
  Result := Trim(Result);
end;

function GetLDAPName(AValue: WideString): WideString;
var
  p : Integer;
begin
  Result := AValue;
  p := Pos(':',AValue);
  if p=0 then Exit;

  Result := RightStr(AValue,length(AValue) - p);
  Result := Trim(Result);
end;

function GetLDAPObjectname(AValue: WideString): WideString;
var
  p : Integer;
begin
  Result := AValue;

  p := Pos(',',Result);
  if p=0 then Exit;

  Result := Copy(Result,1,p-1);
end;


function EscapeDNName(AValue: WideString): WideString;
var
  p : Integer;
begin
  Result := '';
  // erst die Sonderzeichen die für DistinguishedNames escaped werden müssen (plus der / für ADSI Abfragen)
  for p := 1 to length(AValue) do
  begin
    if AValue[p] in [',', '\', '#', '+', '<', '>', ',', ';', '"', '=', '/'] then
      Result := Result + '\' + AValue[p]
    else
      Result := Result + AValue[p];
  end;

  // jetzt auf führendes # prüfen
  if Result[1] = '#' then
    Result := '\#' + Copy(Result, 2, Length(Result) -1);

  // jetzt alle Führenden oder Nachfolgenden Leerzeichen escapen
  p := 1;
  while p < length(Result) do
  begin
    if Result[p] <> ' ' then
      Break;

    if Result[p] = ' ' then
    begin
      Result := Copy(Result, 0, p -1) + '\ ' + Copy(Result,p +1, Length(Result) -p);
      inc(p);
    end;

    inc(p);
  end;

  p := length(Result);
  while p > 1 do
  begin
    if Result[p] <> ' ' then
      Break;

    if Result[p] = ' ' then
    begin
      Result := Copy(Result, 0, p -1) + '\ ' + Copy(Result,p +1, Length(Result) -p);

    end;

    dec(p);
  end;
end;

function EscapeLDAPPath(AValue: WideString): WideString;
var
  p : Integer;
  parts : TStringList;
  part, escaped: WideString;
begin
  parts := TStringList.Create;
  parts.Delimiter := ',';
  parts.StrictDelimiter := True;
  parts.DelimitedText := AValue;

  for p := 0 to parts.Count -1 do
  begin
    part := GetLDAPDisplayname(parts[p]);
    escaped := EscapeDNName(part);
    if part <> escaped then
      parts[p] := StringReplace(parts[p], part, escaped, [rfReplaceAll]);
  end;

  Result := parts.CommaText;
  FreeAndNil(parts);
end;

function CreateHighlightColor(AColor: TColorRef): TColor;
var
  R,G,B: Byte;
  col: LongInt;
begin
  Result := AColor;
  col := ColorToRGB(AColor);
  R := GetRValue(col);
  G := GetGValue(col);
  B := GetBValue(col);

  if R > 127 then
    Dec(R, 20)
  else
    Inc(R, 20);

  if G > 127 then
    Dec(G, 20)
  else
    Inc(G, 20);

  if B > 127 then
    Dec(B, 20)
  else
    Inc(B, 20);

  Result := RGB(R,G,B);
end;

initialization
begin
  sysDateformat := '%d.%m.%Y';

  //24.05.2019 Ticket 17987 -->
  sysEmptyDate := 0;
  GetLocaleFormatSettings(LOCALE_SYSTEM_DEFAULT, formatSettings);

  if LowerCase(formatSettings.ShortDateFormat) = 'dd.mm.yyyy' then
    sysDateformat := '%d.%m.%Y'
  else if LowerCase(formatSettings.ShortDateFormat) = 'm/d/yyyy' then
    sysDateformat := '%m/%d/%Y'
  else if LowerCase(formatSettings.ShortDateFormat) = 'mm/dd/yyyy' then
    sysDateformat := '%m/%d/%Y'
  else if LowerCase(formatSettings.ShortDateFormat) = 'dd/mm/yyyy' then
    sysDateformat := '%d/%m/%Y'
  else if LowerCase(formatSettings.ShortDateFormat) = 'd/m/yyyy' then
    sysDateformat := '%d/%m/%Y'
  else if LowerCase(formatSettings.ShortDateFormat) = 'yyyy/mm/dd' then
    sysDateformat := '%Y/%m/%d';

  sysDateformat := ReplaceStr(sysDateformat, '/' , formatSettings.DateSeparator);
  //24.05.2019 Ticket 17987 <--
end;

finalization

end.


