unit u_EditInfo;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, gnugettext, SpTBXItem, SpTBXControls;

type
   Tfrm_EditInfo = class (TForm)
      memo_Info: TMemo;
      btn_speichern: TSpTBXButton;
      Panel1: TPanel;
      procedure btn_speichernClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure FormCreate(Sender: TObject);
    procedure memo_InfoKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
   private
      { Private-Deklarationen }
   public
     FormTyp : Integer; // 0 - Resub Info; 1 - Commentar
      { Public-Deklarationen }
   end;

implementation

uses MainForm, FloatingResubFrame;

{$R *.dfm}

procedure Tfrm_EditInfo.btn_speichernClick(Sender: TObject);
begin
  if FormTyp = 0 then //Resub Info
  begin
    frmMainForm.fraResub.edtResubInfo.Text := memo_info.Text;
    // Daten der infozeile an mainform bertragen
    frmMainForm.fraResub.btnSaveResub.Click;
    //save routine der Infozeile aufrufen
    Close;
  end;
end;

procedure Tfrm_EditInfo.FormShow(Sender: TObject);
begin
  if FormTyp = 0 then //Resub Info
  begin
    memo_Info.Lines.Clear;
    //  memo_Info.Text:=memo_info.Text;

//    memo_info.Text := frmMainForm.fraResub.edtResubInfo.Text  // bfacrm:ticket__show__35603
    if Self.Owner is TfrmGPL then
      memo_info.Text := frmMainForm.fraResub.edtResubInfo.Text
    else if Self.Owner is TfraFloatingResub then
      memo_info.Text := TfraFloatingResub(Self.Owner).fraResub.edtResubInfo.Text;

    if frmMainForm.fraResub.btnDelegateTasks.Checked then
      // wenn die Mitarbeiter Tasks angezeigt werden
      // soll das memofeld nicht editierbar sein
    begin
      panel1.Visible := False;
      memo_info.ReadOnly := True;
    end
    else
    begin
      panel1.Visible := True;
      memo_info.ReadOnly := False;
    end;
  end;
end;

procedure Tfrm_EditInfo.memo_InfoKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then
    Self.Close;
end;

procedure Tfrm_EditInfo.FormCreate(Sender: TObject);
begin
  FormTyp := -1;
  memo_Info.ScrollBars := ssVertical;
  TranslateComponent(Self, 'Shared36');
end;

end.
