unit u_Message;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  Tfrm_Message = class(TForm)
    lbl_Message: TLabel;
    tmr_Message: TTimer;
    procedure FormShow(Sender: TObject);
    procedure tmr_MessageTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    SaveMorePages: boolean;  // 05.07.2011 b.takacs 3.5.1.26 [3075]
    { Public-Deklarationen }
  end;

var
  frm_Message: Tfrm_Message;

implementation

uses gnugettext;

{$R *.dfm}
//
procedure Tfrm_Message.FormShow(Sender: TObject);
begin                                                                      
  frm_Message.Color:= $000066FF;
//////////////////////////////////////// 05.07.2011 b.takacs 3.5.1.26 [3075] -->
  if SaveMorePages then
  begin
    lbl_Message.Font.Color := clBlack;
    lbl_Message.Caption:= _('nderung wird gespeichert.');
    tmr_Message.Enabled:= true;
  end
//////////////////////////////////////// 05.07.2011 b.takacs 3.5.1.26 [3075] <--
  else
  begin
    lbl_Message.Caption:= _('Miniaturansicht wurde nicht komplett geladen.');
    tmr_Message.Enabled:= true;
  end;
//  Application.ProcessMessages;
end;
//
procedure Tfrm_Message.tmr_MessageTimer(Sender: TObject);
begin
  if frm_Message.Showing then
  begin
    tmr_Message.Enabled := False;
    frm_Message.Close;
  end;
end;
//
procedure Tfrm_Message.FormCreate(Sender: TObject);
begin
	SaveMorePages:= false; //05.07.2011 b.takacs 3.5.1.26 [3075]
end;

end.
