unit bfaImageEnMView;

interface

uses
  Classes, Graphics, iemview;

type
  TbfaImageEnMView = class(TImageEnMView)
  {$IFDEF IMAGEEN1140}
  private
    FException: Boolean;

  public
    constructor Create(AOwner: TComponent); override;

    procedure SetImage(idx: integer; srcImage: TBitmap); overload;

    property Exception: Boolean read FException;
  end
  {$ENDIF};

implementation

{ TbfaImageEnMView }
{$IFDEF IMAGEEN1140}
constructor TbfaImageEnMView.Create(AOwner: TComponent);
begin
  inherited;
  FException := False;
end;

procedure TbfaImageEnMView.SetImage(idx: integer; srcImage: TBitmap);
begin
  FException := False;
  try
    SetImageEx(idx, srcImage);
    ClearImageCache(idx);
    UpdateEx(false);
  except
    FException := True;
  end;
end;
{$ENDIF}
end.
