unit u_bfaScrollBox;

interface

uses
    Windows, Messages, SysUtils, Variants, Classes, Graphics,
    Controls, Forms, Dialogs,
    {$IFDEF DEVEXSCROLLBOX}
     cxScrollBox
    {$ELSE}
    ExtCtrls
    {$ENDIF}
    ;

type
  {$IFDEF DEVEXSCROLLBOX}
  TbfaScrollBox = class(TcxScrollBox)
  {$ELSE}
  TbfaScrollBox = class(TScrollBox)
  {$ENDIF}
    procedure WMHScroll(var Message: TWMHScroll); message WM_HSCROLL;
    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
  private
    FOnScrollVert: TNotifyEvent;
    FOnScrollHorz: TNotifyEvent;
    FAfterScrollVert: TNotifyEvent;
    fAfterScrollHorz: TNotifyEvent;
  public
    property OnScrollVert:TNotifyEvent read FOnScrollVert write FonScrollVert;
    property OnScrollHorz:TNotifyEvent read FOnScrollHorz write FonScrollHorz;
    property AfterScrollVert:TNotifyEvent read FAfterScrollVert write FAfterScrollVert;
    property AfterScrollHorz:TNotifyEvent read FOnScrollHorz write FonScrollHorz;
  end;

implementation

procedure TbfaScrollBox.WMHScroll(var Message: TWMHScroll);
begin
 inherited;
 if Message.ScrollCode = 8 then
 begin
   if Assigned(AfterScrollHorz) then
     AfterScrollHorz(Self);
 end
 else
 begin
   if Assigned(FOnScrollHorz) then
     FOnScrollHorz(Self);
 end;
end;


procedure TbfaScrollBox.WMVScroll(var Message: TWMVScroll);
begin
 inherited;
 if Message.ScrollCode = 8 then
 begin
   if Assigned(AfterScrollVert) then
     AfterScrollVert(Self);
 end
 else
 begin
   if Assigned(OnScrollVert) then
     OnScrollVert(Self);
 end;
end;

end.

