unit u_bfaStandardToolbar;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, TB2Item, SpTBXItem, TB2Dock, TB2Toolbar;

type
  TbfaStandardToolbar = class(TFrame)
    tlbStandard: TSpTBXToolbar;
    tlbStandardSubmenuItem1: TSpTBXSubmenuItem;
    tlbStandardSubmenuItem2: TSpTBXSubmenuItem;
    tlbStandardSubmenuItem3: TSpTBXSubmenuItem;
    SpTBXSeparatorItem1: TSpTBXSeparatorItem;
    tlbStandardRotateLeft: TSpTBXItem;
    tlbStandardFlip: TSpTBXItem;
    tlbStandardRotateRight: TSpTBXItem;
    SpTBXSeparatorItem2: TSpTBXSeparatorItem;
    tlbStandardEditTags: TSpTBXItem;
    tlbStandardNewLink: TSpTBXItem;
    tlbStandardAddLink: TSpTBXItem;
    SpTBXSeparatorItem3: TSpTBXSeparatorItem;
    tlbStandardAuditProof: TSpTBXItem;
    tlbStandardSubmenuItem4: TSpTBXSubmenuItem;
  private
    { Private-Deklarationen }
    function GetAutoResize: Boolean;
    procedure SetAutoResize(Value: Boolean);
  protected
      procedure Resize; override;
  public
    { Public-Deklarationen }

  published
    property  AutoResize : Boolean read GetAutoResize write SetAutoresize;
  end;

implementation

{$R *.dfm}

{ TbfaStandardToolbar }

function TbfaStandardToolbar.GetAutoResize: Boolean;
begin
  Result := tlbStandard.AutoResize;
end;

procedure TbfaStandardToolbar.Resize;
begin
  inherited;
  tlbStandard.Realign;
end;

procedure TbfaStandardToolbar.SetAutoResize(Value: Boolean);
begin
    tlbStandard.AutoResize := Value;
end;

end.
