unit CommonGUIUtils;

interface

uses
  Classes, ExtDlgs ,  TB2Item , SpTBXItem, TB2Toolbar,
  MainForm
  ;

resourcestring

/////////// Messages ///////////////////////////////////////////////////////////
  sMsgErrorAtReadingProfiles              = 'Error at reading profiles!';
  sMsgAdminLoadArchives                   = 'Lade Archivdaten...';
  sMsgAdminDeleteAddfield                 = 'Soll das Zusatzfeld %s entfernt werden?';
  sMsgAdminSaveConfig                     = 'Archiv-Konfiguration wird gespeichert.';
  sMsgAdminSaveObjects                    = 'Speichere Objekte...';
  sMsgAdminRefreshView                    = 'Oberflche aktualisieren...';
  sMsgAdminRefreshConfig                  = 'Konfiguration aktualisieren...';
  sMsgAdminRefreshTreeviews               = 'Baumansichten aktualisieren...';
  sMsgAdminRefresh                        = 'Aktualisiere Administrationsoberflche';
  sMsgAdminLoadTreeviews                  = 'Lade Baumansicht...';
  sMsgAdminInitialize                     = 'Initialisiere Oberflche...';
  sMsgLoadConfiguration                   = 'lade Konfiguration...';
  sMsgLoadTreeviews                       = 'lade Baumansicht...';
  sMsgLoadTreeviewViewer                  = 'lade Baumansicht Viewer...';
  sMsgLoadTreeviewImporter                = 'lade Baumansicht Importer...';
  sMsgLoadImporter                        = 'lade Importer...';
  sMsgLoadBookmarks                       = 'lade Lesezeichen...';
  sMsgLoadViewer                          = 'Viewer wird geladen...';


//////////// Captions //////////////////////////////////////////////////////////
///
  sCaptionPaperFormatUnbekannt            = 'Unbekannt';
  sCaptionPaperFormatDINA4Letter          = 'DIN A4 / Letter';
  sCaptionPaperFormatDINB5                = 'DIN B5';
  sCaptionPaperFormatUSLetter             = 'US Letter';
  sCaptionPaperFormatUSLegal              = 'US Legal';
  sCaptionPaperFormatDINA5                = 'DIN A5';
  sCaptionPaperFormatDINB4                = 'DIN B4';
  sCaptionPaperFormatDINB6                = 'DIN B6';
  sCaptionPaperFormatUSLedger             = 'US Ledger';
  sCaptionPaperFormatUSEXECUTIVE          = 'US EXECUTIVE';
  sCaptionPaperFormatDINA3                = 'DIN A3';
  sCaptionPaperFormatDINB3                = 'DIN B3';
  sCaptionPaperFormatDINA6                = 'DIN A6';
  sCaptionPaperFormatDINC4                = 'DIN C4';
  sCaptionPaperFormatDINC5                = 'DIN C5';
  sCaptionPaperFormatDINC6                = 'DIN C6';
  sCaptionPaperFormatDIN4A0               = 'DIN 4-A0';
  sCaptionPaperFormatDIN2A0               = 'DIN 2-A0';
  sCaptionPaperFormatDINA0                = 'DIN A0';
  sCaptionPaperFormatDINA1                = 'DIN A1';
  sCaptionPaperFormatDINA2                = 'DIN A2';
  sCaptionPaperFormatDINA7                = 'DIN A7';
  sCaptionPaperFormatDINA8                = 'DIN A8';
  sCaptionPaperFormatDINA9                = 'DIN A9';
  sCaptionPaperFormatDINA10               = 'DIN A10';
  sCaptionPaperFormatISODINB0             = 'ISO DIN B0';
  sCaptionPaperFormatISODINB1             = 'ISO DIN B1';
  sCaptionPaperFormatISODINB2             = 'ISO DIN B2';
  sCaptionPaperFormatISODINB5             = 'ISO DIN B5';
  sCaptionPaperFormatISODINB7             = 'ISO DIN B7';
  sCaptionPaperFormatISODINB8             = 'ISO DIN B8';
  sCaptionPaperFormatISODINB9             = 'ISO DIN B9';
  sCaptionPaperFormatISODINB10            = 'ISO DIN B10';
  sCaptionPaperFormatJISB0                = 'JIS B0';
  sCaptionPaperFormatJISB1                = 'JIS B1';
  sCaptionPaperFormatJISB2                = 'JIS B2';
  sCaptionPaperFormatJISB3                = 'JIS B3';
  sCaptionPaperFormatJISB4                = 'JIS B4';
  sCaptionPaperFormatJISB6                = 'JIS B6';
  sCaptionPaperFormatJISB7                = 'JIS B7';
  sCaptionPaperFormatJISB8                = 'JIS B8';
  sCaptionPaperFormatJISB9                = 'JIS B9';
  sCaptionPaperFormatJISB10               = 'JIS B10';
  sCaptionPaperFormatDINC0                = 'DIN C0';
  sCaptionPaperFormatDINC1                = 'DIN C1';
  sCaptionPaperFormatDINC2                = 'DIN C2';
  sCaptionPaperFormatDINC3                = 'DIN C3';
  sCaptionPaperFormatDINC7                = 'DIN C7';
  sCaptionPaperFormatDINC8                = 'DIN C8';
  sCaptionPaperFormatDINC9                = 'DIN C9';
  sCaptionPaperFormatDINC10               = 'DIN C10';
  sCaptionPaperFormatUSStatement          = 'US Statement';
  sCaptionPaperFormatUSBusinesscard       = 'US Businesscard';

  sNeuesDokument                          = 'Neues Dokument';
  sCaptionNewDocument                     = 'Neues Dokument erzeugen';
  sCaptionResubmission                    = 'Wiedervorlage';
  sCaptionNewResubmission                 = 'Neu';
  sCaptionResubDone                       = 'Fertig / Fortsetzen';
  sCaptionResubDelete                     = 'Entfernen';
  sCaptionResubEditor                     = 'Bearbeiter:';

  sCaptionModify                          = 'Bearbeiten';
  sCaptionSave                            = 'Speichern';
  sCaptionPage                            = 'Seite';
  sCaptionZoom                            = 'Zoom';
  sCaptionZoomFactor                      = 'Zoomfaktor';
  sCaptionUserGroups                      = 'Gruppen und Benutzer';
  sCaptionUser                            = 'Benutzer';
  sCaptionGroups                          = 'Gruppen';
  sCaptionDescription                     = 'Beschreibung';
  sCaptionSelection                       = 'Auswahl';

  sEmptyString                            = '';

  sCaptionMainForm                        = 'bitfarm-Archiv - GPL';
  sCaptionMainFormEnterprise              = 'bitfarm-Archiv - Enterprise';

  // Haupmen-Eintrge ohne Hotkey
  sCaptionMenuDatei                       = 'Datei';
  sCaptionMenuAnsicht                     = 'Ansicht';
  sCaptionMenuLesezeichen                 = 'Lesezeichen';
  sCaptionMenuWerkzeuge                   = 'Werkzeuge';
  sCaptionMenuGraphik                     = 'Grafik';
  sCaptionMenuHilfe                       = 'Hilfe';

  //sCaptionMenuDruckenMitVorschau          = 'Drucken mit Vorschau';
  sCaptionNeuesDokumentErzeugenText       = 'Neues Dokument erzeugen (Text)'; // Hinweis: Dummy, da "(Text)" dynamisch aus Ini-File ermittelt wird.
  sCaptionSchlagworteEditieren            = 'Schlagworte editieren';
  sCaptionMenuOberflche                  = 'Oberflche';
  sCaptionMenuSprache                     = 'Sprache';
  sCaptionMenuVorschau                    = 'Vorschau';

  // Haupmen-Eintrge mit Hotkey
  sCaptionMenuDateiHK                     = '&Datei';
  sCaptionMenuAnsichtHK                   = '&Ansicht';
  sCaptionMenuLesezeichenHK               = '&Lesezeichen';
  sCaptionMenuWerkzeugeHK                 = '&Werkzeuge';
  sCaptionMenuGraphikHK                   = '&Grafik';
  sCaptionMenuHilfeHK                     = '&Hilfe';

  sCaptionSeiteDp                         = 'Seite:';
  sCaptionOhne                            = 'Ohne';

  sCaptionSaveDocumentAsPDFOnLocalDevice  = 'Dokument lokal als PDF speichern';
  sCaptionEmailPDFAttachment              = 'Dokument als PDF versenden';
  sCaptionPrintPreview                    = 'Drucken mit Vorschau';
  sCaptionCopyDocToClipboard              = 'Dokument in Zwischenablage kopieren';

  sCaptionChangeDocname                   = 'Dokument umbenennen';
  sCaptionEditTags                        = 'Schlagworte editieren';
  sCaptionCreateNewLink                   = 'Neue Verknpfung erzeugen';
  sCaptionAddLink                         = 'Zu Verknpfung hinzufgen';
  sCaptionCreateResubmission              = 'Wiedervorlage anlegen';
  sCaptionSubscribeToDocument             = 'Dokument abonnieren';
  sCaptionShowAllSymbolicLinks            = 'Alle SymbolicLinks anzeigen';
  sCaptionDeleteDymbolicLink              = 'SymbolicLink entfernen';
  sCaptionSaveDocumentAsBookmark          = 'Dokument als Lesezeichen speichern';

  sCaptionRecoverOriginalFile             = 'Originaldokument wiederherstellen';
  sCaptionRefreshDocument                 = 'Dokument aktualisieren';
  sCaptionCreateEmptyDocument             = 'Leeres Dokument erzeugen';
  sCaptionDeleteNRSDocument               = 'NRS Dokument lschen';

  sCaptionRotateLeft                      = 'Seite nach links drehen';
  sCaptionFlip                            = 'Seite umdrehen';
  sCaptionRotateRight                     = 'Seite nach rechts drehen';

  sCaptionHideSearchDetails               = 'Suchdaten ausblenden';
  sCaptionShowIndexingWithLimit           = 'Verschlagswortungshilfe (limitiert)';

  sCaptionMyTasks                         = 'eigene WVL (offen)';
  sCaptionDelegateTasks                   = 'delegierte WVL (offen)';
  sCaptionProfilWechseln                  = 'Profil wechseln';

  // Optionen
  sCaptionOptions                         = 'Keine';

  sCaptionFilterEntfernen                 = 'Filter entfernen (ESC)';
  sCaptionUhrzeit                         = 'Uhrzeit';
  sCaptionZeitstempel                     = 'Zeitstempel';

  //aus bfaSocketConnection
  sDialogKeineBerechtigungAufDasDokument          = 'Keine Berechtigung auf das Dokument.';
  sDialogFehlerBeiVerbindungMitServerNeuAnmelden  = 'Es hat einen Fehler bei der Verbindung mit dem Server gegeben. Bitte melden Sie sich erneut an.';
  sDialogFehlerBeiVerbindungMitServer             = 'Es hat einen Fehler bei der Verbindung mit dem Server gegeben.';
  sDialogDasDokumentKonnteNichtGeladenWerden      = 'Das Dokument konnte nicht geladen werden.';
  sDiaalogBitteNeuAnmelden                        = 'Bitte melden Sie sich neu an (Datei - Neu anmelden).';
  sDialogKeineBerechtigungAufDieDatei             = 'Keine Berechtigung auf die Datei.';
  sDialogTimeoutBeimWartenAufEineServerantwort    = 'Timeout beim Warten auf eine Serverantwort';


  // Zusatzfelder
  sCaptionDelete                          = 'Lschen';
  sOrigSearchText                         = '  Suchen...  ';
  sCaptionNoMatchesFound                  = 'Keine Eintrge gefunden';

  // Actions
  sCaptionActGraphicOptions               = 'Grafik-Optionen';
  sCaptionActQuit                         = 'Beenden';
  sCaptionActInResub                      = 'auf Wiedervorlage';
  sCaptionActRelogin                      = 'Neu anmelden';
  sCaptionActCreateEmptyDoc               = 'Leeres Dokument erzeugen';
  sCaptionActChangePassword               = 'Passwort ndern';
  sHintActScanOptions                     = 'Optionen anzeigen';
  sCaptionActOptions                      = 'Optionen';
  sHintActOptions                         = 'Optionen anzeigen';
  sCaptionActViewNavigation               = 'Navigation';
  sCaptionActViewSearchOptions            = 'Suchoptionen';
  sCaptionActViewPreview                  = 'Voransicht';
  sCaptionActViewThumbnails               = 'Miniaturansicht';
  sCaptionActViewFloatingWVL              = 'Wiedervorlage in eigenem Fenster';
  sCaptionActDeleteColumnOrder            = 'Spaltensortierung aufheben';
  sCaptionActGetLastDocument              = 'Letztes Dokument aufrufen';
  sCaptionActGetDoc1                      = 'Dokument 1 aufrufen';
  sHintActGetDoc1                         = 'Gemerktes Dokument aufrufen 1';
  sCaptionActGetDoc2                      = 'Dokument 2 aufrufen';
  sHintActGetDoc2                         = 'Gemerktes Dokument aufrufen 2';
  sCaptionActGetDoc3                      = 'Dokument 3 aufrufen';
  sHintActGetDoc3                         = 'Gemerktes Dokument aufrufen 3';
  sCaptionActGetDoc4                      = 'Dokument 4 aufrufen';
  sHintActGetDoc4                         = 'Gemerktes Dokument aufrufen 4';
  sCaptionActGetDoc5                      = 'Dokument 5 aufrufen';
  sHintActGetDoc5                         = 'Gemerktes Dokument aufrufen 5';
  sCaptionActSetDoc1                      = 'Dokument 1 merken';
  sHintActSetDoc1                         = 'Dokument merken 1';
  sCaptionActSetDoc2                      = 'Dokument 2 merken';
  sHintActSetDoc2                         = 'Dokument merken 2';
  sCaptionActSetDoc3                      = 'Dokument 3 merken';
  sHintActSetDoc3                         = 'Dokument merken 3';
  sCaptionActSetDoc4                      = 'Dokument 4 merken';
  sHintActSetDoc4                         = 'Dokument merken 4';
  sCaptionActSetDoc5                      = 'Dokument 5 merken';
  sHintActSetDoc5                         = 'Dokument merken 5';
  sCaptionActInfo                         = 'Info';
  sCaptionActSupport                      = 'Support';
  sCaptionActVideos                       = 'Videos';
  sCaptionActHandbooks                    = 'Handbcher';
  sCaptionActLanguageDE                   = 'Deutsch';
  sCaptionActLanguageEN                   = 'Englisch';
  sCaptionActSave                         = 'Speichern';
  sHintActSave                            = 'Speichern (Strg+S) / (F2)';
  sCaptionActCancel                       = 'Abbrechen';
  sHintActCancel                          = 'Abbrechen (ESC)';
  sCaptionActLayoutSave                   = 'Layout speichern';
  sCaptionActLayoutDelete                 = 'Layout lschen';
  sCaptionActLayoutStandard               = 'Standard';
  sCaptionActSearch                       = 'Suchen';
  sHintActSearch                          = 'Suchen (F5)';
  sCaptionActReset                        = 'Reset  ';
  sHintActReset                           = 'Reset (F6)';
  sHintActBack                            = 'Suchhistorie rckwrts';
  sCaptionActResetImporter                = 'Reset';
  sHintActForward                         = 'Suchhistorie vorwrts';
  sCaptionActMyTasks                      = 'eigene WVL (offen)';
  sHintActMyTasks                         = 'Eigene Aufgaben anzeigen';
  sCaptionActDelegateTasks                = 'del. WVL (offen)';
  sHintActDelegateTasks                   = 'Aufgaben, die an andere Mitarbeiter vergeben wurden';
  sHintActShowCW                          = 'Zeigt die aktuelle Kalenderwoche';
  sHintActCWPrevious                      = 'KW zurck';
  sHintActCWNext                          = 'KW weiter';
  sCaptionActResubOpen                    = 'Offen';
  sCaptionActResubWork                    = 'in Arbeit';
  sCaptionActResubForward                 = 'Weiterleiten';
  sCaptionActResubDone                    = 'Fertig / Fortsetzen';
  sCaptionActScan                         = 'Seite scannen';
  sHintActScanDialog                      = 'mit Scanner-Dialog scannen';
  sHintActLoadFile                        = 'Datei laden';
  sCaptionActDeleteSelected               = 'Dokument entfernen';
  sCaptionActArchive                      = 'Archivieren';
  sCaptionActWPGroup                      = 'Dokumente zusammenfhren';
  sCaptionActWPUngroup                    = 'Dokument trennen';
  sCaptionActArchiveWithDD                = 'Archivieren';
  sCaptionActAddFolder                    = 'Ordner hinzufgen';
  sCaptionActDeleteFolder                 = 'Ordner lschen';
  sCaptionActDeleteFavorite               = 'Lesezeichen lschen';
  sCaptionActExpandAll                    = 'Alle erweitern';
  sCaptionActCollapseAll                  = 'Alle zusammenfassen';
  sCaptionActRefreshTreeView              = 'Baum neu laden';
  sCaptionActExportTree                   = 'Ordner exportieren';
  sCaptionActAddGlobal                    = 'Globales Lesezeichen hinzufgen';
  sCaptionActDeleteGlobal                 = 'Globales Lesezeichen lschen';
  sCaptionActReplaceBookmark              = 'Lesezeichen berschreiben';
  sCaptionActCreateBookmark               = 'Lesezeichen erstellen';
  sCaptionActCopyBookmark                 = 'Lesezeichen kopieren';
  sCaptionActCreateBookmarkForGDocID      = 'Dokument als Lesezeichen speichern';
  sCaptionActCreateBookmarkDialog         = 'Lesezeichen Dialog';
  sCaptionActCreateBookmarkMenu           = 'Lesezeichen erstellen';
  sCaptionActChangeBookmark               = 'Lesezeichen ndern';
  sCaptionActCreateSymbolicLinkInImporter = 'SymbolicLink im Importer erstellen';
  sCaptionActGoToOriginalDocument         = 'Ursprungsdokument aufrufen';
  sCaptionActShowAllSymbolicLinks         = 'Alle SymbolicLinks anzeigen';
  sCaptionActDeleteSymbolicLink           = 'SymbolicLink entfernen';
  sCaptionActCopyOriginalDocToClipboard   = 'Originaldokument in Zwischenablage kopieren';
  sCaptionActCopyPageToClipboard          = 'Seite in Zwischenablage kopieren';
  sCaptionActCopyDocLinkToClipboard       = 'Doklink in Zwischenablage kopieren';
  sCaptionActSendPagesToWorkplace         = 'Selektierte Seiten an Arbeitsplatz senden';
  sCaptionActSendPagesMergedToWorkplace   = 'Selektierte Seiten als ein Dokument an Arbeitsplatz senden';
  sCaptionActSendDocumentsToImporter      = 'Dokument an Importer senden';
  sCaptionActSendDocumentPreviewsToImport = 'Voransicht an Importer senden';
  sCaptionActSendPagesToImporter          = 'Selektierte Seiten an Importer senden';
  sCaptionActSendPagesMergedToImporter    = 'Selektierte Seiten als ein Dokument an Importer senden';
  sCaptionActClearFields                  = 'Reset';
  sCaptionActResubCreate                  = 'Wiedervorlage anlegen';
  sCaptionActHideSearchDetails            = 'Suchdaten ausblenden';
  sCaptionActShowIndexingWithLimit        = 'Verschlagswortungshilfe (limitiert)';
  sCaptionActShowIndexing                 = 'Verschlagswortungshilfe';
  sCaptionActHideIndexing                 = 'Verschlagswortungshilfe ausblenden';
  sCaptionActGoToSourceArchive            = 'Zum Ursprungsarchiv wechseln';
  sCaptionActShowInResub                  = 'Dokument in der Wiedervorlage anzeigen';
  sCaptionActRangeOCR                     = 'Bereichs OCR';
  sCaptionActResetDLM                     = 'Lschdatum erneut berechnen';
  sHintActResetDLM                        = 'Lschdatum auf Basis der DLM Konfiguration neu berechnen (hndische Eingaben werden entfernt)';
  sCaptionActShowAbo                      = 'Abonnements anzeigen';
  sCaptionActCheckoutDocs                 = 'Ausgecheckte Dokumente';
  sHintActCheckoutDocs                    = 'Zeigt alle eigene ausgecheckten Dokumente an';
  sCaptionActDeleteAbo                    = 'Abonnement entfernen';
  sCaptionActReOCR                        = 'Dokument aktualisieren';
  sCaptionActCheckoutDocsAdmin            = 'Alle ausgecheckten Dokumente';
  sHintActCheckoutDocsAdmin               = 'Zeigt alle ausgecheckten Dokumente an, in Archive, in denen man Admin-Rechte besitzt';
  sCaptionActOriginalfile                 = '&Originaldatei';
  sCaptionActCheckout                     = 'Ausgecheckt';
  sCaptionActLinks                        = '&Verknpfungen';
  sHintActLinks                           = 'Verknpfungen';
  sCaptionActLocalSave                    = 'Lokal speichern';
  sCaptionActLocalSavePDF                 = 'Dokument lokal als PDF speichern';
  sCaptionActLocalSaveTIF                 = 'Dokument lokal als TIF speichern';
  sCaptionActLocalSaveOriginal            = 'Original-Datei speichern';
  sCaptionActLocalSaveLink                = 'Verknpfung auf dem Desktop erstellen';
  sCaptionActLocalSavePreview             = 'Speichern mit Vorschau';
  sHintActLocalSavePreview                = 'Lokal speichern mit Vorschau (Umschalt+Strg+L)';
  sCaptionActEmailTIFAttachment           = 'Dokument als TIF versenden';
  sCaptionActEmailPDFAttachment           = 'Dokument als PDF versenden';
  sCaptionActEmailOriginal                = 'Originaldatei versenden';
  sCaptionActEmailLink                    = 'Verknpfung versenden';
  sCaptionActEmailPreview                 = 'E-Mail mit Vorschau versenden';
  sCaptionActPrintStandard                = 'Standarddrucker';
  sHintActPrintStandard                   = 'Drucken auf Standarddrucker';
  sCaptionActPrintSelect                  = 'Druckerauswahl';
  sHintActPrintSelect                     = 'Drucken mit Druckerauswahl';
  sCaptionActPrintPreview                 = 'Drucken mit Vorschau';
  sCaptionActSendDocumentsToWorkplace     = 'Dokument an Arbeitsplatz senden';
  sCaptionActInverted                     = 'Farben invertieren';
  sCaptionActRestoreOriginal              = 'Originaldokument wiederherstellen';
  sCaptionActRefreshDoc                   = 'Dokument aktualisieren';
  sCaptionActDuplicateDoc                 = 'Dokument duplizieren';
  sCaptionActExportCSV                    = 'CSV';
  sHintActExportCSV                       = 'Exportiert die ausgewhlte Dokumenteninformationen in einer .csv Datei';
  sCaptionActDeleteDoc                    = 'NRS Dokument lschen';
  sCaptionActDeScrew                      = 'Seite gerade ausrichten';
  sCaptionActDeSpeckle                    = 'Einzelne Punkte entfernen';
  sCaptionActRemoveBorder                 = 'Rand entfernen';
  sCaptionActRotateLeft                   = 'Seite nach links drehen';
  sCaptionActExportXLS                    = 'XLS';
  sHintActExportXLS                       = 'Exportiert die ausgewhlte Dokumenteninformationen in Excel';
//  sCaptionActExportOO                     = 'OpenOffice';
  sCaptionActExportOO                     = 'OpenDocument'; //01.10.2024 SD <--bfacrm:ticket__show__39480
  sHintActExportOO                        = 'Exportiert die ausgewhlte Dokumenteninformationen in OpenOffice Calc';
  sCaptionActFlip                         = 'Seite umdrehen';
  sCaptionActRotateRight                  = 'Seite nach rechts drehen';
  sCaptionActMergeDoc                     = 'Dokumente verbinden';
  sCaptionActPreviousPage                 = 'vorherige Seite';
  sCaptionActNextPage                     = 'nchste Seite';
  sCaptionActPublicAnno                   = 'ffentliche Anmerkungen';
  sCaptionActPrivateAnno                  = 'Private Anmerkungen';
  sCaptionActStationery                   = 'Briefpapier';
  sCaptionActAutozoom                     = 'Automatisch anpassen';
  sCaptionActZoom100                      = 'Originalauflsung (100%)';
  sCaptionActZoomPage                     = 'Automatisch anpassen ';
  sCaptionActZoomWidth                    = 'Seitenbreite anpassen';
  sCaptionActZoomHeight                   = 'Seitenhhe anpassen';
  sCaptionActZoomSelect                   = 'Selektion';
  sCaptionActZoomOff                      = 'Autozoom aus';
  sCaptionActAuditProof                   = 'Revisionssicher ablegen';
  sCaptionActEditTags                     = 'Schlagworte editieren';
  sCaptionActNewLink                      = 'Neue Verknpfung erzeugen';
  sCaptionActAddLink                      = 'Zu Verknpfung hinzufgen';
  sCaptionActInProgress                   = 'in Bearbeitung';
  sHintActInProgress                      = 'in Bearbeitung setzen';
  sCaptionActIsAuditProof                 = 'Revisionssicher';
  sCaptionActDeletePages                  = 'Seite entfernen';
  sCaptionActChangeDocName                = 'Dokument umbenennen';
  sCaptionActAutoRef                      = 'Autoreferenz anlegen';
  sCaptionActShareLayer                   = 'Freigeben';
  sCaptionActDocAbo                       = 'Dokument abonnieren';
  sCaptionActCreateCopy                   = 'Eine Kopie erstellen';
  sCaptionActCopyDocToClipboard           = 'Dokument in Zwischenablage kopieren';
  sCaptionActSaveImportValues             = 'Standardwerte-Zusatzfelder speichern';
  sCaptionActUndockInNewTab               = 'In Tab ffnen';
  sCaptionActUndockInNewWindow            = 'In Fenster ffnen';
  sCaptionActCollectDocs                  = 'Dokument vormerken';
  sHintActCollectDocs                     = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';
  sCaptionActCancelCollection             = 'Sammlung vorgemerkter Dokumente aufheben';
  sHintActCancelCollection                = 'Hebt die Dokumentensammlung auf';
  sCaptionActSaveCollectionPDF            = 'Gemerktes Dokument als PDF speichern';
  sHintActSaveCollectionPDF               = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';
  sCaptionActSaveCollectionSinglePDF      = 'Gemerktes Dokument als ein PDF speichern';
  sHintActSaveCollectionSinglePDF         = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';
  sCaptionActSaveCollectionTIF            = 'Gemerktes Dokument als TIF speichern';
  sHintActSaveCollectionTIF               = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';
  sCaptionActSaveCollectionOriginal       = 'Gemerktes Dokument als Original speichern';
  sHintActSaveCollectionOriginal          = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';
  sCaptionActEmailCollectionPDF           = 'Gemerktes Dokument als PDF versenden';
  sHintActEmailCollectionPDF              = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';
  sCaptionActEmailCollectionSinglePDF     = 'Gemerktes Dokument als ein PDF versenden';
  sHintActEmailCollectionSinglePDF        = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';
  sCaptionActEmailCollectionTIF           = 'Gemerktes Dokument als TIF versenden';
  sHintActEmailCollectionTIF              = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';
  sCaptionActEmailCollectionOriginal      = 'Gemerktes Dokument als Original versenden';
  sHintActEmailCollectionOriginal         = 'Schnelle Dokumentensammlung zum Speichern oder Emailversenden';

// Enterprise Actions
  sCaptionActCreateExportDB               = 'Export-Datenbank erstellen';
  sCaptionActStartExport                  = 'Export starten';
  sCaptionActDoExport                     = 'Exportieren';
  sCaptionActTeamViewer                   = 'TeamViewer';
  sCaptionActStartHoliday                 = 'Abwesenheit eintragen';
  sCaptionActEndHoliday                   = 'Abwesenheit beenden';
  sCaptionActEditHoliday                  = 'Abwesenheit bearbeiten';
  sHintActFtxPos                          = 'Fundstellenmarkierung';

(*
  sCaptionSelectClientDirectory           = 'Select Client Directory';
  sCaptionSelectServerDirectory           = 'Select Server Directory';
  sCaptionImaging                         = 'Imaging';
  sCaptionNewProfile                      = 'New Profile';
  sCaptionProfileName                     = 'Profilename';
  sCaptionAcquire                         = 'Acquire';
  sCaptionLoadFile                        = 'Load File';
  sCaptionShowScanPool                    = 'Scanpool';
  sCaptionArchive                         = 'Archive';
  sCaptionArchiveID                       = 'ArchiveID';
  sCaptionRecordStore                     = 'RecordStore';
  sCaptionRecordArchive                   = 'RecordArchive';
  sCaptionLoginURL                        = '(c) 2004 - 2021 bitfarm GmbH';
  sCaptionCreateArchiveDlgCaption         = 'Create New Archive...';
  sCaptionModifyArchiveDlgCaption         = 'Modify Archive';
  sCaptionAddUserorGroup                  = 'Add User or Group...';
  sCaptionAddUserOrGroupTo                = 'Add User or Group to ';
  sCaptionAddUserToGroup                  = 'Add User to Group';
  sCaptionAddGroupToGroup                 = 'Add Group to Group';
  sCaptionAddObjectToGroup                = 'Add Object to Group';
  sCaptionSelectAGroup                    = 'Select a Group...';
  sCaptionCreateNewAdditionalFieldCaption = 'Creat New Additionalfield';
  sCaptionCreateNewStatusFieldCaption     = 'Create New sCaptiontatusfield';
  sCaptionGroupID                         = 'GroupID';
  sCaptionLevel                           = 'Level';
  sCaptionID                              = 'ID';
  sCaptionObjType                         = 'ObjType';
  sCaptionDisplayName                     = 'Displayname';
  sCaptionControlItems                    = 'Control items';
  sCaptionDefaultValue                    = 'Default value';
  sCaptionFieldType                       = 'Field type';
  sCaptionValueType                       = 'Value type';
  sCaptionControlType                     = 'Control type';
  sCaptionMode                            = 'Mode';
  sCaptionChkPrg                          = 'ChkPrg';
  sCaptionFunction                        = 'Function';
  sCaptionIndexTableID                    = 'IndexTableID';
  sCaptionStateFunction                   = 'State function';
  sCaptionEnabled                         = 'Enabled';
  sCaptionUser                            = 'User';
  sCaptionGroup                           = 'Group';
  sCaptionAll                             = 'All';
  sCaptionActive                          = 'Active';
  sCaptionLocked                          = 'Locked';
  sCaptionDeleted                         = 'Deleted';
  sCaptionReset                           = 'Reset';
  sCaptionAdditionalField                 = 'Additional field';
  sCaptionMyComputer                      = 'My Computer';
  sCaptionAdditionalFields                = 'Additional Fields';
  sCaptionLoading                         = 'Loading...';
  sCaptionGDocID                          = 'GDocID';
  sCaptionFileType                        = 'Filetype';
  sCaptionPageCount                       = 'Pagecount';
  sCaptionDocLoc                          = 'DocLoc';
  sCaptionTimeStamp                       = 'Timestamp';
  sCaptionDocDate                         = 'Date';
  sCaptionSearchOptions                   = 'Search options';
  sCaptionDocumentLink                    = 'Document link';
  sCaptionDate                            = 'Date';
  sCaptionMoreUsersSelected               = 'More users selected';
  sCaptionMoreFieldsSelected              = 'More fields selected';

  sCaptionDPI50                           = '50 DPI';
  sCaptionDPI75                           = '75 DPI';
  sCaptionDPI100                          = '100 DPI';
  sCaptionDPI150                          = '150 DPI';
  sCaptionDPI200                          = '200 DPI';
  sCaptionDPI300                          = '300 DPI';
  sCaptionDPI400                          = '400 DPI';
  sCaptionDPI600                          = '600 DPI';
  sCaptionDPI1200                         = '1200 DPI';

  sCaptionScrollStep10                    = '10';
  sCaptionScrollStep20                    = '20';
  sCaptionScrollStep30                    = '30';
  sCaptionScrollStep40                    = '40';
  sCaptionScrollStep50                    = '50';
  sCaptionScrollStep60                    = '60';
  sCaptionScrollStep70                    = '70';
  sCaptionScrollStep80                    = '80';
  sCaptionScrollStep90                    = '90';
  sCaptionScrollStep100                   = '100';
  sCaptionScrollStep110                   = '110';
  sCaptionScrollStep120                   = '120';
  sCaptionScrollStep130                   = '130';
  sCaptionScrollStep140                   = '140';
  sCaptionScrollStep150                   = '150';

  sCaptionZoomStep1                       = '1';
  sCaptionZoomStep2                       = '2';
  sCaptionZoomStep3                       = '3';
  sCaptionZoomStep4                       = '4';
  sCaptionZoomStep5                       = '5';
  sCaptionZoomStep10                      = '10';
  sCaptionZoomStep15                      = '15';
  sCaptionZoomStep20                      = '20';
  sCaptionZoomStep25                      = '25';
  sCaptionZoomStep30                      = '30';
  sCaptionZoomStep35                      = '35';
  sCaptionZoomStep40                      = '40';
  sCaptionZoomStep50                      = '50';
  sCaptionZoomStep100                     = '100';

  sCaptionLogLevelNormal                  = 'ErrorCodes';
  sCaptionLogLevelLow                     = 'Low';
  sCaptionLogLevelLowGUI                  = 'Low + GUI';
  sCaptionLogLevelMedium                  = 'Medium';
  sCaptionLogLevelHigh                    = 'High';
  sCaptionLogLevelDEBUG                   = 'Debug';


  sCaptionNewPassword                     = 'New password';
  sCaptionNewPasswordAgain                = 'New password again';
  sCaptionKind                            = 'Kind';



//////////// Default Captions /////////////////////////////////////////////////
  sCaptionFile                            = 'File';
  sCaptionNew                             = 'New';
  sCaptionModify                          = 'Modify';
  sCaptionApply                           = 'Apply';
  sCaptionDelete                          = 'Delete';
  sCaptionOK                              = 'OK';
  sCaptionYES                             = 'Yes';
  sCaptionNO                              = 'No';
  sCaptionWarning                         = 'Warning';
  sCaptionConfirmation                    = 'Confirmation';
  sCaptionMove                            = 'Move';
  sCaptionServer                          = 'Server';
  sCaptionProfile                         = 'Profile';
  sCaptionAdd                             = 'Add';
  sCaptionRemove                          = 'Remove';
  sCaptionProperties                      = 'Properties';



//////////// MainForm Captions /////////////////////////////////////////////////
///       Administrator
  sCaptionMandant                         = 'Mandant';
  sCaptionStore                           = 'Store';
  sCaptionAdministrator                   = 'Administrator';
  sCaptionViewer                          = 'Viewer';
  sCaptionImportScan                      = 'Import/Scan';
  sCaptionSettings                        = 'Settings';
  sCaptionArchives                        = 'Archives';
  sCaptionNewArchive                      = 'New archive';
  sCaptionModifyArchive                   = 'Modify archive';
  sCaptionDeleteArchive                   = 'Delete archive';
  sCaptionCreateArchiveCaption            = 'Create archive';
  sCaptionCreateNewArchiveCaption         = 'Create new archive';
  sCaptionCreateMandant                   = 'Create mandant';
  sCaptionCreateNewMandant                = 'Create new mandant';
  sCaptionCreateStore                     = 'Create store';
  sCaptionCreateNewStore                  = 'Create new store';
  sCaptionCreateUsersAndGroupsContainer   = 'Create users and groups container';
  sCaptionCreateFieldsContainer           = 'Create fields container';
  sCaptionUsersAndGroups                  = 'Users and groups';
  sCaptionCreateNewUserCaption            = 'Create new user';
  sCaptionCreateNewGroupCaption           = 'Create new group';
  sCaptionAddObjectToContainer            = 'Add object to container';
  sCaptionAddObjectToArchive              = 'Add object to archive';
  sCaptionAdditionalAndStatusFields       = 'Additional- and Statusfields';
  sCaptionCreateAdditionalField           = 'Create addititonal field';
  sCaptionCreateStatusField               = 'Create status field';
  sCaptionStoresAndArchives               = 'Stores and Archives';
  sCaptionShowUserContainers              = 'Show user and groups containers';
  sCaptionShowFieldsContainers            = 'Show fields containers';
  sCaptionLayoutEditor                    = 'Layout editor';
  sCaptionOptions                         = 'Options';
  sCaptionNormalView                      = 'Normal view';
  sCaptionRecordView                      = 'Record view';
  sCaptionWorkplace                       = 'Workplace';
  sCaptionImport                          = 'Import';
  sCaptionWorkflow                        = 'Workflow';
  sCaptionResubmissionTasks               = 'Resubmission / Tasks';
  sCaptionStart                           = 'Start';
  sCaptionSkins                           = 'Skins';
  sCaptionLanguage                        = 'Language';


///       Viewer
///       Scan / Import ????
///



/////////////////// Options Caption ////////////////////////////////////////////
///     Global Tab
  sCaptionGlobal                          = 'Global';
  sCaptionUseRoundedPopupMenu             = 'Use rounded popup menu';
  sCaptionForms                           = 'Forms';
  sCaptionFontName                        = 'Font name';
  sCaptionSize                            = 'Size';
  sCaptionTreeView                        = 'Treeview';
  sCaptionUseDefaultOptions               = 'Use default options';
  sCaptionUseDefaultLayouts               = 'Use default layouts';
  sCaptionRestartNeeded                   = 'Restart needed';
  sCaptionClientlogPath                   = 'Client log path';
  sCaptionLogLevel                        = 'Log level';
  sCaptionUseDBMonitor                    = 'Use DB monitor';
  sCaptionGUILayout                       = 'GUI Layout';

///          Scanner Tab
///          Editor Tab
///          Viewer Tab



/////////////////// AdminFrame Caption /////////////////////////////////////////
  sCaptionGeneral                         = 'General';
  sCaptionArchiveType                     = 'Archive type';
  sCaptionBackgroungPicture               = 'Background picture';
  sCaptionDocumentName                    = 'Document name';
  sCaptionIcon                            = 'Icon';
  sCaptionInheritPermissions              = 'Inherit permissions';
  sCaptionInheritFields                   = 'Inherit fields';
  sCaptionArchiveName                     = 'Archivename';
  sCaptionDescription                     = 'Description';
  sCaptionPermission                      = 'Permission';
  sCaptionPermissions                     = 'Permissions';
  sCaptionPermissionsOf                   = 'Permissions of ';
  sCaptionName                            = 'Name';
  sCaptionDocTXT                          = 'DocTXT';
  sCaptionRole                            = 'Role';
  sCaptionNewUser                         = 'New user';
  sCaptionNewGroup                        = 'New group';
  sCaptionType                            = 'Type';
  sCaptionLayoutDesigner                  = 'Layout designer';
  sCaptionApplicationRights               = 'Application rights';
  sCaptionArchiveRights                   = 'Archive rights';
  sCaptionSearch                          = 'Search';
  sCaptionShow                            = 'Show';
  sCaptionWrite                           = 'Write';
  sCaptionEmail                           = 'Email';
  sCaptionExport                          = 'Export';
  sCaptionPrint                           = 'Print';
  sCaptionLink                            = 'Link';
  sCaptionHistory                         = 'History';
  sCaptionListProtocol                    = 'List protocol';
  sCaptionRevSave                         = 'RevSave';
  sCaptionSave                            = 'Save';
  sCaptionEveryone                        = 'Everyone';
  sCaptionArchiveManagement               = 'Archive management';
  sCaptionUserManagement                  = 'User management';
  sCaptionGroupManagement                 = 'Group management';
  sCaptionFieldManagement                 = 'Field management';
  sCaptionLockUser                        = 'Lock user';
  sCaptionModifyUsersPwd                  = 'Modify user''''s password';
  sCaptionResetUsersPwd                   = 'Reset user''''s password';
  sCaptionCreateWorkflow                  = 'Create workflow';
  sCaptionModifyWorkflow                  = 'Modify workflow';
  sCaptionDeleteWorkflow                  = 'Delete workflow';
  sCaptionCancelWorkflow                  = 'Cancel workflow';
  sCaptionView                            = 'View';
  sCaptionLetter                          = 'Letter';
  sCaptionFields                          = 'Fields';
  sCaptionDropDownText                    = 'Dropdown Text';
  sCaptionText                            = 'Text';
  sCaptionSearchMode                      = 'Search Mode';
  sCaptionAncestorObjects                 = 'Ancestor objects';
  sCaptionRights                          = 'Rights';


/////////////////// UserProperties Caption /////////////////////////////////////
  sCaptionUserFirstName                   = 'Firstname';
  sCaptionUserLastName                    = 'Lastname';
  sCaptionUserMiddleName                  = 'Middlename';
  sCaptionUserEmail                       = 'Email';
  sCaptionState                           = 'State';
  sCaptionUserID                          = 'UserID';
  sCaptionMandantName                     = 'Mandant';
  sCaptionUserName                        = 'Username';
  sCaptionUserLocked                      = 'User locked';
  sCaptionChangePassword                  = 'Change password';



/////////////////// GroupProperties Caption ////////////////////////////////////
  sCaptionGroupName                       = 'Group name';
  sCaptionDefaultDocName                  = 'Default document name';


////////////////// System Captions /////////////////////////////////////////////
  sSysBitfarm                             = 'Bitfarm';
  sSysSpace                               = 'Space';
  sSysTab                                 = 'Tab';




/////////// Messages ///////////////////////////////////////////////////////////
  sMsgErrorAtReadingProfiles                          = 'Error at reading profiles!';

  sMsgScannedPagesInScanPool                          = 'There are scanned pages in the Scanpool, would you like to save them?';
  sMsgThereAreMoreThanOneSelectedWouldYouLikeToRotate = 'There are more than one page selected, would you like to rotate all of them?';
  sMsgPleaseRestartTheApplicationToChangeTheLanguage  = 'Please restart the application to change the language settings';
  sMsgError                                           = 'Error';
  sMsgLoginError                                      = 'Login Failure!';
  sMsgConfigConnectionError                           = 'Cannot connect to config database!';
  sMsgPleaseFillArchiveName                           = 'Please fill out the Archive name field!';
  sMsgPleaseFillallRequiredFields                     = 'Please fill all the required fields!';
  sMsgCannotCreateArchiveUnderTheSelectedObject       = 'Cannot create Archive under the selected object! Please choose another!';
  sMsgCannotCreateContainerUnderTheSelectedObject     = 'Cannot create Container under the selected object! Please choose another!';
  sMsgUserNameAlreadyExists                           = 'Username already exists! Please type an other!';
  sMsgUserNameAlreadyExistsAndWillBeResotored         = 'Username already exists and will be restored!';
  sMsgCannotCreateUser                                = 'Cannot create new user!';
  sMsgGroupNameAlreadyExists                          = 'Groupname already exists! Please type an other!';
  sMsgGroupNameAlreadyExistsAndWillBeRestored         = 'Groupname already exists and will be restored!';
  sMsgCannotCreateGroup                               = 'Cannot create new group!';
  sMsgGroupCannotInsertToSysGrpUsr                    = 'Cannot insert group to sys_grpusr';
  sMsgMandantCanbeCreatedbyDMSAdmin                   = 'Mandant can be created under DMSRoot by DMSAdmin!';
  sMsgNotEnoughtRights                                = 'You don''t have enought rights to do this operation!';
  sMsgRightsCannotBeSaved                             = 'Rights cannot be saved!';
  sMsgErrorAtSaveRights                               = 'Error at save rights!';
  sMsgCannotLoadArchive                               = 'Archive cannot be loaded!';
  sMsgObjectAlreadyExists                             = 'The object is already exists!';
  sMsgCannotUpdateGroup                               = 'Group cannot be updated!';
  sMsgCannotUpdateUser                                = 'User cannot be updated!';
  sMsgParentNotFound                                  = 'Parent not found!';
  sMsgObjectSameName                                  = 'Object with the same name cannot be added!';
  sMsgObjectTooDeep                                   = 'Object can be only 3 level deep!';
  sMsgCannotCreateArchive                             = 'Cannot create archive!';
  sMsgSureToDeleteArchive                             = 'Are you sure you want to delete the selected archive';
  sMsgSureToDeleteObject                              = 'Are you sure you want to delete the selected object';
  sMsgPleaseSelectAnArchive                           = 'Please select an archive!';
  sMsgPleaseSelectAContainer                          = 'Please select a container';
  sMsgCannotDeleteArchive                             = 'Archive cannot be deleted!';
  sMsgCannotDeleteContainer                           = 'Container cannot be deleted!';
  sMsgCannotDeleteObject                              = 'Object cannot be deleted!';
  sMsgObjectHasChildNodes                             = 'The selected object has child nodes!';
  sMsgDocumentsBelongsToArchive                       = 'Documents belongs to the archive!';
  sMsgRootCannotBeDeleted                             = 'Root cannot be deleted!';
  sMsgErrorAtReLogin                                  = 'Error at ReLogin!';
  sMsgErrorAtModifyUser                               = 'Error at modify user!';
  sMsgErrorAtModifyUserName                           = 'Error at modify username!';
  sMsgErrorAtModifyGroup                              = 'Error at modify group!';
  sMsgErrorAtModifyGroupName                          = 'Error at modify groupname!';
  sMsgErrorAtModifyArchives                           = 'Error at modify archive!';
  sMsgErrorAtCreateField                              = 'Error at create field!';
  sMsgFieldNameAlreadyExists                          = 'Field name already exists! Please type an other!';
  sMsgCannotUpdateArchive                             = 'Archive cannot be updated!';
  sMsgRootModifyingIsNotAllowed                       = 'Root modifying is not allowed!';
  sMsgErrorAtRemoveObjectFromSysLayout                = 'Error at remove user/group from archive!';
  sMsgObjectCannotBeDeleted                           = 'Object cannot be deleted!';
  sMsgDMSAdminCannotBeDeleted                         = 'DMSAdmin cannot be deleted!';
  sMsgSureToDeleteUser                                = 'Are you sure you want to delete the selected user';
  sMsgSureToDeleteGroup                               = 'Are you sure you want to delete the selected group';
  sMsgCannotDeleteUser                                = 'User cannot be deleted!';
  sMsgCannotDeleteGroup                               = 'Group cannot be deleted!';
  sMsgYouHaveTurnedOffTheInheritance                  = 'Warning: If you proceed, inheritable parent permission will no longer propagate to this object. Are you sure to turn off the inheritance?';
  sMsgDMSAdminCannotBeUpdated                         = 'DMSAdmin cannot be updated!';
  sMsgPleaseSelectUser                                = 'Please select a user!';
  sMsgPleaseSelectGroup                               = 'Please select a group!';
  sMsgErrorAtUserProperties                           = 'Error at User properties!';
  sMsgErrorAtGroupProperties                          = 'Error at Group properties!';
  sMsgPleaseSelectAnObject                            = 'Please select an object!';
  sMsgDMSRootCannotBeUpdated                          = 'DMSRoot cannot be updated!';
  sMsgDisplaynameCannotBeEmpty                        = 'Displayname cannot be empty!';
  sMsgErrorAtAdditionalFieldProperties                = 'Error at Additionalfield properties!';
  sMsgErrorAtArchiveProperties                        = 'Error at Archive properties!';
  sMsgErrorAtStatusFieldProperties                    = 'Error at statusfield properties!';
  sMsgErrorAdditionalfieldCannotBeUpdated             = 'Additionalfield cannot be updated!';
  sMsgErrorStatusfieldCannotBeUpdated                 = 'Statusfield cannot be updated!';
  sMsgGroupCannotBeLoaded                             = 'Group Cannot be Loaded!';
  sMsgPleaseSelectAGroup                              = 'Please seelct a Group!';
  sMsgUserCannotBeLoaded                              = 'User cannot be loaded!';
  sMsgPleaseSelectAUser                               = 'Please select a User!';
  sMsgSureToRemoveUserFromSelectedArchive             = 'Are you sure to remove user from the selected Archive';
  sMsgCannotAddAdditionalFieldToArchive               = 'Error at add Additionalfield to Archive!';
  sMsgCannotAddStatusFieldToArchive                   = 'Error at add statusfield to Archive!';
  sMsgSureToRemoveAdditionalField                     = 'Are you sure you want to remove the selected additional field';
  sMsgSureToRemoveStatusField                         = 'Are you sure you want to remove the selected status field';
  sMsgCannotRemoveAdditionalField                     = 'Additional field cannot be removed!';
  sMsgCannotRemoveStatusField                         = 'Status field cannot be removed!';
  sMsgPleaseSelectAnAdditionalField                   = 'Please select an addititonal field!';
  sMsgPasswordsAreNotTheSame                          = 'Passwords are not the same!';
  sMsgMainFormUserCannotInitialized                   = 'User Cannot be initilalized!';
  sMsgMainFormErrorinSelectClients                    = 'Profils cannot be loaded!';
  sMsgSelectaDirectory                                = 'Select a Directory!';
  sMsgErrorAtScanningWithCode                         = 'Error at scanning! ErrorCode: ';
  sMsgScanning                                        = 'Scanning...';
  sMsgScanningFailed                                  = 'Scanning... FAILED';
  sMsgCannotChangeUserPassword                        = 'Cannot change password!';
  sMsgPleaseGiveAnOtherPassword                       = 'Please give an other password!';
  sMsgPasswordChanged                                 = 'Password Changed!';
  sMsgSureToRemoveGroupFromSelectedArchive            = 'Are you sure you want to remove the selected group?';
  sMsgPleaseSaveArchive                               = 'Please Save archive properties!';
  sMsgFormClassNotFound                               = 'Form class not found';
  sMsgPackageNotFound                                 = 'Package not found';
  sMsgPleaseSaveTheModifications                      = 'Please save the modifications!';
  sMsgWouldYouLikeToSaveTheModifications              = 'You have made changes.\n Do you want to save the changes?';
  sMsgPleaseSaveModification                          = 'Please save the changes!';
  sMsgWouldYouLikeToSaveModification                  = 'Would you like to save changes?';
  sMsgSureToMoveObject                                = 'Are you sure you want to move the object?';
  sMsgSureToSaveObject                                = 'Are you sure you want to save?';
  sMsgWillBeDeleted                                   = 'will be deleted';
  sMsgAnd                                             = 'and';
  sMsgMore                                            = 'more';
  sMsgResult                                          = 'Result';
  sMsgAdded                                           = 'added';
  sMsgSkipped                                         = 'skipped';
  sMsgErrorCode                                       = 'Errorcode';
  sMsgBad                                             = 'bad';
  sMsgFileNotFound                                    = 'File not found!';
  sMsgSeparatorCannotBeEmpty                          = 'Separator cannot be empty!';
  sMsgYouHaveTurnedOnBaseFieldChanging                = 'Warning: If you proceed, you will change the global properties of this field. It can cause data loss in other archives! Are you really sure to turn on this option?';
  sMsgPleaseSaveTheModificationsBefore                = 'Please save the modifications before!';
  sMsgPleaseWaitWhileThumbnailLoaded                  = 'Please wait while thumbnail loaded!';
  sMsgPleaseWaitWhileActualArchiveLoaded              = 'Please wait while actual archive loaded!';
  sMsgPleaseSelectADocument                           = 'Please select a document!';
*)

const

///////// Client Error Codes ////////////////////////////////////////////////
  ecClientErrorAtReadingProfiles    = 11001;

  ecMainFormFillTreeListFailure     = 19001;
  ecMainFormInitApplicationFailure  = 19002;
  ecMainFormFailureinFormCreate     = 19003;
  ecMainFormObjectNotFoundFailure   = 19004;
  ecMainFormRequiredFieldsNotFilled = 19005;
  ecMainFormPasswordsAreNotEqual    = 19006;

procedure InitActionList(frm: TfrmGPL);
procedure SpDxGetTextInitialize(LanguageCode, Path: string; AComponents: array of TComponent; ShellFont, UnicodeResourceStrings: Boolean);
procedure SpDxGetTextChangeLanguage(LanguageCode, Path: string; AComponents: array of TComponent);
//procedure TranslateToolbars(c: TComponent);
//procedure TranslateToolbarItem(tvxItem: TTBCustomItem);
procedure ReadColorscheme;
procedure TranslateToolbarItem(tvxItem: TTBCustomItem);
procedure TranslateToolbar(Toolbar: TSpTBXToolbar);
function FindToolbarSubmenuItemByName(SearchedItemName: string; Item: TTBCustomItem): TSpTBXItem;


implementation

uses
  Windows, ActnList, Controls, Graphics, ShellAPI, SysUtils, DB, DBClient,
  bfaCommonUtils, CRGrid, ComCtrls, SpTBXDkPanels, bfaObjects36,  u_bfaGrid,
  gnugettext, SpTBXTabs, bfaIconsDM,
  Forms, u_bfaAddfield, cxLookAndFeels, IniFiles
  ;

procedure InitActionList(frm: TfrmGPL);
begin
  with frm do
  begin
    mnuQuit.Action := actQuit;
    // SJ 17.12.2021 - in OnClick Action erzeugen, wegen DisplayCheckoutAtShutdown
//    mnuRelogin.Action := actRelogin;
    mnuRelogin.OnClick := frm.mnuReloginClick;
    mnuRelogin.ImageIndex := actRelogin.ImageIndex;
    actCreateBookmark.Enabled := True;
    actCreateBookmarkMenu.Enabled := True;
    mnuCreateBookmark.Action := actCreateBookmarkMenu;
    mnuCreateBookmarkForGDocID.Action := actCreateBookmarkForGDocID;      //MainMenu
    mnuCreateBookmarkForGDocID_.Action := actCreateBookmarkForGDocID;     //ppmTools
    mnuCreateBookmarkDialog.Action := actCreateBookmarkDialog;
    actReplaceBookmark.Enabled := True;
    actChangeBookmark.Enabled := True;
    mnuChangePassword.Action := actChangePassword;
    mnuOptions.Action := actOptions;
    mnuLocalSavePDF.Action := actLocalSavePDF;
    mnuLocalSaveTIF.Action := actLocalSaveTIF;
    mnuLocalSaveOriginal.Action := actLocalSaveOriginal;
    mnuLocalSaveLink.Action := actLocalSaveLink;
    mnuLocalSavePreview.Action := actLocalSavePreview;
    mnuEmailPreview.Action := actEmailPreview;
    mnuEmailPDFAttachment.Action := actEmailPDFAttachment;
    mnuEmailTIFAttachment.Action := actEmailTIFAttachment;
    mnuEmailOriginal.Action := actEmailOriginal;
    mnuEmailLink.Action := actEmailLink;
    mnuPrintStandard.Action := actPrintStandard;
    mnuPrintSelect.Action := actPrintSelect;
    mnuPrintSelect.Visible := False;
    mnuPrintPreview.Action := actPrintPreview;
    mnuViewNavigation.Action := actViewNavigation;
    mnuViewSearchOptions.Action := actViewSearchOptions;
    mnuViewFloatingWVL.Action := actViewFloatingWVL;
    mnuViewFloatingWVL.Images := bfaIcons.ilPreview;
    mnuViewFloatingWVL.ImageIndex := Integer(icoidx_resubmission_view);
    mnuViewPreview.Action := nil;
    mnuViewPreview.Visible := False;
    mnuViewThumbnails.Action := actViewThumbnails;
    mnuDeleteColumnOrder.Action := actDeleteColumnOrder;
    mnuGetLastDocument.Action := actGetLastDocument;
    mnuGetDoc1.Action := actGetDoc1;
    mnuGetDoc2.Action := actGetDoc2;
    mnuGetDoc3.Action := actGetDoc3;
    mnuGetDoc4.Action := actGetDoc4;
    mnuGetDoc5.Action := actGetDoc5;
    mnuSetDoc1.Action := actSetDoc1;
    mnuSetDoc2.Action := actSetDoc2;
    mnuSetDoc3.Action := actSetDoc3;
    mnuSetDoc4.Action := actSetDoc4;
    mnuSetDoc5.Action := actSetDoc5;
    mnuRestoreOriginal.Action := actRestoreOriginal;
    mnuRestoreOriginal_Main.Action := actRestoreOriginal;

    mnuDocEditor.Visible := False;
    mnuDocEditor_Main.Visible := False;

    actDuplicateDoc.Enabled := True;
    mnuDuplicateDoc.Visible := True;
    mnuDuplicateDoc.Action := actDuplicateDoc;
    mnuDuplicateDoc_Main.Enabled := True;
    mnuDuplicateDoc_Main.Visible := True;
    mnuDuplicateDoc_Main.Action := actDuplicateDoc;
    mnuExportCSV.Action := actExportCSV;
    mnuExportXLS.Action := actExportXLS;
    mnuExportOO.Action := actExportOO;
    mnuExportCSV_Main.Action := actExportCSV;
    mnuExportXLS_Main.Action := actExportXLS;
    mnuExportOO_Main.Action := actExportOO;
    mnuCreateEmptyDoc.Action := actCreateEmptyDoc;
    mnuDeleteDoc.Action := actDeleteDoc;
    mnuAuditProof.Action := actAuditProof;
    mnuGraphicOptions.Action := actGraphicOptions;
    //mnuCreateEmptyDoc_Main.Action := actCreateEmptyDoc;
    mnuDeleteDoc_Main.Action := actDeleteDoc;
    mnuAuditProof_Main.Action := actAuditProof;

    mnuMergeDoc.Visible := False;
    mnuRefreshDoc.Action := actReOCR;
    mnuEditTags.Action := actEditTags;
    mnuNewLink.Action := actNewLink;
    mnuAddLink.Action := actAddLink;
    mnuMergeDoc_Main.Visible := False;
    mnuRefreshDoc_Main.Action := actReOCR;
    mnuNewLink_Main.Action := actNewLink;
    mnuAddLink_Main.Action := actAddLink;
    tbsubCreateEmptyDoc.Action := actCreateEmptyDoc;
    mnuCreateEmptyDoc.Visible := False;
    mnuCreateEmptyDoc_Main.Visible := False;

    mnuInverted.Action := actInverted;
    mnuDeScrew.Action := actDeScrew;
    mnuDeScrew.Action := actDeScrew;
    mnuDeSpeckle.Action := actDeSpeckle;
    mnuRemoveBorder.Action := actRemoveBorder;
    mnuRotateLeft.Action := actRotateLeft;
    mnuFlip.Action := actFlip;
    mnuRotateRight.Action := actRotateRight;
    mnuInfo.Action := actInfo;
    mnuSupport.Action := actSupport;
    mnuVideos.Action := actVideos;
    mnuHandbooks.Action := actHandbooks;

    mnuCheckoutAllDocs.Action := actCheckoutDocsAdmin;
    mnuCheckoutDocs.Action := actCheckoutDocs;

    clItemLinks.Action := actLinks;
    clItemOriginalfile.Action := actOriginalfile;
    clItemCheckout.Action := actCheckout;
    clItemIsAuditProof.Action := actIsAuditProof;
    clItemIsAuditProof.Visible := False;

    actLanguageDE.Enabled := True;
    actLanguageEN.Enabled := True;
    mnuLanguageDE.Action := actLanguageDE;
    mnuLanguageEN.Action := actLanguageEN;
//07.09.2020    mnuEmail.ImageIndex := 229;
//    mnuPrint.ImageIndex := 18;
//    mnuLocalSave.ImageIndex := 19;
//    mnuExportMeta.ImageIndex := 129;
//    mnuCopyToClipboard.ImageIndex := 33;
    mnuEmail.ImageIndex := Integer(icoidx_mail_pdf);
    mnuPrint.ImageIndex := Integer(icoidx_print);
    mnuLocalSave.ImageIndex := Integer(icoidx_save_file);
//    mnuExportMeta.ImageIndex := Integer(icoidx_export_meta);
    mnuCopyToClipboard.ImageIndex := Integer(icoidx_clipboard);
    mnuPageToClipboard.Action := actCopyPageToClipboard;
    mnuDocToClipboard.Action := actCopyDocToClipboard;
    mnuOriDocToClipboard.Action := actCopyOriginalDocToClipboard;
    mnuDocLinkToClipboard.Action := actCopyDocLinkToClipboard;
    mnuResetDLM.Action := actResetDLM;
    mnuSaveImportValues.Action := actSaveImportValues;

    btnSave.Action := actSave;
    btnSave.Enabled := False;
    btnCancel.Action := actCancel;
    btnCancel.Enabled := False;
    btnSearch.Action := actSearch;
    btnReset.Action := actReset;
    btnBack.Action := actBack;
    btnForward.Action := actForward;

    // Wiedervorlage
    actMyTasks.Enabled := True;
    fraResub.btnMyTasks.Action := actMyTasks;
    fraResub.btnMyTasks.Images := bfaIcons.ilMainMenu;
    actDelegateTasks.Enabled := True;
    fraResub.btnDelegateTasks.Action := actDelegateTasks;
    fraResub.btnDelegateTasks.Images := bfaIcons.ilMainMenu;
    fraResub.btnShowCW.Action := actShowCW;
    fraResub.btnShowCW.Images := bfaIcons.ilMainMenu;
    fraResub.btnCWPrevious.Action := actCWPrevious;
    fraResub.btnCWPrevious.Images := bfaIcons.ilMainMenu;
    fraResub.btnCWNext.Action := actCWNext;
    fraResub.btnCWNext.Images := bfaIcons.ilMainMenu;
    fraResub.tbiResubWork.Images := bfaIcons.ilMainMenu;
    fraResub.btnResubForward.Images := bfaIcons.ilMainMenu;
    fraResub.btnResubDone.Images := bfaIcons.ilMainMenu;

    // Importer
    fraScanFunctions.btnScan.Action := actScan;
    fraScanFunctions.btnScan.Images := bfaIcons.ilMainMenu;
    fraScanFunctions.btnScan.Caption := '';

    fraScanFunctions.btnScanDialog.Action := actScanDialog;
    fraScanFunctions.btnScanDialog.Images := bfaIcons.ilMainMenu;
    fraScanFunctions.btnScanDialog.Caption := '';

    fraScanFunctions.btnLoadFile.Action := actLoadFile;
    fraScanFunctions.btnLoadFile.Images := bfaIcons.ilMainMenu;
    fraScanFunctions.btnLoadFile.Caption := '';

    fraScanFunctions.btnSaveFile.Action := actLocalSavePreview;
    fraScanFunctions.btnSaveFile.Images := bfaIcons.ilMainMenu;
    // bewusst anderer ImageIndex. Action-ImageIndex soll berschrieben werden !
    fraScanFunctions.btnSaveFile.ImageIndex := Integer(icoidx_files_download);
    fraScanFunctions.btnSaveFile.Caption := '';

    fraScanFunctions.btnDeleteSelected.Action := actDeleteSelected;
    fraScanFunctions.btnDeleteSelected.Images := bfaIcons.ilMainMenu;
    fraScanFunctions.btnDeleteSelected.Caption := '';

    fraScanFunctions.btnArchive.Action := actArchive;
    fraScanFunctions.btnArchive.Images := bfaIcons.ilMainMenu;
    fraScanFunctions.btnReset.Action := actResetImporter;
    fraScanFunctions.btnReset.Images := bfaIcons.ilMainMenu;

    fraScanFunctions.btnScanProfilOptions.Action := actScanOptions;
    fraScanFunctions.btnScanProfilOptions.Images := bfaIcons.ilMainMenu;

    btnIndexingReset.Action := actClearFields;

    // Workplace
    fraWorkplace.btnWPGroup.Action := actWPGroup;
    fraWorkplace.btnWPGroup.Images := bfaIcons.ilMainMenu;
    fraWorkplace.btnWPGroup.Caption := '';

    fraWorkplace.btnWPUngroup.Action := actWPUngroup;
    fraWorkplace.btnWPUngroup.Images := bfaIcons.ilMainMenu;
    fraWorkplace.btnWPUnGroup.Caption := '';

    fraWorkplace.btnWPLoad.Action := actWPLoad;
    fraWorkplace.btnWPLoad.Images := bfaIcons.ilMainMenu;
    fraWorkplace.btnWPLoad.ImageIndex := -1;
    fraWorkplace.btnWPLoad.Visible := False;

    fraWorkplace.btnWPSave.Action := actWPSave;
    fraWorkplace.btnWPSave.Images := bfaIcons.ilMainMenu;
    fraWorkplace.btnWPSave.ImageIndex := -1;
    fraWorkplace.btnWPSave.Visible := False;

    fraWorkplace.btnWPClear.Action := actDeleteSelected;
    fraWorkplace.btnWPClear.Images := bfaIcons.ilMainMenu;

//// Standard Actions die spter nicht gendert werden soll
    actRelogin.Enabled := True;
    actChangePassword.Enabled := True;
    actOptions.Enabled := True;
    actScanOptions.Enabled := True;

    actQuit.Enabled := True;
    actViewNavigation.Enabled := True;
    actViewSearchOptions.Enabled := True;
    actViewPreview.Enabled := True;
    actViewThumbnails.Enabled := True;
    actViewFloatingWVL.Enabled := True;
    actDeleteColumnOrder.Enabled := True;
    actInfo.Enabled := True;
    actSupport.Enabled := True;
    actGraphicOptions.Enabled := True;
    actCancel.Enabled := True;
    actLayoutSave.Enabled := True;
    actLayoutDelete.Enabled := True;
    actLayoutStandard.Enabled := True;
    actAddFolder.Enabled := True;
    actDeleteFolder.Enabled := True;
    actAddGlobal.Enabled := True;
    actDeleteGlobal.Enabled := True;
    actOriginalfile.Enabled := True;
    actLinks.Enabled := True;
    actCheckout.Enabled := True;

    actClearFields.Enabled := True;
    actReset.Enabled := True;
    actResetImporter.Enabled := True;
  end;
end;

{ Languages }
function MyWideCustomLoadResString(ResStringRec: PResStringRec; var Value: WideString): Boolean;
begin
  Result := True;
  Value := GnuGetText.LoadResStringW(ResStringRec);
end;

procedure SpDxGetTextInitialize(LanguageCode, Path: string; AComponents: array of TComponent; ShellFont, UnicodeResourceStrings: Boolean);
// LanguageCode can be an ISO language code: 'en', 'es', 'ko'
// And also can be the ISO code plus a description: '[en] English', '[es] Spanish', '[ko] Korean'
var
  I, L: Integer;
begin
  {$IFDEF DXGETTEXTDEBUG}
  if FileExists(BD.ExeDir + '\gettextlog.log') then
    DeleteFile(BD.ExeDir + '\gettextlog.log');

  gnugettext.DefaultInstance.DebugLogToFile(BD.ExeDir + '\gettextlog.log');
  {$ENDIF}

  if Path = '' then
    Path := IncludeTrailingPathDelimiter(BD.ExeDir + 'locale');
//    Path := IncludeTrailingPathDelimiter(BD.ExeDir + 'Viewer-Files\locale');

  bindtextdomain(sSysGnuViewerDomain, Path);
  bindtextdomain('Shared36', Path);
  AddDomainForResourceString(sSysGnuViewerDomain);
  AddDomainForResourceString('Shared36');
  gnugettext.DefaultInstance.textdomain(sSysGnuViewerDomain);

  // Get the ISO language code
  L := Length(LanguageCode);
  if (L > 2) and (LanguageCode[1] = '[') then begin
    I := Pos(']', LanguageCode);
    if (I > 0) then
      LanguageCode := Copy(LanguageCode, 2, I - 2);
  end;

  {$IFNDEF UNICODE}
  // Override Delphi's automatic ResourceString conversion to Ansi
  if UnicodeResourceStrings then begin
    TntSystem.InstallTntSystemUpdates;
    // Override TNT's LoadResString function
    // This is necessary because dxGetText uses a different
    // way to access the translated ResourceStrings.
    TntSystem.WideCustomLoadResString := MyWideCustomLoadResString;
  end;
  {$ENDIF}

  if ShellFont then begin
    if (Win32Platform = VER_PLATFORM_WIN32_NT) and (Win32MajorVersion >= 5) then
      DefFontData.Name := 'MS Shell Dlg 2'
    else
      DefFontData.Name := 'MS Shell Dlg';
  end;

  {$IFNDEF ENTERPRISE}
    gnugettext.TP_GlobalIgnoreClassProperty(TfrmGPL,'Caption');
  {$ELSE}
    //gnugettext.TP_GlobalIgnoreClassProperty(TfrmEnterprise,'Caption');
  {$ENDIF}

  gnugettext.TP_GlobalIgnoreClassProperty(TAction,'Category');
  gnugettext.TP_GlobalIgnoreClassProperty(TControl,'HelpKeyword');
  gnugettext.TP_GlobalIgnoreClassProperty(TControl,'ImeName');
  gnugettext.TP_GlobalIgnoreClassProperty(TStringField,'FieldName');
  gnugettext.TP_GlobalIgnoreClassProperty(TCRColumn,'FieldName');
  gnugettext.TP_GlobalIgnoreClassProperty(TComboBoxEx, 'ItemsEx');
  gnugettext.TP_GlobalIgnoreClassProperty(TcxLookAndFeel, 'SkinName');
  gnugettext.TP_GlobalIgnoreClassProperty(TSpTBXDockablePanelToolbar, 'CustomHint');
  gnugettext.TP_GlobalIgnoreClassProperty(TSpTBXItem, 'ImageName');
  gnugettext.TP_GlobalIgnoreClassProperty(TSpTBXFontSettings, 'Name');

  //gnugettext.TP_GlobalIgnoreClassProperty(TSaveTextFileDialog,'PicturePanel');
  gnugettext.TP_GlobalIgnoreClass(TSaveTextFileDialog);
  gnugettext.TP_GlobalIgnoreClass(TOpenTextFileDialog);
  gnugettext.TP_GlobalIgnoreClass(Graphics.TFont);
  gnugettext.TP_GlobalIgnoreClass(TSpTBXTabSheet);
  gnugettext.TP_GlobalIgnoreClass(TClientDataSet);
//  gnugettext.TP_GlobalIgnoreClass(TFieldDefs);

  gnugettext.TP_GlobalIgnoreClass(TbfaJvCheckedComboBox);
  // TODO SJ - Zusatzfelder TbfaComboBox etc?

  gnugettext.UseLanguage(LanguageCode);
  for I := Low(AComponents) to High(AComponents) do
  begin
    try
      gnugettext.TranslateComponent(AComponents[I], sSysGnuViewerDomain);
    except
      //
    end;
  end;
end;

procedure SpDxGetTextChangeLanguage(LanguageCode, Path: string; AComponents: array of TComponent);
// LanguageCode can be an ISO language code: 'en', 'es', 'ko'
// And also can be the ISO code plus a description: '[en] English', '[es] Spanish', '[ko] Korean'
var
  I, L: Integer;
  C: TComponent;

  // bersetze rekursiv die MenuItems im Menu
  procedure ReTranslateToolbarItem(tvxItem: TTBCustomItem);
  var
    i: integer;
    s: string;
  begin
    if (tvxItem.Count = 0) then
    begin
      ReTranslateComponent(tvxItem, sSysGnuViewerDomain);
      if Assigned(tvxItem.Action) then
        ReTranslateComponent(tvxItem.Action, sSysGnuViewerDomain);
    end
    else
    begin
      ReTranslateComponent(tvxItem, sSysGnuViewerDomain);
      if Assigned(tvxItem.Action) then
        ReTranslateComponent(tvxItem.Action, sSysGnuViewerDomain);

      for i := 0 to tvxItem.Count - 1 do
      begin
        //s := tvxItem.Caption;
        //s2 := tvxItem.Name;
        ReTranslateComponent(tvxItem ,'ViewerV36');
        if Assigned(tvxItem.Action) then
          ReTranslateComponent(tvxItem.Action ,'ViewerV36');
      end;

      for i := 0 to tvxItem.Count - 1 do
      begin
        ReTranslateToolbarItem(tvxItem.Items[i]);
      end;
    end;
  end;

  procedure ReTranslateToolbars(c: TComponent);
  var
    i, j, k, m: integer;
    frame: Tframe;
    Toolbar: TTBCustomToolbar;
    tvxItem: TSpTBXItem;
  begin
    if not Assigned(c) then
      Exit;

    for i := 0 to c.ComponentCount - 1 do
    begin
      // 1. Finde Toolbar
      if c.Components[i] is TTBCustomToolbar then
      begin
        Toolbar := TTBCustomToolbar(c.Components[i]);

        if Toolbar.ControlCount = 0 then
        begin
          if Toolbar is TSpTBXToolbar then
          begin
            for m := 0 to TSpTBXToolbar(Toolbar).Items.Count-1 do
            begin
              // 4. Finde Toolbar-items und bersetzte sie einzeln (rekursiv)
              if (TSpTBXToolbar(Toolbar).Items[m] is TSpTBXItem) then
              begin
                tvxItem := TSpTBXItem(TSpTBXToolbar(Toolbar).Items[m]);
                if tvxItem is TbfaStatefieldComp then
                  Continue;
                ReTranslateToolbarItem(tvxItem);
              end;
            end
          end;
        end else
        begin
          for j := 0 to Toolbar.ControlCount-1 do
          begin
            //s2 := Toolbar.Controls[n].Name;
            //s3 := Toolbar.Controls[n].ClassName;

            // 2. Finde Frame
            if Toolbar.Controls[j] is TFrame then
            begin
              frame := TFrame(TTBCustomToolbar(c.Components[i]).Controls[j]);
              for k := 0 to frame.ControlCount-1 do
              begin
                //s2 := frame.Controls[k].ClassName + ' ' + frame.Controls[k].Name;
                // 3. Finde eingebette Toolbar im Frame
                if (frame.Controls[k] is TSPTbxToolbar)
                   //and (frame.Controls[k].Name = 'tlbMainMenu')
                then
                begin
                  for m := 0 to TSPTbxToolbar(frame.Controls[k]).Items.Count-1 do
                  begin
                    // 4. Finde Toolbar-items und bersetzte sie einzeln (rekursiv)
                    if (TSPTbxToolbar(frame.Controls[k]).Items[m] is TSpTBXItem) then
                    begin
                      tvxItem := TSpTBXItem(TSPTbxToolbar(frame.Controls[k]).Items[m]);
                      //s := tvxItem.Caption;
                      ReTranslateToolbarItem(tvxItem);
                    end;
                  end
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;

begin
  if Path = '' then
    Path := IncludeTrailingPathDelimiter(BD.ExeDir + 'locale');

  bindtextdomain(sSysGnuViewerDomain, Path);
  bindtextdomain('Shared36', Path);
  AddDomainForResourceString(sSysGnuViewerDomain);
  AddDomainForResourceString('Shared36');

  // Get the ISO language code
  L := Length(LanguageCode);
  if (L > 2) and (LanguageCode[1] = '[') then
  begin
    I := Pos(']', LanguageCode);
    if (I > 0) then
      LanguageCode := Copy(LanguageCode, 2, I - 2);
  end;

  if LanguageCode <> gnugettext.GetCurrentLanguage then
  begin
    gnugettext.UseLanguage(LanguageCode);
    for I := Low(AComponents) to High(AComponents) do
    begin
      C := AComponents[I];
      SpBeginUpdateAllToolbars(C);
      try
        gnugettext.ReTranslateComponent(C, sSysGnuViewerDomain);
        ReTranslateToolbars(c);
      finally
        SpEndUpdateAllToolbars(C);
      end;
    end;
  end;
end;

procedure ReadColorscheme;
var
	lini: TIniFile;
  lsFile: string;
begin
  if FileExists(BD.AppdataBitfarmPd + 'colorscheme.ini') then
    lsFile := BD.AppdataBitfarmPd + 'colorscheme.ini'
  else if FileExists(BD.ExeDir + 'colorscheme.ini') then
    lsFile := BD.ExeDir + 'colorscheme.ini';

  if lsFile <> '' then
  begin
    lini := tinifile.Create(lsFile);

    gclLime := lini.ReadInteger('Status','Set', gclLime);
    gclRed :=  lini.ReadInteger('Status','notSet', gclRed);
    gclTeal := lini.ReadInteger('Status','unSet', gclTeal);

    gclFree := lini.ReadInteger('Resubmission','Free', clWhite);
    gclWork := lini.ReadInteger('Resubmission','Work', $0065ffff);
    gclDone := lini.ReadInteger('Resubmission','Done', $0005EF11);
    gclUrgent := lini.ReadInteger('Resubmission','Urgent', gclRed);

    gclSelected := lini.ReadInteger('Resubmission','Free_Selected', $00bdbdbd);
    gclWorkSelected := lini.ReadInteger('Resubmission','Work_Selected', $0000a3e1);
    gclDoneSelected := lini.ReadInteger('Resubmission','Done_Selected', $00009100);
    gclUrgentSelected := lini.ReadInteger('Resubmission','Urgent_Selected', $000000b7);

    gclRed := lini.ReadInteger('Checkout','Checkout', $002828FF);
    gclBrown := lini.ReadInteger('Checkout','unChecked', $003A3A70);
    gclYellow := lini.ReadInteger('Checkout','Checkin', $00FFFF);

    lini.Free;
  end;
end;

procedure TranslateToolbarItem(tvxItem: TTBCustomItem);
var
  i: integer;
  s: string;
begin
  try
    if (tvxItem.Count = 0) then
    begin
      s := tvxItem.Caption;
      TranslateComponent(tvxItem, sSysGnuViewerDomain);
      if Assigned(tvxItem.Action) then
        TranslateComponent(tvxItem.Action, sSysGnuViewerDomain);
    end
    else
    begin
      s := tvxItem.Caption;
      TranslateComponent(tvxItem, sSysGnuViewerDomain);
      if Assigned(tvxItem.Action) then
        TranslateComponent(tvxItem.Action, sSysGnuViewerDomain);

      for i := 0 to tvxItem.Count - 1 do
      begin
        TranslateToolbarItem(tvxItem.Items[i]);
      end;
    end;
  except
    //
  end;
end;

procedure TranslateToolbar(Toolbar: TSpTBXToolbar);
var
  i: integer;
  tbxItem: TTBCustomItem;
begin
  try
    TranslateComponent(Toolbar, sSysGnuViewerDomain);
    for i := 0 to Toolbar.Items.Count - 1 do
    begin
      if Toolbar.Items[i] is TSpTBXCustomItem then
      begin
        tbxItem := Toolbar.Items[i];
        TranslateToolbarItem(tbxItem);
      end;
    end;
  except
    //
  end;
end;

function FindToolbarSubmenuItemByName(SearchedItemName: string; Item: TTBCustomItem): TSpTBXItem;
var
  I: Integer;
begin
  try
    Result := nil;
    if Item.Count > 0 then
    begin
      for I := 0 to Item.Count - 1 do
      begin
        if Item.Items[I] is TSpTBXSubMenuItem then
          FindToolbarSubmenuItemByName(SearchedItemName, Item.Items[I])
        else if (Item.Items[I] is TSpTBXItem) and (Item.Items[I].Name = SearchedItemName) then
        begin
          Result := TSpTBXItem(Item.Items[I]);
          Break;
        end;
      end;
    end;
  except
    Result := nil;
  end;
end;

end.
