unit NewDocLink;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls,
   gnugettext, SpTBXItem, SpTBXControls, u_bfaAddfield;


function GetNewDocLinkName(Owner : TComponent; bDocLinkList : Boolean;
  out Name : WideString) : Boolean;

type
   Tfrm_NewDocLink = class (TForm)
    pnl1: TSpTBXPanel;
    lbl_Hinweis_1: TLabel;
    cbbName: TComboBox;
    btnOK: TSpTBXButton;
    btnCancel: TSpTBXButton;

     procedure FormCreate(Sender: TObject);
     procedure cbbNameChange(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure cbbNameKeyPress(Sender: TObject; var Key: Char);
//     procedure cbbNameSelect(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

implementation

uses
  //u_dm_DB,
  {u_ShBase,}
  MainForm, bfaCommonUtils, bfaCommonStyles;

{$R *.dfm}

//-----------------------------------------------------------------------------
function GetNewDocLinkName(Owner : TComponent; bDocLinkList : Boolean;
  out Name : WideString) : Boolean;
var
  frm_NewDocLink : Tfrm_NewDocLink;
  mr : integer;
begin
   frm_NewDocLink := Tfrm_NewDocLink.Create(Owner);
   try
//      if igLinkChars = 0 then
//         DbGetLinks(frm_NewDocLink.cbbName.Items,'')
//      else
         frm_NewDocLink.cbbName.Items.Clear;
      frm_NewDocLink.cbbName.AutoComplete := bDocLinkList;

      frm_NewDocLink.cbbName.OnChange := frmMainForm.cbxSearchLinksChange;

//      if frm_Mainform.lbl_choosenlink.Caption <> '' then
//         frm_NewDocLink.cbbName.Text := frm_Mainform.lbl_choosenlink.Caption;
      mr := frm_NewDocLink.ShowModal;
      Result := mr = mrOk;
      if Result then
         Name := frm_NewDocLink.cbbName.Text;
   finally
      frm_NewDocLink.Free;
   end;
end;

procedure Tfrm_NewDocLink.cbbNameKeyPress(Sender: TObject; var Key: Char);
var
  not_allowed: string;
  FBalloonHint: TBalloonHint;
begin
  not_allowed := ';' + sNotAllowedChar;
  if Pos(Key, not_allowed) <> 0 then
  begin
    try
      if FBalloonHint = nil then
        FBalloonHint := TBalloonHint.Create(Self);
      FBalloonHint.Delay := 0;
      FBalloonHint.HideAfter := 800;
      FBalloonHint.Description := _(sMsgNotAllowedCharachters) + not_allowed;
      FBalloonHint.ShowHint(TComboBox(Sender));
      Key := #0;
      Beep;
      Abort;
    except
    //
    end;
  end;
end;

procedure Tfrm_NewDocLink.FormCreate(Sender: TObject);
begin
   TranslateComponent(Self, 'ViewerV36');

   pnl1.Color := stlControl.Color;
   lbl_Hinweis_1.Font.Color := stlControl.Font.Color;

   btnOK.Font.Color := stlControl.Font.Color;
   btnOk.Color := stlControl.Color;
   btnCancel.Font.Color := stlControl.Font.Color;
   btnCancel.Color := stlControl.Color;
   cbbName.Font.Color := stlControl.Font.Color;
   cbbName.Color := stlControl.Color;
   (*
  cbb2 := TBfaAddfieldComp.Create(Self, zfld00_Universal, '');
  with cbb2 do
  begin
    Parent := Self;
    Left := 91;
    Top := 24;
    Width := 218;
    Label1.Visible := False;
    compEdit.Left := compEdit.Left - 10;
    compEdit.Top := compEdit.Top - 16;
    compEdit.Width := compEdit.Width - 63;
    tlbNeg.Top := 1;
    tlbNeg.Left := Width - 25;
    AddButton := True;    // ich vermute, der soll immer angezeigt werden
    btnAdd.Left := compEdit.Left + compEdit.Width + 2;
  end;   *)
end;

procedure Tfrm_NewDocLink.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    Close;

  if Key = VK_RETURN then
  begin
    btnOK.Click;
  end;
end;

procedure Tfrm_NewDocLink.cbbNameChange(Sender: TObject);
begin
//	if length(Trim(cbbName.Text)) < igLinkChars then
//      cbbName.Items.Clear
//   else
//   begin
//      //cbb_SearchDocLink.Items.Clear;
//      frm_Mainform.ReadCbxDocLinks(cbbName, Trim(cbbName.Text));
//   end;
//   cbbName.SelStart := Length(cbbName.Text);

end;

end.

