unit ResubDialogForm;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CreateResubFrame, SpTBXItem, SpTBXControls;

type
  TfrmResubDialog = class(TForm)
    SpTBXPanel1: TSpTBXPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    fraCreateResub: TfraCreateResub;
  end;

implementation

{$R *.dfm}

uses
  MainDataModule, cxCalendar;

procedure TfrmResubDialog.FormCreate(Sender: TObject);
begin
  fraCreateResub := TfraCreateResub.Create(Self);
  fraCreateResub.Parent := SpTBXPanel1;
  fraCreateResub.Align := alClient;
  fraCreateResub.dtDate1.Date := Date();
  fraCreateResub.dtDate1.Enabled := True;
  fraCreateResub.btnOk.Enabled := True;
  fraCreateResub.btnCancel.Enabled := True;
  fraCreateResub.btnOk.Visible := True;
  fraCreateResub.btnCancel.Visible := True;
end;

procedure TfrmResubDialog.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Msg: TMsg;
begin
  if (Key = VK_ESCAPE) and fraCreateResub.btnCancel.Visible and (not fraCreateResub.OpenPopup) then
  begin
    fraCreateResub.btnCancel.Click;
    PeekMessage(Msg, 0, WM_CHAR, WM_CHAR, PM_REMOVE); // gegen PLING-Ton
  end;
end;

procedure TfrmResubDialog.FormShow(Sender: TObject);
begin
  bitfarmApp.FillResubFavCombo(fraCreateResub.cbbFavorites);
  fraCreateResub.edtInfoCreate.SetFocus;
  fraCreateResub.SetSaveView(True);
end;

end.
