program ViewerV362;

uses
  {$IFDEF EurekaLog}
  EMemLeaks,
  EResLeaks,
  EDebugExports,
  EDebugMS,
  EDebugTD32,
  EDebugMap,
  EDebugME,
  EDebugJCL,
  EFixSafeCallException,
  EMapWin32,
  EAppVCL,
  EDialogWinAPIMSClassic,
  EDialogWinAPIEurekaLogDetailed,
  EDialogWinAPIStepsToReproduce,
  ESendMailSMAPI,
  ExceptionLog7,
  {$ENDIF EurekaLog}
  MidasLib,
  Forms,
  Windows,
  SysUtils,
  Dialogs,
  ShlObj,
  bfaApplication in 'bfaApplication.pas',
  MainForm in 'MainForm.pas' {frmGPL},
  AdminFrame in 'AdminFrame.pas' {fraAdmin: TFrame},
  {$IFDEF ENTERPRISE}
  bfaApplicationEnterpreise in 'bfaApplicationEnterprise.pas',
  MainFormEnterprise in 'MainFormEnterprise.pas' {frmEnterprise},
  AdminFrameEnterprise in 'AdminFrameEnterprise.pas' {fraAdminEnterprise: TFrame},
  {$ENDIF}
  ImporterFrameGPL in 'ImporterFrameGPL.pas' {fraImporter: TFrame},
  WorkplaceFrameGPL in 'WorkplaceFrameGPL.pas' {fraWorkplace: TFrame},
  ResubFrameGPL in 'ResubFrameGPL.pas' {fraResub: TFrame},
  CommonGUIUtils in 'CommonGUIUtils.pas',
  MainDataModule in 'MainDataModule.pas' {dmMain: TDataModule},
  LoginGPL in 'LoginGPL.pas' {frmLoginGPL},
  OptionsForm in 'OptionsForm.pas' {frmOptions},
  bfaPreview36 in 'bfaPreview36.pas' {bfaPreview: TFrame},
  bfaThreadedThumbnail in 'bfaThreadedThumbnail.pas',
  PreviewDlg in 'PreviewDlg.pas' {frmPreviewDlg},
  DocLinksFrame in 'DocLinksFrame.pas' {fraDocLinksList: TFrame},
  NewDocLink in 'NewDocLink.pas' {frm_NewDocLink},
  FloatingForm in 'FloatingForm.pas' {bfaFloatingForm},
  PrivateLayer in 'PrivateLayer.pas' {frmPrivateLayer},
  AddGlobalBookmarkFolder in 'AddGlobalBookmarkFolder.pas' {frmAddGlobalBookmarkFolder},
  HistoryFrame in 'HistoryFrame.pas' {fraHistory: TFrame},
  FulltextFrame in 'FulltextFrame.pas' {frmFulltext: TFrame},
  CommentaryFrame in 'CommentaryFrame.pas' {fraCommentary: TFrame},
  SVNInfoForm in 'SVNInfoForm.pas' {frmSVNInfo},
  TagsForm in 'TagsForm.pas' {frmTags},
  CreateResubFrame in 'CreateResubFrame.pas' {fraCreateResub: TFrame},
  ResubDialogForm in 'ResubDialogForm.pas' {frmResubDialog},
  MoveDocForm in 'MoveDocForm.pas' {frmMoveDoc},
  ListItemsForm in 'ListItemsForm.pas' {frmListItems},
  USingleInst in 'USingleInst.pas' {/12.09.2016  ,HolidayForm in 'HolidayForm.pas' {frmHoliday},
  HolidayForm in 'HolidayForm.pas' {frmHoliday},
  LinkMailForm in 'LinkMailForm.pas' {frmLinkMails},
  ContractMgmt in 'ContractMgmt.pas' {frmContractMgmt},
  CreateImporterResubFrame in 'CreateImporterResubFrame.pas' {fraCreateImporterResub: TFrame},
  CreateGlobalBookmark in 'CreateGlobalBookmark.pas' {frmCreateGlobalBookmark},
  PasswordForm in 'PasswordForm.pas' {frmPassword},
  bfaQuickPreview in 'bfaQuickPreview.pas' {frmQuickPreview},
  ExportForm in 'ExportForm.pas' {frmExport},
  DLMForm in 'DLMForm.pas' {frmDLM},
  ChoseReportForm in 'ChoseReportForm.pas' {frmChoseReport},
  bfaAnnoOptionsDialog in 'bfaAnnoOptionsDialog.pas' {frm_DocEditOpt},
  CryptoUtils in 'CryptoUtils.pas',
  bfaIconsDM in '..\bfaObjects\bfaIconsDM.pas' {bfaIcons: TDataModule},
  bfaBaseImageEN in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaBaseImageEN.pas',
  bfaBaseObjects in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaBaseObjects.pas',
  bfaBasePreview in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaBasePreview.pas' {frm_Voransicht: TFrame},
  bfaBaseSocketConnection in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaBaseSocketConnection.pas',
  bfaCommonDB in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaCommonDB.pas',
  bfaCommonDialogs in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaCommonDialogs.pas',
  bfaCommonFiles in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaCommonFiles.pas',
  bfaCommonImageEN in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaCommonImageEN.pas',
  bfaCommonMethods in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaCommonMethods.pas',
  bfaCommonUtils in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaCommonUtils.pas',
  bfaLog in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaLog.pas',
  bfaObjects36 in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaObjects36.pas',
  bfaOfflineDB in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaOfflineDB.pas',
  bfaParser in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaParser.pas',
  bfaProcessing in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaProcessing.pas',
  bfaStampsDialog in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaStampsDialog.pas' {frm_Stamps},
  bfaThreadUtils in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaThreadUtils.pas',
  ScanFunctions in 'ScanFunctions.pas' {fraScanFunctions: TFrame},
  {$IFNDEF ENTERPRISE}
  bitfarm_core in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bitfarm_core.pas',
  {$ELSE}
  bitfarm_enterprise in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bitfarm_enterprise.pas',
  {$ENDIF }
  Collision in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\Collision.pas',
  CRGrid in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\CRGrid.pas',
  u_bfaAddfield in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaAddfield.pas',
  u_bfaGrid in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaGrid.pas',
  u_bfaInputCombo in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaInputCombo.pas' {bfaInputCombo: TFrame},
  u_bfaInputEdit in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaInputEdit.pas' {bfaInputEdit: TFrame},
  u_bfaMainMenuGPL in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaMainMenuGPL.pas' {bfaMainMenu: TFrame},
  u_bfaScrollBox in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaScrollBox.pas',
  bfaTabSheet in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\bfaTabSheet.pas',
  u_bfaSelector in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaSelector.pas' {bfaSelector: TFrame},
  u_bfaSplitter in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaSplitter.pas',
  u_bfaStandardToolbar in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaStandardToolbar.pas' {bfaStandardToolbar: TFrame},
  u_bfaTlbImport in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaTlbImport.pas',
  u_bfaTlbPreview in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaTlbPreview.pas',
  u_bfaTlbStandard in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaTlbStandard.pas',
  bfaSocketConnection in '..\bfaObjects\bfaSocketConnection.pas',
  bfaGridDBTableView in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\bfaGridDBTableView.pas',
  FloatingResubFrame in 'FloatingResubFrame.pas' {fraFloatingResub},
  SynZip in '..\..\Delphi-Lib\SynPDF\SynZip.pas',
  u_bfaTreeView in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\u_bfaTreeView.pas',
  StrictItemsDialog in 'StrictItemsDialog.pas' {frmStrictItemsDialog},
  bfaCalloutPopup in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\bfaCalloutPopup.pas',
  CalloutFrame in '..\..\Delphi-Shared_362\bfaComponents36\SOURCE\CalloutFrame.pas' {fraCallOut: TFrame},
  bfaOptions in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\bfaOptions.pas',
  u_Info in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\u_Info.pas',
  u_Rights in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\u_Rights.pas',
  GridConfigForm in 'GridConfigForm.pas' {frmGridConfig},
  Win11Forms in '..\..\Delphi-Shared_362\bfaCommonUtils\SOURCE\Win11Forms.pas',
  SplashForm in 'SplashForm.pas' {frmSplash},
  ELManagerFrm in 'ELManagerFrm.pas' {frmElManager: TDataModule},
  bfaCommonStyles in '..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaCommonStyles.pas',
  bfaSearchThread in 'bfaSearchThread.pas';

{$R *.res}
{$R 'LizRecht.RES' 'LizRecht.rc'}
{$SETPEFLAGS IMAGE_FILE_NET_RUN_FROM_SWAP or IMAGE_FILE_LARGE_ADDRESS_AWARE or IMAGE_FILE_RELOCS_STRIPPED}
{$SetPEOptFlags IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER_AWARE}

var
  i : Integer;
begin
  try
    if SingleInst.CanStartApp then
    begin
      bitfarmLog.Init(BD.EnvTemp, '', 5, 'ViewerV36', False);
      bitfarmLog.Write(llDebug, ltInfo, 'START', 'ViewerV36');
      bitfarmLog.Write(llDebug, ltInfo, 'ParamCount = ' + IntToStr(ParamCount), 'ViewerV36');
      if ParamCount > 0 then
      begin
        for i := 1 to ParamCount do
          bitfarmLog.Write(llDebug, ltInfo, 'Parameter(' + IntToStr(i) + '): ' + ParamStr(i), 'ViewerV36');
      end;
      bitfarmLog.Write(llDebug, ltInfo, 'SingleInst.CanStartApp', 'ViewerV36');
      Application.Initialize;
      Application.MainFormOnTaskbar := True; //24.10.2019
      Application.ShowHint := True; //28.10.2019
      Application.ModalPopupMode := pmAuto; //29.03.2018 Ticket 14142
      Application.Title := 'bitfarm-Archiv - Enterprise';
      Application.CreateForm(TdmMain, dmMain);
      Application.CreateForm(TbfaIcons, bfaIcons);
      Application.CreateForm(TfrmElManager, frmElManager);
  // Achtung, wenn man etwas an der MainFormGPL ndert, dann erzetzt die XE IDE TfrmGPL durch TfrmMainForm
      {$IFNDEF ENTERPRISE}
        Application.CreateForm(TfrmGPL, frmMainForm);
        CurrentEurekaLogOptions.SendSMAPITarget := 'crashlog-gpl@bitfarm-archiv.de';  //14.10.2024
      {$ELSE}
        Application.CreateForm(TfrmEnterprise, frmMainForm);
      {$ENDIF}
      Application.Run;
    end;
  except
    bitfarmLog.Write(llDebug, ltException, 'ViewerV36', 'ViewerV36');
  end;

end.


















































