unit bfaIconsDM;

interface

uses
  SysUtils, Classes, ImgList, Controls, JvImageList,
  Windows, System.ImageList, cxImageList, cxGraphics, Vcl.VirtualImageList,
  Vcl.BaseImageCollection, Vcl.ImageCollection;

type
  TbfaIcons = class(TDataModule)
    ilAnnoTools: TImageList;
    ilScanIcons: TImageList;
    ilScanOptions: TImageList;
    ilSearch: TImageList;
    imcMain: TImageCollection;
    ilMainMenu: TVirtualImageList;
    ilMainMenu32: TVirtualImageList;
    imcPreview: TImageCollection;
    ilPreview: TVirtualImageList;
    ilPreview32: TVirtualImageList;
    ilMainMenu16: TVirtualImageList;
    ilPreview16: TVirtualImageList;
    imlLanguage: TcxImageList;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);

  private
    { Private-Deklarationen }

  public
    { Public-Deklarationen }
  end;

var
  bfaIcons: TbfaIcons;

implementation

{$R *.dfm}
{$R bfaCursors.RES}

uses
  Forms, bfaCommonUtils;

procedure TbfaIcons.DataModuleCreate(Sender: TObject);
begin
  Screen.Cursors[crDrag] := LoadCursor(hInstance, 'MOVE');
  Screen.Cursors[crMoveCursor] := LoadCursor(hInstance, 'MOVE');
  Screen.Cursors[crCopyCursor] := LoadCursor(hInstance, 'COPY');
  Screen.Cursors[crSymLinkCursor]  := LoadCursor(hInstance, 'SYMLNK');
end;

procedure TbfaIcons.DataModuleDestroy(Sender: TObject);
begin
  DestroyIcon(Screen.Cursors[crSymLinkCursor]);
  DestroyIcon(Screen.Cursors[crMoveCursor]);
  DestroyIcon(Screen.Cursors[crCopyCursor]);
end;

end.
