unit bfaMySQLDataAccessDM;

interface

uses
  SysUtils, Classes, bfaDataAccessDM, Uni, DB, MemDS, DBAccess;

type
  TbfaMySQLDataAccess = class(TDataModule)
    trnBfaServer: TUniTransaction;
    dscSelectApplicationRightsByUser: TUniDataSource;
    spSelectArchiveApplicationRightsByUser: TUniStoredProc;
    spSelectApplicationRightsByUser: TUniStoredProc;
    spSelectLayoutRoots: TUniStoredProc;
    dscSelectLayoutRoots: TUniDataSource;
    spSelectLayoutArchivesWithIdxParams: TUniStoredProc;
    dscSelectLayoutArchivesWithIdxParams: TUniDataSource;
    dscSelectArchivesByUserID: TUniDataSource;
    spSelectArchivesByUserID: TUniStoredProc;
    spSelectArchiveByArcID: TUniStoredProc;
    dscSelectArchiveApplicationRightsByUser: TUniDataSource;
    dscSelectLayoutUsersAndGroups: TUniDataSource;
    spSelectLayoutUsersAndGroups: TUniStoredProc;
    dscSelectUsers: TUniDataSource;
    spSelectUsers: TUniStoredProc;
    dscSelectGroups: TUniDataSource;
    spSelectGroups: TUniStoredProc;
    spInsertUser: TUniStoredProc;
    spInsertGroup: TUniStoredProc;
    spInsertNewGroupToSysGrpUsr: TUniStoredProc;
    spInsertObjectToGrpUsr: TUniStoredProc;
    spCreateArchive: TUniStoredProc;
    spSelectGroupMembers: TUniStoredProc;
    dscSelectGroupMembers: TUniDataSource;
    spSelectAddUsers: TUniStoredProc;
    spSelectAddGroups: TUniStoredProc;
    dscSelectAddGroups: TUniDataSource;
    dscSelectAddUsers: TUniDataSource;
    spSelectGroupSysGrpUsrID: TUniStoredProc;
    spSelectObjectRights: TUniStoredProc;
    spUpdateRightsToObject: TUniStoredProc;
    sp__spSelectArchiveNamesByIDs: TUniStoredProc;
    sp_spSelectObjectsWithMemberIDs: TUniStoredProc;
    dsc_dscSelectObjectsWithMemberIDs: TUniDataSource;
    spUpdateUser: TUniStoredProc;
    spSelectWhereObjMember: TUniStoredProc;
    dscSelectWhereObjMember: TUniDataSource;
    spDeleteArchive: TUniStoredProc;
    spUpdateArchive: TUniStoredProc;
    sp_spDeleteUserOrGroupFromSysLayout: TUniStoredProc;
    sp_spDeleteUserOrGroup: TUniStoredProc;
    spInsertObjectToLayout: TUniStoredProc;
    spSelectLayoutWhereObjMember: TUniStoredProc;
    dscSelectLayoutWhereObjMember: TUniDataSource;
    spSelectGroupByID: TUniStoredProc;
    spInsertField: TUniStoredProc;
    spCheckIfDisplaynameExists: TUniStoredProc;
    spSelectSysDocIdxTableCounter: TUniStoredProc;
    spCheckIfColumnExists: TUniStoredProc;
    spSelectTableColumns: TUniStoredProc;
    dscSelectTableColumns: TUniDataSource;
    spCreateSysDocIdxTable: TUniStoredProc;
    spAlterSysDocIdxTable: TUniStoredProc;
    spUpdateFieldIndexTableID: TUniStoredProc;
    spSelectFieldByID: TUniStoredProc;
    spUpdateField: TUniStoredProc;
    spUpdateGroup: TUniStoredProc;
    spDeleteUserGroupFromGroup: TUniStoredProc;
    spSelectSysGrpUsrParentID: TUniStoredProc;
    spAddObjectToFieldMapping: TUniStoredProc;
    spSelectFields: TUniStoredProc;
    dscSelectFields: TUniDataSource;
    spDeleteObjectFromFieldMapping: TUniStoredProc;
    qryGetFieldValues: TUniQuery;
    spUpdateArchiveLayout: TUniStoredProc;
    spSelectFieldByArchiveID: TUniStoredProc;
    spUpdateFieldInMapping: TUniStoredProc;
    spSelectDocumentByGDocID: TUniStoredProc;
    spLayoutRights: TUniStoredProc;
    spSelectContainerObjects: TUniStoredProc;
    dscSelectContainerOjects: TUniDataSource;
    spAddObjectToUserMapping: TUniStoredProc;
    spSelectAvailableUsers: TUniStoredProc;
    dscSelectAvailableUsers: TUniDataSource;
    dscSelectAvailableGroups: TUniDataSource;
    spSelectAvailableGroups: TUniStoredProc;
    spSelectLayoutIDbyObjectIDs: TUniStoredProc;
    spSelectArchiveAncestorObjects: TUniStoredProc;
    dscSelectArchiveAncestorObjects: TUniDataSource;
    spSelectObjectsMandant: TUniStoredProc;
    spDeleteObjectFromUserMapping: TUniStoredProc;
    spCheckIfGrpUsrObjectExistsOnLevel: TUniStoredProc;
    spUpdateObjectInUserMapping: TUniStoredProc;
    spDeleteObject: TUniStoredProc;
    spDeleteContainer: TUniStoredProc;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

end.

