program ExportErp;

{$APPTYPE CONSOLE}


uses
  u_Functions in 'u_Functions.pas',
  SysUtils,
  IniFiles,
  Classes,
  Windows,
  strUtils,
  DateUtils,
  DB,
  bitfarm_enterprise,
  bfaCommonMethods,
  ievect,
  imageen,
  imageenio,
  hyieutils,
  u_dm_sep in 'u_dm_sep.pas' {dm_sep: TDataModule};

{$R *.res}


Var
 con: TIniFile;
 sProfil, sUser, sPass, tblname, strFilename, arcid, docidx: String;
 strparam,queue, strVon, strBis, strStatus: string;
 strSuchfeld,strSuchfeldname, strPfad, strDateiname,
 strDocid, strDoc_Loc, strExt_Loc, strMaske, strTitle:string;
 i, iCount, iCountFiles, iPages: Integer;
 lsFeld_Name, lsDisp_Name, lsDocidx: Tstringlist;
 bshowsql, bFound, bannos: Boolean;
 DocView      : TImageEnVect;
 lttags: TIETIFFHandler;
 tmp, tmp2, annostream: TMemoryStream;

//Function  AnsiToConCP(Const AString: String): String;
//Var
//  lResult: String;
//Begin
//  SetLength(lResult, Length(AString));
//  {$IFDEF WIN32}
//  CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
//  {$ELSE}
//  AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
//  {$ENDIF}
//  Result := lResult;
//End;
//
//Function WriteCmd(strtext: String):STring ;
//  begin
//    strtext:= AnsiToConCP(strtext);
//    WriteLN(strtext);
//  End;

Function makemysqldate(datum:String):String;
  begin
      makemysqldate:= RightStr(datum,4) + '-' + MidStr(datum,4,2) +'-' + LeftStr(datum,2);

  end;

function CleanFileName(InputStr: string): string;
var
   lsnamfile: string;
begin
   lsNamFile := stringreplace(InputStr, '*', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '?', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '[', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, ']', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '<', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '>', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '|', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '+', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '=', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, ':', '-', [rfReplaceAll]);
   //lsNamFile := stringreplace(lsNamFile, ',', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '\', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '/', '-', [rfReplaceAll]);
   lsNamFile := stringreplace(lsNamFile, '"', '-', [rfReplaceAll]);
  
   Result := lsNamFile;
end;

 function ExpandEnvStr(const szInput: string): string;
  const
    MAXSIZE = 32768;
  begin
    SetLength(Result,MAXSIZE);
    SetLength(Result,ExpandEnvironmentStrings(pchar(szInput),
      @Result[1],length(Result)) - 1);
  end;


function ConnectDB: boolean;
  begin
    // Auslesen der Connection
    con    := TIniFile.Create(sProfil);
    Result := True;
    try
      try
        with con do
        begin
          sUser := ReadString('Connection', 'User', '');
          sPass := ReadString('Connection', 'Pass', '');
          with dm_sep.my_Con do
          begin
            Username := Decrypt(sUser, GlobalKey);
            Password := Decrypt(sPass, GlobalKey);
            Server   := ReadString('Connection', 'Server', '');
            Port     := ReadInteger('Connection', 'Port', 3306);
            Database := ReadString('Connection', 'DB', '');
            WriteCMD('Connection to Server ' + Server + ' with DB ' + Database);
            Connect; // Anmelden an der Datenbank
            if not Connected then // Wenn keine Verbindung dann Tool verlassen
            begin
              ExitCode := 2;
              WriteCMD('Fehler: Keine Verbindung zur Datenbank!');
              Result := False;
              exit;
            end;
          end;
        end;
      except
        on e: Exception do
        begin
          ExitCode := 4;
          WriteCMD('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
          Result := False;
          exit;
        end;
      end;
    finally
      if Assigned(con) then
        FreeAndNil(con);
    end;
  end;



begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }

  WriteCMD('bitfarm Archiv V3  -  Datenbank ExportERP Tool');
  WriteCMD('(c) 2004-2018 bitfarm Informationssysteme GmbH');

  for I := 1 to paramcount do
     strparam:= strparam + Paramstr(i) + ' ';

  WriteCmd('bergebene Parameter:'+strparam);

  if (ParamCount < 7) OR (paramstr(1)='-h') then
  begin
    ExitCode := 1;
    if paramstr(1)<>'-h' then
    begin
      WriteCMD('Fehler: Nicht genuegend Parameter angegeben! Aufrufen mit:');
      WriteCMD('ExportERP <Profil><Arc_ID><-s:Zusatzfeld><-v:Von><-b:Bis><-d:Maske aus Feldnamen><-p:Pfad>{-m:BitMaske}');
      WriteLN('');
    end;

    WriteCMD('ExportERP Tool zum Export von Dokumenten bei denen ein bestimmtes');
    WriteCmd('Zusatzfeld einen Wertebereich erhlt enthlt');
    WriteCMD('Parameter:');
    WriteCMD('ExportERP <Profil><Arc_ID><-s:Zusatzfeld><-v:Von><-b:Bis><-d:Maske aus Feldnamen><-p:Pfad>{-m:BitMaske}');


    WriteCMD('Profil:      Name des Profils');
    WriteCMD('Arc_ID:      Eindeutige ArchivID');
    WriteCMD('-s:Zusatzfeld:  Suchfeldname  ');
    WriteCMD('-v:Wert:     Wertebereich (einschliesslich)');
    WriteCMD('-b:Wert:     Wertebereich (ausschliesslich)');
    WriteCmd('   Der Wertebereich wird als Zahlenwert interpretiert');
    WriteCmd('   Sollen Zeichenfolgen gesucht werden mssen die Werte in Hochkommas');
    WriteCmd('   eingefasst werden, zB: -v:' + #39+ 'abc'+ #39);
    WriteCMD('-d:Maske aus Feldnamen');
    WriteCmd('   Es werden die Feldnamen angegeben, deren Inhalt den Namen bilden sollen');
    WriteCmd('   Es knnen Platzhalter angegeben werden ');
    WriteCmd('   dokid  aktuelle Dokumenten-ID');
    WriteCmd('   title  Dokumentenname');
    WriteCMD('-p:Pfad      Exportpfad mit abschlieenden Backslash');
    WriteCmd('-m:BitMaske  {optional} Bitmaske der Statusbutton (integer) =');
    WriteCMD('             in Bearbeitung=1 + Button1=2 + Button2=4 + Button3=8 etc.');
    WriteCmd('-showsql     optional, zeigt die Such-Query an');
    WriteCmd('-annos       optional, exportiert mit vorhandenen Annotations');

    exit;
  end;

  bshowsql :=false;
  bFound   :=False;
  bannos   := False;

  try
    for i:= 0 to ParamCount  do
    begin
      if LeftStr(ParamStr(i),3)= '-s:' then
      begin
        strSuchfeld:=Copy(ParamStr(i),4,Length(paramstr(i))-3);
        strSuchfeld:=Trim(strSuchfeld);
        WriteCmd('-s:'+strSuchfeld);
      end;
      if LeftStr(ParamStr(i),3)= '-v:' then
      begin
        strVon:=Copy(ParamStr(i),4,Length(paramstr(i))-3);
        strVon:=Trim(strVon);
        WriteCmd('-v:'+strVon);

      end;
      if LeftStr(ParamStr(i),3)= '-b:' then
      begin
        strBis:=Copy(ParamStr(i),4,Length(paramstr(i))-3);
        strBis:=Trim(strBis);
        WriteCmd('-b:'+strBis);

      end;
      if LeftStr(ParamStr(i),3)= '-d:' then
      begin
        strDateiname:=Copy(ParamStr(i),4,Length(paramstr(i))-3);
        strDateiname:=Trim(strDateiname);
        WriteCmd('-d:'+strDateiname);

      end;
      if LeftStr(ParamStr(i),3)= '-p:' then
      begin
        strPfad:=Copy(ParamStr(i),4,Length(paramstr(i))-3);
        strPfad:=Trim(strPfad);
        WriteCmd('-p:'+strPfad);
      end;
      if LeftStr(ParamStr(i),3)= '-m:' then
      begin
        strMaske:=Copy(ParamStr(i),4,Length(paramstr(i))-3);
        strMaske:=Trim(strMaske);
        WriteCmd('-m:'+strMaske);
      end;
      if LeftStr(ParamStr(i),8)= '-showsql' then
      begin
        bshowsql:=True;
      end;
      if LeftStr(ParamStr(i),8)= '-annos' then
      begin
        bannos:=True;
      end;
    end;

    arcid := ParamStr(2);

  except
    on e: Exception do
    begin
        WriteLn('Fehler: Beim Parameter parsen ! ' + e.Message);
        ExitCode := 1;
        exit;
    end;
  end;
  // Initalisieren der Objekte

  sProfil:=ExtractFilePath(Paramstr(0))+Paramstr(1)+'.con';
  queue:=  ExtractFilePath(Paramstr(0))+'queue\';
  if not FileExists(sProfil) then
  begin
    ExitCode := 5;
    WriteCmd('Fehler: Kann condatei <' + ParamStr(1) + '> nicht finden.');
    exit;
  end;
  try
    dm_sep:=tdm_sep.Create(nil);
    connectDB;
  except
    on e: Exception do
    begin
        writecmd('Fehler: Konnte nicht zur Datenbank verbinden');
        ExitCode := 1;
        exit;
    end;
  end;

  try
    dm_sep.my_q.SQL.text:='select * from sys_arc where arcid =' + arcid;
    dm_sep.my_q.Execute;
    while not dm_sep.my_q.Eof do
    begin
       tblname:= dm_sep.my_q.fieldbyname('tblname').asstring;
       writeCmd(' tbl :'+dm_sep.my_q.fieldbyname('tblname').asstring);
       dm_sep.my_q.Next;
    end;
  except
    on e: Exception do
    begin
      WriteLn('Fehler: Beim Auslesen der Sys_Arc Tabelle ! ' + e.Message);
      ExitCode := 1;
      exit;
    end;
  end;

  try
    lsFeld_Name := TStringList.Create;
    lsDisp_Name := TStringList.Create;
    lsDocidx := TStringList.Create;
    dm_sep.my_q.SQL.text:='select * from sys_addfields as a left join sys_addfieldxs as x on a.addfieldid = x.fieldid where x.arcid = ' + arcid;
    dm_sep.my_q.Execute;

    while not dm_sep.my_q.Eof do
    begin
       lsFeld_Name.Add(dm_sep.my_q.fieldbyname('fieldname').asstring);
       lsDisp_Name.Add (dm_sep.my_q.fieldbyname('displayname').asstring);
       lsDocidx.Add(dm_sep.my_q.fieldbyname('indextableid').asstring);
       writeCmd(' Feld_Name :'+dm_sep.my_q.fieldbyname('fieldname').asstring);
       writeCmd(' Feld_Name :'+dm_sep.my_q.fieldbyname('displayname').asstring);
       dm_sep.my_q.Next;
    end;
  except
    on e: Exception do
    begin
      WriteLn('Fehler: Beim Auslesen der sys_addfields Tabelle ! ' + e.Message);
      ExitCode := 1;
      exit;
    end;
  end;

  //feldname fr Suchabfrage ermitteln
  for i:= 0 to lsDisp_Name.Count -1 do
  begin
    if Trim(lsDisp_Name.Strings[i]) = strSuchfeld then
    begin
      strSuchfeldname:= Trim(lsFeld_Name.Strings[i]);
      docidx := 'sys_docidx_' + lsDocidx.Strings[i];
    end;
  end;

  if strSuchfeldname = '' then
  begin
    Writeln('Fehler: Das Suchfeld ' +  strSuchfeld + ' konnte nicht gefunden werden');
    ExitCode:=1;
    Exit;
  end;

  if strMaske <> '' then
  begin
    strStatus:= ' and (docstate_0 & ' + strMaske + ') > 0'
  end;

  if bannos then
  begin
    DocView := TImageEnVect.Create(nil);
    DocView.IO.AutoAdjustDPI := True;
    lttags := TIETIFFHandler.Create;
  end;

  // Suchabfrage
  try
    dm_sep.my_q.SQL.text:='select * from sys_doc as d left join ' + docidx + ' as idx on d.gdocid = idx.gdocid where arcid = ' + arcid + ' and ' + strSuchfeldname+' >= ' + strVon + ' And ' + strSuchfeldname +' <= '+ strBis + strStatus;
    if bshowsql then
      WriteCmd(dm_sep.my_q.SQL.text);
    Writeln('');
    dm_sep.my_q.Execute;
    iCount:= dm_sep.my_q.RecordCount;
  except
    on e: Exception do
    begin
      WriteCmd('Fehler: Beim Auslesen der sys_doc Tabelle ! ' + e.Message);
      ExitCode := 1;
      exit;
    end;
  end;

  try
    while not dm_sep.my_q.Eof do
    begin
      try
        strDocid:= dm_sep.my_q.fieldbyname('gdocid').asstring;
        strTitle:= dm_sep.my_q.fieldbyname('docname').asstring;
        writeCmd('docid:'+strDocid);
        writeCmd('title:'+strTitle);
        strDoc_Loc:= dm_sep.my_q.fieldbyname('docloc').asstring;
        strExt_Loc:= dm_sep.my_q.fieldbyname('extloc').asstring;
        writeCmd('doc_loc:'+dm_sep.my_q.fieldbyname('docloc').asstring);

        strFilename:= strDateiname;
        //Feldnamen parsen fr Dateinamen
        for i:= 0 to lsFeld_name.Count -1 do
        begin
           if (Pos(lsDisp_Name.Strings[i],strDateiname)>0) and (dm_sep.my_q.fieldbyname(lsFeld_Name.Strings[i]).asstring <> '') then
             strFilename:=StringReplace(strFilename,lsDisp_Name.Strings[i],dm_sep.my_q.fieldbyname(lsFeld_Name.Strings[i]).asstring,[rfReplaceAll]);
        end;

        if Pos('dokid',strFilename)> 0 then
            strFilename:=StringReplace(strFilename,'dokid',strDocid,[rfReplaceAll]);
        if Pos('title',strFilename)> 0 then
            strFilename:=StringReplace(strFilename,'title',strTitle,[rfReplaceAll]);

        strFilename:=CleanFileName(strFilename);
        strDoc_Loc := ExpandEnvStr(strDoc_Loc);
      except
          on e: Exception do
          begin
            WriteCmd('Fehler beim Erstellen des Pfades: ' + strPfad + strFilename + '.tif: '+ e.Message);
            ExitCode := 1;
            exit;
          end;
      end;
      // Datei kopieren
      if FileExists(strDoc_Loc) And (strPfad <> '')then
      begin
        try
          Inc(iCountFiles);
          CopyFile(PChar(strDoc_Loc),PChar(strPfad + strFilename + '.tif'),True);
          WriteCmd('Datei kopiert:' + strPfad + strFilename);
          Writeln('');
        except
          on e: Exception do
          begin
            WriteCmd('Fehler: Beim Kopieren der Datei ' + strPfad + strFilename + '.tif: '+ e.Message);
            ExitCode := 1;
            exit;
          end;
        end;
      end
      else
      begin
         WriteCmd('Fehler: Die Datei ' + strPfad + strFilename + '.tif konnte nicht gefunden werden');
         ExitCode := 3;
      end;

      try
        if bannos then
        begin
          DocView.Clear;
          //annostream := TMemoryStream.Create;
          tmp2 := TMemoryStream.Create;
          tmp2.LoadFromFile(strPfad + strFilename + '.tif');
          DeleteFile(PChar(strPfad + strFilename + '.tif'));
          tmp2.Seek(0, 0);
          DocView.IO.LoadFromStream(tmp2);
          for iPages := 0 to DocView.IO.Params.ImageCount -1 do
          begin
            DocView.Clear;
            DocView.IO.Params.ImageIndex := iPages;
            tmp2.Seek(0, 0);
            DocView.IO.LoadFromStreamTIFF(tmp2);

            dm_sep.my_q2.SQL.Text := 'select * from sys_annotations where layer = 0 and gdocid = ' + strDocid + ' and page = ' + IntToStr(iPages);
            dm_sep.my_q2.Execute;
            if dm_sep.my_q2.RecordCount > 0 then
            begin
              if (DocView.io.Params.BitsPerSample <> 8) and
                (DocView.io.Params.SamplesPerPixel <> 3) then
              begin
                DocView.io.Params.BitsPerSample   := 8;
                DocView.io.Params.SamplesPerPixel := 3;
                DocView.Proc.ConvertTo24Bit;
                DocView.IO.Params.TIFF_Compression := ioTIFF_JPEG;
              end;

              //annostream.Position := 0;
              //annostream.Clear;
              annostream := TMemoryStream.Create;
              annostream :=  TMemoryStream(dm_sep.my_q2.CreateBlobStream(dm_sep.my_q2.FieldByName('iev'), bmRead));
              WriteCmd('annostream.size: ' + IntToStr(annostream.Size));
              DocView.LoadFromStreamIEV(annostream);
              //                   DocView.LoadFromFileIEV(StringReplace(strExt_Loc,ExtractFileExt(strExt_Loc),'',[])+ IntToStr(iPages) + '.iev');
              DocView.CopyObjectsToBack(False);
              annostream.Free;
            end;

            tmp := TMemoryStream.Create;
            DocView.IO.SaveToStreamTIFF(tmp);
            tmp.Seek(0, 0);
            lttags.ReadFile(strPfad + strFilename + '.tif');
            lttags.InsertTIFFStream(tmp, lttags.GetPagesCount);
            lttags.WriteFile(strPfad + strFilename + '.tif');
            lttags.FreeData;
            tmp.Free;

            DocView.RemoveAllObjects;

          end;

          tmp2.Free;
          //annostream.Free;
        end;
      except
        on e: Exception do
        begin
          WriteCmd('Fehler: Beim Verarbeiten der Annotation! ' + e.Message);
          ExitCode := 1;
          exit;
        end;
      end;
      dm_sep.my_q.Next;
    end;
  except
    on e: Exception do
    begin
      WriteCmd('Fehler: Beim Verarbeiten der Dokumente! ' + e.Message);
      ExitCode := 1;
      exit;
    end;
  end;

  if iCount = 0 then
  begin
    WriteCmd('Es wurden keine Dokumente gefunden');
    ExitCode:= 2;
  end else begin
    WriteCmd('Es wurden ' + IntToStr(iCount)+' Dokumente gefunden');
  end;

  if iCount <> iCountFiles then
  begin
    WriteCmd('Einzelne Dokumente konnten nicht exportiert werden.');
    WriteCmd('Gefunden:'+ IntToStr(iCount)+' Exportiert:' + IntToStr(iCountFiles));
  end;

  if assigned(lttags) then
  FreeAndNil(lttags);

  WriteLN('Done...');

end.



