unit u_Functions;

interface

uses
   Windows, SysUtils;

function Ente(InputStr, HexKeyStr: String): String;
function Dente(HexInputStr, HexKeyStr: String): String;

implementation

function Ente(InputStr, HexKeyStr: String): String;
   //////////////////////////////////////////////////////////////////
   ///  10.04.2005 Erstellt EnCrypt by SV.                        ///
   ///                                                            ///
   ///  Diese Funktion erzeugt aus dem InputStr einen mit         ///
   ///  HexKeyStr verschlsselten HexString (einfaches XOR)       ///
   ///                                                            ///
   ///  Format: String aus Hexadezimalzahlen                      ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var iCntIStr, iCntKStr: integer;
begin
   iCntIStr := 1;
   iCntKStr := 1;
   result := '';
   while iCntIStr < (Length(InputStr) + 1) do
   begin
      result := result + IntToHex((ord(InputStr[iCntIStr]) xor StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1), 2))), 2);
      inc(iCntIStr, 1);
      inc(iCntKStr, 2);
   end;
end;

function Dente(HexInputStr, HexKeyStr: String): String;
   //////////////////////////////////////////////////////////////////
   ///  10.04.2005 Erstellt DeCrypt by SV.                        ///
   ///                                                            ///
   ///  Diese Funktion erzeugt aus dem HexInputStr einen mit      ///
   ///  HexKeyStr entschlsselten String (einfaches XOR)          ///
   ///                                                            ///
   ///  Format: Entschlsselter String                            ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var iCntIStr, iCntKStr: integer;
begin
   iCntIStr := 1;
   iCntKStr := 1;
   result := '';
   while iCntIStr < (Length(HexInputStr) + 1) do
   begin
      result := result + chr((StrToInt('$' + copy(HexInputStr, iCntIStr, 2)) xor StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1), 2))));
      inc(iCntIStr, 2);
      inc(iCntKStr, 2);
   end;
end;

end.
