program importxls_plugin;

{$APPTYPE CONSOLE}


uses
  SysUtils,
  IniFiles,
  Classes,
  Windows,
  ActiveX,
  Variants,
  Dialogs,
  u_dm_sep in 'u_dm_sep.pas' {dm_sep: TDataModule},
  u_Functions in 'u_Functions.pas',
  bfaCommonMethods in '..\..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaCommonMethods.pas',
  bfaCommonUtils in '..\..\..\Delphi-Shared_362\bfaCommonUtils\Source\bfaCommonUtils.pas';

{$R *.res}

type

   TAddfield = record
   	name : string;
      add : string;
      wert : string;
   end;


const
GlobalKey = '7F1E324C67945C0CF98DBE4EDD87C4DA17DB4A2163B33804950FA52FC8E66CA0' +
   '6B9D523178403F505E53222D7122760CE4D297889BB84CF4639E2A235E0BD940' +
   'AAB3468D929F402ED1B52C42BCAEB10F57AB98F69DE73C609C4A3DFC0FC36DEC' +
   'A5CD0AB22D68C60A326B48FDDB1BFCDC214383DF8C4808B029F6421260100761';

Var
   con, inifile, ini: TIniFile;

   sProfil, sUser, sPass: String;
   tblname, zusname, strlimit: String;
   modus, strparam, strWhere, strInhalt, search: string;
   i, j, k, l, zfound, izeile, ioffset, liFields, licount: Integer;
   tglistsec: Tstringlist;
   spaltenname, zusatzfeld, andsearchfor,
   andsearchforzusname, andsearchforadd, addtoselection: Tstringlist;
   recfound, vorhanden: Boolean;
   mylist, inifilename, sXLSfile, sXLSpath, sXLStabelle, sXLStab, strOutput,
   searchfortemp, stradd, query, sFormat, strtemp, sDNSName, sWert: String;
   found, bConvertCodepage, bReplaceApostroph: Boolean;
   job_list : TStringList;
   spaltenname_temp: TStringList;
   zusatzfeldadd_temp: TStringList;
   zusatzfeld_temp: TStringList;
   wstring: array of WideChar;
   Addfields : array of TAddfield;

Function AnsiToConCP(Const AString: String): String;
Var
   lResult: String;
Begin
   SetLength(lResult, Length(AString));
  {$IFDEF WIN32}
   CharToOEM(PWideChar(AString), PAnsiChar(lResult)); {32Bit}
  {$ELSE}
   AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
  {$ENDIF}
   Result := lResult;
End;

Function WriteCmd(strtext: String): STring;
begin
//   strtext := AnsiToConCP(strtext);
//   WriteLN(strtext);
   WriteLN(AnsiString(strtext));
End;

function StringToWideCharEx(const Source: string;SourceCP:integer; Dest: PWideChar;
  DestSize: Integer): PWideChar;
begin
  Dest[MultiByteToWideChar(SourceCP, 0, PAnsiChar(Source), Length(Source),
    Dest, DestSize - 1)] := #0;
  Result := Dest;
end;


//function ConnectDB: boolean;
//begin
//   // Auslesen der Connection
//   con := TIniFile.Create(sProfil);
//   Result := True;
//   try
//      try
//         with con do
//         begin
//            sUser := ReadString('Connection', 'User', '');
//            sPass := ReadString('Connection', 'Pass', '');
//            with dm_sep.my_Con do
//            begin
//               Username := Decrypt(sUser, GlobalKey);
//               Password := Decrypt(sPass, GlobalKey);
//               Server := ReadString('Connection', 'Server', '');
//               Port := ReadInteger('Connection', 'Port', 3306);
//               Database := ReadString('Connection', 'DB', '');
//               WriteLn('Connection to Server ' + Server + ' with DB ' + Database);
//               Connect; // Anmelden an der Datenbank
//               if not Connected then // Wenn keine Verbindung dann Tool verlassen
//               begin
//                  ExitCode := 2;
//                  WriteLn('Fehler: Keine Verbindung zur Datenbank!');
//                  Result := False;
//                  exit;
//               end;
//            end;
//         end;
//      except
//         on e: Exception do
//         begin
//            ExitCode := 4;
//            WriteLn('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
//            Result := False;
//            exit;
//         end;
//      end;
//   finally
//      if Assigned(con) then
//         FreeAndNil(con);
//   end;
//end;
//

begin
   { TODO -oUser -cConsole Main : Hier Code einfgen }

   WriteLn('bitfarm Archiv V3  -  Datenbank ImportXLS Tool');
   WriteLn('(c) 2004-2023 bitfarm Informationssysteme GmbH v3.6.2.1');

   for I := 1 to paramcount do
      strparam := strparam + Paramstr(i) + ' ';

   WriteCmd('bergebene Parameter:' + strparam);

   if (ParamCount < 1) OR (paramstr(1) = '-h') then
   begin
      ExitCode := 1;
      if paramstr(1) = '-h' then
      begin

         WriteLN('ImportXLS_plugin: Tool zum Import von Zusatzfelddaten aus einer Excel oder');
         WriteCmd('dbf-Datei in Abhngigkeit von Schlsseldaten als Viewerplugin');
         WriteCmd('Zur Konfiguration wird ber die importxls_plugin.ini verwendet.');
         WriteLN('Parameter: importxls_plugin <mylist-datei>');

         WriteLN('mylist-datei: die bergabedatei von der Pluginschnittstelle mit allen Jobdateien');

         WriteLN('ExitCodes:');
         WriteLN('0 = Ok ');
         WriteLN('1 = Zuwenig Parameter   ');
         WriteLN('2 = nicht belegt   ');
         WriteLN('3 = Kann Con-Datei nicht finden oder ffnen ');
         WriteLN('4 = Kann Datenblatt-Datei nicht finden');
         WriteLN('5 = Kann Ini-Datei nicht finden');
         WriteLN('6 = Zusatzfeld in der cfg_Tabelle nicht vorhanden');
         WriteLN('7 = Fehler: keine Zusatzfeld in der cfg_Tabelle vorhanden ');
         WriteLN('8 = Format nicht untersttzt. Mgliche Formate CSV,DBF,XLS,XLSX (bentigt speziellen Treiber');
         WriteLN('9 = Fehler: keine Suchespalte angegeben ');
         WriteLN('10= Fehler: keine Zusatzfelder angegeben ');
         WriteLN('11= Fehler: keine Spalten angegeben');
         WriteLN('12= Fehler: unterschiedliche Anzahl in der Zuordnung ');
         WriteLN('13= Fehler: Suchspalte nicht in Zuordnung enthalten');
         WriteLN('14= Fehler: allgemeiner Fehler beim Lesen der Ini-Datei');
         WriteLN('15= Fehler: allgemeiner Fehler beim Lesen der Archivtabellen');
         WriteLN('16= Fehler: allgemeiner Fehler beim ffnen der Datentabelle');
         WriteLN('17= allgemeiner Fehler beim Lesen der Zusatzfeldkonfiguration');
         WriteLN('18= Fehler: allgemeiner Fehler beim Update der Datenbank');
         WriteLN('19= Fehler: Fehler beim ffnen der Datentabelle');


         WriteLN('255= Unbekannter Fehler');

      end
      else
      begin
         WriteCMD('Fehler: Nicht gengend Parameter angegeben!');
         WriteLn('Aufrufen mit: importxls_plugin <mylist-datei>');
      end;
      exit;
   end;

   NullStrictConvert := false;
   // Initalisieren der Objekte

   mylist := Paramstr(1);

   if not FileExists(mylist) then
   begin
      ExitCode := 5;
      WriteCmd('Fehler: Kann mylist <' + mylist + '> nicht finden.');
      exit;
   end;

   //ini-datei lesen Parameter setzen, Zuordnungsliste erstellen

   job_list := tstringlist.Create;
   spaltenname := tstringlist.Create;
   zusatzfeld := tstringlist.Create;

   spaltenname_temp := tstringlist.Create;
   zusatzfeld_temp := tstringlist.Create;
   zusatzfeldadd_temp := tstringlist.Create;

   andsearchfor := tstringlist.Create;
   andsearchforzusname := tstringlist.Create;
   addtoselection := tstringlist.Create;

   inifile := TIniFile.Create(ExtractFilePath(ParamStr(0))+'importxls_plugin.ini');

   try
      try
         // Auslesen der  Ini Datei
         tglistsec := TStringList.Create;
         inifile.readsections(tglistsec);

         with inifile do
         begin
            i := 1;
            while ReadString('Zuordnung', 'spaltenname' + inttostr(i), '') <> '' do
            begin
               spaltenname.Add(ReadString('Zuordnung', 'spaltenname' + inttostr(i), ''));
               i := i + 1;
            end;

            i := 1;
            while ReadString('Zuordnung', 'zusatzfeld' + inttostr(i), '') <> '' do
            begin
               zusatzfeld.Add(ReadString('Zuordnung', 'zusatzfeld' + inttostr(i), ''));
               i := i + 1;
            end;

            i := 1;
            while ReadString('Query', 'andsearchfor' + inttostr(i), '') <> '' do
            begin
               andsearchfor.Add(ReadString('Query', 'andsearchfor' + inttostr(i), ''));
               i := i + 1;
            end;

            bConvertCodepage := False;
            if LowerCase(ReadString('Optionen', 'convertcodepage', '')) = 'true' then
               bConvertCodepage := True;
            ioffset := 0;
            ioffset := strtoint(ReadString('Optionen', 'offset', '0'));

            bReplaceApostroph := False;
            if LowerCase(ReadString('Optionen', 'replaceapostroph', '')) = 'true' then
            	bReplaceApostroph := True;
            if (LowerCase(ReadString('Tabellen', 'Datenblatt', '')) <> '') and (LowerCase(ReadString('Tabellen', 'Datenblatt', '')) <> 'filename') then
               sXLStabelle := ReadString('Tabellen', 'Datenblatt', '');
            sXLSfile := ReadString('Tabellen', 'Datei', '');
            sFormat := Uppercase(ReadString('Tabellen', 'Format', ''));

            sDNSName := ReadString('Tabellen', 'DNSName', '');

            if sDNSName = '' then
            begin
            	if sFormat = 'XLS' then
               	sDNSName := 'bitfarmXLS';
            	if sFormat = 'XLSX' then
               	sDNSName := 'Excel2007-Dateien';
            	if sFormat = 'CSV' then
               	sDNSName := 'CSV-Dateien';
               if sFormat = 'DBF' then
               	sDNSName := '';
            	if sFormat = 'CDX' then
               	sDNSName := '';
            end;

            if  sXLSfile = '' then
            begin
            	ExitCode := 4;
               WriteLn('Fehler: Kann Datenblatt-Datei nicht finden');
               exit;
            end;

            OleInitialize(nil);
   			    CoInitializeEx(nil, COINIT_MULTITHREADED);
            dm_sep := tdm_sep.Create(nil);

//            sUser := ReadString('Connection', 'User', '');
//            sPass := ReadString('Connection', 'Pass', '');
//            with dm_sep.my_Con do
//            begin
//               Username := Decrypt(sUser, GlobalKey);
//               Password := Decrypt(sPass, GlobalKey);
//               Server := ReadString('Connection', 'Server', '');
//               Port := ReadInteger('Connection', 'Port', 3306);
//               Database := ReadString('Connection', 'DB', '');
//               WriteLn('Connection to Server ' + Server + ' with DB ' + Database);
//               Connect; // Anmelden an der Datenbank
//               if not Connected then // Wenn keine Verbindung dann Tool verlassen
//               begin
//                  ExitCode := 2;
//                  WriteLn('Fehler: Keine Verbindung zur Datenbank!');
//                  exit;
//               end;
//            end;


            // berprfung auf logik und konsistenz


            if (sFormat <> 'XLS') And (sFormat <> 'XLSX') And (sFormat <> 'DBF') And (sFormat <> 'CSV') And (sFormat <> 'CDX') then
            begin
               WriteLN('Fehler: nicht untersttzes Format');
               Exitcode := 8;
               exit;
            end;

            if andsearchfor.Count = 0 then
            begin
               WriteLN('Fehler: keine Suchespalte angegeben');
               Exitcode := 9;
               exit;
            end;

            if zusatzfeld.Count = 0 then
            begin
               WriteLN('Fehler: keine Zusatzfelder angegeben');
               Exitcode := 10;
               exit;
            end;

            if spaltenname.Count = 0 then
            begin
               WriteLN('Fehler: keine Spalten angegeben');
               Exitcode := 11;
               exit;
            end;

            if zusatzfeld.Count <> spaltenname.Count then
            begin
               WriteLN('Fehler: unterschiedliche Anzahl in der Zuordnung');
               Exitcode := 12;
               exit;
            end;

            found := False;
            if andsearchforzusname.Count = 0 then
            begin
               for i := 0 to andsearchfor.Count - 1 do
               begin
                  for j := 0 to spaltenname.Count - 1 do
                  begin
                     if Lowercase(andsearchfor[i]) = LowerCase(spaltenname[j]) then
                     begin
                        andsearchforzusname.add(zusatzfeld[j]);
                        found := True
                     end;
                  end;

               end;
            end;
         end;

      except
         on e: Exception do
         begin
            ExitCode := 14;
            WriteLn('Fehler: allgemeiner Fehler beim Lesen der Ini-Datei: ' + e.Message);
            exit;
         end;
      end;
   finally

      if Assigned(inifile) then
         FreeAndNil(inifile);
   end;

   job_list.LoadFromFile(mylist);

   try
      //*******************************************************************************************************
      //dbase-datei einlesen

      //dm_sep.ADOConnection1.ConnectionString:='Provider=MSDASQL.1;Persist Security Info=False;Extended Properties=' + #34+ 'DSN=mextrakt;DBQ=c:\Programme\Borland\Delphi7\Projects\Archiv-svn\importxls\;DefaultDir=c:\Programme\Borland\Delphi7\Projects\Archiv-svn\importxls\;DriverId=533;FIL=dBase 5.0;MaxBufferSize=2048;PageTimeout=600;'+#34+';Initial Catalog=c:\Programme\Borland\Delphi7\Projects\Archiv-svn\importxls\';
      // dm_sep.ADOConnection1.ConnectionString:='Provider=MSDASQL.1;Persist Security Info=False;Extended Properties=' + #34+ 'DSN=dBASE-Dateien;DBQ='+sXLSpath+';DefaultDir='+sXLSpath+';DriverId=533;FIL=dBase 5.0;MaxBufferSize=2048;PageTimeout=600;'+#34+';Initial Catalog='+sXLSpath;

      try
         sXLStab := sXLStabelle;

         if sFormat = 'DBF' then
         begin
            //dm_sep.ADOConnection1.ConnectionString:='Provider=MSDASQL.1;Persist Security Info=False;Extended Properties='+#34+
            //'DSN=dBASE-Dateien;DBQ='+sXLSpath+';DefaultDir='+sXLSpath+';DriverId=533;FIL=dBase 5.0;MaxBufferSize=2048;PageTimeout=5;'+#34+';Initial Catalog='+sXLSpath;
            dm_sep.ADOConnection1.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=False;Data Source=' + sXLSpath + ';Extended Properties=dBASE 5.0';

            dm_sep.ADOConnection1.loginprompt := false;
         end;
         if sFormat = 'XLSX' then
         begin

            //DSN=Excel2007-Dateien;DBQ=c:\Programme\Borland\Delphi7\Projects\Archiv-svn\importxls\mextrakt.xlsx;DefaultDir=c:\Programme\Borland\Delphi7\Projects\Archiv-svn\importxls;DriverId=1046;FIL=excel 12.0;MaxBufferSize=2048;PageTimeout=5;

            dm_sep.ADOConnection1.ConnectionString := 'Provider=MSDASQL.1;Persist Security Info=False;Extended Properties=' + #34 +
               'DSN='+ sDNSName +';DBQ=' + sXLSfile + ';DefaultDir=' + sXLSpath + ';DriverId=1046;FIL=excel 12.0;MaxBufferSize=2048;PageTimeout=5;' + #34 + ';Initial Catalog=' + sXLSpath;
            sXLStabelle := '[' + sXLStabelle + '$]';
         end;

         if sFormat = 'XLS' then
         begin
            //DSN=Excel-Dateien;DBQ=c:\Programme\Borland\Delphi7\Projects\Archiv-svn\importxls\mextrakt2.xls;DefaultDir=c:\Programme\Borland\Delphi7\Projects\Archiv-svn\importxls;DriverId=790;FIL=excel 8.0;MaxBufferSize=2048;PageTimeout=5;
            //DSN=bitfarmXLS;DBQ=D:\Enterprise-3.5\Delphi-3.5\cmd_utils\importxls\MITGLIED.xls;DefaultDir=D:\Enterprise-3.5\Delphi-3.5\cmd_utils\importxls;DriverId=790;FIL=excel 8.0;MaxBufferSize=2048;PageTimeout=5;
            dm_sep.ADOConnection1.ConnectionString := 'Provider=MSDASQL.1;Persist Security Info=False;Extended Properties=' + #34 +
               'DSN='+ sDNSName +';DBQ=' + sXLSfile + ';DefaultDir=' + sXLSpath + ';DriverId=790;FIL=excel 8.0;MaxBufferSize=2048;PageTimeout=5;' + #34 + ';Initial Catalog=' + sXLSpath;
            sXLStabelle := '[' + sXLStabelle + '$]';
         end;

         if sFormat = 'CSV' then
         begin
            //DSN=CSV-Dateien;DBQ=C:\PROGRAMME\BORLAND\DELPHI7\PROJECTS\ARCHIV-SVN\CMD_UTILS\IMPORTXLS;DefaultDir=C:\PROGRAMME\BORLAND\DELPHI7\PROJECTS\ARCHIV-SVN\CMD_UTILS\IMPORTXLS;DriverId=27;FIL=text;MaxBufferSize=2048;PageTimeout=5;
            dm_sep.ADOConnection1.ConnectionString := 'Provider=MSDASQL.1;Persist Security Info=False;Extended Properties=' + #34 +
               'DSN='+ sDNSName +';DBQ=' + sXLSpath + ';DefaultDir=' + sXLSpath + ';DriverId=27;FIL=text;MaxBufferSize=2048;PageTimeout=5;' + #34 + ';Initial Catalog=' + sXLSpath;
            sXLStabelle := '[' + ExtractFileName(sXLSfile) + ']';

         end;
         if sFormat = 'CDX' then
         begin
            //DSN=CSV-Dateien;DBQ=C:\PROGRAMME\BORLAND\DELPHI7\PROJECTS\ARCHIV-SVN\CMD_UTILS\IMPORTXLS;DefaultDir=C:\PROGRAMME\BORLAND\DELPHI7\PROJECTS\ARCHIV-SVN\CMD_UTILS\IMPORTXLS;DriverId=27;FIL=text;MaxBufferSize=2048;PageTimeout=5;
            dm_sep.ADOConnection1.ConnectionString := 'Provider=VFPOLEDB.1;Data Source='+sXLSfile+';Password="";Collating Sequence=MACHINE';
            sXLStabelle := '[' + ExtractFileName(sXLSfile) + ']';

         end;

         try
            dm_sep.ADOConnection1.Open;
            dm_sep.ADOTable1.TableName := sXLStabelle;
         except on e: exception do
            begin
               writeln('Error ' + e.message);
               ExitCode := 19;
               Exit;
            end;
         end;
         try
            dm_sep.ADOTable1.Active := true;
         except on e: exception do
            begin
               writeln('Error ' + e.message);
               exitcode := 255;
               //exit;
            end;
         end;
         if not dm_sep.ADOTable1.Active then
         begin

            try
               dm_sep.ADOTable1.Active := true;
            except
            end;
         end;

      except
         on e: Exception do
         begin
            ExitCode := 16;
            WriteLn('Fehler: allgemeiner Fehler beim ffnen der Datentabelle: ' + e.Message);
            exit;
         end;
      end;

      for i := 0 to andsearchfor.Count - 1 do
         writeCMD('Suchstring:' + andsearchfor[i] + '  <=>  ' + andsearchforzusname[i]);
      writeCMD('Datenblatt:' + sXLStab);
      WriteCmd('DNSName:' + sDNSName);
      writeCMD('Ini-Datei:' + inifilename);
      WriteCmd('Convertcodepage:' + BoolToStr(bConvertCodepage));
      WriteCmd('Offset:' + IntToStr(ioffset));
      writeCMD('replaceapostroph:' + booltostr(bReplaceApostroph, True));

      // jobdatei(en) lesen

      for i := 0 to job_list.Count - 1 do
      begin

         WriteCMD('Jobdatei:' + job_list[i]);
         if not FileExists(job_list[i]) then
         	Continue;

         ini := TIniFile.Create(job_list[i]);

         with ini do
         begin
         	//WriteString('Version', 'Version', '3.0');
            (*lsProfil := ReadString('Archiv', 'Profil', '');
           	lsArcname := ParseSQLString(ReadString('Archiv', 'Name', ''));
           	lsTblname := ParseSQLString(ReadString('Archiv', 'Tabelle', ''));
            lsDocid := ReadString('Document', 'DOCID', '');
            if lsDocid <> '' then
            begin
            	liArcid := strtoint(Copy(lsDocid,1,Pos('.',lsDocid) -1));
               liDocid := strtoint(Copy(lsDocid,Pos('.',lsDocid) +1 ,Length(lsDocid)-Pos('.',lsDocid) +1));
            end;
            liGdocid :=ReadInteger('Document', 'gdoc_id', 0);
            lsTitel := ReadString('Document', 'Titel', '');
            lsDocloc := ReadString('Document', 'Orginal', '');
            lsExtloc := ReadString('Document', 'Kopie', '');
            lsOriLoc := ReadString('Document', 'Quelle', '');
            lsBenutzer := ReadString('Document', 'Benutzer', '');
            lsVolltext := ReadString('Document', 'Volltext', '');
            liStatus := ReadInteger('Document', 'Status', 0);
            lsSLW := ReadString('Document', 'Schlagworte', '');
            liRef := ReadInteger('Referenz','Anzahl',0);
            for licount := 1 to liRef  do
            begin
            	slRef.add(ParseSQLString(ReadString('Referenz','Referenz' + inttostr(licount),'')));
            end;  *)
            liFields := ReadInteger('Zusatzfelder','Felder',0);
            SetLength(Addfields,liFields);
            for licount := 0 to liFields -1 do
            begin
               Addfields[licount].name := ParseAddfields(ReadString('Zusatzfelder','ZusTitel' + IntToStr(licount +1),''));
               Addfields[licount].add := ParseAddfields(ReadString('Zusatzfelder','ZusFeld' + IntToStr(licount +1),''));
               Addfields[licount].wert := ParseAddfields(ReadString('Zusatzfelder','ZusWert' + IntToStr(licount +1),''));
            end;
         end;

         for  licount := 0 to Length(Addfields) -1 do
         begin
         	if Addfields[licount].name = andsearchforzusname[0] then
            begin
               search := Addfields[licount].wert;
               break;
            end;
         end;

         dm_sep.ADOTable1.First;
         izeile := 0;
         found := False;
         while not (dm_sep.ADOTable1.Eof) do
         begin
            if izeile < ioffset then
            begin
               dm_sep.ADOTable1.Next;
               inc(izeile);
               continue;
            end;

            sWert := dm_sep.ADOTable1.FieldValues[andsearchfor[0]];
            sWert := StringReplace(sWert, #160,' ',[rfReplaceAll]);
            sWert := StringReplace(sWert, #13,' ',[rfReplaceAll]);
            sWert := StringReplace(sWert, #10,'',[rfReplaceAll]);
            sWert := Trim(sWert);
            if bReplaceApostroph then
               sWert := StringReplace(sWert, #39, '',[rfReplaceAll]);

            if search = sWert then  // gefunden
            begin
               found := True;
					Break;
            end;

            dm_sep.ADOTable1.Next;
         end;


         if found then   //datensatz zurck in Addfields schreiben
         begin

         	for j := 0 to spaltenname.Count -1 do
            begin
               if spaltenname[j] = andsearchfor[0] then  // sich selbst berspringen
               	Continue;

            	sWert := dm_sep.ADOTable1.FieldValues[spaltenname[j]];
               sWert := StringReplace(sWert, #160,' ',[rfReplaceAll]);
               sWert := StringReplace(sWert, #13,' ',[rfReplaceAll]);
               sWert := StringReplace(sWert, #10,'',[rfReplaceAll]);
               sWert := Trim(sWert);
               if bReplaceApostroph then
                  sWert := StringReplace(sWert, #39, '',[rfReplaceAll]);

               for k := 0 to Length(Addfields) -1 do
               begin
               	if Addfields[k].name = zusatzfeld[j] then
                  begin
                     Addfields[k].wert := sWert;
                     Break;
                  end;
               end;
            end;

            ini := TIniFile.Create(job_list[i]);

            with ini do
            begin

               WriteInteger('Zusatzfelder','Felder', Length(Addfields));
               for licount := 0 to Length(Addfields) -1 do
               begin
               	WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(licount + 1), Addfields[licount].name);
                  WriteString('Zusatzfelder', 'ZusFeld' + IntToStr(licount + 1), Addfields[licount].add);
                  WriteString('Zusatzfelder', 'ZusWert' + IntToStr(licount + 1), ParseAddfields(Addfields[licount].wert));
               end;
            end;

         end;
      end;

      WriteCMD(DateTimeToStr(Now) + ' Datenbankabgleich mit Datei ' + mylist + ' erfolgreich durchgefhrt');

   finally
      dm_sep.ADOTable1.Close;
      CoUninitialize;
      OleUninitialize;
      if Assigned(job_list) then
         FreeAndNil(job_list);
   end;

end.

