'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  stopscan.vbs      GPL  ***************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0        ***************************************************
'*******************************************************************************************
'***************  stoppt einen scanprozess, z.B. bei papierstau.             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************




'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next
 
Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode



lngReturnCode = 0
 
Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
set oArgs    = Wscript.Arguments 
 


'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
err.clear
fullpath = WScript.ScriptFullName
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
scriptname = WScript.ScriptName
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
If Len(programm)=0 Then
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If





temppath = objWSHShell.ExpandEnvironmentStrings("%temp%")    
If err.number<>0 Then
    MsgBox("Fehler: Kann Tempverzeichnis nicht auswerten.")
    err.clear
    WScript.Quit
  End If 
  

  
systemroot = objWSHShell.ExpandEnvironmentStrings("%systemroot%")    
If err.number<>0 Then
    MsgBox("Fehler: Kann Systemrootverzeichnis nicht auswerten.")
    err.clear
    WScript.Quit
  End If 
systemtemp=systemroot&"\TEMP"
'testspace








'**************************************************************************************************
'******************************************   auf hngenen Job prfen und entfernen   ***************************
'**************************************************************************************************

lockdatei=temppath&"\scanlock"



If fs.fileexists(lockdatei) Then
	fs.deletefile lockdatei, true
End If





err.clear
Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
If err.number<>0 Then
	MsgBox("bitfarm-Archiv Scan: Fehler: kein WMI installiert. Bitte nachinstallieren.")
	WScript.quit
End If			
strQuery = "Select * from Win32_Process where Name='AutoScanV3.exe'"
Set colItems = objWMIService.ExecQuery(strQuery,,48)
z=0
For Each objItem in colItems
   	 objItem.Terminate()
   	 z=z+1	
Next
If z>1 Then
	hangjob=true
End If
Set colItems = NOTHING
Set objWMIService = NOTHING


err.clear
Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
If err.number<>0 Then
	MsgBox("bitfarm-Archiv Scan: Fehler: kein WMI installiert. Bitte nachinstallieren.")
	WScript.quit
End If			
strQuery = "Select * from Win32_Process where Name='ManuscanV3.exe'"
Set colItems = objWMIService.ExecQuery(strQuery,,48)
z=0
For Each objItem in colItems
   	 objItem.Terminate()
   	 z=z+1	
Next
If z>1 Then
	hangjob=true
End If
Set colItems = NOTHING
Set objWMIService = NOTHING


wscript.sleep 500
	
	Set folder = fs.GetFolder(temppath)
	For each file in folder.files

	If LCase(Right(file,3)) = "tmp" Then
		fs.deletefile file, true
		If err.number<>0 Then
			err.clear
			On Error Resume Next
		End If
	End If
	
	If LCase(Right(file,3)) = "job" Then
		fs.deletefile file, true
		If err.number<>0 Then
			err.clear
			On Error Resume Next
		End If
	End If
	
	If LCase(Right(file,3)) = "tif" Then
		fs.deletefile file, true
		If err.number<>0 Then
			err.clear
			On Error Resume Next
		End If
	End If
	
	Next


	Set folder = fs.GetFolder(temppath)
	For each ordner in folder.subfolders
	'msgbox ordner.name
	if left(ordner.name,8) = "bfa-scan" then
		delfolder(ordner)
	end if
	next
	





Msgbox "Stopscan wurde ausgefhrt"
	
wscript.quit



Function delfolder(folder)
On Error Resume Next
Set ordner=fs.getfolder(folder)
For each file in ordner.files
fs.deletefile(file)
err.clear

Next
For each unterordner in ordner.subfolders
delfolder(unterordner)

fs.deletefolder(unterordner)
Next
fs.deletefolder(folder)
Set ordner=nothing
End Function
