'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  changelogcontroler.vbs  GPL  *********************************************
'*******************************************************************************************
'***************  Version 3.6.2.0              *********************************************
'*******************************************************************************************
'***************  Programm zum Start und Kontrolle des changelog-Dienstes    ***************
'***************                                                             ***************
'***************  Syntax: changelogcontroler.bat                             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************


looptime = 500


'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
On Error Resume Next

Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
set oArgs    = Wscript.Arguments 


pid = ""
Profil=""
strname=""
strinput=""
pfadvbs=""


fullpath = WScript.ScriptFullName
scriptname = WScript.ScriptName
mypath = Left(fullpath,Len(fullpath)-Len(scriptname))

If mypath = "" Then
	objWshShell.LogEvent 1, "bitfarm-Archiv: ChangelogController: Kein Pfad aufgelst gefunden."
    	WScript.Quit
End If 


Profil=""

Profil = oArgs.item(0) 
  If err.number<>0 Then
    err.clear
    objWSHShell.LogEvent 1, "bitfarm-Archiv: ChangelogController: Fehlender Parameter: Profil."
    err.clear
    WScript.Quit
  End If 

If (Profil="") or (Profil=" ") or (Profil="	") Then
	objWSHShell.LogEvent 1, "bitfarm-Archiv: ChangelogController: Fehlender Parameter: Profil."
 	WScript.Quit
End If


If fs.FileExists(mypath&"getrunningvbs.exe") = False Then
	objWSHShell.LogEvent 1, "bitfarm-Archiv: ChangelogController: getrunningvbs.exe nicht im Programmpfad gefunden."
 	WScript.Quit
End If



WScript.Sleep 200


start = chr(34)&mypath&"changelog.bat"&chr(34)&" "&Profil

		strname=getrunningvbs()
		
		
		If InStr(strname,"changelog.vbs") <> 0 Then
		'gestartet, aber wie oft ?
		
		
		'erste string berspringen
		'strname = Right(strname,Len(strname)-InStr(1,strname,Chr(13))-1)
		
		Do While Instr(strname,"changelog.vbs")<> 0 
		
		pid = Trim(Left(strname,InStr(strname,"-->")-1))
		strname = Right(strname,Len(strname)-InStr(1,strname,"-->")-3)
		pfadvbs = Left(strname,InStr(1,strname,Chr(13))-1)
		strname = Right(strname,Len(strname)-InStr(1,strname,Chr(13))-1)
		
		
		' alles ber einen laufenden prozess terminieren
		If InStr(pfadvbs,"changelog.vbs") then
		
		If passfirst = True then
		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
		strQuery = "Select * from Win32_Process where Handle='" & pid &"'"
		Set colItems = objWMIService.ExecQuery(strQuery,,48)
	
		For Each objItem in colItems
   			 objItem.Terminate()
   			 objWSHShell.LogEvent 2,"Controler.vbs: doppelte changelog.vbs terminiert" & vbCrLf & "PID=" & pid
   			
		Next
		End If
		passfirst=True		
		
		End If
		pfadvbs=""
		
		Loop
	
				
		Else	' nicht gestartet
		
			Set ergebnis = objWSHShell.exec(start)
			WScript.Sleep looptime
			
			strname = getrunningvbs
			
			Do While Instr(strname,"changelog.vbs")<> 0 
		
			pid = Trim(Left(strname,InStr(strname,"-->")-1))
			strname = Right(strname,Len(strname)-InStr(1,strname,"-->")-3)
			pfadvbs = Left(strname,InStr(1,strname,Chr(13))-1)
			strname = Right(strname,Len(strname)-InStr(1,strname,Chr(13))-1)
			Loop
	
			objWSHShell.LogEvent 0,"ChangelogControler.vbs: Changelog.vbs gestartet" & vbCrLf & "PID=" & pid
		
			
		End If
		


WScript.Quit

Function getrunningvbs
On Error Resume Next
	Set oExec    = objWSHShell.Exec(chr(34)&mypath&"getrunningvbs.exe"&chr(34))
	strinput = oExec.StdOut.ReadAll
	durch = False
	schleife = 0
	Do While schleife < 5000
		If oExec.Status = 1 Then 
	    	durch = True
	     	Exit Do
	     End if
	     	
	     WScript.Sleep 1
	     schleife = schleife +1
	Loop

	getrunningvbs = LCase(strinput)
	Set oExec = Nothing

End Function




'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************







