'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  checkfeedback.vbs   GPL  *************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0          *************************************************
'*******************************************************************************************
'***************  ffnet Dokument im Viewer eines Clients die                ***************
'***************  per .bfa_Datei bergeben wurden                            ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************


Profil=""
popupoffice=true
scriptdebug = False

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume next
 
Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode

ReDim ext(60)

lngReturnCode = 0
 
Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
set oArgs    = Wscript.Arguments 
 
 
clientprogramm=""
uncclientspooler="" 
archivverzeichnis=""
archivkopie=""
zahl=0
officequickimport=False
Typ=""
profil=""



'*******************************************************************************************
'**************************  Startparameter initialisieren  ********************************
err.clear
fullpath = WScript.ScriptFullName
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
scriptname = WScript.ScriptName
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If err.number Then
	err.clear
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If 
If Len(programm)=0 Then
	errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
	objWshShell.LogEvent 1, errortxt
	WScript.Quit
End If

inilesen

'*******************************************************************************************
'**************************  Prfen, ob Server bereit  *************************************


If officequickimport=False Then
	popupoffice=False
End If

erfolg=readconfig(Profil)
If erfolg=false Then
	MsgBox("bitfarm-Archiv: Kann Konfigurationsdatei nicht lesen ("&Profil&")")
	WScript.Quit
End If

druckpfad = uncclientspooler 




'***************************************************************************************
'**************************    Parameterbergabe    ************************************
'***************************************************************************************
'***************************************************************************************


zahl=oArgs.item(0)
If err.number<>0 Then
	err.clear
	wscript.quit
End If
'MsgBox zahl

checkfeedback(zahl)


wscript.quit


Function checkfeedback(zahl)
On Error Resume Next
o=0
mymsg=druckpfad&"msg"&zahl&".bfa"
If scriptdebug Then
	objWSHShell.LogEvent 1, "checkfeedback:" & druckpfad&"msg"&zahl&".bfa"
End If 

abbruch=false
Do While abbruch=false
If o<200 Then
	o=o+1
Else
	

	frage = "Direktes Anzeigen des gerade archivierten Dokuments nicht mglich. Benutzen Sie den Viewer, um das Dokument erneut zu ffnen."
	ueberschrift = "bitfarm-Archiv Officeimport"
	antwort = objWSHShell.Popup(frage,, ueberschrift, vbExclamation)
	wscript.quit
End If

If fs.fileexists(mymsg) Then
	startdocument
End If

wscript.sleep 300

loop


End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function startdocument
On Error Resume Next

	mymsg=druckpfad&"msg"&zahl&".bfa"
	Set msgdatei = fs.OpenTextFile(mymsg,1)
	dokID=msgdatei.readline
	msgdatei.close
	Set msgdatei = nothing
	err.clear

	fs.deletefile mymsg, true
	If err.number <> 0 Then
		err.clear
		On Error Resume next
	End If
	If scriptdebug Then
		objWSHShell.LogEvent 1, "checkfeedback:" & Chr(34) & programm&"\ViewerV3.exe" & Chr(34) & " "&dokID
	End If 
		
	lngReturnCode = objWSHShell.exec(Chr(34) & programm&"\ViewerV3.exe" & Chr(34) & " "&dokID)
	If err.number<>0 Then
		err.clear
	End If
	
	WScript.Quit

End Function



Function inilesen()
On Error Resume Next

err.clear
Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
If err.number Then
	objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
	err.clear
	WScript.Quit
End If 
	
kette=inifile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
Do While Scriptsflag = 0
kette=inifile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
If inifile.AtEndOfStream = True Then
	inifile.close
	objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
    	WScript.Quit
End If
loop


Do While inifile.AtEndOfStream <> True
kette=inifile.readline
If Left(kette,1)<>";" Then
	
		
	If InStr(1,kette,"Profil",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
		If profil="" Then
			profil = wert
		End If
	End If
	
	If InStr(1,kette,"Typ",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"Typ",1)+4)
		typ = wert
	End If
	
	If InStr(1,kette,"MSWordinstalled",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"MSWordinstalled",1)+16)
		If LCase(wert)="true" Then
			acceptdoc = true
		End If	
	End If
	
	If InStr(1,kette,"MSExcelinstalled",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"MSExcelinstalled",1)+17)
		If LCase(wert)="true" Then
			acceptxls = true
		End If	
	End If
	
	If InStr(1,kette,"MSPowerPointinstalled",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"MSPowerPointinstalled",1)+22)
		If LCase(wert)="true" Then
			acceptppt = true
		End If	
	End If
	
	If InStr(1,kette,"MSOffice2007installed",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"MSOffice2007installed",1)+22)
		If (Len(wert)>0) and (wert<>" ") and (wert<>"	") Then
			If LCase(wert)="true" Then
			 MSOffice2007installed=True
		  End If
		End If
	End If
	
	If InStr(1,kette,"DWGViewerinstalled",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"DWGViewerinstalled",1)+19)
		If LCase(wert)="true" Then
			acceptdwg = true
		End If	
	End If
	
	If InStr(1,kette,"acceptallfiletypes",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"acceptallfiletypes",1)+19)
		If LCase(wert)="true" Then
			acceptallfiletypes = true
		End If	
	End If
	
	If InStr(1,kette,"officequickimport",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"officequickimport",1)+18)
		If LCase(wert)="true" Then
			officequickimport = true
		End If	
	End If
	
	If InStr(1,kette,"openofficepath",1)<>0 Then
		'wert=GetString(kette,InStr(1,kette,"openofficepath",1)+15)
		wert = Right(kette,Len(kette) -15)
		If (Len(wert)>0) and (wert<>" ") and (wert<>"	") Then
			openofficepath=Trim(wert)
		End If
	End If	
	
End If

loop
inifile.close
Set inifile = nothing
If programm="" Then
	objWshShell.LogEvent 2, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
	WScript.Quit
End If



End Function



Private Function GetWord(kette,pos)
On Error Resume Next
zeichen=""
ergebnis=""
index1=pos
'MsgBox(Len(kette)&":"&pos)
Do While (zeichen<>" ") and (zeichen<>"	") and (index1>1)
	index1=index1-1
	zeichen=Mid(kette,index1,1)
	
loop
'MsgBox(index1)
zeichen=""
index2=0
maxindex2=Len(kette)-index1+2
Do While (zeichen<>" ") and (zeichen<>Vbcrlf) and (zeichen<>"	") and (index2<maxindex2)
        ergebnis=ergebnis+zeichen
	zeichen=Mid(kette,index1+index2,1)
	index2=index2+1
	If ((zeichen=" ") or (zeichen="	") or (zeichen="=")) and (ergebnis="") Then
		zeichen=""
	End If
loop
'MsgBox(index)
Trim(ergebnis)
GetWord=ergebnis
End Function


Function Zufallszahl(von, bis)
On Error Resume Next
anzahl = bis-von+1
randomize
Zufallszahl = Fix(rnd*(anzahl))+von
end Function


Private Function StrConvert(string)
On Error Resume Next
  wert1=0
  l = Len(string)
  
  For x = 1 to l
    wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
  Next
  StrConvert=wert1
End Function


Private Function GetString(kette,pos)
zeichen=""
ergebnis=""
index=0
Do While (zeichen<>" ") and (zeichen<>Vbcrlf) and (zeichen<>"	") and (index<80)
        ergebnis=ergebnis+zeichen
	zeichen=Mid(kette,pos+index,1)
	index=index+1
	If ((zeichen=" ") or (zeichen="	") or (zeichen="=")) and (ergebnis="") Then
		zeichen=""
	End If
loop
Trim(ergebnis)
GetString=ergebnis
End Function



Function readconfig(profil)
On Error Resume Next
readconfig=true
err.clear

If not fs.FileExists(programm&profil&".con") Then
	err.clear
	errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
	objWshShell.LogEvent 1, errortxt
	readconfig=false
	err.clear
End If
		
If readconfig=true Then	
Set confile = fs.OpenTextFile(programm&profil&".con",1)
If err.number Then
	err.clear
	errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
	objWshShell.LogEvent 1, errortxt
	err.clear
	readconfig=false
	
End If 
End If

If readconfig=true Then	
kette=confile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
Do While Scriptsflag = 0
kette=confile.readline
Scriptsflag=InStr(1,kette,"[Scripts]")
If confile.AtEndOfStream = True Then
	confile.close
	Set confile=nothing
	scriptsflag=1
	errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
	objWshShell.LogEvent 1, errortxt
	readconfig = false
    	
End If
loop

End If


If readconfig = true Then
	
Do While confile.AtEndOfStream <> True
kette=confile.readline
If Left(kette,1)<>";" Then
		
		
	If InStr(1,kette,"uncclientspooler",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"uncclientspooler",1)+16)
		uncclientspooler = wert
	End If
	
	If InStr(1,kette,"archivverzeichnis",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"archivverzeichnis",1)+17)
		archivverzeichnis = wert
	End If
	
	If InStr(1,kette,"archivkopie",1)<>0 Then
		wert=GetString(kette,InStr(1,kette,"archivkopie",1)+11)
		archivkopie = wert
	End If
	
		
End If

loop
confile.close
Set confile = nothing

End If


End Function
