'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'***************  emlconvert.vbs    GPL  ***************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0        ***************************************************
'*******************************************************************************************
'***************  Programm zum Extrahieren von E-Mail Test und Attachments   ***************
'***************  aus einer .EML - Datei (z.B. David E-Mails)                ***************
'***************  die extrahierten Dateien werden automatisch verknpft      ***************
'***************  und in die queue eingestellt.                              ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>emlconvert.vbs {EML-Datei}           ***************
'***************                                                             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

'*** fr den Service:
scriptdebug = False
cleanup = True
limit=60

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next



Dim datei, i, oArgs
Dim fs, objFolder
Dim folder,  file, strPfadQueue, strAnhang, strAttachments, strHtml

Dim Stm, iMsg, iDsrc
Dim appOutLook
Dim MailOutLook


Dim strFrom, strSubject, strTo, strCC, strDate, strSentOn, strReplyTo, StrContent, strPfadTemp
Dim myname, myextension, dokname, mime
ReDim Zusatzfeld(limit)
ReDim Zusatzfeldname(limit)
ReDim linkspeicher(limit)



Set fs = CreateObject("Scripting.FileSystemObject")
Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set Stm = CreateObject("AD"&"O"&"DB.S"&"tream")
Set iMsg = CreateObject("CDO.Message")

For i = 0 To limit
    
    Zusatzfeld(i)=""
    Zusatzfeldname(i)=""
    linkspeicher(i)=""
    
Next
strcontent=""
linkzaehler=0
an=""
username=""
dokdate=""
emailblack=""
emailwhite=""
emailacceptnoextension=""
strAnhang=""
iso=False
bound=""
rescaleemlelements=False
attachmentdontuseoriname=False
attachmentdontuseoriname=False

'******************* int. bitfarm-Archiv Variablen zur Verwendung in USE-Anweisungen


richtung=""
empfaenger=""
absender=""
absenderadresse=""
Betreff=""
versanddatum=""
versanduhrzeit=""
empfangsdatum=""
empfangsuhrzeit=""
kategorie=""
Faxnummer=""
fax=""
cc=""
bcc=""


'************************************************************************************


Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

queue=programm&"queue\"
temp=programm&"temp\"
zahl = Zufallszahl(0,99999)
strPfadQueue = ""
strPfadTemp = programm&"EMLTemp\"
mylink="EMail:"&Date()&"_"&Time()&"_"&zahl



'MsgBox(strPfadTemp)

partcounter=0
Set oArgs    = WScript.Arguments                 

'hole alle Argumente 
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
If  oArgs.Count  = 1 Then    ' hole alle Argumente 
    datei      =         oArgs.item(0)  
Else
    objWshShell.LogEvent 1, "emlconvert: es wurde keine eml-Datei bergeben!" 
    'Set fs = Nothing
    WScript.Quit
End If 



If fs.FileExists(datei) Then
    Set objFolder = fs.GetFile(datei)
    
    'MsgBox objFolder
Else
    objWshShell.LogEvent 1, "emlconvert: Datei existiert nicht oder Dateiname falsch ! " & datei
    'Set fs = Nothing
    WScript.Quit
End If

If fs.GetExtensionName(datei) <> "eml" Then
    objWshShell.LogEvent 1, "emlconvert: bergebene Datei scheint keine .eml-Datei zu sein " & datei
    'Set fs = Nothing
    WScript.Quit
End If



If Not fs.FolderExists(strPfadTemp) Then
    Set test = fs.CreateFolder(strPfadTemp)
    Set test = Nothing
    WScript.sleep 200
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "emlconvert(0): kann verzeichnis nicht erstellen - Berechtigung?"
        Err.clear
        WScript.Quit
    End If 
    
    If Not fs.FolderExists(strPfadTemp) Then
        objWshShell.LogEvent 1, "emlconvert(0b): kann verzeichnis nicht erstellen (2) - Berechtigung?"
        WScript.Quit
    End If
End If

strPfadTemp=strPfadTemp&zahl&"\"

If Not fs.FolderExists(strPfadTemp) Then
    Set test = fs.CreateFolder(strPfadTemp)
    Set test = Nothing
    WScript.sleep 200
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "emlconvert(1): kann verzeichnis nicht erstellen - Berechtigung?"
        Err.clear
        WScript.Quit
    End If 
    
    If Not fs.FolderExists(strPfadTemp) Then
        objWshShell.LogEvent 1, "emlconvert(1b): kann verzeichnis nicht erstellen (2) - Berechtigung?"
        WScript.Quit
    End If
End If

myfilename=fs.getbasename(datei)

If fs.fileexists(queue&myfilename&".job")=False Then
    objWshShell.LogEvent 1, "bitfarm-Archiv emlconvert(3): Zur E-Mail Datei keine Job-Datei vorhanden."
    WScript.quit
End If

mytempname=StrPfadTemp & myfilename


If scriptdebug = True Then
    objWshShell.LogEvent 0, "bitfarm-Archiv emlconvert(3): Starte Verarbeitung..." & vbCrLf & "Datei=" & datei & vbCrLf & "strPfadTemp=" & strPfadTemp
End If


'#####################################  inilesen   ####################################

inilesen


'#####################################   eml- neu  ####################################

'zuerst nach emltemp

fs.copyfile datei,  mytempname & ".emx"
If Err.Number<>0 Then
    objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann eml-Dateien nicht ins emltemp-Verzeichnis kopieren: "&vbCrLf & datei.name & vbCrLf &mytempname & ".eml" & vbCrLf & Err.Number& vbTab & Err.Description
    Err.clear			
    WScript.quit
End If

Set emx = fs.opentextfile(mytempname & ".emx",1)
Set eml = fs.opentextfile(mytempname & ".eml",2,True)
eml.WriteLine "MIME-Version: 1.0"

Do While Not emx.AtEndOfStream
    kette = emx.ReadLine
    eml.WriteLine(kette)
Loop

emx.close
eml.close



If Err.Number<>0 Then
    'objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann eml-Dateien nicht ins emltemp-Verzeichnis kopieren: "&vbCrLf & datei.name & vbCrLf &mytempname & ".eml" & vbCrLf & Err.Number& vbTab & Err.Description
    fs.Movefile  mytempname & ".emx", mytempname & ".eml"
    Err.clear
    
    
End If

If Not fs.fileexists( mytempname & ".eml") Then
    objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann emx-Datei nicht in eml-Datei kopieren: "&vbCrLf & datei.name & vbCrLf &mytempname & ".emx" & vbCrLf & Err.Number& vbTab & Err.Description
    Err.clear			
    WScript.quit
End If

If fs.fileexists( mytempname & ".emx") Then
    fs.Deletefile mytempname & ".emx", True
End If  


Err.Clear




'Mail lesen, Infos holen

With stm
    .Open
    Call .LoadFromFile( mytempname & ".eml")
End With
Set iDsrc = iMsg.DataSource
Call iDsrc.OpenObject(Stm, "_Stream")


strTo = parsestring(iMsg.To)
strFrom = parsestring(iMsg.From)
strSubject = parsestring(iMsg.Subject)
dokname = strSubject
strSentOn = FormatDateTime(iMsg.SentOn,2)
versanduhrzeit = FormatDateTime(iMsg.SentOn,3)
strCC= parsestring(iMsg.CC)
strReplyTo = parsestring((iMsg.ReplyTo))
strReceived= FormatDateTime(iMsg.ReceivedTime,0)
strDate = FormatDateTime(iMsg.ReceivedTime,2)
empfangsuhrzeit = FormatDateTime(iMsg.ReceivedTime,3)
mime = iMsg.MimeFormatted

If strReceived="00:00:00" Then
    strReceived=strSentOn
End If

If strDate = "30.12.1899" Then
    strDate = strSentOn
End If 

' attachments extrahieren


For Each attach In iMsg.Attachments
    If strAttachments<>"" Then
        strAttachments=strAttachments&", "
    End If 	
    
    If attach.FileName<>"" Then
        
        If fs.GetExtensionName(attach.FileName) = "001" And renametobitfax Then
            strFilename = StrPfadTemp&fs.GetBasename(attach.FileName) & ".tif"
        Else
            strFilename = StrPfadTemp&attach.FileName
        End If 
        
        attach.SaveToFile strFilename
        strAttachments = strAttachments & attach.FileName
        mycounter =mycounter +1
    End If
Next 

Err.Clear
bodyfound = False
nobody = False
strHtml=iMsg.HTMLBody
strText = iMsg.TextBody
If strHtml<>"" Then
    htmlencoding = Trim(iMsg.HTMLBodyPart.ContentTransferEncoding)
End If
If strText<>"" Then
    textencoding = Trim(iMsg.TextBodyPart.ContentTransferEncoding)
End If

bound=""		'nach boundaries suchen
html64=False
text64=False
pfademlquelle=mytempname & ".eml"

'haben wir base64 codierte parts. diese erstmal plain in die eml

If htmlencoding="base64" Or textencoding="base64" Then
    
    strVoransicht=strPfadTemp & "voransicht2.eml"
    
    
    Set emlvoransicht = fs.OpenTextFile(strVoransicht,2,True)
    Set emlquelle = fs.OpenTextFile( pfademlquelle,1,True)
    Do 
        strinput = ""
        If Not emlquelle.atendofstream Then
            strinput = emlquelle.readline
        End If 
        
        If mime = False Then
            emlvoransicht.WriteLine "MIME-Version: 1.0"
            mime = True
        End If	
        
        If InStr(LCase(strinput),"boundary") Then
            bound = Right(strinput, Len(strinput)-InStr(1,LCase(strinput),"boundary")-9)
            If InStr(1, bound,Chr(34)) Then
                bound = Replace(bound, Chr(34),"")
            End If
            
            
        End If
        
        
        If bound<>"" And InStr(1,strinput,bound)<>0 And InStr(1,LCase(strinput),"boundary") = 0 Then
            contentinfo=""
            'erstmal die zeile hinschreiben
            emlvoransicht.WriteLine strinput
            
            'jetzt infos lesen
            Do 
                strinput = ""
                If Not emlquelle.atendofstream Then
                    strinput = emlquelle.readline
                End If 
                contentinfo=contentinfo & strinput & vbCrLf
                
                If InStr(LCase(strinput),"content-type: text/html") And LCase(htmlencoding) = "base64" Then
                    html64=True
                End If
                If InStr(LCase(strinput),"content-type: text/plain") And LCase(textencoding) = "base64" Then
                    text64=True
                End If
                
            Loop Until strinput =""
            
            
            'sonderfall  htmlpart base64 encoded
            
            If html64 = True Or text64 = True Then
                Do While strinput=""
                    If Not emlquelle.atendofstream Then
                        strinput = emlquelle.readline
                    End If 
                Loop 
                
                Do 
                    If Not emlquelle.atendofstream Then
                        strinput = emlquelle.readline
                    End If 
                Loop Until (strinput ="" And InStr(strinput,Chr(9)) = False) Or InStr(1,strinput,bound)<>0
                
                ' part sollte jetzt bersprungen sein
                
                If html64 = True Then
                    emlvoransicht.WriteLine "content-type: text/html"
                    emlvoransicht.WriteLine ""
                    
                    emlvoransicht.WriteLine strHtml
                    emlvoransicht.WriteLine ""
                    html64 = False
                End If
                
                If text64 = True Then
                    emlvoransicht.WriteLine "content-type: text/plain"
                    emlvoransicht.WriteLine ""
                    
                    emlvoransicht.WriteLine strText
                    emlvoransicht.WriteLine ""
                    text64 = False
                    
                End If
                'strinput = ""
            Else
                emlvoransicht.WriteLine contentinfo	
                
            End If 
            
        End If
        
        emlvoransicht.WriteLine strinput
        
        
    Loop Until emlquelle.AtEndOfStream 
    
    emlvoransicht.Close
    emlquelle.Close
    
    Set emlvoransicht = Nothing
    Set emlquelle = Nothing
    
    htmlencoding="7bit"
    textencoding="7bit"
    
    'okay jetzt die voransicht 2 benutzen
    pfademlquelle=strVoransicht
End If


If strHtml <> "" Then     'htmlpart gefunden
    
    
    If InStr(1,LCase(strHtml),"<body")=0 Then
        'html mail ohne body-tag, pfui
        nobody = True
    End If
    
    
    strVoransicht=strPfadTemp & "voransicht.eml"
    Set emlvoransicht = fs.OpenTextFile(strVoransicht,2,True)
    Set emlquelle = fs.OpenTextFile( pfademlquelle,1,True)
    Do 
        If Not emlquelle.atendofstream Then
            strinput = emlquelle.readline
        End If 
        
        'If mime = False Then
        'emlvoransicht.WriteLine "MIME-Version: 1.0"
        'mime = True
        'End If	
        
        If nobody = True Then
            If InStr(1,LCase(strinput),"text/html") Then
                Do 
                    emlvoransicht.WriteLine strinput	
                    If Not emlquelle.atendofstream Then
                        strinput = emlquelle.readline
                    End If 
                Loop Until strinput ="" 
                emlvoransicht.WriteLine strinput	
                strinput = "<body>"
                nobody = False
            End If
        End If
        
        'If Left(LCase(strinput),5)="<body" Then
        If InStr(1,LCase(strinput),"<body") <> 0 Then
            bodyfound=True
        End If	
        
        
        If bodyfound = True And InStr(strinput,">") Then
            bodyfound=False
            If htmlencoding = "7bit" Then
                'strccs="<style type=""text/css"">.bfafont { font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; }</style>"
                'style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;""
                strbody = "<p span style=""background-color:#ffffff; padding:6px; margin:0px;""><BR></span><table>" & vbCrLf
                strbody = strbody & "<tr><td valign=""top""><span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Betreff&nbsp;&nbsp;: </td><td style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strSubject & "</td></span></tr>" & vbCrLf
                strbody = strbody & "<tr><td valign=""top""><span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Absender;&nbsp;: </td><td style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strFrom & "</td></span></tr>" & vbCrLf
                strbody = strbody & "<tr><td valign=""top""><span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Datum&nbsp;&nbsp;&nbsp;&nbsp;: </td><td style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strReceived & "</td></span></tr>" & vbCrLf
                strbody = strbody & "<tr><td valign=""top""><span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Empfnger: </td><td style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strTo & "</td></span></tr>" & vbCrLf
                If strCC <> "" Then
                    strbody = strbody & "<tr><td valign=""top""><span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Kopie&nbsp;&nbsp;&nbsp;&nbsp;: </td><td style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strCC & "</td></span></tr>" & vbCrLf
                End If 
                If strAttachments<>"" Then
                    strbody = strbody & "<tr><td valign=""top""><span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Anhang&nbsp;&nbsp;&nbsp;: </td><td style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strAttachments & "</td></span></tr>" & vbCrLf
                End If
                strbody = strbody & "</table><p span style="" border-bottom: 2px  solid black; padding-bottom:0px; margin:0px""></P><BR></p>"
                
                'emlvoransicht.WriteLine "<p span style=""background-color:#ffffff; padding:6px; margin:0px;"">"
                'emlvoransicht.WriteLine "<span><BR></span>"
                'emlvoransicht.WriteLine "<span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Betreff&nbsp;&nbsp;: " & strSubject & "</span></span><BR>"
                'emlvoransicht.WriteLine "<span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Absender&nbsp;: " & strFrom & "</span><BR>"
                'emlvoransicht.WriteLine "<span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Datum&nbsp;&nbsp;&nbsp;&nbsp;: " & strReceived & "</span><BR>"
                'emlvoransicht.WriteLine "<span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Empfnger: " & strTo & "</span><BR>"
                'If strAttachments<>"" Then
                'emlvoransicht.WriteLine "<span style=""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Anhang&nbsp;&nbsp;&nbsp;: " & strAttachments & "</span><BR>"
                'End If
                'emlvoransicht.WriteLine "<p span style="" border-bottom: 2px  solid black; padding-bottom:0px; margin:0px""></P><BR></p>"
                
                
                'string teilen und strbody zwischenfgen
                If InStr(1,LCase(strinput),"<html>") <> 0 Then
                    pos = InStr(1,LCase(strinput),"<html>")
                    pos = pos +5
                Else
                    pos = 1
                End If 
                body1= Left(strinput,InStr(pos,strinput,">"))
                body2 =Right(strinput,Len(strinput)-InStr(pos,strinput,">"))
                
                strinput=  body1 & strbody & body2
                
                
            End If
            If htmlencoding = "quoted-printable" Then
                'strccs="<style type=3D""text/css"">.bfafont { font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; }</style>"
                
                strbody = "<p span style=3D""background-color:#ffffff; padding:6px; margin:0px;""><BR></span><table>" & vbCrLf
                strbody = strbody & "<tr><td valign=3D""top""><span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Betreff&nbsp;&nbsp;: </td><td style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strSubject & "</td></span></tr>" & vbCrLf
                strbody = strbody & "<tr><td valign=3D""top""><span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Absender&nbsp;: </td><td style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strFrom & "</td></span></tr>" & vbCrLf
                strbody = strbody & "<tr><td valign=3D""top""><span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Datum&nbsp;&nbsp;&nbsp;&nbsp;: </td><td style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strReceived & "</td></span></tr>" & vbCrLf
                strbody = strbody & "<tr><td valign=3D""top""><span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Empfnger: </td><td style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strTo & "</td></span></tr>" & vbCrLf
                If strCC <> "" Then
                    strbody = strbody & "<tr><td valign=3D""top""><span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Kopie&nbsp;&nbsp;&nbsp;&nbsp;: </td><td style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strCC & "</td></span></tr>" & vbCrLf
                End If
                If strAttachments<>"" Then
                    strbody = strbody & "<tr><td valign=3D""top""><span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">Anhang&nbsp;&nbsp;&nbsp;: </td><td style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold;"">" & strAttachments & "</td></span></tr>" & vbCrLf
                End If
                strbody = strbody & "</table><p span style=3D"" border-bottom: 2px  solid black; padding-bottom:0px; margin:0px""></P><BR></p>"
                
                'emlvoransicht.WriteLine "<p span style=3D""background-color:#ffffff; padding:6px; margin:0px;"">"
                'emlvoransicht.WriteLine "<span><BR></span>"
                'emlvoransicht.WriteLine "<span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Betreff&nbsp;&nbsp;: " & strSubject & "</span></span><BR>"
                'emlvoransicht.WriteLine "<span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Absender&nbsp;: " & strFrom & "</span><BR>"
                'emlvoransicht.WriteLine "<span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Datum&nbsp;&nbsp;&nbsp;&nbsp;: " & strReceived & "</span><BR>"
                'emlvoransicht.WriteLine "<span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Empfnger: " & strTo & "</span><BR>"
                'If strAttachments<>"" Then
                'emlvoransicht.WriteLine "<span style=3D""font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; "">Anhang&nbsp;&nbsp;&nbsp;: " & strAttachments & "</span><BR>"
                'End If
                'emlvoransicht.WriteLine "<p span style=3D"" border-bottom: 2px  solid black; padding-bottom:0px; margin:0px""></P>"
                'emlvoransicht.WriteLine "<BR></p>"
                
                If InStr(1,LCase(strinput),"<html>") <> 0 Then
                    pos = InStr(1,LCase(strinput),"<html>")
                    pos = pos +6
                Else
                    pos = 1
                End If 
                body1= Left(strinput,InStr(pos,strinput,">"))
                body2 =Right(strinput,Len(strinput)-InStr(pos,strinput,">"))
                strinput= body1 & strbody & body2
                
            End If
            
        End If
        
        emlvoransicht.WriteLine strinput
        
        
    Loop Until emlquelle.AtEndOfStream 
    
    emlvoransicht.Close
    emlquelle.Close
    
    Set emlvoransicht = Nothing
    Set emlquelle = Nothing
    
Else	'textpart
    
    strText = iMsg.TextBody
    
    If strText = "" Then
        If mycounter>0 Then
            
            strText="-leerer Textkrper - siehe Anhnge-"
        Else
            strText="-leerer Textkrper-"
        End If
    End If 
    
    
    If strText <> "" Then
        strTextBody = Replace(strText,vbCrLf,"<BR>")
        strVoransicht = strPfadTemp & "voransicht.htm"
        Set htmlvoransicht = fs.OpenTextFile(strVoransicht,2,True)	
        
        strbody= "<html><head><title>" & strSubject & "</title><style type=""text/css"">.bfafont { font-size:11pt; font-color:#000000; font-family: Lucida Console, monospace; font-weight:bold; }</style></head><body>" & vbCrLf
        strbody = strbody &"<p span style=""background-color:#ffffff; padding:6px; margin:0px;""><BR></span><table>" & vbCrLf
        strbody = strbody & "<tr><td valign=""top""><span class=""bfafont"">Betreff&nbsp;&nbsp;: </td><td class=""bfafont"">" & strSubject & "</td></span></tr>" & vbCrLf
        strbody = strbody & "<tr><td valign=""top""><span class=""bfafont"">Absender&nbsp;: </td><td class=""bfafont"">" & strFrom & "</td></span></tr>" & vbCrLf
        strbody = strbody & "<tr><td valign=""top""><span class=""bfafont"">Datum&nbsp;&nbsp;&nbsp;&nbsp;: </td><td class=""bfafont"">" & strReceived & "</td></span></tr>" & vbCrLf
        strbody = strbody & "<tr><td valign=""top""><span class=""bfafont"">Empfnger: </td><td class=""bfafont"">" & strTo & "</td></span></tr>" & vbCrLf
        If strCC <> "" Then
            strbody = strbody & "<tr><td valign=""top""><span class=""bfafont"">Kopie;&nbsp;&nbsp;&nbsp;: </td><td class=""bfafont"">" & strCC & "</td></span></tr>" & vbCrLf
        End If 
        If strAttachments<>"" Then
            strbody = strbody & "<tr><td valign=""top""><span class=""bfafont"">Anhang&nbsp;&nbsp;&nbsp;: </td><td class=""bfafont"">" & strAttachments & "</td></span></tr>" & vbCrLf
        End If
        strbody = strbody & "</table><p span style="" border-bottom: 2px  solid black; padding-bottom:0px; margin:0px""></P><BR></p>"
        
        
        htmlvoransicht.WriteLine strbody
        htmlvoransicht.WriteLine strTextBody
        htmlvoransicht.WriteLine "</body></html>"
        
        htmlvoransicht.Close
        Set htmlvoransicht = Nothing
    Else
        'keine Inhalt, was nun ?
        objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: leere Mail ohne Anhnge "
        
        makefilltif(strPfadTemp&"voransicht")
        
    End If
    
End If

' jetzt vertiffen lassen

DOCtoPS(strVoransicht)

PStoColorTif(strVoransicht)


Err.Clear
If fs.FileExists(strVoransicht&".tif") And fs.FileExists(strVoransicht&".ps") Then
    fs.DeleteFile(strVoransicht&".ps"), True
    If Err.Number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann "& strVoransicht&".ps nicht lschen "&vbCrLf & Err.Number& vbTab & Err.Description
        Err.clear			
        
    End If
End If

If fs.FileExists(strVoransicht) Then
    fs.DeleteFile(strVoransicht), True
    If Err.Number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann "& strVoransicht&" nicht lschen "&vbCrLf & Err.Number& vbTab & Err.Description
        Err.clear			
        
    End If
End If 	

If fs.FileExists(strPfadTemp&"voransicht2.eml") Then
    fs.DeleteFile(strPfadTemp&"voransicht2.eml"), True
    If Err.Number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann "& strVoransicht&"2 nicht lschen "&vbCrLf & Err.Number& vbTab & Err.Description
        Err.clear			
        
    End If
End If





' Voll-Text extrahieren

If strText="" Then
    strText=iMsg.TextBody
End If


If Not fs.FileExists(mytempname&".txt") Then
    If strText<>"" Then
        strText=NormString(strText)
        Set textfile= fs.OpenTextFile(mytempname&".txt",2,True)
        textfile.WriteLine strText
        textfile.Close
        Set textfile = Nothing
    End If
End If 


'#####################################  Einstellen in queue ###########################


If fs.fileexists(mytempname&".txt") Then
    Typ="EXT"
Else
    Typ="EMP"
End If 
newtempname=""
myextension=""



erfolg=readjob(myfilename)

If dokdate="" Then
    dokdate=setdokdate()
End If

If username="" Then
    username="System"
End If

If mycounter>0 Then
    linkspeicher(linkzaehler)=mylink
    linkzaehler=linkzaehler+1
End If


'---------------------------  falls vorhanden schon in zusatzfelder bergeben

For i = 0 To limit
    If LCase(zusatzfeldname(i))="empfnger" Or LCase(zusatzfeldname(i))="empfaenger" Or LCase(zusatzfeldname(i))="an" Then
        zusatzfeld(i)=strTo
    End If
    If LCase(zusatzfeldname(i))="recipient" Or LCase(zusatzfeldname(i))="to"  Then
        zusatzfeld(i)=strTo
    End If
    If LCase(zusatzfeldname(i))="absender" Or LCase(zusatzfeldname(i))="von"   Then
        zusatzfeld(i)=strFrom
    End If
    If LCase(zusatzfeldname(i))="sender" Or LCase(zusatzfeldname(i))="from"   Then
        zusatzfeld(i)=strFrom
    End If
    If LCase(zusatzfeldname(i))="empfangsdatum"  Or LCase(zusatzfeldname(i))="datum" Or LCase(zusatzfeldname(i))="am"   Then
        zusatzfeld(i)=strDate
    End If
    If LCase(zusatzfeldname(i))="empfangsuhrzeit"  Or LCase(zusatzfeldname(i))="uhrzeit" Or LCase(zusatzfeldname(i))="um"   Then
        zusatzfeld(i)=empfangsuhrzeit
    End If
    If LCase(zusatzfeldname(i))="time"  Or LCase(zusatzfeldname(i))="receivedtime" Then
        zusatzfeld(i)=empfangsuhrzeit
    End If
    If LCase(zusatzfeldname(i))="date"  Or LCase(zusatzfeldname(i))="at" Then
        zusatzfeld(i)=strDate
    End If
    If LCase(zusatzfeldname(i))="versanddatum" Or LCase(zusatzfeldname(i))="vom"   Then
        zusatzfeld(i)=strSentOn
    End If
    If LCase(zusatzfeldname(i))="senton" Or LCase(zusatzfeldname(i))="sent"   Then
        zusatzfeld(i)=strSentOn
    End If
    If LCase(zusatzfeldname(i))="betreff" Or LCase(zusatzfeldname(i))="subject"   Then
        zusatzfeld(i)=strSubject
    End If
    If LCase(zusatzfeldname(i))="empfangen"  Or LCase(zusatzfeldname(i))="received"    Then
        zusatzfeld(i)=strReceived
    End If
    
Next 




'---------------------------  Hier werden die Dateien in die queue gestellt


newtempname = getfifo(queue,"temp-eml")
If fs.FileExists(mytempname & ".eml") Then
    fs.MoveFile mytempname & ".eml",newtempname&".eml"
    If Err.Number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann Dateien nicht in queue kopieren: "&mytempname & ".eml" & vbCrLf & Err.Number& vbTab & Err.Description
        Err.clear
        
    End If
End If
If fs.FileExists(strVoransicht & ".tif") Then
    fs.MoveFile strVoransicht & ".tif",newtempname&".tif"
    If Err.Number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann Dateien nicht in queue kopieren: "&strVoransicht & ".tif" & vbCrLf & Err.Number& vbTab & Err.Description
        Err.clear
        
        
    End If
End If

If fs.FileExists(mytempname & ".txt") Then
    fs.MoveFile mytempname & ".txt",newtempname&".txt"
    If Err.Number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann Dateien nicht in queue kopieren: "&mytempname & ".txt" & vbCrLf & Err.Number& vbTab & Err.Description
        Err.clear
        
        
    End If
End If

erfolg = rejob(myfilename)
copyschlagwort



' Attachments
Set folder = fs.GetFolder(strPfadTemp)
For Each file In folder.files
    
    
    myname=file.name
    Err.clear
    myextension="." & LCase(fs.GetExtensionName(myname))
    If attachmentdontuseoriname=True Then
        dokname=""
    Else    
        dokname = Replace(myname, myextension,"")
    End If
    
    ' ----------------------------  hier die blacklist abfrage , bei true weitermachen
    
    erlaubt = False		
    
    
    If emailwhite="" And emailblack="" Then
        erlaubt = True
    Else
        If InStr(1,emailwhite,myextension) <> 0 Or emailwhite = "" Then
            erlaubt = True
        End If
        If InStr(1,emailblack,myextension) <> 0  Then
            erlaubt = False
        End If
    End If
    
    If myextension = "" And emailacceptnoextension = True Then
        erlaubt = True
    End If
    
    If myextension = "" And emailacceptnoextension = False Then
        erlaubt = False
    End If
    
    
    'MsgBox erlaubt
    
    If erlaubt = True Then
        Typ = "EMP"
        newtempname = getfifo(queue,"temp-eml")
        
        fs.MoveFile file, newtempname&myextension
        If Err.number<>0 Then
            objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: Kann Dateien nicht in queue kopieren: "&file
            
        End If
        
        erfolg = rejob(myfilename)
        copyschlagwort()
        
        
        If fs.fileexists(queue&mytempname&".vtx") Then
            fs.copyfile queue&mytempname&".vtx", newtempname&".vtx", True
        End If
        
        If fs.fileexists(queue&mytempname&".ftx") Then
            fs.copyfile queue&mytempname&".ftx", newtempname&".ftx", True
        End If
        
        Set myhandle = fs.OpenTextFile(newtempname&".slw",8,True)
        
        myhandle.writeline(vbCrLf&myname&vbCrLf)
        myhandle.close
        Set myhandle=Nothing
        WScript.sleep 50
    Else
        
        fs.deletefile file, True
        mycounter = mycounter -1
        
    End If
    
Next

Set folder =Nothing
WScript.sleep 20

If cleanup=True Then
    Err.clear
    Set folder = fs.GetFolder(strPfadTemp)
    For Each file In folder.files
        fs.deletefile file, True
        If Err.number<>0 Then
            objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: kann datei nicht lschen."&file
            'wscript.quit
        End If
    Next
    Set folder=Nothing
    WScript.sleep 50
    strPfadTemp=Left(strPfadTemp,Len(strPfadTemp)-1)
    
    fs.deletefolder strPfadTemp, True
    If Err.number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv emlconvert: kann Ordner nicht lschen."&strPfadTemp
        'wscript.quit
    End If
End If


Set fs = Nothing


If scriptdebug = True Then
    objWshShell.LogEvent 0, "bitfarm-Archiv emlconvert(3): Ende Verarbeitung"
End If

WScript.Quit




'######################################  Ende Hauptroutine  ####################################
'###############################################################################################




' Decodes a base-64 encoded string (BSTR type).
' 1999 - 2004 Antonin Foller, http://www.motobit.com
' 1.01 - solves problem with Access And 'Compare Database' (InStr)
Function Base64Decode(ByVal base64String)
    On Error Resume Next  
    'rfc1521
    '1999 Antonin Foller, Motobit Software, http://Motobit.cz
    Const Base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
    Dim dataLength, sOut, groupBegin
    
    'remove white spaces, If any
    base64String = Replace(base64String, vbCrLf, "")
    base64String = Replace(base64String, vbTab, "")
    base64String = Replace(base64String, " ", "")
    
    'The source must consists from groups with Len of 4 chars
    dataLength = Len(base64String)
    If dataLength Mod 4 <> 0 Then
        '    Err.Raise 1, "Base64Decode", "Bad Base64 string."
        Base64Decode = "#ERROR#"
        Exit Function
    End If
    
    
    ' Now decode each group:
    For groupBegin = 1 To dataLength Step 4
        Dim numDataBytes, CharCounter, thisChar, thisData, nGroup, pOut
        ' Each data group encodes up To 3 actual bytes.
        numDataBytes = 3
        nGroup = 0
        
        For CharCounter = 0 To 3
            ' Convert each character into 6 bits of data, And add it To
            ' an integer For temporary storage.  If a character is a '=', there
            ' is one fewer data byte.  (There can only be a maximum of 2 '=' In
            ' the whole string.)
            
            thisChar = Mid(base64String, groupBegin + CharCounter, 1)
            
            If thisChar = "=" Then
                numDataBytes = numDataBytes - 1
                thisData = 0
            Else
                thisData = InStr(1, Base64, thisChar, vbBinaryCompare) - 1
            End If
            If thisData = -1 Then
                'Err.Raise 2, "Base64Decode", "Bad character In Base64 string."
                Base64Decode = "#ERROR#"
                Exit Function
            End If
            
            nGroup = 64 * nGroup + thisData
        Next
        
        'Hex splits the long To 6 groups with 4 bits
        nGroup = Hex(nGroup)
        
        'Add leading zeros
        nGroup = String(6 - Len(nGroup), "0") & nGroup
        
        'Convert the 3 byte hex integer (6 chars) To 3 characters
        pOut = Chr(CByte("&H" & Mid(nGroup, 1, 2))) + _
        Chr(CByte("&H" & Mid(nGroup, 3, 2))) + _
        Chr(CByte("&H" & Mid(nGroup, 5, 2)))
        
        'add numDataBytes characters To out string
        sOut = sOut & Left(pOut, numDataBytes)
    Next
    
    Base64Decode = sOut
End Function




Function hex2dez(ByVal HexZahl)    'fr hexzahlen von 00 - FF
    On Error Resume Next       
    Dim  summe, i
    summe = 0
    Const HexChars = "0123456789ABCDEF"
    
    If InStr(HexChars,Mid(Hexzahl,1,1)) = 0 Then 
        hex2dez = Hexzahl
        Exit Function
    End If
    
    If InStr(HexChars,Mid(Hexzahl,2,1)) = 0 Then
        hex2dez = Hexzahl
        Exit Function
    End If
    
    summe = summe + (InStr(HexChars,(Mid(Hexzahl,1,1)))-1) * 16 
    summe = summe + (InStr(HexChars,(Mid(Hexzahl,2,1)))-1) 
    
    hex2dez = summe
    
End Function



Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function



'################################################################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################


Function rejob(oldbase)
    On Error Resume Next
    rejob = True
    
    
    
    
    
    If rejob=True Then	
        Set quelljobfile = fs.OpenTextFile(queue&oldbase&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann alte Jobdatei nicht zum lesen ffnen."
            objWshShell.LogEvent 1, errortxt
            rejob=False
            
        End If 
    End If
    
    If rejob=True Then
        If fs.FileExists(newtempname&".tmp") Then
            fs.DeleteFile(newtempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="bitfarm-Archiv EMLconvert: Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                rejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If rejob=True Then
        Set zieljobfile = fs.OpenTextFile(newtempname&".job",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            rejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If rejob = True Then
        'Termin=Date()
        'Alarm=Date()+7
        stopflag=False
        ersatzstring=""	
        Do While Not quelljobfile.AtEndOfStream
            kette=quelljobfile.readline
            ersatzstring=""
            
            
            If (InStr(1,kette,"[Referenz]",1)<>0) And (quelljobfile.AtEndOfStream <> True) Then
                abbruch=False
                Do While abbruch=False 
                    kette=quelljobfile.readline
                    If quelljobfile.AtEndOfStream = True Then
                        abbruch=True
                    End If
                    If (InStr(1,kette,"Referenz",1)=0) And (InStr(1,kette,"Anzahl",1)=0) Then
                        abbruch = True
                    End If
                Loop
                zieljobfile.writeline("[Referenz]")
                zieljobfile.writeline("Anzahl="&linkzaehler)
                x=0
                Do While x < linkzaehler
                    zieljobfile.writeline("Referenz"&x+1&"="&linkspeicher(x))
                    x=x+1
                    
                Loop
                
            End If
            ersatzstring=""
            
            
            
            If (InStr(1,kette,"Titel=",1)<>0) Then
                
                
                ersatzstring="Titel="&dokname
            End If

            If (InStr(1,kette, "gdoc_id=",1)<>0) Then
            	ersatzstring="gdoc_id="
            End If            
             
            If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            
            'If (InStr(1,kette,"Quelle=",1)<>0) Then
            '	ersatzstring="Quelle="&mychangedoc
            'End If
            If InStr(1,kette,"Schlagworte=",1)<>0 Then
                
                ersatzstring="Schlagworte="
                
            End If
            
            'If (dokDate<>"") and (InStr(1,kette,"Datum=",1)<>0) Then
            '	ersatzstring="Datum="
            'End If
            '
            'If (dokID4<>"") and (InStr(1,kette,"DOCID=",1)<>0) Then
            '	
            '	
            '	ersatzstring="DOCID="&dokID4
            '	
            'End If
            
            If Left(kette,8)="ZusTitel" Then
                
                For x=1 To limit
                    
                    
                    If InStr(1,kette,"ZusTitel"&x&"=",1)<>0 Then
                        
                        If x<10 Then
                            wert=GetString(kette,InStr(1,kette,"ZusTitel"&x,1)+9)
                        Else
                            wert=GetString(kette,InStr(1,kette,"ZusTitel"&x,1)+10)
                        End If
                        
                        For w=0 To limit
                            
                            If LCase(Zusatzfeldname(w))=LCase(wert) Then
                                
                                ersatzstring="ZusWert"&x&"="&Zusatzfeld(w)
                                Exit For
                                
                            End If
                        Next
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                        
                    End If
                Next
                
                
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        
    End If
    
    'If rejob=true Then	
    'fs.deletefile cngfilename, true
    'End If
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function readjob(tempname)
    On Error Resume Next
    readjob=True
    Err.clear
    
    If Not fs.FileExists(queue&tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(queue&tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Jobdatei nicht vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            
            readjob=False
            
        End If 
    End If
    
    
    If readjob = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                
                
                If InStr(1,kette,"Referenz1=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz1=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz2=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz2=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz3=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz3=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz4=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz4=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz5=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz5=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz6=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz6=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz7=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz7=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz8=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz8=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz9=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz9=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                
                If InStr(1,kette,"Referenz10=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz10=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz11=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz11=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz12=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz12=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz13=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz13=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz14=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz14=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz15=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz15=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz16=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz16=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz17=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz17=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz18=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz18=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz19=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz19=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz20=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz20=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
                
                If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        
                        'Typ = wert
                    Else
                        'Typ = "MAN"	
                    End If
                End If
                
                If InStr(1,kette,"Name=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Name=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        laenge=Len(kette)+1
                        pos1=InStr(1,kette,"Name=",1)+5
                        wert=Mid(kette,pos1,laenge-pos1)
                        Tabelle = wert
                    End If
                    
                End If 
                
                If InStr(1,kette,"Filter=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Filter=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Filtermakro = LCase(wert)
                        If InStr(1,LCase(wert),"color",1)<>0 Then
                            'Filtermakro=""
                            Filtermakro=Replace(Filtermakro,"color","")			
                            color=True
                        End If
                        If InStr(1,LCase(wert),"highres",1)<>0 Then
                            Filtermakro=Replace(Filtermakro,"highres","")				
                            'Filtermakro=""
                            hires=True
                        End If
                    End If
                    
                End If
                
                If InStr(1,kette,"Datum=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Datum=",1)+6)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        laenge=Len(kette)+1
                        pos1=InStr(1,kette,"Datum=",1)+6
                        wert=Mid(kette,pos1,laenge-pos1)
                        dokdate = wert
                    End If
                    
                End If 
                
                
                
                If InStr(1,kette,"DOCID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"DOCID=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        dokID = wert
                    End If
                End If
                
                If InStr(1,kette,"Titel=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Titel=",1)+5))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        myname = wert
                    End If
                End If
                
                If InStr(1,kette,"Benutzer=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Benutzer=",1)+8))
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        username = wert
                    End If
                End If
                
                If InStr(1,kette,"Tabelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Tabelle=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        folderID = wert
                    End If
                End If
                
                If InStr(1,kette,"Quelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Quelle=",1)+6))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        quelle = wert
                    End If
                End If
                
                If InStr(1,kette,"Orginal=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Orginal=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Orginal = wert
                    End If
                End If
                
                
                If InStr(1,kette,"Status=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Status=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        oldstatus = wert
                    End If
                End If
                
                If InStr(1,kette,"clientID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"clientID=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        clientID = wert
                    End If
                End If
                
                If InStr(1,kette,"Felder=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Felder=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzfelder = strconvert(wert)
                        If Zusatzfelder > 29 Then
                            errortxt="Jobdatei: mehr als "&limit&" Zusatzfelder werden nicht untersttzt."
                            objWshShell.LogEvent 1, errortxt
                            readjob=False
                        End If
                        'If Zusatzfelder > 0 Then
                        '	checkOCR=false
                        'End If
                    End If
                End If
                
                
                If InStr(1,kette,"ZusTitel",1)<>0 Then
                    wert=getstring(kette,InStr(1,kette,"ZusTitel",1)+10)
                    gefunden=False
                    x=0
                    Do While gefunden=False
                        If Zusatzfeldname(x)="" Then
                            gefunden=True
                            Zusatzfeldname(x)=wert
                            
                        End If
                        If gefunden=False Then
                            x=x+1
                        End If
                    Loop
                    
                End If
                
                If InStr(1,kette,"ZusWert",1)<>0 Then
                    wert=getstring(kette,InStr(1,kette,"ZusWert",1)+9)
                    
                    pos1=InStr(1,kette,wert,1)
                    If wert="" Then
                        pos1=0
                    End If
                    If pos1>3 Then
                        wert=Right(kette,Len(kette)-pos1+1)
                    Else
                        wert=""
                    End If
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzfeld(x)=wert
                        
                        checkOCR=False
                    End If
                    
                End If
                
                
            End If
            
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function



Function copyschlagwort()
    On Error Resume Next
    datei1=queue&mytempname
    datei2=newtempname
    Set zieldatei=fs.opentextfile(datei2&".slw",8,1)
    
    If fs.fileexists(datei1&".slw") Then
        Set quelldatei=fs.opentextfile(datei1&".slw",1)
        Do While quelldatei.atendofstream=False
            kette=quelldatei.readline
            zieldatei.writeline(kette)
        Loop
        quelldatei.close
        Set quelldatei=Nothing
    End If
    
    If fs.fileexists(datei1&".swd") Then
        Set quelldatei=fs.opentextfile(datei1&".swd",1)
        Do While quelldatei.atendofstream=False
            kette=quelldatei.readline
            zieldatei.writeline(kette)
        Loop
        quelldatei.close
        Set quelldatei=Nothing
    End If
    
    
    zieldatei.writeline("Richtung="&richtung)
    zieldatei.writeline("Empfaenger="&strTo)
    zieldatei.writeline("Absender="&strFrom)
    zieldatei.writeline("Absenderadresse="&strFrom)
    zieldatei.writeline("Betreff="&strSubject)
    zieldatei.writeline("Versanddatum="&strSentOn)
    zieldatei.writeline("Versanduhrzeit="&versanduhrzeit)
    zieldatei.writeline("Empfangsdatum="&strDate)
    zieldatei.writeline("Empfangsuhrzeit="&empfangsuhrzeit)
    zieldatei.writeline("Kategorie="&kategorie)
    zieldatei.writeline("Faxnummer="&Faxnummer)
    zieldatei.writeline("Fax="&fax)
    zieldatei.writeline("CC="&strCC)
    zieldatei.writeline("BCC="&bcc)
    
    
    
    zieldatei.close
    Set zieldatei=Nothing
    
End Function


Private Function maketime(byVal mytime)
    On Error Resume Next
    maketime="ERROR"
    pattern = "\d\d:\d\d\:\d\d"
    Set objRE = New RegExp
    objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
    objRE.IgnoreCase = False
    objRE.Pattern    = pattern
    
    Set colMatches = objRE.Execute(mytime)
    
    'WScript.Echo vbNewLine & "Resulting Matches:"
    For Each objMatch In colMatches
        maketime = objMatch.Value
        
        'WScript.Echo "At position " & objMatch.FirstIndex & " matched " & objMatch.Value
    Next
    Set objRE = Nothing
    
End Function


'Private Function makedate(mydate)
'  myday="01"
'	mymonth="01"
'	myyear="1900"
'	myhour="12"
'	myminute="00"
'	mysecond="00"
'	
'	err.clear
'	On Error Resume Next
'	makedate="Error"
'	mydate=Trim(mydate)
'	datetype=0
'	'varlaenge=Len(mydate)
'	compdate=""
'	'For o=1 to varlaenge
'	'	If Mid(mydate,o,1)<>" " Then
'	'		compdate=compdate&Mid(mydate,o,1)
'	'	End If
'	'Next
'	'compdate=LCase(compdate)
'	compdate = Replace(mydate," ", "")
'	
'ReDim chararray(60)
'ReDim chartype(60)
'For x=0 to 60
' chararray(x)=""
' chartype(x)=0
'Next
'mycharstring=""
'varlaenge=Len(compdate)
'For x=1 to varlaenge
'	a=Asc(Mid(compdate,x,1))
'	
'	chararray(x)=a
'  If (a>=48) and (a<=57) Then 'Zahlen
'  	chartype(x)=1
'  End If
'	If (a>=97) and (a<=122) Then 'Buchstaben
'  	chartype(x)=2
'  End If
'  If (a>=228) and (a<=231) Then 'Buchstaben Umlaute
'  	chartype(x)=2
'  End If
'  If (a=47) or (a=92) Then ' /
'  	chartype(x)=3
'  End If
'  If (a=46) Then ' .
'  	chartype(x)=3
'  End If
'  
'  mycharstring=mycharstring&chartype(x)
'Next
'
'
'If (chartype(1)=1) and (chartype(2)=1) and (chartype(3)=3) and (chartype(4)=2) and (chartype(5)=2) and (chartype(6)=2) and (chartype(varlaenge)=1) and (chartype(varlaenge-1)=1) and (chartype(varlaenge-2)=1) and (chartype(varlaenge-3)=1) and (chartype(varlaenge-4)=2) and (chartype(varlaenge-5)=2) and (chartype(varlaenge-6)=2) Then
'	datetype=2
'End If
'
'
'	
'	If Right(mydate,2)="UT" Or Right(mydate,3) = "CET" Then
'		datetype=1
'	End If
'	
'	If InStr("mon,tue,wed,thu,fri,sat,sun",LCase(Left(mydate,4))) <> 0 Then
'		mydate = Right(mydate, Len(mydate)-4)
'		mydate = Trim(mydate)
'		datetype = 1
'	End If
'	
'	
'	If datetype=1 Then
'				
'		myday=Left(mydate,2)
'		mymonth=Mid(mydate,4,3)
'		myyear=Mid(mydate,8,4)
'		myhour=Mid(mydate,13,2)
'		myminute=Mid(mydate,16,2)
'		mysecond=Mid(mydate,19,2)
'	
'		If LCase(mymonth)="dec" Then
'			mymonth="12"
'		ElseIf LCase(mymonth)="nov" Then
'			mymonth="11"
'		ElseIf LCase(mymonth)="oct" Then
'			mymonth="10"
'		ElseIf LCase(mymonth)="sep" Then
'			mymonth="09"
'		ElseIf LCase(mymonth)="aug" Then
'			mymonth="08"
'		ElseIf LCase(mymonth)="jul" Then
'			mymonth="07"
'		ElseIf LCase(mymonth)="jun" Then
'			mymonth="06"
'		ElseIf LCase(mymonth)="may" Then
'			mymonth="05"
'		ElseIf LCase(mymonth)="apr" Then
'			mymonth="04"
'		ElseIf LCase(mymonth)="mar" Then
'			mymonth="03"
'		ElseIf LCase(mymonth)="feb" Then
'			mymonth="02"
'		ElseIf LCase(mymonth)="jan" Then
'			mymonth="01"
'		Else
'			mymonth="01"
'		End If
'		
'	
'	'makedate=myyear&"-"&mymonth&"-"&myday&" "&myhour&":"&myminute&":"&mysecond
'	makedate=myday&"."&mymonth&"."&myyear
'	
'	End If
'	
'	
'	
'	If datetype=2 Then
'		myyear=Right(compdate,4)
'		myday=Left(compdate,2)
'		mymonth=Mid(compdate,4,varlaenge-7)
'		If mymonth="januar" Then
'			mymonth="01"
'		End If
'		If mymonth="februar" Then
'			mymonth="02"
'		End If
'		If mymonth="mrz" Then
'			mymonth="03"
'		End If
'		If mymonth="april" Then
'			mymonth="04"
'		End If
'		If mymonth="mai" Then
'			mymonth="05"
'		End If
'		If mymonth="juni" Then
'			mymonth="06"
'		End If
'		If mymonth="juli" Then
'			mymonth="07"
'		End If
'		If mymonth="august" Then
'			mymonth="08"
'		End If
'		If mymonth="september" Then
'			mymonth="09"
'		End If
'		If mymonth="oktober" Then
'			mymonth="10"
'		End If
'		If mymonth="november" Then
'			mymonth="11"
'		End If
'		If mymonth="dezember" Then
'			mymonth="12"
'		End If
'			
'		'makedate=myyear&"-"&mymonth&"-"&myday&" "&myhour&":"&myminute&":"&mysecond
'		makedate=myday&"."&mymonth&"."&myyear
'	
'	End If
'	
'	
'	If err.number<>0 Then
'		makedate="Error"
'	End If
'
'End function


Private Function makedate(byVal mydate)
    On Error Resume Next
    
    myday="01"
    mymonth="01"
    myyear="1900"
    myhour="12"
    myminute="00"
    mysecond="00"
    
    Err.clear
    On Error Resume Next
    makedate="ERROR"
    mydate=Trim(mydate)
    datetype=0
    
    
    
    
    pattern = "\d+.\w{3}.\d{4}"
    Set objRE = New RegExp
    objRE.Global     = False    ' Nur eine bereinstimmung  (die erste)
    objRE.IgnoreCase = False
    objRE.Pattern    = pattern
    
    Set colMatches = objRE.Execute(mydate)
    
    'WScript.Echo vbNewLine & "Resulting Matches:"
    For Each objMatch In colMatches
        makedate = objMatch.Value
        
        'WScript.Echo "At position " & objMatch.FirstIndex & " matched " & objMatch.Value
    Next
    Set objRE = Nothing
    
    If makedate<>"ERROR" Then
        mydate=makedate
        
    End If	
    
    
    compdate=LCase(Replace(mydate," ",""))
    
    
    
    ReDim chararray(60)
    ReDim chartype(60)
    For x=0 To 60
        chararray(x)=""
        chartype(x)=0
    Next
    mycharstring=""
    varlaenge=Len(compdate)
    For x=1 To varlaenge
        a=Asc(Mid(compdate,x,1))
        
        chararray(x)=a
        If (a>=48) And (a<=57) Then 'Zahlen
            chartype(x)=1
        ElseIf (a>=97) And (a<=122) Then 'Buchstaben
            chartype(x)=2
        ElseIf (a>=228) And (a<=231) Then 'Buchstaben Umlaute
            chartype(x)=2
        ElseIf (a=47) Or (a=92) Or (a=45) Or (a=150) Or (a=58) Or (a=59) Or (a=44) Then ' / - 
            chartype(x)=3
        ElseIf (a=46) Then ' .
            chartype(x)=3
        Else
            chartype(x)=4
        End If
        
        mycharstring=mycharstring&chartype(x)
    Next
    
    If scriptdebug = True Then
        objWshShell.LogEvent 1, "mydate-debug: mycharstring:"&mycharstring&" compdate:"&compdate
    End If
    
    If varlaenge>6 Then
        If (chartype(1)=1) And (chartype(2)=1) And (chartype(3)=3) And (chartype(4)=2) And (chartype(5)=2) And (chartype(6)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1) And (chartype(varlaenge-4)=2) And (chartype(varlaenge-5)=2) And (chartype(varlaenge-6)=2) Then
            
            datetype=2
        End If
    End If
    
    If varlaenge>6 Then
        If (chartype(1)=1) And (chartype(2)=1) And (chartype(3)=3) And (chartype(4)=2) And (chartype(5)=2) And (chartype(6)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1)  Then
            
            datetype=2
        End If
    End If
    
    
    If varlaenge>6 Then
        If (chartype(1)=1) And (chartype(2)=3) And (chartype(3)=2) And (chartype(4)=2) And (chartype(5)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1) And (chartype(varlaenge-4)=2) And (chartype(varlaenge-5)=2) And (chartype(varlaenge-6)=2) Then
            datetype=8
        End If
    End If
    
    If varlaenge>6 Then
        If (chartype(1)=1) And (chartype(2)=3) And (chartype(3)=2) And (chartype(4)=2) And (chartype(5)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1)  Then
            datetype=8
        End If
    End If
    
    
    If mycharstring="112221111"  Then
        datetype = 1
    End If
    
    If mycharstring="12221111" Then
        mydate = "0" & mydate
        datetype = 1
    End If
    
    If mycharstring="1131131111" Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,2)
        
        If usformat = False Then
            makedate=myday&"."&mymonth&"."&myyear
        Else
            makedate=mymonth&"."&myday&"."&myyear
        End If
    End If
    
    If mycharstring="1111311311" Then
        myyear=Left(compdate,4)
        myday=Right(compdate,2)
        mymonth=Mid(compdate,6,2)
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    
    If mycharstring="111131111" Then
        datetype=3
    End If
    
    If mycharstring="113111111" Then
        datetype=4
    End If	
    
    
    If mycharstring="11311311" Then
        datetype=5
    End If	
    
    If mycharstring="1111311" Then
        datetype=6
    End If	
    
    If mycharstring="1131111" Then
        datetype=7
    End If		
    
    
    If Right(mydate,2)="UT" Then
        datetype=1
    End If
    
    
    
    
    If datetype=1 Then
        
        myday=Left(mydate,2)
        mymonth=Mid(mydate,4,3)
        myyear=Mid(mydate,8,4)
        myhour=Mid(mydate,13,2)
        myminute=Mid(mydate,16,2)
        mysecond=Mid(mydate,19,2)
        
        If LCase(mymonth)="dec" Then
            mymonth="12"
        ElseIf LCase(mymonth)="nov" Then
            mymonth="11"
        ElseIf LCase(mymonth)="oct" Then
            mymonth="10"
        ElseIf LCase(mymonth)="sep" Then
            mymonth="09"
        ElseIf LCase(mymonth)="aug" Then
            mymonth="08"
        ElseIf LCase(mymonth)="jul" Then
            mymonth="07"
        ElseIf LCase(mymonth)="jun" Then
            mymonth="06"
        ElseIf LCase(mymonth)="may" Then
            mymonth="05"
        ElseIf LCase(mymonth)="apr" Then
            mymonth="04"
        ElseIf LCase(mymonth)="mar" Then
            mymonth="03"
        ElseIf LCase(mymonth)="feb" Then
            mymonth="02"
        ElseIf LCase(mymonth)="jan" Then
            mymonth="01"
        Else
            mymonth="01"
        End If
        
        
        'makedate=myyear&"-"&mymonth&"-"&myday&" "&myhour&":"&myminute&":"&mysecond
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
    
    
    
    If datetype=2 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=LCase(Mid(compdate,4,varlaenge-7))
        If mymonth="januar" Then
            mymonth="01"
        End If
        If mymonth="februar" Then
            mymonth="02"
        End If
        If mymonth="mrz" Then
            mymonth="03"
        End If
        If mymonth="april" Then
            mymonth="04"
        End If
        If mymonth="mai" Then
            mymonth="05"
        End If
        If mymonth="juni" Then
            mymonth="06"
        End If
        If mymonth="juli" Then
            mymonth="07"
        End If
        If mymonth="august" Then
            mymonth="08"
        End If
        If mymonth="september" Then
            mymonth="09"
        End If
        If mymonth="oktober" Then
            mymonth="10"
        End If
        If mymonth="november" Then
            mymonth="11"
        End If
        If mymonth="dezember" Then
            mymonth="12"
        End If
        
        'makedate=myyear&"-"&mymonth&"-"&myday&" "&myhour&":"&myminute&":"&mysecond
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
    
    
    
    If datetype=8 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,1)
        mymonth=LCase(Mid(compdate,3,varlaenge-6))
        If mymonth="januar" Then
            mymonth="01"
        End If
        If mymonth="februar" Then
            mymonth="02"
        End If
        If mymonth="mrz" Then
            mymonth="03"
        End If
        If mymonth="april" Then
            mymonth="04"
        End If
        If mymonth="mai" Then
            mymonth="05"
        End If
        If mymonth="juni" Then
            mymonth="06"
        End If
        If mymonth="juli" Then
            mymonth="07"
        End If
        If mymonth="august" Then
            mymonth="08"
        End If
        If mymonth="september" Then
            mymonth="09"
        End If
        If mymonth="oktober" Then
            mymonth="10"
        End If
        If mymonth="november" Then
            mymonth="11"
        End If
        If mymonth="dezember" Then
            mymonth="12"
        End If
        
        'makedate=myyear&"-"&mymonth&"-"&myday&" "&myhour&":"&myminute&":"&mysecond
        makedate="0"&myday&"."&mymonth&"."&myyear
        
    End If
    
    
    If datetype=3 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,3,2)
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    
    If datetype=4 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,2)
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    
    If datetype=5 Then
        myyear=Right(compdate,2)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,2)
        
        If strconvert(myyear)>39 Then
            myyear="19"&myyear
        Else
            myyear="20"&myyear
        End If
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    If datetype=6 Then
        myyear=Right(compdate,2)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,3,2)
        
        If strconvert(myyear)>39 Then
            myyear="19"&myyear
        Else
            myyear="20"&myyear
        End If
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    If datetype=7 Then
        myyear=Right(compdate,2)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,2)
        
        If strconvert(myyear)>39 Then
            myyear="19"&myyear
        Else
            myyear="20"&myyear
        End If
        
        makedate=myday&"."&mymonth&"."&myyear
    End If
    
    
    If Datetype = 0 Then	'keine bereinstimmung gefunden
        
        
        
    End If
    
    
    
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        makedate=""
    End If
    
    
    'objWshShell.LogEvent 1, "mydate:"&mydate
    
End Function



Function setdokdate()
    On Error Resume Next
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    Tag = DatePart("d",Date)
    Stunde = DatePart("h",Time)
    Minuten = DatePart("n",Time)
    Sekunde = DatePart("s", Time)
    If Len(Monat)=1 Then 
        monat="0"&monat
    End If
    If Len(tag)=1 Then 
        tag="0"&tag
    End If
    If Len(stunde)=1 Then 
        stunde="0"&stunde
    End If
    If Len(minuten)=1 Then 
        minuten="0"&minuten
    End If
    If Len(sekunde)=1 Then 
        sekunde="0"&sekunde
    End If
    setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function


Private Function GetString(kette,pos)
    zeichen=""
    ergebnis=""
    index=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function

Private Function GetWord(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index1=pos
    'MsgBox(Len(kette)&":"&pos)
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>"	") And (charwert<>13) And (index1>1)
        index1=index1-1
        zeichen=Mid(kette,index1,1)
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
            If charwert=13 Then
                
                index1=index1+1
            End If
        End If
        
    Loop
    'MsgBox(index1)
    zeichen=""
    index2=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,index1+index2,1)
        index2=index2+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    'MsgBox(index)
    Trim(ergebnis)
    
    GetWord=normstring(ergebnis)
End Function


Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function

Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        Unlock(lockdatei)
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            Unlock(lockdatei)
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            If InStr(1,kette,"Profil",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Profil",1)+7)
                If profil="" Then
                    profil = wert
                End If
            End If
            
            If InStr(1,kette,"Typ",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"Typ",1)+4)
                typ = wert
            End If
            
            If InStr(1,kette,"deletesourcefiles",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"deletesourcefiles",1)+18)
                If LCase(wert)="true" Then
                    deletesourcefiles = True
                End If	
            End If
            
            If InStr(1,kette,"acceptallfiletypes",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"acceptallfiletypes",1)+19)
                If LCase(wert)="true" Then
                    acceptallfiletypes = True
                End If	
            End If
            
            If InStr(1,kette,"maildomain",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"maildomain",1)+11)
                
                maildomain = Trim(wert)
                
            End If
            
            If InStr(1,kette,"emailacceptnoextension",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailacceptnoextension",1)+23)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        emailacceptnoextension=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"emailwhitelistextensions",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailwhitelistextensions",1)+25)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    
                    emailwhite=Trim(LCase(wert))
                    
                End If
            End If
            
            
            If InStr(1,kette,"emailblacklistextensions",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"emailblacklistextensions",1)+25)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    
                    emailblack=Trim(LCase(wert))
                End If
            End If
            
            If InStr(1,kette,"rescaleemlelements",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"rescaleemlelements",1)+19)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert = Trim(LCase(wert))
                    If wert = "true" Then 
                        rescaleemlelements=True
                    Else
                        rescaleemlelements=False
                    End If 
                End If
            End If			
            
            If InStr(1,kette,"renametobitfax",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"renametobitfax",1)+15)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    wert = Trim(LCase(wert))
                    If wert = "true" Then 
                        renametobitfax=True
                    Else
                        renametobitfax=False
                    End If 
                End If
            End If	
            
            If InStr(1,kette,"attachmentdontuseoriname",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"attachmentdontuseoriname",1)+25)
                If LCase(wert)="true" Then
                    attachmentdontuseoriname = True
                End If	
            End If   
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 2, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
    
End Function




Private Function NormString(String)
    On Error Resume Next
    tempkette=""
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=Asc(Mid(String,x,1))
        If (wert1>=14) And (wert1<=32) Then
            tempkette=tempkette&" "
        Else
            
            
            
            'If ((wert1>=48) and (wert1<=57)) or ((wert1>=64) and (wert1<=90)) or ((wert1>=97) and (wert1<=122)) Or (Chr(wert1)="-") Or (Chr(wert1)="_") Or (Chr(wert1)=".") Then		
            If ((wert1>=48) And (wert1<=57)) Or ((wert1>=64) And (wert1<=90)) Or ((wert1>=97) And (wert1<=122)) Or (Chr(wert1)="-") Or (Chr(wert1)="_") Or (Chr(wert1)=".") Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="")Or (Chr(wert1)="") Or wert1=13 Or wert1=10 Then			
                tempkette=tempkette+Chr(wert1)
            Else
                tempkette=tempkette&""
            End If
        End If
        
        
        
        
    Next
    
    
    NormString=Trim(tempkette)
    
    
End Function

Function parsestring(strparse)
    
    strparse = Replace(strparse,Chr(34),"")
    strparse = Replace(strparse,Chr(39),"")
    strparse = Replace(strparse,Chr(59),"")
    
    
    
    parsestring=Trim(strparse)
End Function

'##########################################################################################################################



Function getfifo(fifopath,fifoname)
    On Error Resume Next
    If fs.fileexists(programm & "queue\Thumbs.db") Then
        fs.deletefile programm & "queue\Thumbs.db", True
        If Err.number<>0 Then
            objWshShell.LogEvent 1, "Archivspooler: konnte Thums.db nicht lschen"
            
        End If 
        
    End If
    
    Dim fifofile
    Dim fifofolder
    Beginn = Timer
    tempnumber=""
    fifoname=LCase(fifoname)
    
    highest = 0
    
    
    fifofile = GetLastFile(programm & "queue", fifoname&"*.*")
    If fifofile<>"" Then
        strfifo = fs.GetBaseName(fifofile)
        If InStr(1,strfifo,"_0") <> 0 Then
            strfifo = Replace(strfifo,"_0","")
        End If
        If InStr(1,strfifio,"-archiv") <> 0 Then
            strfifo = Replace(strfifo,"-archiv","")
        End If
        If InStr(1,strfifio,"-temp") <> 0 Then
            strfifo = Replace(strfifo,"-temp","")
        End If
        strnumber = Right(strfifo,5)
        If IsNumeric(strnumber) Then
            highest= strConvert(strnumber)
        Else
            'Achtung ermittelter Dateiname hat keinen 5 stelligen Index. So eine datei hat hier nichts verloren.
            'wir suchen den letzten job
            fifofile = GetLastFile(programm & "queue", fifoname&"*.job")
            If fifofile<>"" Then
                strfifo = fs.GetBaseName(fifofile)
                strnumber = Right(strfifo,5)
                If IsNumeric(strnumber) Then
                    highest= strConvert(strnumber)
                End If		
                
                
            Else
                'es gibt keinen job
                
            End If
            
        End If
        
        
        If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
            If fifoname = "prio" Then
                
                objWshShell.LogEvent 2,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                
                Set fifofolder = Nothing
                WScript.Quit
            Else
                fifoname = "prio"
                
                getfifo = getfifo(fifopath,fifoname)
                
                Exit Function
            End If
        End If
        
    End If
    
    
    tempnumber = MakeFifoString(highest +1)
    
    WScript.Sleep 200
    
    
    fifofile = GetLastFile(programm & "queue",fifoname&"*.*")
    strfifo = fs.GetBaseName(fifofile)
    
    
    If strfifo = fifoname& tempnumber Then
        If scriptdebug = True Then
            objWshShell.LogEvent 0, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
        End If
        
        getfifo = getfifo(fifopath,fifoname)
        
        Exit Function
    End If
    
    'vielleicht wurde aus unbekannten grnden doch ein schon vergebener name ermittelt
    
    If fs.FileExists(fifopath & fifoname& tempnumber & extension) Then
        highest = highest + 1
        tempnumber = MakeFifoString(highest +1)
        
        Do While fs.FileExists(fifopath & fifoname& tempnumber & extension) And highest <99999
            highest = highest + 1
            tempnumber = MakeFifoString(highest +1)
        Loop
        
    End If
    
    
    If tempnumber<>"" Then
        getfifo = fifopath & fifoname & tempnumber
    Else
        'alternativ alte routine
        highest = 0
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            strfifo = fs.GetBaseName(fifofile)
            If InStr(1,strfifo,"_0") <> 0 Then
                strfifo = Replace(strfifo,"_0","")
            End If
            If InStr(1,strfifio,"-archiv") <> 0 Then
                strfifo = Replace(strfifo,"-archiv","")
            End If
            If InStr(1,strfifio,"-temp") <> 0 Then
                strfifo = Replace(strfifo,"-temp","")
            End If
            'msgbox "strfifo="& strfifo
            ' Bedingung Basename = fifoname+ 5 stellige Zahl
            
            If Len(strfifo) = Len(fifoname)+5 Then
                If LCase(Left(strfifo,Len(strfifo)-5)) = fifoname Then
                    
                    strnumber = Right(strfifo,5)
                    If IsNumeric(strnumber) Then
                        strnumber= strConvert(strnumber)
                        'MsgBox "strnumber=" & strnumber		
                    End If
                    If strnumber> highest Then
                        highest =  strnumber
                    End If
                End If
            End If
            
            'msgbox "highest=" & highest
            
            If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
                If fifoname = "prio" Then
                    
                    objWshShell.LogEvent 2,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                    
                    Set fifofolder = Nothing
                    WScript.Quit
                Else
                    fifoname = "prio"
                    
                    getfifo = getfifo(fifopath,fifoname)
                    'msgbox "overflow-getfifo=" & getfifo	
                    'Set fifofolder = Nothing
                    'Set fifofile = Nothing
                    Exit Function
                End If
            End If
            
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        
        tempnumber = MakeFifoString(highest +1)
        
        WScript.Sleep 200
        'MsgBox "checkfifo - nochmals nachsehen ob in der zwischenzeit der name von woanders her besetzt wurde"
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            
            
            strfifo = fs.GetBaseName(fifofile)
            
            If strfifo = fifoname& tempnumber Then
                'MsgBox "doch gefunden, die routine nochmals aufrufen"
                If scriptdebug = True Then
                    objWshShell.LogEvent 0, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
                End If
                
                getfifo = getfifo(fifopath,fifoname)
                Set fifofolder = Nothing
                Set fifofile = Nothing
                Exit Function
            End If
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        getfifo = fifopath & fifoname & tempnumber
        
        
    End If
    Ende = Timer
    'MsgBox "Getfifo in : " & ende - beginn
    If scriptdebug = True Then
        objWshShell.LogEvent 0, "Archivspooler: ermittelter tempname=" & getfifo
    End If 
    
End Function


Function MakeFiFoString(nummer) 
    On Error Resume Next
    
    If Len(nummer) = 1 Then MakeFiFoString = "0000" & nummer
    If Len(nummer) = 2 Then MakeFiFoString = "000" & nummer
    If Len(nummer) = 3 Then MakeFiFoString = "00" & nummer
    If Len(nummer) = 4 Then MakeFiFoString = "0" & nummer
    If Len(nummer) = 5 Then MakeFiFoString = "" & nummer
    
End Function


Function GetFirstFile(folder,mask)
    On Error Resume Next
    
    GetFirstFile=""
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask & " -lf")
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetFirstFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function


Function GetLastFile(folder,mask)
    On Error Resume Next
    
    GetLastFile=""
    
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask & " -ll")
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetLastFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function



Function CountFiles(folder,mask)
    On Error Resume Next
    
    CountFiles=0
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(programm&"countfiles.exe "& folder & " " & mask)
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname = Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        If InStr(strname,"Anzahl:") Then
            strname = Right(strname,Len(strname)-7)
            
            'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
            CountFiles = Strconvert(strname)
        End If
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function




Function makefilltif(dateiname)
    On Error Resume Next
    makefilltif=True
    
    If fs.fileexists(dateiname&".tff") Then
        makefilltif=False
    End If
    
    If makefilltif=True Then
        Err.clear
        Set temptxtfile = fs.OpenTextFile(dateiname&".tff",8,True)
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline("   Datei: " & strAnhang&"   ")
        temptxtfile.writeline("   Anhang konnte nicht entpackt werden")
        temptxtfile.writeline("   (keine Voransicht verfgbar)   ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.writeline(" ")
        temptxtfile.close
        Set temptxtfile=Nothing
    End If
    
    
    
    
    lngReturnCode = objWSHShell.Run(programm&"Text2TIF.exe "&dateiname&".tff",0,True)
    
    
    If lngReturnCode <> 0 Then
        Err.clear
        errortxt="Emlconvert.vbs: Fehler bei Text2TIF.exe"
        objWshShell.LogEvent 1, errortxt
        
        
    End If
    
    WScript.Sleep 100
    fs.deletefile dateiname&".tff",True
    
End Function




'################################################################



Function DOCtoPS(dateiname)
    On Error Resume Next
    Err.clear
    erfolg=True
    'tempextension=extension
    
    Set wshnet = CreateObject("WScript.Network")
    If Err.number<>0 Then
        Err.clear
        On Error Resume Next
        errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (1) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
    End If
    
    If erfolg=True Then
        wshnet.SetDefaultPrinter "Serviceprinter"
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            errortxt="bitfarm-Archiv: Archivierung: Kann keinen Standarddrucker (2) festlegen. Entweder Serviceprinter nicht installiert oder Scripting Host Version zu alt."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
        Set wshnet=Nothing
    End If
    
    'If (isBusy=true) and (rundirect=false) Then
    '	objWshShell.LogEvent 1, "bitfarm-Archiv Serverdienst: Kollission mit einer weiteren Instanz entdeckt."
    '	WScript.Quit
    'End If
    
    
    If erfolg=True Then
        Set objWord = WScript.CreateObject("Word.Application")
        If Err.number <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="archivierung(11-5): Kein Word installiert oder Fehler beim Zugriff."
            objWshShell.LogEvent 1, errortxt
            erfolg=False
        End If
    End If
    
    
    'SavEnvAlert=objWord.Displayalerts
    'savenvBackground = objWord.Options.PrintBackground
    objWord.Visible = False
    objWord.DisplayAlerts = False
    objWord.Options.UpdateLinksAtOpen = True
    objWord.Options.UpdateLinksAtPrint = True
    
    objWord.Options.PrintBackgrounds = True
    objWord.Options.PrintHiddenText = False
    objWord.DisplayAlerts = False
    
    
    
    If erfolg=True Then
        Err.clear
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number <> 0 Then
                errortxt="archivierung(11-6): kann Serviceprinter.ps nicht lschen."
                objWshShell.LogEvent 1, errortxt
                erfolg=False
                Set objWord = Nothing
            End If
        End If
    End If
    
    Err.clear
    On Error Resume Next
    'objWord.ActivePrinter=Serviceprinter
    'If err.number <> 0 Then
    '	errortxt="archivierung(12b): Konfiguration Serviceprinter in Scripts.ini fehlerhaft."
    '	objWshShell.LogEvent 1, errortxt
    '	GetGarbage(dateiname)   
    '    	Unlock(programm&lockdatei)
    '	WScript.Quit
    'End If
    
    
    Err.clear
    
    
    
    If erfolg = True Then
        
        'lngReturnCode = objWSHShell.Run(programm&"processmonitor.bat WORD",0,true)
        WScript.Sleep 200
        On Error Resume Next
        Err.clear
        erfolg = False
        versuche = 0
        
        
        Do While erfolg = False And versuche < 3 
            Set wordDoc = objWord.Documents.Add (dateiname)
            
            
            If Err.number<>0 Then
                Set wordDoc = Nothing
                versuche = versuche +1
                errortxt="emlconvert: Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
                objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description & vbCrLf & "Versuche:" & versuche
                erfolg=False
                
                Err.clear
                WScript.Sleep 2000
                
                'Set objWord = nothing
                'On Error Resume next
                'err.clear
            Else
                erfolg = True
            End If
            
        Loop
        
    End If
    
    
    Err.Clear
    
    
    If erfolg=True Then	
        'MsgBox wordDoc.InlineShapes.Count
        
        If rescaleemlelements Then
            For i = 1 To wordDoc.InlineShapes.Count
                
                wordDoc.InlineShapes(i).scaleWidth=100
                wordDoc.InlineShapes(i).scaleHeight=100
                
                If Err.Number Then
                    Err.Clear
                End If
                
            Next
        End If  
        
        
        '############################################################################################
        
        
        'objWord.Options.AllowPixelUnits = True
        'objWord.Options.PrintDrawingObjects = True
        'objWord.Options.UpdateFieldsAtPrint = True
        objWord.ActiveDocument.PageSetup.Orientation = 0
        objWord.ActiveDocument.PageSetup.TopMargin = 21.4
        objWord.ActiveDocument.PageSetup.LeftMargin = 28.4
        objWord.ActiveDocument.PageSetup.RightMargin = 18.4
        objWord.ActiveDocument.PageSetup.BottomMargin = 18.4
        
        
        
        Err.Clear
        
        
    End If
    
    
    'objWord.ActiveDocument.PrintOut
    wordDoc.PrintOut False, , , , , , 0
    
    
    
    If Err.number<>0 Then
        
        errortxt="emlconvert: Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren." & vbCrLf & Err.Number & vbCrLf & Err.Description
        objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
        
        Err.clear
        erfolg=False
        On Error Resume Next
        Set wordDoc = Nothing
        Set objWord = Nothing
        On Error Resume Next
        Err.clear
    End If
    
    
    Err.clear
    
    '
    If erfolg=True Then
        'Wscript.Sleep 500
        'If officeOC R=false Then
        dateiname2 = fs.GetParentFolderName(dateiname) &"\"& fs.GetBaseName(dateiname)
        If Not fs.FileExists(dateiname2&".txt") Then
            
            'objWord.ActiveDocument.SaveAs mytempname&".txt", 2
            wordDoc.SaveAs mytempname&".txt", 2
            '
            '
            If Err.number<>0 Then
                errortxt="archivierung(100d): Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen als .txt gespeichert werden kann, ggf. nderungen vornehmen und erneut archivieren."
                objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
                '	erfolg=false
                '	On Error Resume Next
                Err.clear
                '	Set objWord = nothing
                '	On Error Resume Next
                '	err.clear
                '	
            End If
        End If
        '
        'err.clear
        'On Error Resume next
        '
        'If fs.fileexists(dateiname&".txt") Then
        'Typ="TXT"
        'End If
        'End If
    End If
    
    
    
    If erfolg=True Then
        
        'objWord.ActiveDocument.Saved = True
        wordDoc.Saved = True
        
        WScript.Sleep 100
        'objWord.ActiveDocument.Close
        wordDoc.Close()
        
        If Err.number<>0 Then
            
            errortxt="emlconvert: Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            erfolg=False
            On Error Resume Next
            Err.clear
            Set wordDoc = Nothing
            Set objWord = Nothing
            
            On Error Resume Next
            Err.clear
        End If
    End If
    
    If erfolg=True Then
        objWord.Quit
        Set wordDoc = Nothing
        Set objWord=Nothing
        
        
        
        If Err.number<>0 Then
            
            errortxt="emlconvert: Fehler bei MS-Office zu TIF Wandlung. Bitte prfen, ob das Dokument in Office ohne weitere Meldungen gedruckt werden kann, ggf. nderungen vornehmen und erneut archivieren."
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            erfolg=False
            
            Err.clear
            
        End If
    End If
    
    If erfolg=True Then
        If fs.FileExists(dateiname&".ps") Then
            fs.deletefile dateiname&".ps", True
            
        End If
    End If
    
    WScript.sleep 200
    If erfolg=True Then
        abbruch=False
        k=0
        Do While abbruch = False
            If fs.FileExists(temp&"Serviceprinter.ps") Then
                WScript.Sleep 400
                fs.CopyFile temp&"Serviceprinter.ps", dateiname&".ps", True
                If Err.number<>0 Then
                    errortxt="archivierung(11-7): konnte aus Postscript-Datei nicht kopieren."
                    objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
                    Err.clear
                    On Error Resume Next
                    erfolg=False
                    abbruch=True
                End If
                abbruch=True
            Else
                WScript.Sleep 200
                k=k+1
                If k>280 Then
                    abbruch=True
                End If
            End If
        Loop
    End If
    
    If erfolg=True Then	
        If fs.FileExists(temp&"Serviceprinter.ps") Then
            Err.clear
            fs.deletefile temp&"Serviceprinter.ps", True
            If Err.number<>0 Then
                Err.clear
                On Error Resume Next
            End If
        End If
        
        
        If Not fs.FileExists(dateiname&".ps") Then
            
            errortxt="emlconvert(11-8): konnte aus DOC-Datei keine PS-Datei erzeugen."
            objWshShell.LogEvent 1, errortxt & vbCrLf & Err.Number & vbTab & Err.Description
            erfolg=False
        End If
    End If
    
    
    If IsEmpty(objWord) = False Then
        Set objWord = Nothing 
    End If
    
    
    DOCtoPS=erfolg
    
End Function


Function PStoColorTIF(dateiname)
    On Error Resume Next
    Err.clear
    
    erfolg=True
    lngReturnCode = objWSHShell.Run(programm&"processmonitor.bat ghostscript",0,True)
    WScript.Sleep 200
    lngReturnCode = objWSHShell.Run(programm&"ghostscript.bat @"&programm&"tiff-OCR.rsp "&dateiname&"-temp.tif "&dateiname&".ps",0,True)
    If lngReturnCode <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="emlconvert(10-15): Fehler bei Ghostscript(Color)."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    If Not fs.fileexists(dateiname&"-temp.tif") Then
        Err.clear
        On Error Resume Next
        errortxt="emlconvert(10-16): Fehler bei Ghostscript: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
        objWshShell.LogEvent 1, errortxt
        erfolg=False
        
    End If
    
    If erfolg=True Then
        'lngReturnCode = objWSHShell.Run(programm&"filterv3.bat "&dateiname&"-temp.tif "&programm&"TIFF-300.txt "&dateiname&".tif",0,true)
        
        
        lngReturnCode = runfilter(dateiname&"-temp.tif",programm&"TIFF-300.txt",dateiname&".tif")
        
        If lngReturnCode <> 0 Then
            Err.clear
            On Error Resume Next
            errortxt="emlconvert(10-17): Fehler bei Filtern nach Ghostscript(Color)."
            objWshShell.LogEvent 1, errortxt
            GetGarbage(dateiname)   
            Unlock(programm&lockdatei)
            WScript.Quit
            
        End If
        WScript.Sleep 200
        
        
        If Not fs.fileexists(dateiname&".tif") Then
            Err.clear
            On Error Resume Next
            errortxt="emlconvert(10-18): Fehler beim Filtern: keine TIF-Datei erzeugt. Mglicherweise zu wenig freier Festplattenspeicher."
            objWshShell.LogEvent 1, errortxt
            erfolg = False
            
        Else
            If fs.fileexists(dateiname&"-temp.tif") Then
                fs.deletefile(dateiname&"-temp.tif"),True
            End If
            
        End If
    End If
    
    PStoColorTIF=erfolg
    
    
End Function



Function runFilter(param1,param2,param3)
    On Error Resume Next
    
    
    If Not fs.Fileexists(param2) Then
        'Filterdatei nicht vorhanden
        objWshShell.LogEvent 1, "emlconvert.vbs.vbs: Filterdatei nicht vorhanden:" & param2
        runfilter = 4
        abbruch = True
        
    Else
        
        runfilter=0
        
        Filterrun = objWSHShell.Run(programm&"filterv3.bat "&param1&" "&param2&" "&param3,0,True)
        
        
        '******************************** auf Ergebnis warten ****************************
        WScript.Sleep 1000
        abbruch=False
        
        '	If testfilter = False Then				' FilterV3 schon terminiert
        '		abbruch = True
        '	End If
        '	
        
    End If
    
    a=0
    wartezeit=2000
    Do While abbruch = False
        
        If checkfilter=0 Then
            
            abbruch=True
        End If
        
        
        If abbruch = False Then
            
            zaehler3=0
            zaehler2=0
            abbruch2=False
            WScript.Sleep 500
            Do While abbruch2=False
                
                
                mycheck=0
                mycheck=checkfilter
                
                If mycheck=3 Then
                    zaehler3=zaehler3+1
                End If
                
                If mycheck=2 Then
                    zaehler2=zaehler2+1
                    If zaehler3>0 Then
                        zaehler2=zaehler2+zaehler3
                        zaehler3=0
                    End If
                End If	
                
                If mycheck=1 Then
                    abbruch2=True
                End If
                
                If mycheck=0 Then
                    abbruch=True
                    abbruch2=True
                End If
                
                If zaehler3>10 Then
                    abbruch2=True
                    abbruch=True
                    a=wartezeit
                    runfilter=3
                End If
                
                If zaehler2>35 Then
                    abbruch2=True
                    abbruch=True
                    a=wartezeit
                    runfilter=2
                End If
                
                If abbruch2=False Then
                    WScript.sleep 1500
                End If
            Loop
            
            
        End If
        
        If abbruch=False Then	
            WScript.Sleep 1000
        End If
        a = a + 1
        If a>=wartezeit Then
            abbruch=True
        End If
    Loop
    
    WScript.sleep 50
    
    
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='FilterV3.exe'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        objItem.Terminate()
        z=z+1
    Next
    If z>0 Then
        objWshShell.LogEvent 2, "bitfarm-Archiv: emlconvert: Filter-Prozess terminiert bei "&tempname
        
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
    ende2 = Timer
    
End Function


Function checkfilter
    On Error Resume Next
    
    
    checkfilter=0
    If scriptdebug=True Then
        Set mydebugfile = fs.OpenTextFile(tempname&".log",8,True)
    End If	
    
    
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'FilterV3'")
    WScript.Sleep 50
    
    oldtestcounter1=0
    oldtestcounter2=0
    oldtestcounter3=0
    oldtestcounter4=0
    oldtestcounter5=0
    oldtestcounter6=0
    oldtestcounter7=0
    newtestcounter1=0
    newtestcounter2=0
    newtestcounter3=0
    newtestcounter4=0
    newtestcounter5=0
    newtestcounter6=0
    newtestcounter7=0
    
    kette=""
    
    For Each strProcess In colProcesses
        oldtestcounter1=strProcess.IOReadBytesPerSec
        oldtestcounter2=strProcess.IOReadOperationsPerSec
        oldtestcounter3=strProcess.IOWriteBytesPerSec
        oldtestcounter4=strProcess.IOWriteOperationsPerSec
        oldtestcounter5=strProcess.IOOtherBytesPerSec
        oldtestcounter6=strProcess.IOOtherOperationsPerSec
        oldtestcounter7=strProcess.PercentProcessorTime
        
    Next
    'Set colProcess=nothing
    'Set objWMIService=nothing
    WScript.Sleep 2000
    'Set objWMIService = GetObject("winmgmts:" _
    ' & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    'WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = 'FilterV3'")
    WScript.Sleep 50
    
    kette=""
    mycounter1=0
    For Each strProcess In colProcesses
        newtestcounter1=strProcess.IOReadBytesPerSec
        newtestcounter2=strProcess.IOReadOperationsPerSec
        newtestcounter3=strProcess.IOWriteBytesPerSec
        newtestcounter4=strProcess.IOWriteOperationsPerSec
        newtestcounter5=strProcess.IOOtherBytesPerSec
        newtestcounter6=strProcess.IOOtherOperationsPerSec
        newtestcounter7=strProcess.PercentProcessorTime
        mycounter1=mycounter1+1
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    
    
    test1diff=0
    test2diff=0
    test3diff=0
    test4diff=0
    test5diff=0
    test6diff=0
    test7diff=0
    
    test1diff=strconvert(Trim(newtestcounter1))-strconvert(Trim(oldtestcounter1))
    test2diff=strconvert(Trim(newtestcounter2))-strconvert(Trim(oldtestcounter2))
    test3diff=strconvert(Trim(newtestcounter3))-strconvert(Trim(oldtestcounter3))
    test4diff=strconvert(Trim(newtestcounter4))-strconvert(Trim(oldtestcounter4))
    test5diff=strconvert(Trim(newtestcounter5))-strconvert(Trim(oldtestcounter5))
    test6diff=strconvert(Trim(newtestcounter6))-strconvert(Trim(oldtestcounter6))
    test7diff=strconvert(Trim(newtestcounter7))-strconvert(Trim(oldtestcounter7))
    
    If scriptdebug=True Then
        mydebugfile.writeline("Checkfilter: "&test1diff&"	:"&test2diff&"	:"&test3diff&"	:"&test4diff&"	:"&test5diff&"	:"&test6diff&"	:"&test7diff)
        
    End If
    
    If test7diff>0 Then
        checkfilter=2
    End If
    
    zaehler1=0
    If test1diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test2diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test3diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test4diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test5diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test6diff>0 Then
        zaehler1=zaehler1+1
    End If
    If test7diff>0 Then
        zaehler1=zaehler1+1
    End If
    
    If zaehler1>2 Then
        checkfilter=1
    End If
    
    If zaehler1=0 Then
        checkfilter=3
    End If
    
    
    If (test1diff>0) And (test2diff>0) And (test3diff=0) And (test4diff=0) And (test5diff>0) And (test6diff=0) And (test7diff>0) Then
        checkfilter=3
    End If 
    
    If checkfilter=2 Then
        If (test1diff=0) And (test2diff=0) And (test3diff=0) And (test4diff=0) And (test5diff=0) And (test6diff=0) Then
            checkfilter=3
        End If 
    End If
    
    If (test1diff=0) And (test2diff=0) And (test3diff=0) And (test4diff=0) And (test5diff=0) And (test6diff=0) And (test7diff=0) Then
        checkfilter=0
    End If 
    
    
    If scriptdebug=True Then
        mydebugfile.writeline("Checkfilter: "&checkfilter)
        mydebugfile.close
        Set mydebugfile=Nothing
    End If
    
    
End Function			

