'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  ghostscriptwatcher.vbs   GPL  ********************************************
'*******************************************************************************************
'***************  Version 3.6.2.0               ********************************************
'*******************************************************************************************
'***************  Programm zur berwachung der ghostscript.bat               ***************
'***************  wird kein Ghostscript Child Prozess gefunden, wird         ***************
'***************                                                             ***************
'***************  ghostscript.bat terminiert um ein einfrieren der           ***************
'***************  Archivierung zu verhindern.                                ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>ghostscriptwatcher.vbs               ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next


Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set oArgs    = WScript.Arguments 

myprocessname=""
myprocessexe=""

bit32 = False
bit64 = False

OSBitWidth()


myprocess="cmd"


'****************************************************************************
'****************************************************************************
'******************************** Bekannte Prozesse *************************
'****************************************************************************
'****************************************************************************

If LCase(myprocess)="cmd" Then
    myprocessname="cmd"
    myprocessexe="cmd.exe"
End If

'****************************************************************************
'****************************************************************************
'****************************************************************************
'****************************************************************************
'****************************************************************************
'****************************************************************************



If myprocessname="" Then
    objWshShell.LogEvent 4, "bitfarm-Archiv: processmonitor: Nicht definierter Prozess: "&myprocess
    WScript.Quit
End If

i=0
i2=0
zeile=""
gotGhost=False
stemp=""
procID=0
abbruch=False
Do While abbruch=False
    WScript.sleep 300
    i=i+1
    If i>10 Then 
        abbruch=True
    End If
    'wenn cmd gefunden
    If testprocess=True Then
    	'cmd suchen das die ghostscript.bat ausfhrt
    	Do While gotGhost=False And (i2 <= 10)
    		Set objWMIService = GetObject("winmgmts:" _
    		& "{impersonationLevel=impersonate}!\\.\root\cimv2")
    		
    		strQuery="SELECT * FROM Win32_Process WHERE Name = '"&myprocessexe & "' AND CommandLine like '%ghostscript.bat%'"
    		
    		Set colItems = objWMIService.ExecQuery(strQuery,,48) 
			
			For Each objItem In colItems
				procID=objItem.processid
			Next
			
			Set colItems = objWMIService.ExecQuery( _
    		"SELECT * FROM Win32_Process" & _
    		" WHERE ParentProcessId = " & procID ,,48)
    		
    		If bit32 Then sTemp="gswin32c.exe"
			If bit64 Then sTemp="gswin64c.exe"
			
			For Each objItem In colItems
				gotGhost = (LCase(objItem.Name) = LCase(sTemp)) 
			Next
		
    		i2=i2+1
    		WScript.Sleep 500
    		Set objWMIService=Nothing
    		Set colItems=Nothing
    	Loop
    	'wenn 10 mal durchlaufen und kein ghostscript gefunden, dann cmd die die ghostscript.bat ausfhrt terminieren
    	If Not gotGhost And (i2 > 10) Then
    		'Killen des prozesses
    		Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    		strQuery = "Select * from Win32_Process where processid="&procID
    		Set colItems = objWMIService.ExecQuery(strQuery,,48)
    		
    		objWshShell.LogEvent 4, "Ghostscriptwatcher: Terminiere ghostscript.bat wegen Timeout!"
    		For Each objItem In colItems
        		objItem.Terminate()
      		Next
    
    		Set colItems = Nothing
    		Set objWMIService = Nothing
    		
    	End If	
        abbruch=True
    End If
Loop

WScript.sleep 1000	
WScript.quit


Sub OSBitWidth
	Bits = GetObject("winmgmts:root\cimv2:Win32_Processor='cpu0'").AddressWidth
	If Bits = 32 then
		bit32 = True
		bit64 = False
	End If 
	If Bits = 64 then
		bit32 = False
		bit64 = True
	End If 
End sub

Function testprocess
    On Error Resume Next
    testprocess=False
    Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    strQuery = "Select * from Win32_Process where Name='"&myprocessexe&"'"
    Set colItems = objWMIService.ExecQuery(strQuery,,48)
    z=0
    For Each objItem In colItems
        
        z=z+1
    Next
    If z>0 Then
        testprocess=True
    End If
    
    Set colItems = Nothing
    Set objWMIService = Nothing
End Function
