unit Unit2;

interface

uses
//  ShareMem,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, System.NetEncoding, bfaCommonMethods, bitfarm_enterprise;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Label2: TLabel;
    Button3: TButton;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Button4: TButton;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

  TGetAnnoText = function(server: PChar; port: Integer; db, user,pass: PChar; gdocid: Int64): PChar; stdcall;
  TGetLastError = function: Integer; stdcall;
  TGetAnnoSVG = function(server: PChar; port: Integer; db, user,pass: PChar; gdocid: Int64): PChar; stdcall;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//function GetAnno(server,port,user,pass: PChar; gdocid: Int64): PChar; stdcall; external 'AnnoText.dll';


procedure TForm1.Button1Click(Sender: TObject);
var
 Handle: THandle;
 anntext : TGetAnnoText;
begin

  Handle := LoadLibrary('AnnoText64.DLL');
  if Handle <> 0 then
  begin
     @anntext := GetProcAddress(Handle, 'GetAnnoText');

      if @anntext <> nil then
      begin
         try
           Label1.Caption :=  anntext('pcfs1', 3306, 'bitfarm362',
                                PChar(Encrypt('sa', GlobalKey)), PChar(Encrypt('bitfarmIT', GlobalKey)), StrToInt64(Edit1.Text))
         except
           Label1.Caption := 'Exception';
         end;
      end;
      FreeLibrary(Handle);
  end;


end;



procedure TForm1.Button2Click(Sender: TObject);
var
 Handle: THandle;
 error : TGetLastError;
begin

  Handle := LoadLibrary('AnnoText64.DLL');
  if Handle <> 0 then
  begin
     @error := GetProcAddress(Handle, 'GetLastError');

      if @error <> nil then
      begin
         try
           Label2.Caption :=  IntToStr(error())
         except
           Label2.Caption := 'Exception';
         end;
      end;
      FreeLibrary(Handle);
  end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var
 Handle: THandle;
 annosvg : TGetAnnoSVG;
 psvg: PWideChar;
 fs: TFileStream;
 i: Integer;
begin
  i := 0;
  Handle := LoadLibrary('AnnoText64.DLL');
  if Handle <> 0 then
  begin
     @annosvg := GetProcAddress(Handle, 'GetAnnoSVG');

    if @annosvg <> nil then
    begin
       try

         psvg :=  annosvg(PChar(Edit2.Text), StrToInt(Edit3.Text), PChar(Edit4.Text),
                    PChar(Encrypt(Edit5.Text, GlobalKey)),PChar(Encrypt(Edit6.Text, GlobalKey)), StrToInt64(Edit1.Text));

          while FileExists('c:\test\svgstream' + IntToStr(i) +'.svg') do
            inc(i);

          fs := TFileStream.Create('c:\test\svgstream' + IntToStr(i) +'.svg', fmCreate);
          fs.WriteBuffer(psvg[0], Length(psvg) * 2);
          fs.Free;

       except
         Label2.Caption := 'Exception';
       end;
    end;
    FreeLibrary(Handle);
  end;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
 Handle: THandle;
 anntext : TGetAnnoText;
begin

  Handle := LoadLibrary('AnnoText64.DLL');
  if Handle <> 0 then
  begin
     @anntext := GetProcAddress(Handle, 'GetAnnoText');

      if @anntext <> nil then
      begin
         try
           Label4.Caption :=  anntext(PChar(Edit2.Text), StrToInt(Edit3.Text), PChar(Edit4.Text),
                                  PChar(Encrypt(Edit5.Text, GlobalKey)), PChar(Encrypt(Edit6.Text, GlobalKey)), StrToInt64(Edit1.Text))
         except
           Label4.Caption := 'Exception';
         end;
      end;
      FreeLibrary(Handle);
  end;


end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #13) and (Edit1.Text <> '') then
    Button1Click(Sender);
end;

end.


