program HotSearch36;

{$R 'dpiAware.res' 'dpiAware.rc'}

uses
  Windows,
  Forms,
  SysUtils,
  u_Main in 'u_Main.pas' {frm_Main},
  u_ttwvl in 'u_ttwvl.pas',
  u_screenshot in 'u_screenshot.pas' {Form2},
  USingleInst in 'USingleInst.pas';

{$R *.res}
{$SETPEFLAGS IMAGE_FILE_NET_RUN_FROM_SWAP or IMAGE_FILE_LARGE_ADDRESS_AWARE or IMAGE_FILE_RELOCS_STRIPPED}
{$SetPEOptFlags IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER_AWARE}



  procedure StartViewer;
  var
    str, aktStr : string;
    i : Integer;
  begin
    try
      str := '';

      i := 1;
      while i <= paramcount do
      begin
        if pos('-time', paramstr(i)) > 0 then //HotSearch Parameter nicht fr Viewer
          inc(i)
        else if pos('-debug', paramstr(i)) > 0 then //HotSearch Parameter nicht fr Viewer
        begin
          //
        end
        else //Parameters fr Viewer
        begin
          if ((Pos('-l:', LowerCase(ParamStr(i))) > 0) or
             (Pos('-a:', LowerCase(ParamStr(i))) > 0))
             and (Pos(' ', LowerCase(ParamStr(i))) > 0) then
            aktStr := Copy(ParamStr(i), 1, 3) + '"' + Copy(ParamStr(i), 4, Length(ParamStr(i)) - 3) + '"'
          else
            aktStr := ParamStr(i);

          if str = '' then
            str := str + aktStr
          else
            str := str + ' ' + aktStr;
        end;
        inc(i);
      end;

      if str <> '' then
        StartViewerWithParameters(nil, 'HotSearch36', str);
    except;

    end;
  end;

begin
  if SingleInst.CanStartApp then
  begin
    Application.Initialize;
    Application.Title := 'bitfarm Archiv V36 - HotSearch Tool';
    Application.CreateForm(Tfrm_Main, frm_Main);
    StartViewer;
    Application.Run;
  end
  else
    StartViewer;
end.








