unit u_screenshot;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm2 = class(TForm)
    image1: TImage;
    img1: TImage;
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

    procedure image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    SelX,SelY,SelX1,SelY1 : integer; // Selection rectangle
    DoSelect : boolean;
  end;

var
  Form2: TForm2;
  x1, y1, x2, y2 : Integer;
  start : Boolean;



implementation

uses u_Main;

{$R *.dfm}

procedure TForm2.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Key = 27 then
  begin
    frm_Main.fsOCR := '';
    Self.Close;
    Screen.Cursor := crDefault;

  end;

end;


procedure TForm2.image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   //if DoSelect then begin
     DoSelect := True;
     SelX := X;
     SelY := Y;
     SelX1 := X;
     SelY1 := Y;
     with Image1.Canvas do
     begin                    // Options shown in comments
        Pen.Width := 1;      // 2; // use with solid pen style
        Pen.Style := psDashDotDot; // psSolid;
        Pen.Mode := pmNotXOR; // pmXor;
        Brush.Style := bsClear;
        Pen.Color := clBlue; // clYellow;
     end;
   //end;
end;

procedure TForm2.image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  DestRect, SourceRect : TRect;
begin

  if DoSelect then begin
    Image1.Canvas.Rectangle(SelX,SelY,SelX1,SelY1);   // invert selection rect
    // Change coordinates if the user has drawn a rectangle 'backwards'
    // i.e. to left or above starting point, SelX,SelY
    if X <= SelX then
    begin
      SelX1 := SelX;
      SelX := X;
    end
    else
      SelX1 := X;

    if Y <= SelY then
    begin
      SelY1 := SelY;
      SelY := Y;
    end
    else
      SelY1 := Y;

    Image1.Canvas.Pen.Mode := pmCopy;
    SourceRect := Rect(SelX,SelY,SelX1,SelY1);
    DestRect := Rect(0,0,SelX1-SelX,SelY1-SelY);
    img1.BoundsRect := SourceRect;

    img1.Canvas.CopyRect(DestRect,Image1.Canvas,SourceRect);
    //Image1.Picture.Bitmap.Height := SelY1-SelY;
    //Image1.Picture.Bitmap.Width := SelX1-SelX;
    //Image1.SetBounds(0,0,SelX1-SelX,SelY1-SelY);
    img1.Picture.Bitmap.PixelFormat := pf24bit;
    //img1.Picture.SaveToFile('d:\test\test.bmp');
    DoSelect := false;
    //if FormIsFullScreen then
    //  RestoreForm;

    Self.Close;
    Screen.Cursor := crDefault;
    
    if  (SelX1-SelX > 10) and (SelY1-SelY >10) then
      frm_Main.getocrtext(img1.Picture.Bitmap);


  end;
end;

procedure TForm2.image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if DoSelect then begin
     if ssLeft in Shift then
     begin
      Image1.Canvas.Rectangle(SelX,SelY,SelX1,SelY1); // invert selection rect
      SelX1 := X;
      SelY1 := Y;
      Image1.Canvas.Rectangle(SelX,SelY,SelX1,SelY1); // draw new selection rect
     end;
   end;
end;


procedure TForm2.FormShow(Sender: TObject);
begin
  DoSelect := False;
  Screen.Cursor := crCross;
end;



procedure TForm2.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;

end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form2 := nil;
  Action := caFree;
end;

end.

