unit u_bfaMainMenuGPL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, TB2Item, SpTBXItem, TB2Dock, TB2Toolbar, ImgList;

type
  TbfaMainMenu = class(TFrame)
    tlbMainMenu: TSpTBXToolbar;
    mnuFiles: TSpTBXSubmenuItem;
    mnuRelogin: TSpTBXItem;
    mnuChangePassword: TSpTBXItem;
    SpTBXSeparatorItem1: TSpTBXSeparatorItem;
    mnuLocalSave: TSpTBXSubmenuItem;
    mnuEmail: TSpTBXSubmenuItem;
    mnuPrint: TSpTBXSubmenuItem;
    SpTBXSeparatorItem2: TSpTBXSeparatorItem;
    mnuQuit: TSpTBXItem;
    mnuLocalSavePDF: TSpTBXItem;
    mnuLocalSaveTIF: TSpTBXItem;
    mnuLocalSaveOriginal: TSpTBXItem;
    mnuEmailTIFAttachment: TSpTBXItem;
    mnuEmailOriginal: TSpTBXItem;
    mnuEmailLink: TSpTBXItem;
    mnuPrintStandard: TSpTBXItem;
    mnuPrintSelect: TSpTBXItem;
    mnuPrintPreview: TSpTBXItem;
    mnuView: TSpTBXSubmenuItem;
    mnuViewNavigation: TSpTBXItem;
    mnuViewSearchOptions: TSpTBXItem;
    mnuViewPreview: TSpTBXItem;
    mnuViewThumbnails: TSpTBXItem;
    tlbMainMenuSeparatorItem3: TSpTBXSeparatorItem;
    tbsubSkin: TSpTBXSubmenuItem;
    tlbMainMenuSkinGroupItem1: TSpTBXSkinGroupItem;
    tlbMainMenuSeparatorItem4: TSpTBXSeparatorItem;
    mnuDeleteColumnOrder: TSpTBXItem;
    SpTBXSeparatorItem5: TSpTBXSeparatorItem;
    mnuOptions: TSpTBXItem;
    mnuBookmarks: TSpTBXSubmenuItem;
    mnuCreateBookmark: TSpTBXItem;
    SpTBXSeparatorItem6: TSpTBXSeparatorItem;
    mnuGetLastDocument: TSpTBXItem;
    mnuGetDoc1: TSpTBXItem;
    mnuGetDoc2: TSpTBXItem;
    mnuGetDoc3: TSpTBXItem;
    mnuGetDoc4: TSpTBXItem;
    mnuGetDoc5: TSpTBXItem;
    SpTBXSeparatorItem7: TSpTBXSeparatorItem;
    mnuSetDoc1: TSpTBXItem;
    mnuSetDoc2: TSpTBXItem;
    mnuSetDoc3: TSpTBXItem;
    mnuSetDoc4: TSpTBXItem;
    mnuSetDoc5: TSpTBXItem;
    mnuTools: TSpTBXSubmenuItem;
    mnuRestoreOriginal: TSpTBXItem;
    mnuDocEditor: TSpTBXItem;
    mnuRefreshDoc: TSpTBXItem;
    mnuMergeDoc: TSpTBXItem;
    mnuDuplicateDoc: TSpTBXItem;
    mnuExportMeta: TSpTBXSubmenuItem;
    mnuExportCSV: TSpTBXItem;
    mnuExportXLS: TSpTBXItem;
    mnuExportOO: TSpTBXItem;
    mnuDeleteDoc: TSpTBXItem;
    mnuGraphic: TSpTBXSubmenuItem;
    mnuGraphicOptions: TSpTBXItem;
    mnuInverted: TSpTBXItem;
    mnuDeScrew: TSpTBXItem;
    mnuDeSpeckle: TSpTBXItem;
    mnuRemoveBorder: TSpTBXItem;
    mnuRotateLeft: TSpTBXItem;
    mnuFlip: TSpTBXItem;
    mnuRotateRight: TSpTBXItem;
    mnuHelp: TSpTBXSubmenuItem;
    mnuInfo: TSpTBXItem;
    mnuSupport: TSpTBXItem;
    mnuAuditProof: TSpTBXItem;
    tlbMainMenuSeparatorItem8: TSpTBXSeparatorItem;
    tbsubToolbars: TSpTBXSubmenuItem;
    mStandard: TSpTBXItem;
    mTools: TSpTBXItem;
    mGraphic: TSpTBXItem;
    mPreview: TSpTBXItem;
    mnuEditTags: TSpTBXItem;
    mnuNewLink: TSpTBXItem;
    tlbMainMenuSeparatorItem5: TSpTBXSeparatorItem;
    tbsubLanguages: TSpTBXSubmenuItem;
    mnuLanguageDE: TSpTBXItem;
    mnuLanguageEN: TSpTBXItem;
    tlbMainMenuSeparatorItem6: TSpTBXSeparatorItem;
    tbsubLayout: TSpTBXSubmenuItem;
    tbiLayoutSave: TSpTBXItem;
    tbiLayoutDelete: TSpTBXItem;
    tbiLayoutStandard: TSpTBXItem;
    mnuLocalSavePreview: TSpTBXItem;
    mnuEmailPreview: TSpTBXItem;
    mnuShowAllSymbolicLinks: TSpTBXItem;
    mnuDeleteSymbolicLink: TSpTBXItem;
    mnuCreateEmptyDoc: TSpTBXItem;
    TBSeparatorItem1: TTBSeparatorItem;
    TBSeparatorItem2: TTBSeparatorItem;
    mnuCopyToClipboard: TSpTBXSubmenuItem;
    mnuDocLinkToClipboard: TSpTBXItem;
    mnuPageToClipboard: TSpTBXItem;
    mnuOriDocToClipboard: TSpTBXItem;
    mnuDocToClipboard: TSpTBXItem;
    mnuLocalSaveLink: TSpTBXItem;
    mnuEmailPDFAttachment: TSpTBXItem;
    mnuCreateBookmarkForGDocID: TSpTBXItem;
    mnuAddLink: TSpTBXSubmenuItem;
    mnuCreateBookmarkDialog: TSpTBXItem;
    mnuResetDLM: TSpTBXItem;
    mnuChangeProfile: TSpTBXSubmenuItem;
    mnuSaveImportValues: TSpTBXItem;
    mQueueCount: TSpTBXItem;
    mResubFavorites: TSpTBXItem;
    mnuViewFloatingWVL: TSpTBXItem;
    mnuVideos: TSpTBXItem;
    mnuHandbooks: TSpTBXItem;
  private
    { Private-Deklarationen }
    function GetImageList: TCustomImageList;
    procedure SetImageList(const Value: TCustomImageList);
  public
    { Public-Deklarationen }
  published
    property Images: TCustomImageList read GetImageList write SetImageList;
  end;

implementation

{$R *.dfm}

{ TbfaMainMenu }

function TbfaMainMenu.GetImageList: TCustomImageList;
begin
  Result := tlbMainMenu.Images;
end;

procedure TbfaMainMenu.SetImageList(const Value: TCustomImageList);
begin
  tlbMainMenu.Images := Value;
end;

end.
