unit LinkMailForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SpTBXControls, StdCtrls, SpTBXEditors, u_bfaSelector, SpTBXItem, gnugettext;

type
  TfrmLinkMails = class(TForm)
    SpTBXPanel1: TSpTBXPanel;
    bfsLinkMail: TbfaSelector;
    edtRecp: TSpTBXEdit;
    btnOK: TSpTBXButton;
    btnCancel: TSpTBXButton;
    SpTBXLabel1: TSpTBXLabel;
    SpTBXLabel2: TSpTBXLabel;
    SpTBXLabel3: TSpTBXLabel;
    mmoBody: TMemo;
    procedure FormShow(Sender: TObject);
    procedure Retranslate;
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;


implementation

uses
  MainDataModule, bfaCommonUtils, bfaLog;

{$R *.dfm}

procedure TfrmLinkMails.FormCreate(Sender: TObject);
begin
  TranslateComponent(Self, 'ViewerV36');
end;

procedure TfrmLinkMails.Retranslate;
var
  i: integer;
begin
  ReTranslateComponent(Self, 'ViewerV36');
  for i := 0 to ComponentCount-1 do
  begin
    if Components[i] is tbfaSelector then
    begin
      tbfaSelector(Components[i]).ReTranslate;
    end;
  end;
end;

procedure TfrmLinkMails.FormShow(Sender: TObject);
begin
  try
    bitfarmApp.ReadEmailUser;
  except
    bitfarmLog.Write(llNormal, ltException, 'FormShow', ClassName);
  end;
end;

end.
