unit bfaAnnoOptionsDialog;

interface

uses
  gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls, Registry, ievect, ImageEnView,
  ieview, hyiedefs, hyieutils, ImageEnProc, JvExStdCtrls, JvCombobox,
  JvListComb, System.UITypes,
  Mask, JvExMask, JvSpin,
  JvColorCombo, ImgList, System.ImageList, SpTBXEditors, cxGraphics, cxControls,
  cxLookAndFeels, cxLookAndFeelPainters, cxContainer, cxEdit, cxTextEdit,
  cxMaskEdit, cxDropDownEdit, cxRadioGroup, Vcl.Menus, cxButtons, cxButtonEdit,
  Vcl.NumberBox, SpTBXItem, SpTBXControls, bfaTabSheet, cxCheckBox
  {$IFDEF IMAGEEN1140}
  , iexBitmaps, iesettings,
  iexLayers, iexRulers, iexToolbars, iexUserInteractions, imageenio,
  iexProcEffects
  {$ENDIF}
  ;

type
  TListView = class(comctrls.TListView)
  protected
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMRButtonDown(var Message: TWMRButtonDown); message WM_RBUTTONDOWN;
    procedure WMLButtonDblClk(var Message: TWMRButtonDown); message WM_LBUTTONDBLCLK;
    procedure WMRButtonDblClk(var Message: TWMRButtonDown); message WM_RBUTTONDBLCLK;
  end;

  Tfrm_DocEditOpt = class (TForm)
    pctrl_DocEditOpt: TPageControl;
    tbs_Annotations: TbfaTabSheet;
    btn_Cancel: TSpTBXButton;
    btn_Save: TSpTBXButton;
    btn_ok: TSpTBXButton;
    tctrl_Annos: TTabControl;
    grbx_Color: TSpTBXGroupBox;
    lbl_CBackground: TLabel;
    lbl_CBorder: TLabel;
    lbl_CLabel: TLabel;
    lbl_CNoteBorder: TLabel;
    clbx_CBackground: TColorBox;
    clbx_CBorder: TColorBox;
    clbx_CLabel: TColorBox;
    clbx_CNoteBorder: TColorBox;
    grbx_Brush: TSpTBXGroupBox;
    lbl_BBackground: TLabel;
    lbl_BBorder: TLabel;
    lbl_BLabel: TLabel;
    lbl_BNoteBorder: TLabel;
    grbx_Shape: TSpTBXGroupBox;
    lbl_SShapeStart: TLabel;
    lbl_SShapeEnd: TLabel;
    lbl_SSHeight: TLabel;
    lbl_SSWidth: TLabel;
    pnl_SShape: TPanel;
    rbtn_SENo: TSpTBXRadioButton;
    rbtn_SEOut: TSpTBXRadioButton;
    rbtn_SEIn: TSpTBXRadioButton;
    rbtn_SSNo: TSpTBXRadioButton;
    rbtn_SSOut: TSpTBXRadioButton;
    rbtn_SSIn: TSpTBXRadioButton;
    edt_SSHeight: TNumberBox;
    edt_SSWidth: TNumberBox;
    grbx_Text: TSpTBXGroupBox;
    lbl_TFont: TLabel;
    lbl_TFontAngle: TLabel;
    lbl_TFontSize: TLabel;
    sbtn_TFont: TcxButton;
    lbl_TLabelPos: TLabel;
    lbl_TAlign: TLabel;
    lbl_TGrad: TLabel;
    edt_TFont: TSpTBXEdit;
    edt_TFontAngle: TNumberBox;
    edt_TFontSize: TNumberBox;
    cbx_TLabelPos: TComboBox;
    cbx_TAlign: TComboBox;
    memo_TObjText: TMemo;
    dlg_Schrift: TFontDialog;
    tbs_Stempel: TbfaTabSheet;
    grbx_Stamps: TSpTBXGroupBox;
    lv_Stamps: TListView;
    grp_StampBorder: TSpTBXGroupBox;
    btn_NewStamp: TSpTBXButton;
    btn_SaveStamp: TSpTBXButton;
    btn_DelStamp: TSpTBXButton;
    lbl_SName: TLabel;
    lbl_STyp: TLabel;
    memo_SText: TMemo;
    lbl_SText: TLabel;
    lbl_SBild: TLabel;
    edt_SName: TSpTBXEdit;
    rbtn_SText: TSpTBXRadioButton;
    rbtn_SBild: TSpTBXRadioButton;
    edt_SBild: TSpTBXEdit;
    sbtn_SBild: TcxButton;
    lbl_SFont: TLabel;
    edt_SFont: TSpTBXEdit;
    sbtn_SFont: TcxButton;
    img_SBild: TImageEnView;
    lbl_SWidth: TLabel;
    edt_SHeight: TSpTBXEdit;
    edt_SWidth: TSpTBXEdit;
    lbl_SWidthMes: TLabel;
    lbl_Stemp_how2: TLabel;
    lv_eigenschaftstempel: TListView;
    grbx_Algem: TSpTBXGroupBox;
    lbl_AObjName: TLabel;
    lbl_APenWidth: TLabel;
    lbl_ARulerTyp: TLabel;
    lbl_ARulerMeasure: TLabel;
    lbl_ATransp: TLabel;
    lbl_APixel: TLabel;
    lbl_objheight: TLabel;
    lbl_objwidth: TLabel;
    edt_AObjName: TSpTBXEdit;
    edt_APenWidth: TNumberBox;
    cbx_ARulerTyp: TComboBox;
    cbx_ARulerMes: TComboBox;
    chbx_AOpenPoly: TSpTBXCheckBox;
    chbx_AIsHiLite: TSpTBXCheckBox;
    chbx_ASizeable: TSpTBXCheckBox;
    chbx_AMoveable: TSpTBXCheckBox;
    edt_ATransp: TNumberBox;
    edt_objheight: TNumberBox;
    Edt_objwidth: TNumberBox;
    cbx_nummer: TComboBox;
    lbl_nummer: TLabel;
    chbx_TObjAutoSize: TSpTBXCheckBox;
    cbx_BBackground: TJvImageComboBox;
    cbx_BBorder: TJvImageComboBox;
    cbx_BLabel: TJvImageComboBox;
    cbx_BNoteBorder: TJvImageComboBox;
    lbl1: TLabel;
    lbl_Textstyle: TLabel;
    lbl_Stampcolor: TLabel;
    clrbx_Stampborder: TColorBox;
    clrbx_Stampcolor: TColorBox;
    cbx_Textstyle: TJvImageComboBox;
    cbx_Stampstyle: TJvImageComboBox;
    cbx_Stampborder: TJvImageComboBox;
    lbl_Stampborder: TLabel;
    lbl_Deckkraft: TLabel;
    edt_Deckkraft1: TNumberBox;
    lbl_DeckkraftProzent: TLabel;
    btn_Transparenz: TSpTBXSpeedButton;
    btn_TranspSpeichern: TSpTBXButton;
    cbb_fav: TJvImageComboBox;
    btn_Textvariable: TSpTBXButton;
    grp_StampAction: TSpTBXGroupBox;
    rbtn_StampStatefield: TcxRadioButton;
    rbtn_StampNoAction: TcxRadioButton;
    rbtn_StampPlugin: TcxRadioButton;
    cbx_StampAction: TcxComboBox;
    Image1: TImage;
    chk_fixedsize: TcxCheckBox;
    chk_Anpassen: TcxCheckBox;
    chkClipboard: TcxCheckBox;
    cbx_autoincreasehigh: TSpTBXCheckBox;
    cbx_autolineincrease: TSpTBXCheckBox;
    procedure btn_SaveClick(Sender: TObject);
    procedure tctrl_AnnosChange(Sender: TObject);
    procedure tctrl_AnnosChanging(Sender: TObject; var AllowChange: Boolean);
    procedure btn_okClick(Sender: TObject);
    procedure edt_SSHeightChange(Sender: TObject);
    procedure edt_SSWidthChange(Sender: TObject);
    procedure edt_APenWidthChange(Sender: TObject);
    procedure edt_ATranspChange(Sender: TObject);
    procedure edt_TFontAngleChange(Sender: TObject);
    procedure edt_TFontSizeChange(Sender: TObject);
    procedure cbx_TLabelPosChange(Sender: TObject);
    procedure cbx_TAlignChange(Sender: TObject);
    procedure cbx_ARulerTypChange(Sender: TObject);
    procedure cbx_ARulerMesChange(Sender: TObject);
    procedure sbtn_TFontClick(Sender: TObject);
    procedure load_SBild;
    procedure btn_NewStampClick(Sender: TObject);
    procedure btn_SaveStampClick(Sender: TObject);
    procedure btn_DelStampClick(Sender: TObject);
    procedure lv_StampsClick(Sender: TObject);
    procedure sbtn_SBildClick(Sender: TObject);
    procedure rbtn_STextClick(Sender: TObject);
    procedure rbtn_SBildClick(Sender: TObject);
    procedure tbs_AnnotationsShow(Sender: TObject);
    procedure sbtn_SFontClick(Sender: TObject);
    procedure edt_SWidthChange(Sender: TObject);
    procedure edt_SHeightChange(Sender: TObject);
    procedure lv_eigenschaftstempelClick(Sender: TObject);
    procedure frmsto_docoptionenRestorePlacement(Sender: TObject);
    procedure cbx_nummerChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure memo_TObjTextKeyDown(Sender: TObject; var Key: Word;
       Shift: TShiftState);
    procedure chk_AnpassenClick(Sender: TObject);
    procedure btn_transpClick(Sender: TObject);
    procedure img_SBildMouseEnter(Sender: TObject);
    procedure img_SBildMouseLeave(Sender: TObject);
    procedure btn_TransparenzClick(Sender: TObject);
    procedure img_SBildMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btn_TranspSpeichernClick(Sender: TObject);
    procedure pctrl_DocEditOptChange(Sender: TObject);
    procedure edt_SBildKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btn_TextvariableClick(Sender: TObject);
    procedure lv_StampsKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure rbtn_StampActionClick(Sender: TObject);
    procedure Image1MouseEnter(Sender: TObject);
    procedure Image1MouseLeave(Sender: TObject);
    procedure chkClipboardClick(Sender: TObject);
    procedure edt_objheightChange(Sender: TObject);
    procedure pctrl_DocEditOptDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect;
      Active: Boolean);
    procedure tctrl_AnnosDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect; Active: Boolean);

  private
    mStampFavoOld, HintPause, HintHidePause: Integer;
//    fBalloonHint: TBalloonHint;

    function isCreateStampOk(stampName: String): Boolean;
    function isSaveStampOk(stampKey: String): Boolean;
    function existsStampName(stampName: String): Boolean;
    function StampNameUnique(stampName: String): Boolean;

    procedure selectStampListItem(stampName: String); overload;
    procedure selectStampListItem(Idx: Integer); overload;
    procedure btnSaveStampExecute(SelectByName: Boolean = True);

  protected
    { Private-Deklarationen }
    fifavnum: Integer;
//11.03.2024    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public-Deklarationen }
    floadedindex: Integer;

    function LoadObjVal(ObjTyp: Integer): Boolean;
    function SaveObjVal(ObjTyp: Integer): Boolean;
    function ListStamps(fobjekteigen: Boolean; SelectByName: Boolean = True): Boolean;
    function LoadStamp(StampKey: String): Boolean;
//    function LoadStampEigenschaften(StampKey: String): Boolean;
    function CreStamp: Boolean;
    function SavStamp(StampKey: String): Boolean;
    function DelStamp(StampKey: String): Boolean;
    procedure ShowStampsElements(IsGraphicStamp: Boolean);
    procedure EnableBreiteHoehe(bEnable: Boolean);
    function CheckStampModification(StampKey: String): Boolean;
    procedure FillCbxStampActionItems;
  end;

var
  sGStampKey: String; // aktuell bearbeiteter Stempel-Schlssel
  gbGetTransClr: Boolean;

implementation

{$R *.dfm}

uses
  bfaLog, MainDataModule, bfaCommonUtils, bfaCommonMethods, bfaCommonDialogs, bfaCommonStyles,
  bfaApplication, bfaBaseObjects, bfaIconsDM, bfaImageEnVect;

/////////////////////////////////////////////////////////////////////////////////////////////////////
//  Stempel lschen

function Tfrm_DocEditOpt.DelStamp(StampKey: String): Boolean;
var
  reg: TRegistry;
begin
  Result := True;
  reg := TRegistry.Create;
  try
    try
      with reg do
      begin
        RootKey := HKEY_CURRENT_USER;
        DeleteKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey);
        CloseKey;
      end;
    except
      on e: Exception do
      begin
        BfShowMessage(_('Fehler beim Schreiben in die Registrierung:') + e.Message);
        Result := False;
      end;
    end;
  finally
    if Assigned(reg) then
      FreeAndNil(reg);
  end;
end;

(*
  Zweck:
    Selektiert einen Eintrag der ListView 'lv_stamps' ber den Listen-Index
  Eingabe:
    'Idx' Ist der zu selektierende Listen-Index
*)
procedure Tfrm_DocEditOpt.selectStampListItem(Idx: Integer);
begin
  if Idx > lv_Stamps.Items.Count - 1 then
    Idx := lv_Stamps.Items.Count - 1;

  if lv_Stamps.Items.Count > 0 then
  begin
    lv_stamps.ItemIndex := Idx;
    sGStampKey := lv_Stamps.Selected.SubItems.Strings[1];

    LoadStamp(sGStampKey);
  end;
end;


(*
  Zweck:
    Selektiert einen Eintrag der ListView 'lv_stamps' ber den Namen
  Eingabe:
    'stampName' Ist der zu selektierende Stempel-Name
*)
procedure Tfrm_DocEditOpt.selectStampListItem(stampName: String);
var
  lIdx: Integer;
begin
  for lIdx := 0 to lv_stamps.Items.Count - 1 do
  begin
    if stampName = lv_stamps.Items.Item[lIdx].Caption then
    begin
      selectStampListItem(lIdx);
      Break;
    end;
  end;
end;


(*
  Zweck:
    berprft, ob der Stempel mit Hilfe der Daten aus der Dialog-Maske
    in der Win-Registry gesichert werden kann.
  Eingabe:
    'stampKey' Stempel-Schlssel aus der Win-Registry
  Rckgabe:
    true: Der Stempel darf gesichert werden.
*)
function Tfrm_DocEditOpt.isSaveStampOk (stampKey: String): Boolean;
var
  lStampName, lsMsg: String;
begin
  Result := True;
  lStampName := edt_SName.Text;  //  Stempel-Name aus Masken-Feld entnehmen

  if Trim(lStampName) = '' then
  begin
    lsMsg := _('Es ist kein Stempel-Name vergeben worden!') +#13+#10
            +_('Bitte Stempel-Namen eintragen!');
    MessageBox(Self.Handle, PChar(lsMSg), PChar(''), MB_OK);
    edt_SName.Text := '';
    edt_SName.SetFocus;
    Result := False;
  end else if Trim(stampKey) = '' then
  begin
    lsMsg := _('Der Stempel konnte nicht in der Registry gespeichert werden!');
    MessageBox(Self.Handle, PChar(lsMSg), PChar(''), MB_OK);
    Result := False;
    Exit;
  end;
end;


(*
  Zweck:
    Sichert die Daten eines Stempels in der Win-Registry.
  Voraussetzung:
    Der Stempel mu bereits in der Win-Registry vorhanden sein.
  Eingabe:
    'StampKey': Der Registry-Schlssel des Stempels
  Rckgabe:
    true: Der Eintrag in die Win-Registry hat geklappt.
*)
function Tfrm_DocEditOpt.SavStamp(StampKey: String): Boolean;
type
  rListEntry =
    record
      Name  : String;
      FavoNr: Integer;
      Key   : String;
    end;

var
  reg: TRegistry;
  fsTmp: TFontStyles;
  reg1: TRegistry;
  bsTmp: TBrushStyle;
  psTmp: TPenStyle;
  lFavoNr, lIdx, liDeckkraft, liStatefield: Integer;
  lFavoExists: Boolean;
  lListEntry: rListEntry;
  lsMsg, lsInfo, lsStampText, lsPlugin: String;
begin
  if not isSaveStampOk(StampKey) then
  begin
    Result := False;
    Exit;
  end;

  Result := True;
  reg := TRegistry.Create;
  fsTmp := dlg_Schrift.Font.Style;

  try
    try
      with reg do
      begin
        RootKey := HKEY_CURRENT_USER;

        if not rbtn_SBild.Checked then  //  Bei Text-Stempeln die Bilddatei lschen,
          edt_SBild.Text := '';         //  denn beides wird zur Typ-Abfrage verwendet!

        if not rbtn_SText.Checked then
          memo_SText.Text := '';

        if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
          Exit;

        lsStampText := StringReplace(memo_SText.Text, sLineBreak, '\n\r',[rfReplaceAll]);
        OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);

        WriteString('StampName', edt_SName.Text);
        WriteString('StampFile', edt_SBild.Text);
        WriteString('StampText', lsStampText);
        WriteBool('StampTyp', rbtn_SBild.Checked);
        WriteBool('StampClipboard', chkClipboard.Checked);
        WriteBool('StampFitToText',chk_Anpassen.Checked);
        WriteBool('StampFixedSize',chk_fixedsize.Checked);
        WriteInteger('StampHeight', StrToInt(edt_SHeight.Text));
        WriteInteger('StampWidth', StrToInt(edt_SWidth .Text));
        WriteInteger('FontColor', dlg_Schrift.Font.Color);
        WriteString('FontName', dlg_Schrift.Font.Name);
        WriteBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
        WriteInteger('FontSize', dlg_Schrift.Font.size);
        // da man ja nicht genau wissen kann welches objekt welche werte abfragt
        WriteInteger('ObjFontHeight', dlg_Schrift.Font.size);

        liDeckkraft := Round(StrToInt(edt_Deckkraft1.Text) * 2.55);
        WriteInteger('ObjTransparency', liDeckkraft);

        WriteInteger('Version', 36);
        case cbx_Textstyle.ItemIndex of
          0:
            bsTmp := bsClear;
          1:
            bsTmp := bsSolid;
        end;
        WriteBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp));

        case cbx_Stampstyle.ItemIndex of
          0:
            bsTmp := bsClear;
          1:
            bsTmp := bsFDiagonal;
          2:
            bsTmp := bsBDiagonal;
          3:
            bsTmp := bsVertical;
          4:
            bsTmp := bsHorizontal;
          5:
            bsTmp := bsCross;
          6:
            bsTmp := bsDiagCross;
          7:
            bsTmp := bsSolid;
        end;
        WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));

        WriteInteger('objBrushColor', clrbx_Stampcolor.Selected);

        case cbx_Stampborder.ItemIndex of
          0:
            psTmp := psSolid;
          1:
            psTmp := psClear;
          2:
            psTmp := psDash;
          3:
            psTmp := psDashDot;
          4:
            psTmp := psDashDotDot;
          5:
            psTmp := psDot;
        end;
        WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
        WriteInteger('objMemoBorderColor', clrbx_Stampborder.Selected);

        if rbtn_StampNoAction.Checked then
        begin
          WriteInteger('StampStatefield', -1);
          WriteString('StampPlugin', '');
        end else if rbtn_StampStatefield.Checked then
        begin
          if (cbx_StampAction.ItemIndex <> -1) then
            liStatefield := Integer(cbx_StampAction.Properties.Items.Objects[cbx_StampAction.ItemIndex])
          else
            liStatefield := -1;

          WriteInteger('StampStatefield', liStatefield);
          WriteString('StampPlugin', '');
        end else if rbtn_StampPlugin.Checked then
        begin
          if (cbx_StampAction.ItemIndex <> -1) then
            lsPlugin := cbx_StampAction.Properties.Items[cbx_StampAction.ItemIndex]
          else
            lsPlugin := '';

          WriteInteger('StampStatefield', -1);
          WriteString('StampPlugin', lsPlugin);
        end;

        lFavoNr := cbb_fav.ItemIndex;
        lFavoExists := False;

        if lFavoNr > 0 then
        begin
          for lIdx := 0 to lv_stamps.Items.Count - 1 do
          begin
            lListEntry.Name := lv_stamps.Items.Item[lIdx].Caption;
            lListEntry.FavoNr := StrToInt0(lv_Stamps.Items.Item[lIdx].SubItems[0]);
            lListEntry.Key := lv_Stamps.Items.Item[lIdx].SubItems[1];

            if (lListEntry.FavoNr > 0) and (lListEntry.FavoNr = lFavoNr) and
               (lListEntry.Key <> StampKey) then
            begin
              lFavoExists := True;
              Break;
            end;
          end;
        end;

        if lFavoExists then
        begin

          lsMsg:= Format(_('Es gibt bereits einen Stempel mit der Favoriten Nr: %d') +
                   #13 + _('Mchten Sie diese Nummer neu vergeben?'),[lFavoNr]);
          lsInfo:= _('Favoritennummer belegt');
          if MessageBox(Self.Handle,Pchar(lsMsg),PChar(lsInfo), MB_ICONQUESTION or MB_YESNO) = mrNo then
          begin
            lFavoNr := mStampFavoOld;  //  12.05.2010  r.sch.  3.5.0.76  [2197]
            cbb_fav.ItemIndex := mStampFavoOld;
          end else
          begin
            reg1 := TRegistry.Create;
            reg1.RootKey := HKEY_CURRENT_USER;

            reg1.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +lListEntry.Key, True);
            reg1.WriteInteger('favnr', 0);
            reg1.CloseKey;
            reg1.Free;
          end;
        end;

        if lFavoNr > 0 then
          WriteInteger('favnr', cbb_fav.ItemIndex)
        else
          WriteInteger('favnr', 0);

        CloseKey;
      end;
    except
      on e: Exception do
      begin
        BfShowMessage(_('Fehler beim Schreiben in die Registrierung:') + e.Message);
        Result := False;
      end;
    end;
  finally
    if Assigned(reg) then
      FreeAndNil(reg);
  end;
end;


(*
  Zweck:
    berprft, ob ein Stempel-Name in der Stempel-Liste
    (links in der Dialog-Maske) vorhanden ist.
  Rckgabe:
    true: Der Stempel-Name ist vorhanden.
*)
function Tfrm_DocEditOpt.existsStampName(stampName: String): Boolean;
var
  lIdx : Integer;
begin
  Result := False;
  for lIdx := 0 to lv_Stamps.Items.Count -1 do // aus Stempel-Liste in der Maske
  begin
    if stampName = lv_Stamps.Items.Item[lIdx].Caption then
    begin
      Result := True;
      Break;
    end;
  end;
end;

function Tfrm_DocEditOpt.StampNameUnique(stampName: String): Boolean;
var
  lIdx : Integer;
  found: Boolean;
begin
  Result := True;
  Found := False;

  if not existsStampName(stampName) then
    Exit;

  for lIdx := 0 to lv_Stamps.Items.Count -1 do
  begin
    if stampName = lv_Stamps.Items.Item[lIdx].Caption then
    begin
    // wenn wir der aktuell geladene Stempel sind, darf der Stempelname 1x vorkommen
    // sonst knnten wir bestehende Stempel ja nicht mehr speichern...
    // also setzen wir found und steigen erst beim zweiten Fund aus.
    // Ansonsten steigen wir direkt aus
      if Found or (lv_Stamps.Items[lIdx].SubItems.Strings[1] <> sGStampKey) then
      begin
        Result := False;
        Break;
      end else
        Found := True;
    end;
  end;
end;


(*
  Zweck:
    berprft, ob der Stempel mit Hilfe der Daten aus der Dialog-Maske
    in der Win-Registry angelegt werden kann.
  Eingabe:
    'stampName': Name des Stempels
  Rckgabe:
    true: Der Stempel darf angelegt werden.
*)
function Tfrm_DocEditOpt.isCreateStampOk(stampName: String) : Boolean;
var
  lsMsg: String;
  iStamp: Integer;
begin
  if lv_Stamps.Selected <> nil then
  begin
    Result := True;

    if Trim(stampName) = '' then
    begin
      lsMsg := _('Es ist kein Stempel-Name vergeben worden!') + #13+#10 +
               _('Bitte Stempel-Namen eintragen!');
      MessageBox(Self.Handle, PChar(lsMSg), PChar(''), MB_OK);
      Result := False;
    end
    else if existsStampName(stampName) and (not StampNameUnique(stampName)) then
    begin
      lsMsg := Format(_('Der Stempel-Name "%s" existiert bereits!') + #13+#10 +
                      _('Bitte einen anderen Stempel-Namen whlen!'), [stampName]);

      MessageBox(Self.Handle, PChar(lsMSg), PChar(''), MB_OK);
      for iStamp := 0 to lv_Stamps.Items.Count - 1 do
      begin
        if lv_Stamps.Items[iStamp].SubItems.Strings[1] = sGStampKey
        then
          lv_Stamps.Selected := lv_Stamps.Items[iStamp];
      end;
      Result := False;
    end;
  end else
    Result := False;
end;


(*
  Zweck:
    Legt einen neuen Stempel in der Win-Registry an und
    initialisiert alle Variablen durch den Aufruf von 'LoadStamp'.
    Der globale Stempel-Schlssel 'sGStampKey' wird aktualisiert.
  Hinweis:
    Wird nur von 'btn_NewStampClick' aufgerufen.
    Da diese Methode als public deklariert ist kann nicht ausgeschlossen werden,
    da der Aufruf durch andere Units erfolgt.
  Rckgabe:
    true: Der Eintrag in die Win-Registry hat geklappt.
*)
function Tfrm_DocEditOpt.CreStamp: Boolean;
var
  lReg: TRegistry;
  sStampKey, lStampName: String;
  fsTmp: TFontStyles;
  bsTmp: TBrushStyle;
  psTmp: TPenStyle;
  iIndex: Integer;
begin
  iIndex := 1;

  lStampName := _('Neuer Stempel') +'_'+ IntToStr(iIndex);
  while existsStampName(lStampName) do
  begin
    inc(iIndex);
    lStampName := _('Neuer Stempel') +'_'+ IntToStr(iIndex);
  end;

  edt_SName.Text := lStampName;
  edt_SName.SetFocus;

  Result := True;
  lReg := TRegistry.Create;
  fsTmp := [];
  bsTmp := bsClear;
  psTmp := psClear;
  DateTimeToString(sStampKey, 'ddmmyyyyhhnnss', Now);

  try
    try
      lReg.RootKey := HKEY_CURRENT_USER;
      lReg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + sStampKey, True);
      lReg.WriteString('StampName', lStampName);
      lReg.WriteString('StampFile', '');
      lReg.WriteString('StampText', 'neuer Text');
      lReg.WriteBool('StampTyp', False);
      lReg.WriteInteger('StampHeight', 30);
      lReg.WriteInteger('StampWidth', 40);
      lReg.WriteBool('StampFitToText',True);
      lReg.WriteBool('StampFixedSize', False); // bfacrm:ticket__show__28910 - wegen Stemmpeln mit Variabeln standardmig false
      lReg.WriteInteger('FontColor', 0);
      lReg.WriteInteger('FontSize', 72);
      lReg.WriteString('FontName', 'Arial');
      lReg.WriteBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
      lReg.WriteInteger('objBrushColor', StrToInt('$ffffff'));
      lReg.WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
      lReg.WriteInteger('ObjMemoBorderColor', StrToInt('$0'));
      lReg.WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
      lReg.WriteBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp));
      lReg.WriteInteger('ObjTransparency', 255);
      lReg.WriteInteger('favnr', 0);
      lReg.CloseKey;
      mStampFavoOld := 0;
      sGStampKey := sStampKey;

      LoadStamp(sGStampKey);
      ListStamps(False);
    except
      on e: Exception do
      begin
        BfShowMessage(_('Fehler beim Schreiben in die Registrierung:') + e.Message);
        Result := False;
      end;
    end;
  finally
    if Assigned(lReg) then
      FreeAndNil(lReg);
  end;
end;


(*
  Zweck:
    Holt die Daten eines Stempels aus der Win-Registry und
    belegt, wenn ntig initialisiert, alle Daten des Stempels.
    Die Dialog-Maske wird ausgefllt.
  Voraussetzung:
    Der Stempel mu bereits in der Win-Registry vorhanden sein.
  Eingabe:
    'StampKey': Der Registry-Schlssel des Stempels
  Rckgabe:
    true: Der Eintrag wurde aus der Win-Registry hat geladen.
*)
function Tfrm_DocEditOpt.LoadStamp(StampKey: String): Boolean;
var
  reg: TRegistry;
  fsTmp: TFontStyles;
  bsTmp: TBrushStyle;
  psTmp: TPenStyle;
  sStampText, sPluginName: String;
  bStampTyp: Boolean;
  liDeckkraft, liStatefieldId: Integer;
begin
  if btn_Transparenz.Checked then
    btn_Transparenz.Checked := False;

  Result := True;
  reg := TRegistry.Create;
  try
    try
      with reg do
      begin
        RootKey := HKEY_CURRENT_USER;

        if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
          Exit;

        OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);

        if ValueExists('StampFitToText') then
          chk_Anpassen.Checked := ReadBool('StampFitToText')
        else
          chk_Anpassen.Checked := True;

        if ValueExists('StampFixedSize') then
          chk_fixedsize.Checked := ReadBool('StampFixedSize')
        else
          chk_fixedsize.Checked := False; // bfacrm:ticket__show__28910 - wegen Stemmpeln mit Variabeln standardmig false

        if ValueExists('StampName') then
          edt_SName.Text := ReadString('StampName')
        else
          edt_SName.Text := _('(keine Bezeichnung)');

        if ValueExists('StampText') then
          sStampText := StringReplace(ReadString('StampText'), '\n\r', sLineBreak, [rfReplaceAll])
        else
          sStampText := _('(kein Text)');

        memo_SText.Text := sStampText;

        if ValueExists('StampFile') then
          edt_SBild.Text := ReadString('StampFile')
        else
          edt_SBild.Text := '';

        if ValueExists('StampTyp') then
        begin
          bStampTyp := ReadBool('StampTyp');
          if bStampTyp then
            rbtn_SBildClick(Self)
          else
            rbtn_STextClick(Self);
        end else
          ShowStampsElements(False);

        if ValueExists('StampClipboard') then
          chkClipboard.Checked := ReadBool('StampClipboard')
        else
          chkClipboard.Checked := False;

        if ValueExists('StampWidth') then
          edt_SWidth.Text := IntToStr(ReadInteger('StampWidth'))
        else
          edt_SWidth.Text := '40';

        if ValueExists('StampHeight') then
          edt_SHeight.Text := IntToStr(ReadInteger('StampHeight'))
        else
          edt_SHeight.Text := '30';

        if ValueExists('FontColor') then
          dlg_Schrift.Font.Color := ReadInteger('FontColor')
        else
          dlg_Schrift.Font.Color := 0;

        if ValueExists('FontName') then
        begin
          dlg_Schrift.Font.Name := ReadString('FontName');
          edt_TFont.Text := dlg_Schrift.Font.Name;
          edt_SFont.Text := edt_TFont.Text;
        end else
        begin
          dlg_Schrift.Font.Name := 'Arial';
          edt_TFont.Text := 'Arial';
          edt_SFont.Text := edt_TFont.Text;
        end;

        if ValueExists('FontStyle') then
        begin
          ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
          dlg_Schrift.Font.Style := fsTmp;
        end else
          dlg_Schrift.Font.Style := [];

        if ValueExists('FontSize') then
          dlg_Schrift.Font.Size := ReadInteger('FontSize')
        else
          dlg_Schrift.Font.Size := 72;

        if ValueExists('ObjFontHeight') then
           dlg_Schrift.Font.Size := ReadInteger('ObjFontHeight');

        if ValueExists('ObjMemoCharsBrushStyle') then
          ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp))
        else
          bsTmp := bsClear;

        if bsTmp = bsClear then
          cbx_Textstyle.ItemIndex := 0;
        if bsTmp = bsSolid then
          cbx_Textstyle.ItemIndex := 1;

        if ValueExists('ObjBrushStyle') then
          ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
        else
          bsTmp := bsClear;

        if bsTmp = bsClear then
          cbx_Stampstyle.ItemIndex := 0
        else if bsTmp = bsFDiagonal then
          cbx_Stampstyle.ItemIndex := 1
        else if bsTmp = bsBDiagonal then
          cbx_Stampstyle.ItemIndex := 2
        else if bsTmp = bsVertical then
          cbx_Stampstyle.ItemIndex := 3
        else if bsTmp = bsHorizontal then
          cbx_Stampstyle.ItemIndex := 4
        else if bsTmp = bsCross then
          cbx_Stampstyle.ItemIndex := 5
        else if bsTmp = bsDiagCross then
          cbx_Stampstyle.ItemIndex := 6
        else if bsTmp = bsSolid then
          cbx_Stampstyle.ItemIndex := 7;

        if ValueExists('ObjBrushColor') then
          clrbx_Stampcolor.Selected := ReadInteger('ObjBrushColor')
        else
          dlg_Schrift.Font.Color := clWhite;

        if ValueExists('ObjMemoBorderStyle') then
          ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
        else
          psTmp := psClear;

        if psTmp = psSolid then
          cbx_Stampborder.ItemIndex := 0
        else if psTmp = psClear then
          cbx_Stampborder.ItemIndex := 1
        else if psTmp = psDash then
          cbx_Stampborder.ItemIndex := 2
        else if psTmp = psDashDot then
          cbx_Stampborder.ItemIndex := 3
        else if psTmp = psDashDotDot then
          cbx_Stampborder.ItemIndex := 4
        else if psTmp = psDot then
          cbx_Stampborder.ItemIndex := 5;

        if ValueExists('ObjMemoBorderColor') then
          clrbx_Stampborder.Selected := ReadInteger('ObjMemoBorderColor')
        else
          clrbx_Stampborder.ItemIndex := 1;

        if ValueExists('ObjTransparency') then
          liDeckkraft := ReadInteger('ObjTransparency')
        else
          liDeckkraft := 255;

        if liDeckkraft < 51 then
        begin
          liDeckkraft := 255;
          WriteInteger('ObjTransparency', liDeckkraft);
        end;
        edt_Deckkraft1.Text := IntToStr(Round(liDeckkraft / 2.55));

        if ValueExists('favnr') then
          cbb_fav.ItemIndex := ReadInteger('favnr')
        else
          cbb_fav.ItemIndex := 0;

        mStampFavoOld := cbb_fav.ItemIndex;

        if ValueExists('StampStatefield') then
          liStatefieldId := ReadInteger('StampStatefield')
        else
          liStatefieldId := -1;

        if liStatefieldId <> -1 then
        begin
          rbtn_StampStatefield.Checked := True;
          cbx_StampAction.ItemIndex := cbx_StampAction.Properties.Items.IndexOfObject(TObject(liStatefieldId));
        end;

        if ValueExists('StampPlugin') then
          sPluginName := ReadString('StampPlugin')
        else
          sPluginName := '';

        if sPluginName <> '' then
        begin
          rbtn_StampPlugin.Checked := True;
          cbx_StampAction.ItemIndex := cbx_StampAction.Properties.Items.IndexOf(sPluginName);
        end;

        if (liStatefieldId = -1) and (sPluginName = '') then
          rbtn_StampNoAction.Checked := True;

        CloseKey;
      end;
    except
      on e: Exception do
      begin
        BfShowMessage('Fehler beim Lesen des Registrierung: ' + e.Message);
        Result := False;
      end;
    end;
  finally
    if Assigned(reg) then
      FreeAndNil(reg);
  end;
end;

procedure Tfrm_DocEditOpt.ShowStampsElements(IsGraphicStamp: Boolean);
begin
  if not IsGraphicStamp then
  begin
  // <!-- Textstempel
    // Bildelemente ausblenden
    rbtn_SBild.Checked := False;
    edt_SBild.Visible := False;
    sbtn_SBild.Visible := False;
    img_SBild.Clear;
    img_SBild.Visible := False;
    img_SBild.Enabled := False;
    lbl_SBild.Visible := False;
    sbtn_SBild.Visible := False;
    btn_Transparenz.Visible := False;
    btn_TranspSpeichern.Visible := False;
    btn_TranspSpeichern.Enabled := False;
    chkClipboard.Visible := False;
    chkClipboard.Enabled := False;

    // Textelement einblenden
    rbtn_SText.Checked := True;
    memo_SText.Enabled := True;
    edt_SFont.Enabled := True;
    sbtn_SFont.Enabled := True;
    lbl_SText.Visible := True;
    memo_SText.Visible := True;
    lbl_SFont.Visible := True;
    edt_SFont.Visible := True;
    sbtn_SFont.Visible := True;
    lbl_Textstyle.Visible := True;
    clrbx_Stampborder.Visible := True;
    clrbx_Stampborder.ItemIndex := 16;
    cbx_Textstyle.Visible := True;
    cbx_Textstyle.ItemIndex := 0;
    lbl_Stampcolor.Visible := True;
    clrbx_Stampcolor.Visible := True;
    clrbx_Stampcolor.ItemIndex := 16;
    cbx_Stampstyle.Visible := True;
    cbx_Stampstyle.ItemIndex := 0;
    lbl_Stampborder.Visible := True;
    cbx_Stampborder.Visible := True;
    cbx_Stampborder.ItemIndex := 1;
    chk_Anpassen.Visible := True;
    EnableBreiteHoehe(not chk_Anpassen.Checked);
    btn_Textvariable.Visible := True;
    chk_fixedsize.Enabled := True;
  // Textstempel -->
  end else
  begin
  // <!-- Bildstempel
    // Textelemente ausblenden
    rbtn_SText.Checked := False;
    memo_SText.Visible := False;
    edt_SFont.Visible := False;
    sbtn_SFont.Visible := False;
    lbl_SText.Visible := False;
    lbl_SFont.Visible := False;
    edt_SFont.Visible := False;
    sbtn_SFont.Visible := False;
    lbl_Textstyle.Visible := False;
    clrbx_Stampborder.Visible := False;
    cbx_Textstyle.Visible := False;
    lbl_Stampcolor.Visible := False;
    clrbx_Stampcolor.Visible := False;
    cbx_Stampstyle.Visible := False;
    lbl_Stampborder.Visible := False;
    cbx_Stampborder.Visible := False;
    chk_Anpassen.Visible := False;
    EnableBreiteHoehe(not chkClipboard.Checked);
    btn_Textvariable.Visible := False;

    // Bildelemente einblenden
    rbtn_SBild.Checked := True;
    chkClipboard.Visible := True;
    chkClipboard.Enabled := True;
    img_SBild.Clear;
    if (edt_SBild.Text <> '') and (not chkClipboard.Checked) then
      load_SBild;

    edt_SBild.Enabled := (not chkClipboard.Checked);
    edt_SBild.Visible := True;
    edt_SBild.Refresh;
    edt_SBild.Repaint;
    chk_fixedsize.Enabled := (not chkClipboard.Checked);

    sbtn_SBild.Visible := True;
    img_SBild.Enabled := True;
    img_SBild.Visible := True;
    lbl_SBild.Visible := True;
    btn_Transparenz.Visible := True;
    btn_TranspSpeichern.Visible := True;
    btn_TranspSpeichern.Enabled := False;
  // Bildstempel -->
  end;
  grp_StampBorder.Repaint;
  grp_StampBorder.Refresh;
end;

procedure Tfrm_DocEditOpt.EnableBreiteHoehe(bEnable: Boolean);
begin
  lbl_SWidth.Enabled := bEnable;
  edt_SWidth.Enabled := bEnable;
  lbl_SWidthMes.Enabled := bEnable;
  edt_SHeight.Enabled := bEnable;
end;

function Tfrm_DocEditOpt.ListStamps(fobjekteigen: Boolean; SelectByName: Boolean = True): Boolean;
var
  reg: TRegistry;
  slStampKeys: TStrings;
  iCount, ALastSelected: Integer;
  lItem: TListItem;
  lmylistview: TListView;
  lbtyp: Boolean;
begin
  Result := True;
  reg := TRegistry.Create;
  slStampKeys := TStringList.Create;
  try
    try
      with reg do
      begin
        RootKey := HKEY_CURRENT_USER;
        OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps', True);
        GetKeyNames(slStampKeys);
        CloseKey;
        if fobjekteigen then
          lmylistview := lv_eigenschaftstempel
        else
          lmylistview := lv_Stamps;

        if not SelectByName then
          ALastSelected := lmylistview.ItemIndex;

        lmylistview.Clear;

        for iCount := 0 to (slStampKeys.Count - 1) do
        begin
          RootKey := HKEY_CURRENT_USER;
          OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + slStampKeys.Strings[iCount], True);
          if fobjekteigen then
          begin
            if ValueExists('StampTyp') then
              lbtyp := ReadBool('StampTyp')
            else
              lbtyp := True;
            if lbtyp then
            begin
              CloseKey;
              Continue;
            end;
          end;
          lItem := lmylistview.Items.Add;
          if ValueExists('StampName') then
            lItem.Caption := ReadString('StampName')
          else
            lItem.Caption := 'unbekannter Stempel';

          if ValueExists('StampTyp') then
          begin
            if ReadBool('StampTyp') then
              lItem.ImageIndex := Integer(icoidx_stamp_green)
            else
              lItem.ImageIndex := Integer(icoidx_stamp_blue);
          end else
            lItem.ImageIndex := Integer(icoidx_stamp_purple);

          if not fobjekteigen then
          begin
            if ValueExists('favnr') then
              litem.SubItems.Add(IntToStr(ReadInteger('favnr')))
            else
              litem.SubItems.Add(' ');
          end;
          lItem.SubItems.Add(slStampKeys.Strings[iCount]);
          CloseKey;
        end;
      end;

      if SelectByName then
        selectStampListItem(edt_SName.Text)
      else
        selectStampListItem(ALastSelected);
    except
      on e: Exception do
      begin
        BfShowMessage(_('Fehler beim Lesen der Registrierung:') + e.Message);
        Result := False;
      end;
    end;
  finally
    if Assigned(reg) then
      FreeAndNil(reg);
    if Assigned(slStampKeys) then
      FreeAndNil(slStampKeys);
  end;
end;

function Tfrm_DocEditOpt.LoadObjVal(ObjTyp: Integer): Boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function ld die Objekteigenschaften des Objekt-    ///
   ///  typs [ObjTyp] aus der Registrierung.                      ///
   ///                                                            ///
   ///  Parameter: ObjTyp        Objekttyp                        ///
   ///             0             Textmarker                       ///
   ///             1             Notiz                            ///
   ///             2             Beschriftung                     ///
   ///             3             Freihandlinie                    ///
   ///             4             Poligon                          ///
   ///             5             Ellipse                          ///
   ///             6             Rechteck                         ///
   ///             7             Pfeil                            ///
   ///             8             Messlinie                        ///
   ///             9             Winkel                           ///
   ///             10            Linie                            ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
  sRegKey, lstampname, lszusstring: String;
  Reg: TRegistry;
  fsTmp: TFontStyles;
  {$IFDEF IMAGEEN1140}
  shTmp: TIEVArrowShape;
  {$ELSE}
  shTmp: TIEShape;
  {$ENDIF}
  bsTmp: TBrushStyle;
  lpTmp: TIELabelPos;
  psTmp: TPenStyle;
  rtTmp: TIEVRulerType;
  ruTmp: TIEUnits;
  osTmp: TIEVStyle;
  taTmp: TIEAlignment;

begin
  Result := True;
  reg := TRegistry.Create;
  if fifavnum = 0 then
    lszusstring := ''
  else
    lszusstring := inttostr(fifavnum);

  try
    try
      clbx_CLabel.Visible := True;
      clbx_CLabel.Visible := False;
      clbx_CNoteBorder.Visible := True;
      clbx_CNoteBorder.Visible := False;
      grbx_Color.Visible := True;
      grbx_Algem.Visible := True;
      grbx_Shape.Visible := True;
      case ObjTyp of
        0:
        begin
          sRegKey := 'HiLite' + lszusstring;
          lbl_CBackground.Visible := True;
          clbx_CBackground.Visible := True;
          lbl_CBorder.Visible := True;
          clbx_CBorder.Visible := True;
          lbl_CLabel.Visible := False;
          clbx_CLabel.Visible := False;
          lbl_CNoteBorder.Visible := False;
          clbx_CNoteBorder.Visible := False;
          lbl_BBackground.Visible := True;
          cbx_BBackground.Visible := True;
          lbl_BBorder.Visible := True;
          cbx_BBorder.Visible := True;
          lbl_BLabel.Visible := False;
          cbx_BLabel.Visible := False;
          lbl_BNoteBorder.Visible := False;
          cbx_BNoteBorder.Visible := False;
          grbx_Brush.Visible := True;
          grbx_Text.Visible := False;
          chbx_AIsHiLite.Visible := False;
          lbl_nummer.Visible := True;
          cbx_nummer.Visible := True;
          cbx_nummer.ItemIndex := fifavnum;
          chbx_AOpenPoly.Visible := False;
        end;

        1:
        begin
          sRegKey := 'Note' + lszusstring;
          lbl_CBackground.Visible := True;
          clbx_CBackground.Visible := True;
          lbl_CBorder.Visible := False;
          clbx_CBorder.Visible := False;
          lbl_CLabel.Visible := False;
          clbx_CLabel.Visible := False;
          lbl_CNoteBorder.Visible := True;
          clbx_CNoteBorder.Visible := True;
          lbl_BBackground.Visible := True;
          cbx_BBackground.Visible := True;
          lbl_BBorder.Visible := False;
          cbx_BBorder.Visible := False;
          lbl_BLabel.Visible := False;
          cbx_BLabel.Visible := False;
          lbl_BNoteBorder.Visible := True;
          cbx_BNoteBorder.Visible := True;
          grbx_Brush.Visible := True;
          grbx_Text.Visible := True;
          chbx_AIsHiLite.Visible := False;
          lbl_nummer.Visible := True;
          cbx_nummer.Visible := True;
          cbx_nummer.ItemIndex := fifavnum;
          chbx_AOpenPoly.Visible := False;
        end;

        2:
        begin
          sRegKey := 'Text' + lszusstring;
          cbx_BBackground.ItemIndex := 0;
          lbl_CBackground.Visible := True;
          clbx_CBackground.Visible := True;
          lbl_CBorder.Visible := False;
          clbx_CBorder.Visible := False;
          lbl_CLabel.Visible := False;
          clbx_CLabel.Visible := False;
          lbl_CNoteBorder.Visible := True;
          clbx_CNoteBorder.Visible := True;
          lbl_BBackground.Visible := True;
          cbx_BBackground.Visible := True;
          lbl_BBorder.Visible := False;
          cbx_BBorder.Visible := False;
          lbl_BLabel.Visible := True;
          cbx_BLabel.Visible := True;
          lbl_BNoteBorder.Visible := True;
          cbx_BNoteBorder.Visible := True;
          grbx_Brush.Visible := True;
          grbx_Text.Visible := True;
          chbx_AIsHiLite.Visible := False;
          lbl_nummer.Visible := True;
          cbx_nummer.Visible := True;
          cbx_nummer.ItemIndex := fifavnum;
          chbx_AOpenPoly.Visible := False;
        end;

//        3:
//        begin
//          sRegKey := 'LineLabel';
//          lbl_CBackground.Visible := False;
//          clbx_CBackground.Visible := False;
//          lbl_CBorder.Visible := False;
//          clbx_CBorder.Visible := False;
//          lbl_CLabel.Visible := False;
//          clbx_CLabel.Visible := False;
//          lbl_CNoteBorder.Visible := False;
//          clbx_CNoteBorder.Visible := False;
//          lbl_BBackground.Visible := False;
//          cbx_BBackground.Visible := False;
//          lbl_BBorder.Visible := False;
//          cbx_BBorder.Visible := False;
//          lbl_BLabel.Visible := False;
//          cbx_BLabel.Visible := False;
//          lbl_BNoteBorder.Visible := False;
//          cbx_BNoteBorder.Visible := False;
//          grbx_Brush.Visible := False;
//          grbx_Text.Visible := False;
//          chbx_AIsHiLite.Visible := False;
//          grbx_Brush.Visible := False;
//          grbx_Text.Visible := False;
//          chbx_AIsHiLite.Visible := False;
//          grbx_Color.Visible := False;
//          grbx_Algem.Visible := False;
//          grbx_Shape.Visible := False;
//        end;

//        4:
        3:
        begin
          sRegKey := 'Polyline';
          lbl_CBackground.Visible := False;
          clbx_CBackground.Visible := False;
          lbl_CBorder.Visible := True;
          clbx_CBorder.Visible := True;
          lbl_CLabel.Visible := False;
          clbx_CLabel.Visible := False;
          lbl_CNoteBorder.Visible := False;
          clbx_CNoteBorder.Visible := False;
          lbl_BBackground.Visible := True;
          cbx_BBackground.Visible := True;
          lbl_BBorder.Visible := True;
          cbx_BBorder.Visible := True;
          lbl_BLabel.Visible := False;
          cbx_BLabel.Visible := False;
          lbl_BNoteBorder.Visible := False;
          cbx_BNoteBorder.Visible := False;
          grbx_Brush.Visible := True;
          grbx_Text.Visible := False;
          chbx_AIsHiLite.Visible := False;
          lbl_nummer.Visible := False;
          cbx_nummer.Visible := False;
          chbx_AOpenPoly.Visible := True;
        end;

//        5:
//        begin
//          sRegKey := 'Poligon';
//          lbl_CBackground.Visible := True;
//          clbx_CBackground.Visible := True;
//          lbl_CBorder.Visible := True;
//          clbx_CBorder.Visible := True;
//          lbl_CLabel.Visible := False;
//          clbx_CLabel.Visible := False;
//          lbl_CNoteBorder.Visible := False;
//          clbx_CNoteBorder.Visible := False;
//          lbl_BBackground.Visible := True;
//          cbx_BBackground.Visible := True;
//          lbl_BBorder.Visible := True;
//          cbx_BBorder.Visible := True;
//          lbl_BLabel.Visible := False;
//          cbx_BLabel.Visible := False;
//          lbl_BNoteBorder.Visible := False;
//          cbx_BNoteBorder.Visible := False;
//          grbx_Brush.Visible := True;
//          grbx_Text.Visible := False;
//          chbx_AIsHiLite.Visible := False;
//        end;

//        6:
//        begin
//          sRegKey := 'Ellipse';
//          lbl_CBackground.Visible := True;
//          clbx_CBackground.Visible := True;
//          lbl_CBorder.Visible := True;
//          clbx_CBorder.Visible := True;
//          lbl_CLabel.Visible := False;
//          clbx_CLabel.Visible := False;
//          lbl_CNoteBorder.Visible := False;
//          clbx_CNoteBorder.Visible := False;
//          lbl_BBackground.Visible := True;
//          cbx_BBackground.Visible := True;
//          lbl_BBorder.Visible := True;
//          cbx_BBorder.Visible := True;
//          lbl_BLabel.Visible := False;
//          cbx_BLabel.Visible := False;
//          lbl_BNoteBorder.Visible := False;
//          cbx_BNoteBorder.Visible := False;
//          grbx_Brush.Visible := True;
//          grbx_Text.Visible := False;
//          chbx_AIsHiLite.Visible := False;
//        end;

//        7:
//        begin
//          sRegKey := 'Box';
//          lbl_CBackground.Visible := True;
//          clbx_CBackground.Visible := True;
//          lbl_CBorder.Visible := True;
//          clbx_CBorder.Visible := True;
//          lbl_CLabel.Visible := False;
//          clbx_CLabel.Visible := False;
//          lbl_CNoteBorder.Visible := False;
//          clbx_CNoteBorder.Visible := False;
//          lbl_BBackground.Visible := True;
//          cbx_BBackground.Visible := True;
//          lbl_BBorder.Visible := True;
//          cbx_BBorder.Visible := True;
//          lbl_BLabel.Visible := False;
//          cbx_BLabel.Visible := False;
//          lbl_BNoteBorder.Visible := False;
//          cbx_BNoteBorder.Visible := False;
//          grbx_Brush.Visible := True;
//          grbx_Text.Visible := False;
//          chbx_AIsHiLite.Visible := True;
//        end;

//        8:
        4:
        begin
          sRegKey := 'Arrow';
          lbl_CBackground.Visible := True;
          clbx_CBackground.Visible := True;
          lbl_CBorder.Visible := True;
          clbx_CBorder.Visible := True;
          lbl_CLabel.Visible := False;
          clbx_CLabel.Visible := False;
          lbl_CNoteBorder.Visible := False;
          clbx_CNoteBorder.Visible := False;
          lbl_BBackground.Visible := True;
          cbx_BBackground.Visible := True;
          lbl_BBorder.Visible := True;
          cbx_BBorder.Visible := True;
          lbl_BLabel.Visible := False;
          cbx_BLabel.Visible := False;
          lbl_BNoteBorder.Visible := False;
          cbx_BNoteBorder.Visible := False;
          grbx_Brush.Visible := False;
          grbx_Text.Visible := False;
          chbx_AIsHiLite.Visible := False;
          chbx_AIsHiLite.Checked := False;
          lbl_nummer.Visible := False;
          cbx_nummer.Visible := False;
          chbx_AOpenPoly.Visible := False;
        end;

//        9:
//        begin
//          sRegKey := 'Ruler';
//          lbl_CBackground.Visible := True;
//          clbx_CBackground.Visible := True;
//          lbl_CBorder.Visible := True;
//          clbx_CBorder.Visible := True;
//          lbl_CLabel.Visible := False;
//          clbx_CLabel.Visible := False;
//          lbl_CNoteBorder.Visible := False;
//          clbx_CNoteBorder.Visible := False;
//          lbl_BBackground.Visible := True;
//          cbx_BBackground.Visible := True;
//          lbl_BBorder.Visible := True;
//          cbx_BBorder.Visible := True;
//          lbl_BLabel.Visible := False;
//          cbx_BLabel.Visible := False;
//          lbl_BNoteBorder.Visible := False;
//          cbx_BNoteBorder.Visible := False;
//          grbx_Brush.Visible := False;
//          grbx_Text.Visible := False;
//          chbx_AIsHiLite.Checked := False;
//        end;

//        10:
//        begin
//          sRegKey := 'Angle';
//          lbl_CBackground.Visible := True;
//          clbx_CBackground.Visible := True;
//          lbl_CBorder.Visible := True;
//          clbx_CBorder.Visible := True;
//          lbl_CLabel.Visible := False;
//          clbx_CLabel.Visible := False;
//          lbl_CNoteBorder.Visible := False;
//          clbx_CNoteBorder.Visible := False;
//          lbl_BBackground.Visible := True;
//          cbx_BBackground.Visible := True;
//          lbl_BBorder.Visible := True;
//          cbx_BBorder.Visible := True;
//          lbl_BLabel.Visible := False;
//          cbx_BLabel.Visible := False;
//          lbl_BNoteBorder.Visible := False;
//          cbx_BNoteBorder.Visible := False;
//          cbx_BNoteBorder.Visible := False;
//          grbx_Brush.Visible := True;
//          grbx_Text.Visible := False;
//          chbx_AIsHiLite.Visible := False;
//        end;

//        11:
//        begin
//          sRegKey := 'Buchungsstempel';
//          lbl_CBackground.Visible := False;
//          clbx_CBackground.Visible := False;
//          lbl_CBorder.Visible := False;
//          clbx_CBorder.Visible := False;
//          lbl_CLabel.Visible := False;
//          clbx_CLabel.Visible := False;
//          lbl_CNoteBorder.Visible := False;
//          clbx_CNoteBorder.Visible := False;
//          lbl_BBackground.Visible := False;
//          cbx_BBackground.Visible := False;
//          lbl_BBorder.Visible := False;
//          cbx_BBorder.Visible := False;
//          lbl_BLabel.Visible := False;
//          cbx_BLabel.Visible := False;
//          lbl_BNoteBorder.Visible := False;
//          cbx_BNoteBorder.Visible := False;
//          grbx_Brush.Visible := False;
//          chbx_AIsHiLite.Checked := False;
//          grbx_Color.Visible := False;
//          grbx_Algem.Visible := False;
//          grbx_Shape.Visible := False;
//          grbx_Text.Visible := False;
//        end;

//        12:
        5:
        begin
          sRegKey := 'Freihand' + lszusstring;
          lbl_CBackground.Visible := False;
          clbx_CBackground.Visible := False;
          lbl_CBorder.Visible := True;
          clbx_CBorder.Visible := True;
          lbl_CLabel.Visible := False;
          clbx_CLabel.Visible := False;
          lbl_CNoteBorder.Visible := False;
          clbx_CNoteBorder.Visible := False;
          lbl_BBackground.Visible := True;
          cbx_BBackground.Visible := True;
          lbl_BBorder.Visible := True;
          cbx_BBorder.Visible := True;
          lbl_BLabel.Visible := False;
          cbx_BLabel.Visible := False;
          lbl_BNoteBorder.Visible := False;
          cbx_BNoteBorder.Visible := False;
          grbx_Brush.Visible := True;
          grbx_Text.Visible := False;
          chbx_AIsHiLite.Visible := False;
          lbl_nummer.Visible := True;
          cbx_nummer.Visible := True;
          cbx_nummer.ItemIndex := fifavnum;
          chbx_AOpenPoly.Visible := False;
        end;

//        13:
//        begin
//          sRegKey := 'Stempel';
//          lbl_CBackground.Visible := True;
//          clbx_CBackground.Visible := True;
//          lbl_CBorder.Visible := False;
//          clbx_CBorder.Visible := False;
//          lbl_CLabel.Visible := False;
//          clbx_CLabel.Visible := False;
//          lbl_CNoteBorder.Visible := True;
//          clbx_CNoteBorder.Visible := True;
//          lbl_BBackground.Visible := True;
//          cbx_BBackground.Visible := True;
//          lbl_BBorder.Visible := False;
//          cbx_BBorder.Visible := False;
//          lbl_BLabel.Visible := False;
//          cbx_BLabel.Visible := False;
//          lbl_BNoteBorder.Visible := True;
//          cbx_BNoteBorder.Visible := True;
//          grbx_Brush.Visible := True;
//          grbx_Text.Visible := True;
//          chbx_AIsHiLite.Visible := False;
//        end;
      end;
      with reg do
      begin
        shTmp := iesNONE;
        psTmp := psSolid;
        osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
        bsTmp := bsClear;
        fsTmp := [];
        taTmp := iejLeft;
        rtTmp := iertRULER;
        ruTmp := ieuPIXELS;
        lpTmp := ielBegin;

        // if ((Objtyp = 0) or (Objtyp = 3) or (Objtyp = 4) or (Objtyp = 5) or (Objtyp = 6) or
        // (Objtyp = 7) or (Objtyp = 8) or (Objtyp = 9) or (Objtyp = 10) or (objtyp = 11) or (objtyp = 12)) then
//        if objtyp in [0, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12] then
        if objtyp in [0, 3, 4, 5] then
          grbx_Text.Visible := False
        else
          grbx_Text.Visible := True;

        if ObjTyp = 13 then
        begin
          memo_TObjText.Visible := False;
          lv_eigenschaftstempel.Visible := True;
          if lv_eigenschaftstempel.SelCount > 0 then
            lstampname := lv_eigenschaftstempel.Selected.SubItems.Strings[0]
          else
          begin
            ListStamps(True);
            if lv_eigenschaftstempel.Items.Count = 0 then
            begin
              ShowMessage(_('Kein Textstempel vorhanden.') + #13 +
                          _('Bitte erstellen Sie einen neuen Textstempel,') + ' ' +
                          _('um diese Eigenschaften zu bearbeiten.'));
              pctrl_DocEditOpt.ActivePage := tbs_Stempel;
              tctrl_Annos.TabIndex := 0;
              Exit;
            end;
            lstampname := lv_eigenschaftstempel.Items.Item[0].SubItems.Strings[0];
          end;

          RootKey := HKEY_CURRENT_USER;
          OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + lstampname, True);

          if ValueExists('ObjBrushColor') then
            clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
          else
            clbx_CBackground.Selected := 0;

          if ValueExists('ObjPenColor') then
            dlg_Schrift.Font.Color := ReadInteger('ObjPenColor')
          else
            dlg_Schrift.Font.Color := 0;

          case ObjTyp of
//            0, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12:
            0, 3, 4, 5:
            begin
              if ValueExists('ObjPenColor') then
              begin
                dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
                clbx_CBorder.Selected := ReadInteger('ObjPenColor');
              end else
              begin
                clbx_CBorder.Selected := 0;
              end;
            end;
          end;
          if ValueExists('ObjLabelBrushColor') then
            clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
          else
            clbx_CLabel.Selected := 0;

          if ValueExists('ObjMemoBorderColor') then
            clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
          else
            clbx_CNoteBorder.Selected := 0;

//            cbx_autolineincrease.Checked := ReadBool('ObjAutoIncreaseLine')
//            cbx_autoincreasehigh.Checked := ReadBool('ObjAutoIncreaseHeight')

          if ValueExists('ObjBrushStyle') then
          begin
            ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            case bsTmp of
              bsSolid:
                cbx_BBackground.ItemIndex := 7;
              bsClear:
                cbx_BBackground.ItemIndex := 0;
              bsHorizontal:
                cbx_BBackground.ItemIndex := 4;
              bsVertical:
                cbx_BBackground.ItemIndex := 3;
              bsFDiagonal:
                cbx_BBackground.ItemIndex := 1;
              bsBDiagonal:
                cbx_BBackground.ItemIndex := 2;
              bsCross:
                cbx_BBackground.ItemIndex := 5;
              bsDiagCross:
                cbx_BBackground.ItemIndex := 6;
            end;
          end else
            cbx_BBackground.ItemIndex := 0;

          if ValueExists('ObjLabelBrushStyle') then
          begin
            ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
            case bsTmp of
              bsSolid:
                cbx_BLabel.ItemIndex := 7;
              bsClear:
                cbx_BLabel.ItemIndex := 0;
              bsHorizontal:
                cbx_BLabel.ItemIndex := 4;
              bsVertical:
                cbx_BLabel.ItemIndex := 3;
              bsFDiagonal:
                cbx_BLabel.ItemIndex := 1;
              bsBDiagonal:
                cbx_BLabel.ItemIndex := 2;
              bsCross:
                cbx_BLabel.ItemIndex := 5;
              bsDiagCross:
                cbx_BLabel.ItemIndex := 6;
            end;
//            if objtyp = 2 then
//              cbx_BLabel.ItemIndex := 0;
          end else
          begin
            cbx_BLabel.ItemIndex := 0;

//            if objtyp = 2 then
//              cbx_BLabel.ItemIndex := 1;
          end;

          if ValueExists('ObjPenStyle') then
          begin
            ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            case psTmp of
              psSolid:
                cbx_BBorder.ItemIndex := 0;
              psDash:
                cbx_BBorder.ItemIndex := 2;
              psDot:
                cbx_BBorder.ItemIndex := 5;
              psDashDot:
                cbx_BBorder.ItemIndex := 3;
              psDashDotDot:
                cbx_BBorder.ItemIndex := 4;
              psClear:
                cbx_BBorder.ItemIndex := 1;
            end;
//            if objtyp = 2 then
//              cbx_BBorder.ItemIndex := 1;
          end else
          begin
            cbx_BBorder.ItemIndex := 0;

            if objtyp = 2 then
              cbx_BBorder.ItemIndex := 1;
          end;

          if ValueExists('ObjMemoBorderStyle') then
          begin
            ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
            case psTmp of
              psSolid:
                cbx_BNoteBorder.ItemIndex := 0;
              psDash:
                cbx_BNoteBorder.ItemIndex := 2;
              psDot:
                cbx_BNoteBorder.ItemIndex := 5;
              psDashDot:
                cbx_BNoteBorder.ItemIndex := 3;
              psDashDotDot:
                cbx_BNoteBorder.ItemIndex := 4;
              psClear:
                cbx_BNoteBorder.ItemIndex := 1;
            end;

            if objtyp = 2 then
              cbx_BNoteBorder.ItemIndex := 1;
          end else
          begin
            cbx_BNoteBorder.ItemIndex := 0;

            if objtyp = 2 then
              cbx_BNoteBorder.ItemIndex := 1;
          end;

          if ValueExists('ObjBeginShape') then
          begin
            ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            case shTmp of
              iesNONE:
                rbtn_SSNo.Checked := True;
              iesINARROW:
                rbtn_SSIn.Checked := True;
              iesOUTARROW:
                rbtn_SSOut.Checked := True;
            end;
          end else
            rbtn_SSNo.Checked := True;

          if ValueExists('ObjEndShape') then
          begin
            ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            case shTmp of
              iesNONE:
                rbtn_SENo.Checked := True;
              iesINARROW:
                rbtn_SEIn.Checked := True;
              iesOUTARROW:
                rbtn_SEOut.Checked := True;
            end;
          end else
            rbtn_SENo.Checked := True;

          if ValueExists('ObjShapeHeight') then
            edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
          else
            edt_SSHeight.Text := '0';

          if ValueExists('ObjShapeWidth') then
            edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
          else
            edt_SSWidth.Text := '0';

          if ValueExists('ObjName') then
            edt_AObjName.Text := dgettext('Shared36',ReadString('ObjName'))
          else
            edt_AObjName.Text := dgettext('Shared36', 'neues Objekt');

          if ValueExists('ObjPenWidth') then
            edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
          else
            edt_APenWidth.Text := '1';

          if ValueExists('ObjRulerType') then
          begin
            ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
            case rtTmp of
              iertRULER:
                cbx_ARulerTyp.ItemIndex := 0;
              iertQUOTEBEGIN:
                cbx_ARulerTyp.ItemIndex := 1;
              iertQUOTECENTER:
                cbx_ARulerTyp.ItemIndex := 2;
              iertQUOTEEND:
                cbx_ARulerTyp.ItemIndex := 3;
            end;
          end else
            cbx_ARulerTyp.ItemIndex := 0;

          if ValueExists('ObjRulerUnit') then
          begin
            ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
            case ruTmp of
              ieuPIXELS:
                cbx_ARulerMes.ItemIndex := 0;
              ieuINCHES:
                cbx_ARulerMes.ItemIndex := 1;
              ieuKM:
                cbx_ARulerMes.ItemIndex := 5;
              ieuMETERS:
                cbx_ARulerMes.ItemIndex := 4;
              ieuCENTIMETERS:
                cbx_ARulerMes.ItemIndex := 3;
              ieuMILLIMETERS:
                cbx_ARulerMes.ItemIndex := 2;
              ieuMICRONS:
                cbx_ARulerMes.ItemIndex := 6;
              ieuNANOMETERS:
                cbx_ARulerMes.ItemIndex := 7;
            end;
          end else
            cbx_ARulerMes.ItemIndex := 0;

          if ValueExists('ObjTransparency') then
            edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
          else
            edt_ATransp.Text := '110';

          if ValueExists('ObjHeight') then
            edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
          else
            edt_objheight.Text := '400';

          if ValueExists('Objwidth') then
            Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
          else
            Edt_objwidth.Text := '400';

          if ValueExists('ObjPolylineClosed') then
            chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
          else
            chbx_AOpenPoly.Checked := False;

          if ValueExists('ObjBoxHighlight') then
            chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
          else
            chbx_AIsHiLite.Checked := False;

          if ValueExists('ObjStyle') then
          begin
            ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            chbx_AMoveable.Checked := ievsMoveable in osTmp;
            chbx_ASizeable.Checked := ievsSizeable in osTmp;
//          SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
//            chbx_ASelectable.Checked := ievsSelectable in osTmp;
//            chbx_AVisible.Checked := ievsVisible in osTmp;
          end else
          begin
            chbx_AMoveable.Checked := True;
            chbx_ASizeable.Checked := True;
//          SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
//            chbx_ASelectable.Checked := True;
//            chbx_AVisible.Checked := True;
          end;

          if ValueExists('FontName') then
              edt_TFont.Text := ReadString('FontName')
          else
              edt_TFont.Text := '';

          dlg_Schrift.Font.Name := edt_TFont.Text;
          edt_SFont.Text := edt_TFont.Text;

          if ValueExists('FontSize') then
          begin
            dlg_Schrift.Font.Size := ReadInteger('FontSize');
            edt_TFontSize.Text := IntToStr(ReadInteger('FontSize'));
          end else
          begin
            dlg_Schrift.Font.Size := 72;
            edt_TFontSize.Text := '72';
          end;

          if ValueExists('FontColor') then
            dlg_Schrift.Font.Color := ReadInteger('FontColor')
          else if ValueExists('ObjFontColor') then
            dlg_Schrift.Font.Color := ReadInteger('ObjFontColor');

          if ValueExists('FontStyle') then
          begin
            ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
            dlg_Schrift.Font.Style := fsTmp;
          end else
            dlg_Schrift.Font.Style := [];

          if ValueExists('ObjFontAngle') then
            edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
          else
            edt_TFontAngle.Text := '0';

          if ValueExists('ObjLabelPosition') then
          begin
            ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            case lpTmp of
              ielBegin:
                cbx_TLabelPos.ItemIndex := 0;
              ielEnd:
                cbx_TLabelPos.ItemIndex := 1;
            end;
          end else
            cbx_TLabelPos.ItemIndex := 0;

          if ValueExists('ObjTextAlign') then
          begin
            ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
            case taTmp of
              iejLeft:
                cbx_TAlign.ItemIndex := 0;
              iejRight:
                cbx_TAlign.ItemIndex := 1;
              iejCenter:
                cbx_TAlign.ItemIndex := 2;
              iejJustify:
                cbx_TAlign.ItemIndex := 3;
            end;
          end else
            cbx_TAlign.ItemIndex := 0;

          if ValueExists('ObjText') then
            memo_TObjText.Text := StringReplace(ReadString('ObjText'), '\n\r', sLineBreak, [rfReplaceAll])  // SJ 07.01.2020
          else
            memo_TObjText.Text := 'neuer Text';

          CloseKey;
        end else
        begin
          lv_eigenschaftstempel.Visible := False;
          memo_TObjText.Visible := True;
          memo_TObjText.Update;
          RootKey := HKEY_CURRENT_USER;
          OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKey, True);

          if ValueExists('ObjBrushColor') then
            clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
          else
            clbx_CBackground.Selected := 0;

          if ValueExists('ObjPenColor') then
            dlg_Schrift.Font.Color := ReadInteger('ObjPenColor')
          else
            dlg_Schrift.Font.Color := 0;

          case ObjTyp of
//            0, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12:
            0, 3, 4, 5:
            begin
              if ValueExists('ObjPenColor') then
              begin
                dlg_Schrift.Font.Color := ReadInteger('ObjPenColor');
                clbx_CBorder.Selected := ReadInteger('ObjPenColor');
              end else
                clbx_CBorder.Selected := 0;
            end;
          end;

          if ValueExists('ObjLabelBrushColor') then
            clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
          else
            clbx_CLabel.Selected := 0;

          if ValueExists('ObjMemoBorderColor') then
            clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
          else
            clbx_CNoteBorder.Selected := 0;

// <!-- SJ 05.09.2023 - ObjAutoIncreaseLine und ObjAutoIncreaseHeight sind rausgeflogen.
//                    - dafr ObjAutoSize neu. Sollte vorher ObjAutoIncreaseLine oder ObjAutoIncreaseHeight
//                    - gesetzt gewesen sein, nehmen wir das als ja fr ObjAutoSize.

//          if ValueExists('ObjAutoIncreaseLine') then
//            cbx_autolineincrease.Checked := ReadBool('ObjAutoIncreaseLine')
//          else
//            cbx_autolineincrease.Checked := False;
//
//          if ValueExists('ObjAutoIncreaseHeight') then
//            cbx_autoincreasehigh.Checked := ReadBool('ObjAutoIncreaseHeight')
//          else
//            cbx_autoincreasehigh.Checked := False;

          if not (ObjTyp in [0, 3, 4, 5]) then
          begin
            chbx_TObjAutoSize.Checked := False;
            if not ValueExists('ObjAutoSize') then
            begin
              if ValueExists('ObjAutoIncreaseLine') then
                chbx_TObjAutoSize.Checked := ReadBool('ObjAutoIncreaseLine');

              if ValueExists('ObjAutoIncreaseHeight') and (not chbx_TObjAutoSize.Checked) then
                chbx_TObjAutoSize.Checked := ReadBool('ObjAutoIncreaseHeight');
            end else
              chbx_TObjAutoSize.Checked := ReadBool('ObjAutoSize');
          end;
// SJ 05.09.2023 -->

          if ValueExists('ObjBrushStyle') then
          begin
            ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            case bsTmp of
              bsSolid:
                cbx_BBackground.ItemIndex := 7;
              bsClear:
                cbx_BBackground.ItemIndex := 0;
              bsHorizontal:
                cbx_BBackground.ItemIndex := 4;
              bsVertical:
                cbx_BBackground.ItemIndex := 3;
              bsFDiagonal:
                cbx_BBackground.ItemIndex := 1;
              bsBDiagonal:
                cbx_BBackground.ItemIndex := 2;
              bsCross:
                cbx_BBackground.ItemIndex := 5;
              bsDiagCross:
                cbx_BBackground.ItemIndex := 6;
            end;

//            if objtyp = 2 then
//              cbx_BBackground.ItemIndex := 0;
          end else
          begin
            cbx_BBackground.ItemIndex := 0;

            if objtyp = 2 then
             cbx_BBackground.ItemIndex := 0;
          end;

          if ValueExists('ObjLabelBrushStyle') then
          begin
            ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
            case bsTmp of
              bsSolid:
                cbx_BLabel.ItemIndex := 7;
              bsClear:
                cbx_BLabel.ItemIndex := 0;
              bsHorizontal:
                cbx_BLabel.ItemIndex := 4;
              bsVertical:
                cbx_BLabel.ItemIndex := 3;
              bsFDiagonal:
                cbx_BLabel.ItemIndex := 1;
              bsBDiagonal:
                cbx_BLabel.ItemIndex := 2;
              bsCross:
                cbx_BLabel.ItemIndex := 5;
              bsDiagCross:
                cbx_BLabel.ItemIndex := 6;
            end;

            if objtyp = 2 then
              cbx_BLabel.ItemIndex := 0;
          end else
          begin
            cbx_BLabel.ItemIndex := 0;

            if objtyp = 2 then
              cbx_BLabel.ItemIndex := 1;
          end;

          if ValueExists('ObjMemoCharsBrushStyle') then
          begin
            ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp));
            case bsTmp of
              bsClear:
                cbx_BLabel.ItemIndex := 0;
              bsSolid:
                cbx_BLabel.ItemIndex := 1;
            end;
          end else
            cbx_BLabel.ItemIndex := 0;

          if ValueExists('ObjPenStyle') then
          begin
            ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            case psTmp of
              psSolid:
                cbx_BBorder.ItemIndex := 0;
              psDash:
                cbx_BBorder.ItemIndex := 2;
              psDot:
                cbx_BBorder.ItemIndex := 5;
              psDashDot:
                cbx_BBorder.ItemIndex := 3;
              psDashDotDot:
                cbx_BBorder.ItemIndex := 4;
              psClear:
                cbx_BBorder.ItemIndex := 1;
            end;

            if objtyp = 2 then
              cbx_BBorder.ItemIndex := 1;
          end else
          begin
            cbx_BBorder.ItemIndex := 0;

            if objtyp = 2 then
              cbx_BBorder.ItemIndex := 1;
          end;

          if ValueExists('ObjMemoBorderStyle') then
          begin
            ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
            case psTmp of
              psSolid:
                cbx_BNoteBorder.ItemIndex := 0;
              psDash:
                cbx_BNoteBorder.ItemIndex := 2;
              psDot:
                cbx_BNoteBorder.ItemIndex := 5;
              psDashDot:
                cbx_BNoteBorder.ItemIndex := 3;
              psDashDotDot:
                cbx_BNoteBorder.ItemIndex := 4;
              psClear:
                cbx_BNoteBorder.ItemIndex := 1;
            end;

            if objtyp = 2 then
              cbx_BNoteBorder.ItemIndex := 1;
          end else
          begin
            cbx_BNoteBorder.ItemIndex := 0;

            if objtyp = 2 then
              cbx_BNoteBorder.ItemIndex := 1;
          end;

          if ValueExists('ObjBeginShape') then
          begin
            ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            case shTmp of
              iesNONE:
                rbtn_SSNo.Checked := True;
              iesINARROW:
                rbtn_SSIn.Checked := True;
              iesOUTARROW:
                rbtn_SSOut.Checked := True;
            end;
          end else
            rbtn_SSNo.Checked := True;

          if ValueExists('ObjEndShape') then
          begin
            ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            case shTmp of
              iesNONE:
                rbtn_SENo.Checked := True;
              iesINARROW:
                rbtn_SEIn.Checked := True;
              iesOUTARROW:
                rbtn_SEOut.Checked := True;
            end;
          end else
            rbtn_SENo.Checked := True;

          if ValueExists('ObjShapeHeight') then
            edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
          else
            edt_SSHeight.Text := '0';

          if ValueExists('ObjShapeWidth') then
            edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
          else
            edt_SSWidth.Text := '0';

          if ValueExists('ObjName') then
            edt_AObjName.Text := dgettext('Shared36', ReadString('ObjName'))
          else
            edt_AObjName.Text := sRegKey;

          if ValueExists('ObjPenWidth') then
            edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
          else
            edt_APenWidth.Text := '1';

          if ValueExists('ObjRulerType') then
          begin
            ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
            case rtTmp of
              iertRULER:
                cbx_ARulerTyp.ItemIndex := 0;
              iertQUOTEBEGIN:
                cbx_ARulerTyp.ItemIndex := 1;
              iertQUOTECENTER:
                cbx_ARulerTyp.ItemIndex := 2;
              iertQUOTEEND:
                cbx_ARulerTyp.ItemIndex := 3;
            end;
          end else
            cbx_ARulerTyp.ItemIndex := 0;

          if ValueExists('ObjRulerUnit') then
          begin
            ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
            case ruTmp of
              ieuPIXELS:
                cbx_ARulerMes.ItemIndex := 0;
              ieuINCHES:
                cbx_ARulerMes.ItemIndex := 1;
              ieuKM:
                cbx_ARulerMes.ItemIndex := 5;
              ieuMETERS:
                cbx_ARulerMes.ItemIndex := 4;
              ieuCENTIMETERS:
                cbx_ARulerMes.ItemIndex := 3;
              ieuMILLIMETERS:
                cbx_ARulerMes.ItemIndex := 2;
              ieuMICRONS:
                cbx_ARulerMes.ItemIndex := 6;
              ieuNANOMETERS:
                cbx_ARulerMes.ItemIndex := 7;
            end;
          end else
            cbx_ARulerMes.ItemIndex := 0;

          if ValueExists('ObjTransparency') then
            edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
          else
            edt_ATransp.Text := '110';

          if ValueExists('ObjHeight') then
            edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
          else
            edt_objheight.Text := '400';

          if ValueExists('Objwidth') then
            Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
          else
            Edt_objwidth.Text := '400';

          if ValueExists('ObjPolylineClosed') then
            chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
          else
          begin
            if ObjTyp = 13 then
              chbx_AOpenPoly.Checked := True
            else
              chbx_AOpenPoly.Checked := False;
          end;

          if ValueExists('ObjBoxHighlight') then
            chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
          else
            chbx_AIsHiLite.Checked := False;

          if ValueExists('ObjStyle') then
          begin
            ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            chbx_AMoveable.Checked := ievsMoveable in osTmp;
            chbx_ASizeable.Checked := ievsSizeable in osTmp;
//          SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
//            chbx_ASelectable.Checked := ievsSelectable in osTmp;
//            chbx_AVisible.Checked := ievsVisible in osTmp;
          end else
          begin
            chbx_AMoveable.Checked := True;
            chbx_ASizeable.Checked := True;
//          SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
//            chbx_ASelectable.Checked := True;
//            chbx_AVisible.Checked := True;
          end;

          if ValueExists('ObjFontName') then
            edt_TFont.Text := ReadString('ObjFontName')
          else
            edt_TFont.Text := '';

          dlg_Schrift.Font.Name := edt_TFont.Text;
          edt_SFont.Text := edt_TFont.Text;

          if ValueExists('ObjFontHeight') then
          begin
            dlg_Schrift.Font.Size := ReadInteger('ObjFontHeight');
            edt_TFontSize.Text := IntToStr(ReadInteger('ObjFontHeight'));
          end else
          begin
            dlg_Schrift.Font.Size := 72;
            edt_TFontSize.Text := '72';
          end;

          if ValueExists('ObjFontStyles') then
          begin
            ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            dlg_Schrift.Font.Style := fsTmp;
          end else
            dlg_Schrift.Font.Style := [];

          if ValueExists('ObjFontAngle') then
            edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
          else
            edt_TFontAngle.Text := '0';

          if ValueExists('ObjLabelPosition') then
          begin
            ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            case lpTmp of
              ielBegin:
                cbx_TLabelPos.ItemIndex := 0;
              ielEnd:
                cbx_TLabelPos.ItemIndex := 1;
            end;
          end else
            cbx_TLabelPos.ItemIndex := 0;

          if ValueExists('ObjTextAlign') then
          begin
            ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
            case taTmp of
              iejLeft:
                cbx_TAlign.ItemIndex := 0;
              iejRight:
                cbx_TAlign.ItemIndex := 1;
              iejCenter:
                cbx_TAlign.ItemIndex := 2;
              iejJustify:
                cbx_TAlign.ItemIndex := 3;
            end;
          end else
            cbx_TAlign.ItemIndex := 0;

          if ValueExists('ObjText') then
            memo_TObjText.Text := StringReplace(ReadString('ObjText'), '\n\r', sLineBreak, [rfReplaceAll]) // SJ 07.01.2020
          else
            memo_TObjText.Text := 'neuer Text';

          CloseKey;
        end;
      end;
    except
      on e: Exception do
      begin
        BfShowMessage(_('Fehler beim Lesen des Registrierung:') + e.Message);
        Result := False;
      end;
    end;
  finally
    if Assigned(reg) then
      FreeAndNil(reg);
    cbx_nummer.Invalidate;
    Self.Invalidate;
  end;
end;

/////////////////////////////////////////////////////////////////////////////////////////////
//    Objekt eigenschaften in der Registrierung sichern


function Tfrm_DocEditOpt.SaveObjVal(ObjTyp: Integer): Boolean;
   //////////////////////////////////////////////////////////////////
   ///  11.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function sichert die Objekteigenschaften des Ob-    ///
   ///  jekttyps [ObjTyp] in der Registrierung.                   ///
   ///                                                            ///
   ///  Parameter: ObjTyp        Objekttyp                        ///
   ///             0             Textmarker                       ///
   ///             1             Notiz                            ///
   ///             2             Text                             ///
   ///             3             Stempel  nicht mehr angezeigt    ///
   ///             4             LineLabel                        ///
   ///             5             Polyline                         ///
   ///             6             Poligon                          ///
   ///             7             Ellipse                          ///
   ///             8             Box                              ///
   ///             9             Arrow                            ///
   ///             10            Mastab                          ///
   ///             11            Winkel                           ///
   ///             12            Buchungsstempel                  ///
   ///             13            Freihand                         ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
  sRegKey, lszusstring: String;
  Reg: TRegistry;
  fsTmp: TFontStyles;
  {$IFDEF IMAGEEN1140}
  shTmp: TIEVArrowShape;
  {$ELSE}
  shTmp: TIEShape;
  {$ENDIF}
  bsTmp: TBrushStyle;
  lpTmp: TIELabelPos;
  psTmp: TPenStyle;
  rtTmp: TIEVRulerType;
  ruTmp: TIEUnits;
  osTmp: TIEVStyle;
  taTmp: TIEAlignment;
begin
  Result := True;
  reg := TRegistry.Create;
  try
    try
      if fifavnum = 0 then
        lszusstring := ''
      else
        lszusstring := inttostr(fifavnum);

      case ObjTyp of
        0:
          sRegKey := 'HiLite' + lszusstring;
        1:
          sRegKey := 'Note' + lszusstring;
        2:
          sRegKey := 'Text' + lszusstring;
        3:
          sRegKey := 'Polyline';
        4:
          sRegKey := 'Arrow';
        5:
          sRegKey := 'Freihand' + lszusstring;
        13:
          sRegKey := 'Stempel';
//        3:
//          sRegKey := 'LineLabel';
//        4:
//          sRegKey := 'Polyline';
//        5:
//          sRegKey := 'Poligon';
//        6:
//          sRegKey := 'Ellipse';
//        7:
//          sRegKey := 'Box';
//        8:
//          sRegKey := 'Arrow';
//        9:
//          sRegKey := 'Ruler';
//        10:
//          sRegKey := 'Angle';
//        11:
//          sRegKey := 'Buchungsstempel';
//        12:
//          sRegKey := 'Freihand' + lszusstring;
//        13:
//          sRegKey := 'Stempel';
      end;

      with reg do
      begin
        if ObjTyp = 13 then
        begin
          if lv_eigenschaftstempel.Selected = nil then
            Exit;

          RootKey := HKEY_CURRENT_USER;
          OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  lv_eigenschaftstempel.Selected.SubItems.Strings[0], True);
          WriteInteger('ObjBrushColor', clbx_CBackground.Selected);
          WriteInteger('ObjPenColor', dlg_Schrift.Font.Color);
          WriteInteger('ObjLabelBrushColor', clbx_CLabel.Selected);
          WriteInteger('ObjMemoBorderColor', clbx_CNoteBorder.Selected);
          case cbx_BBackground.ItemIndex of
            0:
              bsTmp := bsClear;
            1:
              bsTmp := bsFDiagonal;
            2:
              bsTmp := bsBDiagonal;
            3:
              bsTmp := bsVertical;
            4:
              bsTmp := bsHorizontal;
            5:
              bsTmp := bsCross;
            6:
              bsTmp := bsDiagCross;
            7:
              bsTmp := bsSolid;
          end;
          WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));

          case cbx_BLabel.ItemIndex of
            0:
              bsTmp := bsClear;
            1:
              bsTmp := bsFDiagonal;
            2:
              bsTmp := bsBDiagonal;
            3:
              bsTmp := bsVertical;
            4:
              bsTmp := bsHorizontal;
            5:
              bsTmp := bsCross;
            6:
              bsTmp := bsDiagCross;
            7:
              bsTmp := bsSolid;
          end;
          WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));

          case cbx_BBorder.ItemIndex of
            0:
              psTmp := psSolid;
            1:
              psTmp := psClear;
            2:
              psTmp := psDash;
            3:
              psTmp := psDashDot;
            4:
              psTmp := psDashDotDot;
            5:
              psTmp := psDot;
          end;
          WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));

          case cbx_BNoteBorder.ItemIndex of
            0:
              psTmp := psSolid;
            1:
              psTmp := psClear;
            2:
              psTmp := psDash;
            3:
              psTmp := psDashDot;
            4:
              psTmp := psDashDotDot;
            5:
              psTmp := psDot;
          end;
          WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));

          if rbtn_SSNo.Checked then
            shTmp := iesNONE;
          if rbtn_SSIn.Checked then
            shTmp := iesINARROW;
          if rbtn_SSOut.Checked then
            shTmp := iesOUTARROW;
          WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));

          if rbtn_SENo.Checked then
            shTmp := iesNONE;
          if rbtn_SEIn.Checked then
            shTmp := iesINARROW;
          if rbtn_SEOut.Checked then
            shTmp := iesOUTARROW;
          WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));

          WriteInteger('ObjShapeHeight', Round(edt_SSHeight.Value));
          WriteInteger('ObjShapeWidth', Round(edt_SSWidth.Value));
          WriteString('ObjName', edt_AObjName.Text);
          WriteInteger('ObjPenWidth', Round(edt_APenWidth.Value));
          case cbx_ARulerTyp.ItemIndex of
            0:
              rtTmp := iertRULER;
            1:
              rtTmp := iertQUOTEBEGIN;
            2:
              rtTmp := iertQUOTECENTER;
            3:
              rtTmp := iertQUOTEEND;
          end;
          WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));

          case cbx_ARulerMes.ItemIndex of
            0:
              ruTmp := ieuPIXELS;
            1:
              ruTmp := ieuINCHES;
            2:
              ruTmp := ieuMILLIMETERS;
            3:
              ruTmp := ieuCENTIMETERS;
            4:
              ruTmp := ieuMETERS;
            5:
              ruTmp := ieuKM;
            6:
              ruTmp := ieuMICRONS;
            7:
              ruTmp := ieuNANOMETERS;
          end;
          WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));

          WriteInteger('ObjTransparency', Round(edt_ATransp.Value));
          WriteInteger('Objwidth', Round(edt_objwidth.Value));
          WriteInteger('Objheight', Round(edt_objheight.Value));
          WriteBool('ObjPolylineClosed', not chbx_AOpenPoly.Checked);
          WriteBool('ObjBoxHighlight', chbx_AIsHiLite.Checked);

//        SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
//          osTmp := [];
//          if chbx_ASelectable.Checked then
//            osTmp := osTmp + [ievsSelectable];
//          if chbx_AVisible.Checked then
//            osTmp := osTmp + [ievsVisible];
          osTmp := [ievsSelectable, ievsVisible];
          if chbx_AMoveable.Checked then
            osTmp := osTmp + [ievsMoveable];
          if chbx_ASizeable.Checked then
            osTmp := osTmp + [ievsSizeable];

          WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
          WriteString('ObjFontName', dlg_Schrift.Font.Name);
          WriteString('FontName', dlg_Schrift.Font.Name);
          WriteInteger('ObjFontColor', dlg_Schrift.Font.Color);
          WriteInteger('FontColor', dlg_Schrift.Font.Color);
          WriteInteger('ObjFontHeight', Round(edt_TFontSize.Value));
          WriteInteger('Fontsize', Round(edt_TFontSize.Value));
          // SJ 16.03.23 - wir speichern die gleichen Werte in ObjFontHeight, FontSize, ObjFontSize ???
//          WriteInteger('ObjFontSize', Round(edt_TFontSize.Value));
          fsTmp := dlg_Schrift.Font.Style;
          WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
          WriteInteger('ObjFontHeight', Round(edt_TFontSize.Value));
          WriteFloat('ObjFontAngle', StrToFloat(edt_TFontAngle.Text));

          case cbx_TLabelPos.ItemIndex of
            0:
              lpTmp := ielBegin;
            1:
              lpTmp := ielEnd;
          end;
          WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));

          case cbx_TAlign.ItemIndex of
            0:
              taTmp := iejLeft;
            1:
              taTmp := iejRight;
            2:
              taTmp := iejCenter;
            3:
              taTmp := iejJustify;
          end;
          WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
          WriteString('ObjText', StringReplace(memo_TObjText.Text, sLineBreak, '\n\r',[rfReplaceAll])); // SJ 07.01.2020
          CloseKey;
        end else
        begin
          RootKey := HKEY_CURRENT_USER;
          OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKey, True);
          WriteInteger('ObjBrushColor', clbx_CBackground.Selected);
          case ObjTyp of
//            0, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12:
            0, 3, 4, 5:
              WriteInteger('ObjPenColor', clbx_CBorder.Selected);
          else
            WriteInteger('ObjPenColor', dlg_Schrift.Font.Color);
          end;

          WriteInteger('ObjLabelBrushColor', clbx_CLabel.Selected);
          WriteInteger('ObjMemoBorderColor', clbx_CNoteBorder.Selected);
//          WriteBool('ObjAutoIncreaseLine', cbx_autolineincrease.Checked);
//          WriteBool('ObjAutoIncreaseHeight', cbx_autoincreasehigh.Checked);

          case cbx_BBackground.ItemIndex of
            0:
              bsTmp := bsClear;
            1:
              bsTmp := bsFDiagonal;
            2:
              bsTmp := bsBDiagonal;
            3:
              bsTmp := bsVertical;
            4:
              bsTmp := bsHorizontal;
            5:
              bsTmp := bsCross;
            6:
              bsTmp := bsDiagCross;
            7:
              bsTmp := bsSolid;
          end;
          WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));

          if objTyp = 2 then
          begin
             case cbx_BLabel.ItemIndex of
               0:
                 bsTmp := bsClear;
               1:
                 bsTmp := bsSolid;
             end;
             WriteBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp));
          end else
          begin
             case cbx_BLabel.ItemIndex of
               0:
                 bsTmp := bsClear;
               1:
                 bsTmp := bsFDiagonal;
               2:
                 bsTmp := bsBDiagonal;
               3:
                 bsTmp := bsVertical;
               4:
                 bsTmp := bsHorizontal;
               5:
                 bsTmp := bsCross;
               6:
                 bsTmp := bsDiagCross;
               7:
                 bsTmp := bsSolid;
             end;
             WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
          end;

          case cbx_BBorder.ItemIndex of
            0:
              psTmp := psSolid;
            1:
              psTmp := psClear;
            2:
              psTmp := psDash;
            3:
              psTmp := psDashDot;
            4:
              psTmp := psDashDotDot;
            5:
              psTmp := psDot;
          end;
          WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));

          case cbx_BNoteBorder.ItemIndex of
            0:
              psTmp := psSolid;
            1:
              psTmp := psClear;
            2:
              psTmp := psDash;
            3:
              psTmp := psDashDot;
            4:
              psTmp := psDashDotDot;
            5:
              psTmp := psDot;
          end;
          WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));

          if rbtn_SSNo.Checked then
            shTmp := iesNONE;
          if rbtn_SSIn.Checked then
            shTmp := iesINARROW;
          if rbtn_SSOut.Checked then
            shTmp := iesOUTARROW;
          WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));

          if rbtn_SENo.Checked then
            shTmp := iesNONE;
          if rbtn_SEIn.Checked then
            shTmp := iesINARROW;
          if rbtn_SEOut.Checked then
            shTmp := iesOUTARROW;
          WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));

          WriteInteger('ObjShapeHeight', Round(edt_SSHeight.Value));
          WriteInteger('ObjShapeWidth', Round(edt_SSWidth.Value));
          WriteString('ObjName', edt_AObjName.Text);
          WriteInteger('ObjPenWidth', Round(edt_APenWidth.Value));

          case cbx_ARulerTyp.ItemIndex of
            0:
              rtTmp := iertRULER;
            1:
              rtTmp := iertQUOTEBEGIN;
            2:
              rtTmp := iertQUOTECENTER;
            3:
              rtTmp := iertQUOTEEND;
          end;
          WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));

          case cbx_ARulerMes.ItemIndex of
            0:
              ruTmp := ieuPIXELS;
            1:
              ruTmp := ieuINCHES;
            2:
              ruTmp := ieuMILLIMETERS;
            3:
              ruTmp := ieuCENTIMETERS;
            4:
              ruTmp := ieuMETERS;
            5:
              ruTmp := ieuKM;
            6:
              ruTmp := ieuMICRONS;
            7:
              ruTmp := ieuNANOMETERS;
          end;
          WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));

          WriteInteger('ObjTransparency', Round(edt_ATransp.Value));
          WriteInteger('Objwidth', Round(edt_objwidth.Value));
          WriteInteger('Objheight', Round(edt_objheight.Value));
          WriteBool('ObjPolylineClosed', not chbx_AOpenPoly.Checked);
          WriteBool('ObjBoxHighlight', chbx_AIsHiLite.Checked);

//        SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
//          osTmp := [];
//          if chbx_ASelectable.Checked then
//            osTmp := osTmp + [ievsSelectable];
//          if chbx_AVisible.Checked then
//            osTmp := osTmp + [ievsVisible];
          osTmp := [ievsSelectable, ievsVisible];
          if chbx_AMoveable.Checked then
            osTmp := osTmp + [ievsMoveable];
          if chbx_ASizeable.Checked then
            osTmp := osTmp + [ievsSizeable];
          WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));

          WriteString('ObjFontName', dlg_Schrift.Font.Name);
          WriteInteger('ObjFontSize', Round(edt_TFontSize.Value));
          WriteInteger('ObjFontHeight', Round(edt_TFontSize.Value));
          fsTmp := dlg_Schrift.Font.Style;
          WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
          WriteInteger('FontSize', Round(edt_TFontSize.Value));
          WriteFloat('ObjFontAngle', Round(edt_TFontAngle.Value));
          WriteBool('ObjAutoSize', chbx_TObjAutoSize.Checked); // SJ 05.09.2023

          case cbx_TLabelPos.ItemIndex of
            0:
              lpTmp := ielBegin;
            1:
              lpTmp := ielEnd;
          end;
          WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));

          case cbx_TAlign.ItemIndex of
            0:
              taTmp := iejLeft;
            1:
              taTmp := iejRight;
            2:
              taTmp := iejCenter;
            3:
              taTmp := iejJustify;
          end;
          WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));

          WriteString('ObjText', StringReplace(memo_TObjText.Text, sLineBreak, '\n\r',[rfReplaceAll])); // SJ 07.01.2020
          CloseKey;
        end;
      end;
    except
      on e: Exception do
      begin
        BfSHowMessage(_('Fehler beim Schreiben in die Registrierung: ') + e.Message);
        Result := False;
      end;
    end;
  finally
    if Assigned(reg) then
      FreeAndNil(reg);
  end;
end;


procedure Tfrm_DocEditOpt.btn_SaveClick(Sender: TObject);
begin
  if pctrl_DocEditOpt.ActivePage = tbs_Annotations then
    SaveObjVal(tctrl_Annos.TabIndex)
  else if pctrl_DocEditOpt.ActivePage = tbs_Stempel then
    btn_SaveStampClick(Self);
end;

procedure Tfrm_DocEditOpt.tctrl_AnnosChange(Sender: TObject);
begin
  LoadObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_DocEditOpt.tctrl_AnnosChanging(Sender: TObject; var AllowChange: Boolean);
begin
  SaveObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_DocEditOpt.tctrl_AnnosDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect;
  Active: Boolean);
var
  AText: string;
  APoint: TPoint;
begin
  with (Control as TTabControl).Canvas do
  begin
    Brush.Color := stlControl.Color;
    Font.Color := stlControl.TextColor;
    FillRect(Rect);
    TTabControl(Control).Font.Color := stlControl.TextColor;
    AText := TTabControl(Control).Tabs[TabIndex];
    with Control.Canvas do
    begin
      APoint.x := (Rect.Right - Rect.Left) div 2 - TextWidth(AText) div 2;
      APoint.y := (Rect.Bottom - Rect.Top) div 2 - TextHeight(AText) div 2;
      TextRect(Rect, Rect.Left + APoint.x, Rect.Top + APoint.y, AText);
    end;
  end;
end;

procedure Tfrm_DocEditOpt.btn_okClick(Sender: TObject);
begin
  ////////////////////////////////////////////////////////////////////////////////////

  //  Modifizierte Daten des Objektes Speichern

  try
    if pctrl_DocEditOpt.ActivePage = tbs_Annotations then
      SaveObjVal(tctrl_Annos.TabIndex)
    else if pctrl_DocEditOpt.ActivePage = tbs_Stempel then
      btn_SaveStampClick(Self);
  except

  end;
end;

procedure Tfrm_DocEditOpt.edt_SSHeightChange(Sender: TObject);
begin
  if TNumberBox(Sender).Value < 1 then
  begin
    TNumberBox(Sender).Text := '1';
    TNumberBox(Sender).Value := 1;
  end;
end;

procedure Tfrm_DocEditOpt.edt_SSWidthChange(Sender: TObject);
begin
  if TNumberBox(Sender).Value < 1 then
  begin
    TNumberBox(Sender).Text := '1';
    TNumberBox(Sender).Value := 1;
  end;
end;

procedure Tfrm_DocEditOpt.edt_APenWidthChange(Sender: TObject);
var
  iValue: Integer;
begin
  if TryStrToInt(TSpTBXEdit(Sender).Text, iValue) then
    TSpTBXEdit(Sender).Tag := iValue
  else
    TSpTBXEdit(Sender).Text := IntToStr(TSpTBXEdit(Sender).Tag);
end;

///////////////////////////////////////////////////////////////////////////////////
//  Transparenz aendern

procedure Tfrm_DocEditOpt.edt_ATranspChange(Sender: TObject);
begin
  if TNumberBox(Sender).Value < 0 then
  begin
    TNumberBox(Sender).Text := '0';
    TNumberBox(Sender).Value := 0;
  end else if TNumberBox(Sender).Value > 255 then
  begin
    TNumberBox(Sender).Text := '255';
    TNumberBox(Sender).Value := 255;
  end;
end;

procedure Tfrm_DocEditOpt.edt_objheightChange(Sender: TObject);
begin
  if TNumberBox(Sender).Value < 1 then
  begin
    TNumberBox(Sender).Text := '1';
    TNumberBox(Sender).Value := 1;
  end;
end;

procedure Tfrm_DocEditOpt.edt_TFontAngleChange(Sender: TObject);
begin
  if TNumberBox(Sender).Value < -359 then
  begin
    TNumberBox(Sender).Text := '-359';
    TNumberBox(Sender).Value := -359;
  end else if TNumberBox(Sender).Value > 359 then
  begin
    TNumberBox(Sender).Text := '359';
    TNumberBox(Sender).Value := 359;
  end;
end;

procedure Tfrm_DocEditOpt.edt_TFontSizeChange(Sender: TObject);
begin
  if TNumberBox(Sender).Value < 1 then
  begin
    TNumberBox(Sender).Value := 0;
    TNumberBox(Sender).Text := '0';
  end;
end;

procedure Tfrm_DocEditOpt.cbx_TLabelPosChange(Sender: TObject);
begin
  if cbx_TLabelPos.ItemIndex = -1 then
    cbx_TLabelPos.ItemIndex := 0;
end;

function Tfrm_DocEditOpt.CheckStampModification(StampKey: String): Boolean;
var
  reg: TRegistry;
  bsTmp: TBrushStyle;
  psTmp: TPenStyle;
begin
// wir prfen ob der aktuelle Stempel gendert wurde. Wenn ja, knnen wir fragen ob
// die nderungen gespeichert oder verworfen werden sollen
  try
    Result := False;

    if not Self.Visible then
      Exit;

    reg := TRegistry.Create;
    with reg do
    begin
      if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
        Exit;
      OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);

      if ValueExists('favnr') then
        if cbb_fav.ItemIndex <> ReadInteger('favnr') then
          Result := True;

      if ValueExists('FontColor') then
      begin
        if dlg_Schrift.Font.Color <> ReadInteger('FontColor') then
          Result := True;
      end else
      if ValueExists('ObjFontColor') then
      begin
        if dlg_Schrift.Font.Color <> ReadInteger('ObjFontColor') then
          Result := True;
      end;

      if ValueExists('FontName') then
      begin
        if dlg_Schrift.Font.Name <> ReadString('FontName') then
          Result := True;
      end else
      if ValueExists('ObjFontName') then
      begin
        if dlg_Schrift.Font.Name <> ReadString('ObjFontName') then
          Result := True;
      end;

      if ValueExists('FontSize') then
        if dlg_Schrift.Font.Size <> ReadInteger('FontSize') then
          Result := True;

      if ValueExists('StampName') then
        if edt_SName.Text <> ReadString('StampName') then
          Result := True;

      if ValueExists('StampText') then
        if StringReplace(memo_SText.Text,''#$D#$A'','\n\r',[rfReplaceAll]) <> ReadString('StampText') then    //31.05.2024 SD -->bfacrm:ticket__show__38338
          Result := True;

      if ValueExists('StampTyp') then
      begin
  //    StampTyp 0 = rbtn_SBild
  //    StampTyp 1 = rbtn_SText
        if ReadBool('StampTyp') and (not rbtn_SBild.Checked) then
          Result := True
        else if (not ReadBool('StampTyp')) and (not rbtn_SText.Checked) then
          Result := True;
      end;

      if ValueExists('StampFitToText') then
        if chk_Anpassen.Checked <> ReadBool('StampFitToText') then
          Result := True;

      if ValueExists('StampFixedSize') then
        if chk_fixedsize.Checked <> ReadBool('StampFixedSize') then
          Result := True;

      if ValueExists('ObjBrushColor') then
        if clrbx_Stampcolor.Selected <> ReadInteger('ObjBrushColor') then
          Result := True;

      if ValueExists('ObjMemoBorderColor') then
        if clrbx_Stampborder.Selected <> ReadInteger('ObjMemoBorderColor') then
          Result := True;

      if ValueExists('ObjMemoBorderStyle') then
        ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
      else
        psTmp := psClear;
      if (cbx_Stampborder.ItemIndex = 0) and (psTmp <> psSolid) then
        Result := True
      else if (cbx_Stampborder.ItemIndex = 1) and (psTmp <> psClear) then
        Result := True
      else if (cbx_Stampborder.ItemIndex = 2) and (psTmp <> psDash) then
        Result := True
      else if (cbx_Stampborder.ItemIndex = 3) and (psTmp <> psDashDot) then
        Result := True
      else if (cbx_Stampborder.ItemIndex = 4) and (psTmp <> psDashDotDot) then
        Result := True
      else if (cbx_Stampborder.ItemIndex = 5) and (psTmp <> psDot) then
        Result := True;

      if ValueExists('ObjBrushStyle') then
        ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
      else
        bsTmp := bsClear;
      if (cbx_Stampstyle.ItemIndex = 0) and (bsTmp <> bsClear) then
        Result := True
      else if (cbx_Stampstyle.ItemIndex = 1) and (bsTmp <> bsFDiagonal) then
        Result := True
      else if (cbx_Stampstyle.ItemIndex = 2) and (bsTmp <> bsBDiagonal) then
        Result := True
      else if (cbx_Stampstyle.ItemIndex = 3) and (bsTmp <> bsVertical) then
        Result := True
      else if (cbx_Stampstyle.ItemIndex = 4) and (bsTmp <> bsHorizontal) then
        Result := True
      else if (cbx_Stampstyle.ItemIndex = 5) and (bsTmp <> bsCross) then
        Result := True
      else if (cbx_Stampstyle.ItemIndex = 6) and (bsTmp <> bsDiagCross) then
        Result := True
      else if (cbx_Stampstyle.ItemIndex = 7) and (bsTmp <> bsSolid) then
        Result := True;

      if ValueExists('ObjMemoCharsBrushStyle') then
        ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp))
      else
        bsTmp := bsClear;

      if (cbx_Textstyle.ItemIndex <> 0) and (bsTmp = bsClear) then
        Result := True
      else if (cbx_Textstyle.ItemIndex <> 1) and (bsTmp = bsSolid) then
        Result := True;

      if ValueExists('ObjTransparency') then
        if edt_Deckkraft1.Text <> IntToStr(Round(ReadInteger('ObjTransparency') / 2.55)) then
          Result := True;

      if ValueExists('StampFile') then
        if edt_SBild.Text <> ReadString('StampFile') then
          Result := True;

      if ValueExists('StampHeight') then
        if edt_SHeight.Text <> IntToStr(ReadInteger('StampHeight')) then
          Result := True;

      if ValueExists('StampWidth') then
        if edt_SWidth.Text <> IntToStr(ReadInteger('StampWidth')) then
          Result := True;

      if ValueExists('StampWidth') then
        if edt_SWidth.Text <> IntToStr(ReadInteger('StampWidth')) then
          Result := True;

    end;
  finally
    if Assigned(reg) then
       FreeAndNil(reg);
  end;
end;

procedure Tfrm_DocEditOpt.cbx_TAlignChange(Sender: TObject);
begin
  if cbx_TAlign.ItemIndex = -1 then
    cbx_TAlign.ItemIndex := 0;
end;

procedure Tfrm_DocEditOpt.cbx_ARulerTypChange(Sender: TObject);
begin
  if cbx_ARulerTyp.ItemIndex = -1 then
    cbx_ARulerTyp.ItemIndex := 0;
end;

procedure Tfrm_DocEditOpt.cbx_ARulerMesChange(Sender: TObject);
begin
  if cbx_ARulerMes.ItemIndex = -1 then
    cbx_ARulerMes.ItemIndex := 0;
end;

procedure Tfrm_DocEditOpt.sbtn_TFontClick(Sender: TObject);
begin
  if dlg_Schrift.Execute then
  begin
    edt_TFont.Text := dlg_Schrift.Font.Name;
    edt_SFont.Text := edt_TFont.Text;
    edt_TFontSize.Text := IntToStr(dlg_Schrift.Font.Size);
    if tctrl_Annos.TabIndex = 4 then
      clbx_CBorder.Selected := dlg_Schrift.Font.Color;
  end;
end;

procedure  Tfrm_DocEditOpt.load_SBild;
var
  iSWidth, iSHeight: Integer;
  iev_myvect: TbfaImageEnVect;
  mesTmp: TIEUnits;
begin
  if Trim(edt_SBild.Text) = '' then
    Exit
  else if FileExists(edt_SBild.Text) then
  begin
    img_SBild.IO.LoadFromFile(edt_SBild.Text);
    img_SBild.Show;
    iSWidth := img_SBild.IO.Params.Width;
    iSHeight := img_SBild.IO.Params.Height;
    iev_myvect := TbfaImageEnVect.Create(self);
    iev_myvect.DpiX := img_SBild.IO.Params.DpiX;
    iev_myvect.DpiY := img_SBild.IO.Params.DpiY;
    with iev_myvect do
    begin
      mesTmp := MUnit;
      MUnit := ieuMILLIMETERS;
      edt_SWidth.Text := inttostr(Round(iSWidth * MeasureCoefX));
      edt_SHeight.Text := inttostr(Round(iSHeight * MeasureCoefY));
      MUnit := mesTmp;
    end;
  end else
  begin
    img_SBild.Clear;
    img_SBild.Bitmap.Canvas.Font.Color := clBlack;
    img_SBild.Bitmap.Canvas.Font.Name := 'Arial';
    img_SBild.Bitmap.Canvas.Font.Size := 48;
    img_SBild.Bitmap.Canvas.TextOut(50,70,'Bilddatei nicht gefunden');
  end;
end;



procedure Tfrm_DocEditOpt.btn_NewStampClick(Sender: TObject);
begin
  CreStamp;
end;

procedure Tfrm_DocEditOpt.btn_SaveStampClick(Sender: TObject);
begin
  btnSaveStampExecute(True);
end;

procedure Tfrm_DocEditOpt.btnSaveStampExecute(SelectByName: Boolean = True);
begin
  if lv_Stamps.Selected <> nil then
  begin
    try
      if not isCreateStampOk(edt_SName.Text) then
      begin
//        lv_Stamps.Selected.Caption := '';
//        edt_SName.Text := '';
//        edt_SName.SetFocus;
        Exit;
      end;

      SavStamp(sGStampKey);
      ListStamps(False, SelectByName);
    except
      //
    end;
  end;
end;

procedure Tfrm_DocEditOpt.btn_DelStampClick(Sender: TObject);
var
  lStampName, lsMsg, lsInfo: String;
  liindex: Integer;
begin
  lStampName := Trim(edt_SName.Text);

  if lStampName = '' then
  begin
    selectStampListItem(0);
    Exit;
  end;

  // der Aufruf mittel MessageBox verhindert, das der Dialog DocEditOpt ausgeblendet wird
  // f.schneider
  lsMsg := Format(_('Wollen Sie den Stempel "%s" wirklich lschen ?'),[lStampName]);
  lsInfo := _('Stempel lschen ?');
  if MessageBox(Self.Handle,Pchar(lsMsg),PChar(lsInfo), MB_ICONWARNING or MB_YESNO) = mrNo then
    Exit;

  if lv_Stamps.SelCount > 0 then
  begin
    liindex := lv_Stamps.Selected.Index;
    DelStamp(lv_Stamps.Selected.SubItems.Strings[1]);
    ListStamps(False);
    if (liindex < lv_stamps.Items.Count) then
    begin
      if liindex > 0 then
      begin
        lv_stamps.Items[liindex - 1].Selected := True;
        lv_stamps.Items.Item[liindex - 1].Focused := True;
      end else
      begin
        lv_stamps.Items[liindex].Selected := True;
        lv_stamps.Items.Item[liindex].Focused := True;
      end;
    end else
    begin
      if lv_stamps.Items.Count > 0 then
      begin
        lv_stamps.Items[0].Selected := True;
        lv_stamps.Items.Item[0].Focused := True;
      end;
    end;

    lv_stamps.SetFocus;
    lv_StampsClick(lv_stamps.Selected);
  end;
end;

procedure Tfrm_DocEditOpt.lv_StampsClick(Sender: TObject);
begin
  if (Sender <> nil) and Self.Visible then
  begin
    if lv_Stamps.SelCount > 0 then
    begin
      if sGStampKey <> lv_Stamps.Selected.SubItems.Strings[1] then
      begin
        if CheckStampModification(sGStampKey) then
        begin
          if (BfMessageDlg(_('Stempel gendert. nderungen speichern?'), mtConfirmation, [mbYes,mbNo]) = mrYes) then
            btnSaveStampExecute(False);
        end;
        sGStampKey := lv_Stamps.Selected.SubItems.Strings[1];
        LoadStamp(sGStampKey);
      end;
    end;
  end;
end;

procedure Tfrm_DocEditOpt.lv_StampsKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_RETURN) and (lv_Stamps.Selected.SubItems.Strings[1] <> sGStampKey) then
  begin
    lv_StampsClick(Sender);
  end;
end;

procedure Tfrm_DocEditOpt.sbtn_SBildClick(Sender: TObject);
var
  sFileName: String;
begin
  if PromptForFileName(sFileName, '','',_('ffnen')) then
    edt_SBild.Text := sFileName;
  if edt_SBild.Text <> '' then
  	load_SBild;
end;

procedure Tfrm_DocEditOpt.rbtn_STextClick(Sender: TObject);
begin
  ShowStampsElements(False);
end;

procedure Tfrm_DocEditOpt.rbtn_SBildClick(Sender: TObject);
begin
  ShowStampsElements(True);
end;

procedure Tfrm_DocEditOpt.rbtn_StampActionClick(Sender: TObject);
begin
  try
    FillCbxStampActionItems;
  except
    //
  end;
end;

procedure Tfrm_DocEditOpt.tbs_AnnotationsShow(Sender: TObject);
begin
  LoadObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_DocEditOpt.sbtn_SFontClick(Sender: TObject);
begin
  if dlg_Schrift.Execute then
    edt_SFont.Text := dlg_Schrift.Font.Name;
end;

procedure Tfrm_DocEditOpt.edt_SWidthChange(Sender: TObject);
var
  iValue: Integer;
begin
  if TryStrToInt(edt_SWidth.Text, iValue) then
    edt_SWidth.Tag := iValue
  else
    edt_SWidth.Text := IntToStr(edt_SWidth.Tag);
end;

procedure Tfrm_DocEditOpt.edt_SHeightChange(Sender: TObject);
var
  iValue: Integer;
begin
  if TryStrToInt(edt_SHeight.Text, iValue) then
    edt_SHeight.Tag := iValue
  else
    edt_SHeight.Text := IntToStr(edt_SHeight.Tag);
end;

procedure Tfrm_DocEditOpt.btn_transpClick(Sender: TObject);
begin
  Screen.Cursor := crCross;
  Windows.SetCursor(Screen.Cursors[0]);
  gbGetTransClr := True;
end;

//function Tfrm_DocEditOpt.LoadStampEigenschaften(StampKey: String): Boolean;
//var
//  reg: TRegistry;
//  fsTmp: TFontStyles;
//  shTmp: TIEShape;
//  bsTmp: TBrushStyle;
//  lpTmp: TIELabelPos;
//  psTmp: TPenStyle;
//  rtTmp: TIEVRulerType;
//  ruTmp: TIEUnits;
//  osTmp: TIEVStyle;
//  taTmp: TIEAlignment;
//  li: Integer;
//begin
//  Result := True;
//  reg := TRegistry.Create;
//  try
//    try
//      with reg do
//      begin
//        RootKey := HKEY_CURRENT_USER;
//        if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
//          Exit;
//        OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
//
//        if ValueExists('Stamptyp') then
//        begin
//          li := ReadInteger('Stamptyp');
//          if li = 1 then
//            Exit;
//        end;
//
//        if ValueExists('ObjBrushColor') then
//          clbx_CBackground.Selected := ReadInteger('ObjBrushColor')
//        else
//          clbx_CBackground.Selected := 0;
//
//        if ValueExists('ObjPenColor') then
//          dlg_Schrift.Font.Color := ReadInteger('ObjPenColor')
//        else
//        begin
//          clbx_CBorder.Selected := 0;
//          dlg_Schrift.Font.Color := 0;
//        end;
//
//        if ValueExists('ObjLabelBrushColor') then
//           clbx_CLabel.Selected := ReadInteger('ObjLabelBrushColor')
//        else
//          clbx_CLabel.Selected := 0;
//
//        if ValueExists('ObjMemoBorderColor') then
//          clbx_CNoteBorder.Selected := ReadInteger('ObjMemoBorderColor')
//        else
//          clbx_CNoteBorder.Selected := 0;
//
//        if ValueExists('ObjBrushStyle') then
//        begin
//          ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
//          case bsTmp of
//            bsSolid:
//              cbx_BBackground.ItemIndex := 7;
//            bsClear:
//              cbx_BBackground.ItemIndex := 0;
//            bsHorizontal:
//              cbx_BBackground.ItemIndex := 4;
//            bsVertical:
//              cbx_BBackground.ItemIndex := 3;
//            bsFDiagonal:
//              cbx_BBackground.ItemIndex := 1;
//            bsBDiagonal:
//              cbx_BBackground.ItemIndex := 2;
//            bsCross:
//              cbx_BBackground.ItemIndex := 5;
//            bsDiagCross:
//              cbx_BBackground.ItemIndex := 6;
//          end;
//          cbx_BBackground.Enabled := True;
//        end else
//        begin
//          cbx_BBackground.ItemIndex := 0;
//          cbx_BBackground.Enabled := True;
//        end;
//
//        if ValueExists('ObjLabelBrushStyle') then
//        begin
//          ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
//          case bsTmp of
//            bsSolid:
//              cbx_BLabel.ItemIndex := 7;
//            bsClear:
//              cbx_BLabel.ItemIndex := 0;
//            bsHorizontal:
//              cbx_BLabel.ItemIndex := 4;
//            bsVertical:
//              cbx_BLabel.ItemIndex := 3;
//            bsFDiagonal:
//              cbx_BLabel.ItemIndex := 1;
//            bsBDiagonal:
//              cbx_BLabel.ItemIndex := 2;
//            bsCross:
//              cbx_BLabel.ItemIndex := 5;
//            bsDiagCross:
//              cbx_BLabel.ItemIndex := 6;
//          end;
//          cbx_BLabel.Enabled := True;
//        end else
//        begin
//          cbx_BLabel.ItemIndex := 0;
//          cbx_BLabel.Enabled := True;
//        end;
//
//        if ValueExists('ObjPenStyle') then
//        begin
//          ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
//          case psTmp of
//            psSolid:
//              cbx_BBorder.ItemIndex := 0;
//            psDash:
//              cbx_BBorder.ItemIndex := 2;
//            psDot:
//              cbx_BBorder.ItemIndex := 5;
//            psDashDot:
//              cbx_BBorder.ItemIndex := 3;
//            psDashDotDot:
//              cbx_BBorder.ItemIndex := 4;
//            psClear:
//              cbx_BBorder.ItemIndex := 1;
//          end;
//          cbx_BBorder.Enabled := True;
//        end else
//        begin
//          cbx_BBorder.ItemIndex := 0;
//          cbx_BBorder.Enabled := True;
//        end;
//
//        if ValueExists('ObjMemoBorderStyle') then
//        begin
//          ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
//          case psTmp of
//            psSolid:
//              cbx_BNoteBorder.ItemIndex := 0;
//            psDash:
//              cbx_BNoteBorder.ItemIndex := 2;
//            psDot:
//              cbx_BNoteBorder.ItemIndex := 5;
//            psDashDot:
//              cbx_BNoteBorder.ItemIndex := 3;
//            psDashDotDot:
//              cbx_BNoteBorder.ItemIndex := 4;
//            psClear:
//              cbx_BNoteBorder.ItemIndex := 1;
//          end;
//          cbx_BNoteBorder.Enabled := True;
//        end else
//        begin
//          cbx_BNoteBorder.ItemIndex := 0;
//          cbx_BNoteBorder.Enabled := True;
//        end;
//
//        if ValueExists('ObjBeginShape') then
//        begin
//          ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
//          case shTmp of
//            iesNONE:
//              rbtn_SSNo.Checked := True;
//            iesINARROW:
//              rbtn_SSIn.Checked := True;
//            iesOUTARROW:
//              rbtn_SSOut.Checked := True;
//          end;
//        end else
//          rbtn_SSNo.Checked := True;
//
//        if ValueExists('ObjEndShape') then
//        begin
//          ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
//          case shTmp of
//            iesNONE:
//              rbtn_SENo.Checked := True;
//            iesINARROW:
//              rbtn_SEIn.Checked := True;
//            iesOUTARROW:
//              rbtn_SEOut.Checked := True;
//          end;
//        end else
//          rbtn_SENo.Checked := True;
//
//        if ValueExists('ObjShapeHeight') then
//          edt_SSHeight.Text := IntToStr(ReadInteger('ObjShapeHeight'))
//        else
//          edt_SSHeight.Text := '0';
//
//        if ValueExists('ObjShapeWidth') then
//          edt_SSWidth.Text := IntToStr(ReadInteger('ObjShapeWidth'))
//        else
//          edt_SSWidth.Text := '0';
//
//        if ValueExists('ObjName') then
//          edt_AObjName.Text := dgettext('Shared36', ReadString('ObjName'))
//        else
//          edt_AObjName.Text := dgettext('Shared36', 'neues Objekt');
//
//        if ValueExists('ObjPenWidth') then
//          edt_APenWidth.Text := IntToStr(ReadInteger('ObjPenWidth'))
//        else
//          edt_APenWidth.Text := '1';
//
//        if ValueExists('ObjRulerType') then
//        begin
//          ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
//          case rtTmp of
//            iertRULER:
//              cbx_ARulerTyp.ItemIndex := 0;
//            iertQUOTEBEGIN:
//              cbx_ARulerTyp.ItemIndex := 1;
//            iertQUOTECENTER:
//              cbx_ARulerTyp.ItemIndex := 2;
//            iertQUOTEEND:
//              cbx_ARulerTyp.ItemIndex := 3;
//          end;
//        end else
//          cbx_ARulerTyp.ItemIndex := 0;
//
//        if ValueExists('ObjRulerUnit') then
//        begin
//          ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
//          case ruTmp of
//            ieuPIXELS:
//              cbx_ARulerMes.ItemIndex := 0;
//            ieuINCHES:
//              cbx_ARulerMes.ItemIndex := 1;
//            ieuKM:
//              cbx_ARulerMes.ItemIndex := 5;
//            ieuMETERS:
//              cbx_ARulerMes.ItemIndex := 4;
//            ieuCENTIMETERS:
//              cbx_ARulerMes.ItemIndex := 3;
//            ieuMILLIMETERS:
//              cbx_ARulerMes.ItemIndex := 2;
//            ieuMICRONS:
//              cbx_ARulerMes.ItemIndex := 6;
//            ieuNANOMETERS:
//              cbx_ARulerMes.ItemIndex := 7;
//          end;
//        end else
//          cbx_ARulerMes.ItemIndex := 0;
//
//        if ValueExists('ObjTransparency') then
//          edt_ATransp.Text := IntToStr(ReadInteger('ObjTransparency'))
//        else
//          edt_ATransp.Text := '110';
//
//        if ValueExists('ObjPolylineClosed') then
//          chbx_AOpenPoly.Checked := not ReadBool('ObjPolylineClosed')
//        else
//          chbx_AOpenPoly.Checked := False;
//
//        if ValueExists('ObjBoxHighlight') then
//          chbx_AIsHiLite.Checked := ReadBool('ObjBoxHighlight')
//        else
//          chbx_AIsHiLite.Checked := False;
//
//        if ValueExists('ObjStyle') then
//        begin
//          ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
//          chbx_AMoveable.Checked := ievsMoveable in osTmp;
//          chbx_ASizeable.Checked := ievsSizeable in osTmp;
////        SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
////          chbx_ASelectable.Checked := ievsSelectable in osTmp;
////          chbx_AVisible.Checked := ievsVisible in osTmp;
//        end else
//        begin
//          chbx_AMoveable.Checked := True;
//          chbx_ASizeable.Checked := True;
////        SJ 05.07.2021 - Auswhlbar und Sichtbar entfernt - jetzt immer wahr
////          chbx_ASelectable.Checked := True;
////          chbx_AVisible.Checked := True;
//        end;
//
//        if ValueExists('ObjHeight') then
//          edt_objheight.Text := IntToStr(ReadInteger('ObjHeight'))
//        else
//          edt_objheight.Text := '400';
//
//        if ValueExists('Objwidth') then
//          Edt_objwidth.Text := IntToStr(ReadInteger('Objwidth'))
//        else
//          Edt_objwidth.Text := '400';
//
//        if ValueExists('FontName') then
//          edt_TFont.Text := ReadString('FontName')
//        else
//          edt_TFont.Text := '';
//
//        dlg_Schrift.Font.Name := edt_TFont.Text;
//        edt_SFont.Text := edt_TFont.Text;
//
//        if ValueExists('FontSize') then
//        begin
//          dlg_Schrift.Font.Size := ReadInteger('FontSize');
//          edt_TFontSize.Text := IntToStr(ReadInteger('FontSize'));
//        end else
//        begin
//          dlg_Schrift.Font.Size := 72;
//          edt_TFontSize.Text := '72';
//        end;
//
//        if ValueExists('FontStyle') then
//        begin
//          ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
//          dlg_Schrift.Font.Style := fsTmp;
//        end else
//          dlg_Schrift.Font.Style := [];
//
//        if ValueExists('ObjFontAngle') then
//          edt_TFontAngle.Text := FloatToStr(ReadFloat('ObjFontAngle'))
//        else
//          edt_TFontAngle.Text := '0';
//
//        if ValueExists('ObjLabelPosition') then
//        begin
//          ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
//          case lpTmp of
//            ielBegin:
//              cbx_TLabelPos.ItemIndex := 0;
//            ielEnd:
//              cbx_TLabelPos.ItemIndex := 1;
//          end;
//        end else
//          cbx_TLabelPos.ItemIndex := 0;
//
//        if ValueExists('ObjTextAlign') then
//        begin
//          ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//          case taTmp of
//            iejLeft:
//              cbx_TAlign.ItemIndex := 0;
//            iejRight:
//              cbx_TAlign.ItemIndex := 1;
//            iejCenter:
//              cbx_TAlign.ItemIndex := 2;
//            iejJustify:
//              cbx_TAlign.ItemIndex := 3;
//          end;
//        end else
//          cbx_TAlign.ItemIndex := 0;
//
//        if ValueExists('ObjText') then
//          memo_TObjText.Text := StringReplace(ReadString('ObjText'), '\n\r', sLineBreak, [rfReplaceAll])  // SJ 07.01.2020
//        else
//          memo_TObjText.Text := 'neuer Text';
//
//        CloseKey;
//      end;
//    except
//      on e: Exception do
//      begin
//        BfShowMessage(_('Fehler beim Lesen des Registrierung:') + e.Message);
//        Result := False;
//      end;
//    end;
//  finally
//    if Assigned(reg) then
//      FreeAndNil(reg);
//  end;
//end;

procedure Tfrm_DocEditOpt.lv_eigenschaftstempelClick(Sender: TObject);
begin
  if lv_eigenschaftstempel.SelCount > 0 then
  begin
    sGStampKey := lv_eigenschaftstempel.Selected.SubItems.Strings[0];
    LoadStamp(sGStampKey);
    LoadObjVal(13);
  end;
end;

procedure Tfrm_DocEditOpt.frmsto_docoptionenRestorePlacement(Sender: TObject);
begin
  LoadObjVal(tctrl_Annos.TabIndex);
end;

procedure Tfrm_DocEditOpt.Image1MouseEnter(Sender: TObject);
begin
  HintPause := Application.HintPause;
  HintHidePause := Application.HintHidePause;
  Application.HintPause := 100;
  Application.HintHidePause := -1;
end;

procedure Tfrm_DocEditOpt.Image1MouseLeave(Sender: TObject);
begin
  Application.HintPause := HintPause;
  Application.HintHidePause := HintHidePause;
end;

procedure Tfrm_DocEditOpt.cbx_nummerChange(Sender: TObject);
begin
  fifavnum := cbx_nummer.ItemIndex;
  LoadObjVal(tctrl_Annos.TabIndex);
  cbx_nummer.SetFocus;
end;

procedure Tfrm_DocEditOpt.memo_TObjTextKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Key = Ord('A')) and (ssCtrl in Shift) then
  begin
    TMemo(Sender).SelectAll;
    Key := 0;
  end;
end;

procedure Tfrm_DocEditOpt.FillCbxStampActionItems;
var
  I: Integer;
begin
  try
    try
      cbx_StampAction.Properties.BeginUpdate;
      cbx_StampAction.Properties.Items.Clear;

      if rbtn_StampStatefield.Checked then
      begin
        try
          for I := 0 to High(aStatefields) do
          begin
            if (aStatefields[i] <> nil) and (aStatefields[i].DisplayName <> '') and
               (_(aStatefields[i].DisplayName) <> _('auf Wiedervorlage'))
            then
              cbx_StampAction.Properties.Items.AddObject(aStatefields[i].DisplayName, TObject(aStatefields[i].ID));
          end;
          cbx_StampAction.Enabled := True;
        except
          bitfarmLog.Write(llNormal, ltException, 'FillCbxStampActionItems - Statefield', ClassName);
        end;
      {$IFDEF ENTERPRISE}
      end else if rbtn_StampPlugin.Checked then
      begin
        try
          for I := 0 to High(bitfarmApp.PluginsArray) do
          begin
            if (bitfarmApp.PluginsArray <> nil) and (bitfarmApp.PluginsArray[I].Name <> '') then
              cbx_StampAction.Properties.Items.Add(bitfarmApp.PluginsArray[I].Name);
          end;
          cbx_StampAction.Enabled := True;
        except
          bitfarmLog.Write(llNormal, ltException, 'FillCbxStampActionItems - Plugin', ClassName);
        end;
      {$ENDIF}
      end else if rbtn_StampNoAction.Checked then
      begin
        try
          cbx_StampAction.Enabled := False;
        except
          bitfarmLog.Write(llNormal, ltException, 'FillCbxStampActionItems - NoAction', ClassName);
        end;
      end
    except
      bitfarmLog.Write(llNormal, ltException, 'FillCbxStampActionItems', ClassName);
    end;
  finally
    cbx_StampAction.Properties.EndUpdate;
  end;
end;

procedure Tfrm_DocEditOpt.FormCreate(Sender: TObject);
var
  bmap: TBitmap;
begin
  TranslateComponent(self, 'ViewerV36');
  mStampFavoOld := 0;
  fifavnum := 0;

  if pctrl_DocEditOpt.ActivePage = tbs_Stempel then
  begin
    ListStamps(False);
    selectStampListItem(0);
  end;
  cbx_StampAction.Style.StyleController := ctlWhite;
  rbtn_StampPlugin.Visible := {$IFDEF ENTERPRISE}True{$ELSE}False{$ENDIF};

  try
    bmap := TBitmap.Create;
    bfaIcons.ilMainMenu16.GetBitmap(Integer(icoidx_info), bmap);
    Image1.Picture.Bitmap.Assign(bmap);
    FreeAndNil(bmap);
  except

  end;

  Self.Color := stlControl.Color;
  Self.Font.Color := stlControl.TextColor;
  cbx_StampAction.Style.StyleController := ctlGeneral;

  var obj, obj2 : TObject;
  for var i := 0 to ComponentCount - 1 do
  begin
    obj := Components[i];
//    if (obj is TFrame) then
//    begin
//      TFrame(obj).Color := stlControl.Color;
//      for var j := 0 to TFrame(obj).ComponentCount - 1 do
//      begin
//        obj2 := TFrame(obj).Components[j];
//        if (obj2 is TSpTBXPanel) then
//          TSpTBXPanel(obj2).Color := stlControl.Color;
//      end;
//    end
//    else
    if (obj is TspTBXEdit) then
    begin
      TspTBXEdit(obj).Color := stlControl.Color;
      TspTBXEdit(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TNumberBox) then
    begin
      TNumberBox(obj).Color := stlControl.Color;
      TNumberBox(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TComboBox) then
    begin
      TComboBox(obj).Color := stlControl.Color;
      TComboBox(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TLabel) then
    begin
      TLabel(obj).Color := stlControl.Color;
      TLabel(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TCheckBox) then
    begin
      TCheckBox(obj).Color := stlControl.Color;
      TCheckBox(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TRadioGroup) then
    begin
      TRadioGroup(obj).Color := stlControl.Color;
      TRadioGroup(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TSpTBXGroupBox) then
    begin
      TSpTBXGroupBox(obj).Color := stlControl.Color;
      TSpTBXGroupBox(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TbfaTabSheet) then
    begin
      TbfaTabSheet(obj).Color := stlControl.Color;
      TbfaTabSheet(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TColorBox) then
    begin
      TColorBox(obj).Color := stlControl.Color;
      TColorBox(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TJvImageComboBox) then
    begin
      TJvImageComboBox(obj).Color := stlControl.Color;
      TJvImageComboBox(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TListView) then
    begin
      TListView(obj).Color := stlControl.Color;
      TListView(obj).Font.Color := stlControl.TextColor;
    end
    else if (obj is TMemo) then
    begin
      TMemo(obj).Color := stlControl.Color;
      TMemo(obj).Font.Color := stlControl.TextColor;
    end





//    else if (obj is TListView) then
//    begin
//      TListView(obj).Color := stlControl.Color;
//    end
//    else if (obj is TSptbxPanel) and (not (obj is TBfaAddfieldComp)) then
//    begin
//      TSptbxPanel(obj).Color := stlControl.Color;
//      for j := 0 to TSptbxPanel(obj).ComponentCount - 1 do
//      begin
//        obj2 := TSptbxPanel(obj).Components[j];
//        if (obj2 is TPanel) then
//          TPanel(obj2).Color := stlControl.Color;
//      end;
//    end;
  end;
end;

//11.03.2024 bfacrm:ticket__show__35985
//procedure Tfrm_DocEditOpt.CreateParams(var Params: TCreateParams);
//begin
//// so that mainform doesnt throw frm_docedit to background
//  inherited;
//  Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
//  Params.WndParent := GetDesktopWindow;
//end;

procedure Tfrm_DocEditOpt.chkClipboardClick(Sender: TObject);
begin
  edt_SBild.Enabled := not chkClipboard.Checked;
  edt_SBild.Refresh;
  edt_SBild.Repaint;
  sbtn_SBild.Enabled := not chkClipboard.Checked;
  img_SBild.Enabled := not chkClipboard.Checked;
  btn_Transparenz.Enabled := not chkClipboard.Checked;
  btn_TranspSpeichern.Enabled := False;
//  edt_SWidth.Enabled := not chkClipboard.Checked;
//  edt_SHeight.Enabled := not chkClipboard.Checked;
  if chkClipboard.Checked then
    EnableBreiteHoehe(False)
  else
    EnableBreiteHoehe(not chk_Anpassen.Checked);
  chk_fixedsize.Enabled := not chkClipboard.Checked;
  if chkClipboard.Checked then
    img_SBild.Clear
  else
    load_SBild;
  img_SBild.Update;
end;

procedure Tfrm_DocEditOpt.chk_AnpassenClick(Sender: TObject);
begin
  EnableBreiteHoehe(not chk_Anpassen.Checked);
end;

procedure Tfrm_DocEditOpt.img_SBildMouseEnter(Sender: TObject);
begin
  if gbGetTransClr then
  begin
    Screen.Cursor := crCross;
    img_SBild.Cursor := Screen.Cursor;
  end;
end;

procedure Tfrm_DocEditOpt.img_SBildMouseLeave(Sender: TObject);
begin
  if gbGetTransClr then
  begin
    Screen.Cursor := crDefault;
    img_SBild.Cursor := Screen.Cursor;
  end;
end;

procedure Tfrm_DocEditOpt.btn_TransparenzClick(Sender: TObject);
begin
  gbGetTransClr := btn_Transparenz.Checked;
  if gbGetTransClr then
  begin
    Screen.Cursor := crCross;
    img_SBild.Cursor := Screen.Cursor;
    btn_TranspSpeichern.Enabled := True;
  end else
    btn_TranspSpeichern.Enabled := False;
end;

procedure Tfrm_DocEditOpt.img_SBildMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  cl_rgb: TRGB;
begin
  // transform client coorindates to bitmap ones
  X := img_SBild.XScr2Bmp(X);
  Y := img_SBild.YScr2Bmp(Y);

  if (ssLeft in Shift) and (Y >= 0) and (X >= 0) then
  begin
    img_SBild.Proc.SaveUndo;
    img_SBild.IO.Params.BitsPerSample := 8;
    img_SBild.IO.Params.SamplesPerPixel := 4;
    img_SBild.IEBitmap.PixelFormat := ie32RGB;
    img_SBild.Update;
    cl_rgb := img_SBild.IEBitmap.Pixels[X, Y];
    img_SBild.Proc.SetTransparentColors(cl_rgb, cl_rgb, 0);
    if not img_SBild.HasAlphaChannel then
      img_SBild.AlphaChannel.Create(img_SBild.IEBitmap);

    img_SBild.Update;
  end;
end;

procedure Tfrm_DocEditOpt.btn_TranspSpeichernClick(Sender: TObject);
var
  sPfad : String;
begin
  try
    btn_Transparenz.Checked := False;
    btn_TranspSpeichern.Enabled := False;

    sPfad := changeFileExt(edt_SBild.Text,'.gif');
    try
      img_SBild.IO.SaveToFileGIF(sPfad);
    except
      BfMessageDlg(_('Die Datei konnte nicht gespeichert werden: ') + sPfad, mtError, [mbOK], False, sSysError);
      bitfarmLog.Write(llNormal, ltException, 'img_SBild.IO.SaveToFileGIF(' +sPfad + ')', ClassName);
    end;
    edt_SBild.Text := sPfad;
    btn_SaveStampClick(Sender);
  except
    bitfarmLog.Write(llNormal, ltException, 'btn_TranspSpeichernClick', ClassName);
  end;
end;

//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// [3008]  b.takacs  12.04.2011 3.5.0.175
//------------------------------------------------------------------------------
procedure Tfrm_DocEditOpt.pctrl_DocEditOptChange(Sender: TObject);
begin
	if pctrl_DocEditOpt.ActivePage = tbs_Stempel then
  begin
    ListStamps(False);
    if lv_Stamps.SelCount = 1 then
      SelectStampListItem(lv_Stamps.ItemIndex)
    else
      selectStampListItem(0);
  end;
end;
procedure Tfrm_DocEditOpt.pctrl_DocEditOptDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect;
  Active: Boolean);
var
  AText: string;
  APoint: TPoint;
begin
  with (Control as TPageControl).Canvas do
  begin
    Brush.Color := stlControl.Color;
    Font.Color := stlControl.TextColor;
    FillRect(Rect);
    AText := TPageControl(Control).Pages[TabIndex].Caption;
    with Control.Canvas do
    begin
      APoint.x := (Rect.Right - Rect.Left) div 2 - TextWidth(AText) div 2;
      APoint.y := (Rect.Bottom - Rect.Top) div 2 - TextHeight(AText) div 2;
      TextRect(Rect, Rect.Left + APoint.x, Rect.Top + APoint.y, AText);
    end;
  end;
end;

procedure Tfrm_DocEditOpt.edt_SBildKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 13 then
  	load_SBild;
end;

procedure Tfrm_DocEditOpt.btn_TextvariableClick(Sender: TObject);
begin
	BfShowMessage(_('Mgliche Textvariablen:\n%U  Username\n%A  Anzeigename\n%D  ' +
    'Datum\n%Z  Uhrzeit\n%Fx%  Inhalt des x-ten Zusatzfeldes\n%T  Tag\n%M  ' +
    'Monat\n%J  Jahr\n%H  Stunde\n%N  Minute\n%S  Sekunde\n%GDOCID  GDocID\n%add_x%  ' +
    'Inhalt von Zusatzfeld add_x\n%CLIPBOARD%  Text aus der Zwischenablage'));
end;

{ TListView }

procedure TListView.WMLButtonDblClk(var Message: TWMRButtonDown);
begin
  if GetItemAt(Message.XPos, Message.YPos) <> nil then
    inherited;
end;

procedure TListView.WMLButtonDown(var Message: TWMLButtonDown);
begin
  if GetItemAt(Message.XPos, Message.YPos) <> nil then
    inherited;
end;

procedure TListView.WMRButtonDblClk(var Message: TWMRButtonDown);
begin
  if GetItemAt(Message.XPos, Message.YPos) <> nil then
    inherited;
end;

procedure TListView.WMRButtonDown(var Message: TWMRButtonDown);
begin
  if GetItemAt(Message.XPos, Message.YPos) <> nil then
    inherited;
end;

end.

