# -*- mode: python -*-

block_cipher = None

import sys
import zipfile
import zlib
import os
import subprocess
import shutil

sys.modules['FixTk'] = None

a = Analysis(['bfaServer36.py'],
             pathex=[],
             hiddenimports=['packaging', 'appdirs', 'sqlalchemy.sql.default_comparator', 'servicemanager', 'bitfarm_baseobj',
                            'bitfarm_configobj', 'bitfarm_doc', 'bitfarm_proc', 'bitfarm_con', 'bitfarm_history',
                            'bitfarm_errors', 'bitfarm_xml', 'bitfarm_core',
                            'bitfarm_translate', 'bitfarm_oauth', 'bfaServerCore',
                            'bfaRenderClient', 'bfa_tessocr', 'bfa_hocr', 'thtiflib', 'Renderer',
                            'dpapi', 'glob', 'random', 'hashlib', 'msal', 'oauth2',
                            'win32api', 'win32security', 'win32service', 'win32file', 'win32com', 'cpuinfo', 'dateutil.relativedelta',
                            'socket', 'base64', 'time', 'cStringIO', 'inspect', 'codecs', 'tempfile', 'datetime',
                            'uuid', 'subprocess', 'threading', 'logging', 'xml.dom', 'logging.config', 'decimal',
                            'xml.etree.cElementTree', 'defusedxml', 'htmlentitydefs', 're', 'xml.parsers', 'collections',
                            'ldap', 'email.mime', 'email.mime.multipart', 'email.mime.application',
                            'email.mime.text', 'email.utils', 'email.header'
                            ],
             hookspath=[],
             runtime_hooks=[],
             excludes=['FixTk', 'tcl', 'tk', '_tkinter', 'tkinter', 'Tkinter', 'matplotlib', 'bfaServerEnterprise', 'bitfarm_enterprise'])
a.datas += [('ServiceV3.ico', 'ServiceV3.ico', 'DATA')]  
a.datas += [('Renderer.cfg', 'Renderer.cfg', 'DATA')]
# a.datas += [('AnnoText64.dll', 'AnnoText64.dll', 'DATA')]
a.datas += [('ielib64.dll', 'ielib64.dll', 'DATA')]
a.datas += [('libeay32.dll', 'libeay32.dll', 'DATA')]
a.datas += [('ssleay32.dll', 'ssleay32.dll', 'DATA')]
a.datas += [('borlndmm.dll', 'borlndmm.dll', 'DATA')]

pyz = PYZ(a.pure)
exe = EXE(pyz,
          a.scripts,
          exclude_binaries=True,
          name='bfaServer36.exe',
          version=r'bfa_version.txt',
          icon='ServiceV3.ico',
          debug=False,
          strip=None,
          upx=True,
          console=True )
coll = COLLECT(exe,
               a.binaries,
               a.zipfiles,
               a.datas,
               strip=None,
               upx=True,
               name='bfaServer36-GPL')

# if os.path.exists('c:\development\codesigning\signing.bat'):
#     p = subprocess.Popen(['cmd', '/C', 'c:\development\codesigning\signing.bat', '.\\dist\\bfaServer36-GPL\\bfaServer36.exe'])
#     p.wait()

# sys.stdout.write('create zipfile...')
# sys.stdout.flush()
# shutil.make_archive('.\\dist\\bfaServer36', 'zip', '.\\dist\\bfaServer36')

#with zipfile.ZipFile('.\dist\get_doc_by_sha.zip', 'w') as zip:
#	zip.write('.\dist\get_doc_by_sha.exe', arcname='get_doc_by_sha.exe', compress_type=zipfile.ZIP_DEFLATED)

sys.stdout.write('done...')