Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
Set oArgs    = WScript.Arguments 

appdata=objWSHShell.ExpandEnvironmentStrings("%APPDATA%")

myname = left(Wscript.ScriptName, len(Wscript.ScriptName) - 4)
bfashare = ""

mylistfile = oArgs(0)
bfausername = oArgs(1)
bfapass = oArgs(2)
profile = oArgs(3)

readconfig(profile)


'##################### hier anpassen #####################
configfile = bfashare & "plugins\plugin_runner\plugin_runner.ini"

sourcedir = bfashare & "plugins\plugin_runner"
installdir = appdata & "\bitfarm-archiv\plugins\plugin_runner"

localexe = installdir & "\plugin_runner.exe"
remoteexe = sourcedir & "\plugin_runner.exe"

sourceplugindir = bfashare & "plugins\plugin_runner\plugins\bfa_xmlmapper"
installplugindir = installdir & "\plugins\bfa_xmlmapper"

reinstall = True
'#########################################################


'####### lokale Installation & Update prfen ################

If reinstall = True Then
	If fs.FolderExists(installdir) Then
		fs.DeleteFolder(installdir)
	End If
End If

' Neuinstallation
If Not fs.FolderExists(installdir) Then
	BuildFullPath installdir
	Set srcfolder = fs.GetFolder(sourcedir)	
	Set subfolders = srcfolder.SubFolders	
	For Each folder in subFolders
		If folder.Name <> "plugins"  And folder.Name <> "tools" Then
			fs.CopyFolder folder.Path, installdir & "\" & folder.Name
		End If
		If folder.Name = "plugins" Then
			fs.CreateFolder installdir & "\plugins"
			fs.CopyFolder sourceplugindir, installplugindir
		End If
	Next
	
	For Each file In srcfolder.Files
		If Right(file.Name, 4) <> ".ini" Then
			fs.CopyFile file.Path, installdir & "\" & file.Name
		End If
	Next
	Set srcfolder = Nothing
	Set subfolders = Nothing
End If

'If Not fs.FolderExists
'If Not fs.FileExists(localexe) Then
'	fs.CopyFile remoteexe, localexe
'End If 


'If updatecheck = True Then
'	Set f = fs.GetFile(localexe)
'	localdate = f.DateLastModified
'	Set f = fs.GetFile(remoteexe)
'	sourcedate = f.DateLastModified
'	If sourcedate <> localdate Then
'		fs.DeleteFile localexe
'		fs.CopyFile remoteexe, localexe
'	End If
'End If
'###########################################################

'########## Parameter entgegennehmen und lokal starten #####
'mylistfile = oArgs(0)
'bfausername = oArgs(1)
'bfapass = oArgs(2)
'profile = oArgs(3)




If fs.FileExists(localexe) Then
	' "plugins/map_erechnung/data/1385.job", "plugin_runner_example.ini", "vmth5", "dmsadmin", "1D77462A06E63145AD"
	cmd = Chr(34)& localexe & Chr(34) & " " & Chr(34) & mylistfile & Chr(34) & " " & Chr(34) & configfile & Chr(34) & " " & Chr(34) & profile & Chr(34) & " " & Chr(34) & bfausername & Chr(34) & " " & Chr(34) & bfapass & Chr(34)
	'cmd = Chr(34)& localexe & Chr(34) & " -c viewerplugin -s " & section & " --mylist " & Chr(34) & mylistfile &  Chr(34)& " --config " & Chr(34)& configfile & Chr(34) & " --user " &bfausername & " --password " & bfapass & " --profile " & profile 
	objwshshell.LogEvent 1, Wscript.ScriptFullName & " run " & cmd
	oExec = objWSHShell.Run(cmd,6,True)
Else
	MsgBox("Das Plugin ist nicht installiert")
End If
'###########################################################


Sub BuildFullPath(ByVal FullPath)
    If Not fs.FolderExists(FullPath) Then
        BuildFullPath fs.GetParentFolderName(FullPath)
        fs.CreateFolder FullPath
    End If
End Sub



Function readconfig(profil)
    On Error Resume Next
    readconfig=True
    Err.clear
    If Not fs.FileExists(profil) Then
        Err.clear
        errortxt=profil&".con Datei nicht im Scriptpfad vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readconfig=False
        Err.clear
    End If
    
    If readconfig=True Then	
        Set confile = fs.OpenTextFile(profil,1)
        If Err.number Then
            Err.clear
            errortxt="Profilfdatei nicht im Scriptpfad vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            Err.clear
            readconfig=False
            
        End If 
    End If
    
    If readconfig=True Then	
        kette=confile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        Do While Scriptsflag = 0
            kette=confile.readline
            Scriptsflag=InStr(1,kette,"[Scripts]")
            If confile.AtEndOfStream = True Then
                confile.close
                Set confile=Nothing
                scriptsflag=1
                errortxt="Fehler beim Lesen der CON-Datei - falsche Formatierung."
                objWshShell.LogEvent 1, errortxt
                readconfig = False
                
            End If
        Loop
        
    End If
    
    
    If readconfig = True Then
        
        Do While confile.AtEndOfStream <> True
            kette=Trim(confile.readline)
            kette = Replace(kette,vbTab,"")
            kette = Replace(kette," = ", "=")
            If Left(kette,1)<>";" Then
                If InStr(1,kette,"clientprogram",1)<>0 Then
                    wert = Right(kette,Len(kette) -14)
                    bfashare = Trim(wert)
                End If
			End If
		Loop
	End If
End Function



