'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  Serviceprinter.vbs   GPL  ************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0           ************************************************
'*******************************************************************************************
'***************  Programm zur bergabe der vom Druckertreiber erzeugten      **************
'***************  Postscript-Datei und eingegen ins Temp-Verzeichniss	      **************
'***************                                                              **************
'***************  wird gestartet auf dem Server fr die externe               **************
'***************  Dateiarchivierung                                           **************
'***************                                                              **************
'***************  Syntax: wscript <server-programmpfad>Serviceprinter.vbs %1  **************
'***************                                                              **************
'***************                                                              **************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                              **************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert   **************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"              **************
'***************                                                              **************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************




'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next
 
Dim objWSHShell, fso, FileIn, FileOut 
Dim Datei, Text, Txt, i, arrSort, arrTest(), oArgs, Druckername
Dim lngReturnCode
 
Set objWSHShell = WScript.CreateObject("WScript.Shell") 
Set fs      = WScript.CreateObject("Scripting.FileSystemObject") 
set oArgs    = Wscript.Arguments 




'*******************************************************************************************
'******************************* Initialisierung der globalen Variablen ********************



err.clear
fullpath = WScript.ScriptFullName
If err.number Then
	err.clear
	errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
	
	WScript.Quit
End If 
scriptname = WScript.ScriptName
If err.number Then
	err.clear
	errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
	
	WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If err.number Then
	err.clear
	errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
	
	WScript.Quit
End If 
If Len(programm)=0 Then
	errortxt="bitfarm-Archiv: Achtung, es konnte nicht archiviert werden! Fehler beim Drucken/Archivieren: Kann Startparameter nicht initialisieren - aktueller Scripting Host? Wenden Sie sich an den Administrator."
	
	WScript.Quit
End If
queue=programm&"queue\"
temp=programm&"temp\"

'*******************************************************************************************
'*******************************************************************************************



'*************************************************************************************
'**************************   Parameterbergabe **************************************
'************************************************************************************* 

err.clear

Datei = oArgs.item(0) 
  If err.number<>0 Then
    
    err.clear
    WScript.Quit
  End If 

Ausgabename=temp&"Serviceprinter.ps"
If fs.FileExists(Ausgabename) Then
	

fs.DeleteFile Ausgabename, True
  If err.number<>0 Then
    
    err.clear
    WScript.Quit
  End If
  WScript.Sleep 200
End If

If fs.FileExists(Datei) Then
fs.CopyFile Datei, Ausgabename, True
  If err.number<>0 Then
    
    err.clear
    WScript.Quit
  End If
End If

  


'*******************************************************************************************
'*******************************************************************************************
'********************************          Ende             ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
