'*******************************************************************************************
'*******************************************************************************************
'**********************************    bitfarm Archiv 2024    ******************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************  bfa_unzip.vbs     GPL  ***************************************************
'*******************************************************************************************
'***************  Version 3.6.2.0        ***************************************************
'*******************************************************************************************
'***************  Programm zum Entpacken von .zip-Archiven                   ***************
'***************  unter Vorgabe einer White/Blacklist                        ***************
'***************                                                             ***************
'***************  die entpackten Dateien werden automatisch verknpft        ***************
'***************  und in die queue eingestellt.                              ***************
'***************                                                             ***************
'***************  Syntax: <programmpfad>bfa_unzip.vbs {zip-Datei}            ***************
'***************                                                             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'***************                                                             ***************
'***************  Dieses Programm darf im Rahmen der GPL kopiert, erweitert  ***************
'***************  und verwendet werden. Siehe Datei "Lizenz.txt"             ***************
'***************                                                             ***************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************
'************************************   Setzen der Anfangswerte    *************************
'*******************************************************************************************
'*******************************************************************************************

'*** fr den Service:
scriptdebug = False
cleanup = True

'*******************************************************************************************
'*******************************************************************************************
'********************************     Start des Programms   ********************************
'*******************************************************************************************
'*******************************************************************************************
'*******************************************************************************************

On Error Resume Next

limit = 50

Dim datei, arg1, Progr, Zeit, i, oArgs
Dim fso, objFolder, objTextFile, umlautfile
Dim f, filedecode, folder, allfiles, file, strPfadQueue, strAnhang, strExt
Dim strLine, strLen, decode
Dim strHtmlDatei, strHtml, filehtml

Dim strFrom, strSubject, strTo, strCC, strDate, StrContent, strPfadTemp
ReDim Zusatzfeld(limit)
ReDim Zusatzfeldname(limit)
ReDim linkspeicher(limit)


'Set fso = CreateObject("Scripting.FileSystemObject")
Set fs = CreateObject("Scripting.FileSystemObject")
Set objWSHShell = WScript.CreateObject("WScript.Shell") 

zippath = ""
deletezip = False
zipacceptnoextension = False
extractrecursive = False
zipuseoriname = True
zipwhite = ""
zipblack = ""
errortxt = ""
linkzaehler = 0
username=""
Zusatzfelder=0
dokdate=""
oldstatus=""
Typ=""
myname=""
Tabelle=""
Filtermakro=""
OCRFilter=""
folderID=""
color=""
hires=""
dokdate=""
Typ=""
Profil=""
quelle=""
Original=""
clientID=""
checkOCR=""
Tabelle=""



For i = 0 To limit
    
    Zusatzfeld(i)=""
    Zusatzfeldname(i)=""
    linkspeicher(i)=""
    
Next


Err.clear
fullpath = WScript.ScriptFullName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
scriptname = WScript.ScriptName
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
programm = Left(fullpath,Len(fullpath)-Len(scriptname))
If Err.number Then
    Err.clear
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If 
If Len(programm)=0 Then
    errortxt="Kann Startparameter nicht initialisieren - aktueller Scripting Host?"
    'objWshShell.LogEvent 1, errortxt
    WScript.Quit
End If

queue=programm&"queue\"
garbagepath=programm&"garbage\"

zahl = Zufallszahl(0,99999)
strPfadQueue = ""
strPfadTemp = programm&"ZIPTemp\"

' wenn jobdatei mit referenz diese auslesen als mylink




mylink="ZIP:"&Date()&"_"&Time()&"_"&zahl

If Not fs.FolderExists(strPfadTemp) Then
    Set test = fs.CreateFolder(strPfadTemp)
    Set test = Nothing
    WScript.sleep 200
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "bfa_unzip(0): kann verzeichnis nicht erstellen - Berechtigung?"
        Err.clear
        WScript.Quit
    End If 
    
    If Not fs.FolderExists(strPfadTemp) Then
        objWshShell.LogEvent 1, "bfa_unzip(0b): kann verzeichnis nicht erstellen (2) - Berechtigung?"
        WScript.Quit
    End If
End If

strPfadTemp=strPfadTemp&zahl&"\"

If Not fs.FolderExists(strPfadTemp) Then
    Set test = fs.CreateFolder(strPfadTemp)
    Set test = Nothing
    WScript.sleep 200
    If Err.number<>0 Then
        objWshShell.LogEvent 1, "bfa_unzip(1): kann verzeichnis nicht erstellen - Berechtigung?"
        Err.clear
        WScript.Quit
    End If 
    
    If Not fs.FolderExists(strPfadTemp) Then
        objWshShell.LogEvent 1, "bfa_unzip(1b): kann verzeichnis nicht erstellen (2) - Berechtigung?"
        WScript.Quit
    End If
End If

partcounter=0
Set oArgs    = WScript.Arguments                 

datei = oArgs.item(0) 
If Err.number<>0 Then
    Err.clear
    objWshShell.LogEvent 1, "bitfarm-Archiv: bfa_unzip: Fehlender Parameter: Datei:" & datei 
    Err.clear
    WScript.Quit
End If 


If fs.FileExists(datei) Then
    Set objFolder = fs.GetFile(datei)
    
Else
    objWshShell.LogEvent 1, "bfa_unzip.vbs: Datei existiert nicht oder Dateiname falsch !" &vbCrLf& datei
    Set fs = Nothing
    WScript.Quit
End If

If fs.GetExtensionName(datei) <> "zip" And fs.GetExtensionName(datei) <> "rar" Then
    objWshShell.LogEvent 1, "bergebene Datei ist keine .zip-Datei oder .rar-Datei "
    Set fs = Nothing
    WScript.Quit
End If

extension = "." & LCase(fs.GetExtensionName(datei))

myfilename=objfolder.name
'myfoldername=Left(datei,Len(datei)-Len(myfilename))
myfoldername= fs.GetParentFolderName(datei) & "\"
'MsgBox "myfoldername:"&myfoldername
'mytempname=Left(myfilename,Len(myfilename)-4)
mytempname = fs.GetBaseName(myfilename)
'MsgBox "mytempname:"&mytempname


If fs.fileexists(queue&mytempname&".job")=False Then
    objWshShell.LogEvent 1, "bitfarm-Archiv bfa_unzip(3): Zur zip-Datei keine Job-Datei vorhanden."
    WScript.quit
End If


'##################################  inilesen   #######################################


inilesen

If zippath = "" Then 
    
    errortxt = "bitfarm-Archiv bfa_unzip(4): Konnte Pfad zu 7Zip nicht aus der scripts.ini lesen"
    objWshShell.LogEvent 1, errortxt
    GetGarbage(myfoldername & mytempname)
    
    WScript.quit
End If

If Not fs.Fileexists(zippath) Then
    errortxt = "bitfarm-Archiv bfa_unzip(4): Konnte 7Zip nicht im angegebenen Pfad finden: " & zippath
    objWshShell.LogEvent 1, errortxt
    GetGarbage(myfoldername & mytempname)
    
    WScript.quit
End If




'##################################  Archiv berprfen   ############################


erfolg = True
ii = 0
Set oExec    = objWSHShell.Exec(zippath & " l -slt " & datei  )	

Do While Not oExec.StdOut.AtEndOfStream
    strinput = strinput & oExec.StdOut.Read(127)	
    ii = ii +1
    If ii = 10000 Then Exit Do
    
Loop

If InStr(1,strinput,"Encrypted = 1") <> 0 Or InStr(1,strinput,"Encrypted = +") <> 0 Then
    deletezip = False
    erfolg = False
    'fs.CopyFile datei, strPfadTemp & myfilename
    
End If

If InStr(1,strinput,"Split Before = 1") <> 0 Or InStr(1,strinput, "Split After = 1") <> 0 Or InStr(1,strinput, "Type = Split") Then
    deletezip = False
    erfolg = False
    
    'MsgBox "bitfarm-archiv untersttzt keine verteilten rar-Archive"
End If


If InStr(1,strinput,"Error") <> 0 Then
    erfolg = False
    
    errortxt = "bitfarm-Archiv bfa_unzip: Fehler beim Zip-Entpacken, Zip-Datei fehlerhaft " & vbCrLf & strinput
    objWshShell.LogEvent 1, errortxt
    GetGarbage(myfoldername & mytempname)
    
End If


'################################### Verarbeitung #####################################

If erfolg = True Then
    
    
	cmd = Chr(34)&zippath &Chr(34)& " e " & Chr(34)&datei &Chr(34)& " -aou -o" &Chr(34)& strPfadTemp &Chr(34)& " -r -y"

    returncode = objWSHShell.Run(Chr(34)&zippath &Chr(34)& " e " & Chr(34)&datei &Chr(34)& " -aou -o" &Chr(34)& strPfadTemp &Chr(34)& " -r -y", 0, False)	
    
    durch = False
    zrunning = True
    Do While zrunning=True
        zrunning = check7zip	
        WScript.Sleep 1000  
    Loop
    
    'Msgbox "bfa_unzip: " & vbCrLf & "Status: " & oExec.Status & vbCrLf & "Exitcode " & oExec.ExitCode & vbCrLf & "Schleife: " & schleife & vbCrLF & strinput
    
    If returncode <> 0 Then
        errortxt = "bitfarm-Archiv bfa_unzip: Fehler beim Zip-Entpacken, keine Dateien entpackt " & vbCrLf & "ExitCode von 7Zip: " & oExec.ExitCode & vbCrLf & "Durchlauf (200max): " & schleife
        objWshShell.LogEvent 1, errortxt
        
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='7z.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte 7z.exe-Instanzen: "&z
        End If
        
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        'GetGarbage(myfoldername & mytempname)
        deletezip = False	
        erfolg = False
    Else
    	erfolg = True
    End If
End If

If extractrecursive=True Then
	If erfolg = True Then
		Set mainzipfolder = fs.GetFolder(strPfadTemp)
		For Each zipdatei In mainzipfolder.files
		    myextension = fs.GetExtensionName(zipdatei)
		    myextension = LCase(myextension)	
		    If myextension = "rar" Or myextension = "zip" Then
		        recursive_extract zipdatei
		    End If	
		Next
	End If
End If

If deletezip = False Then
    
    If fs.fileexists(myfoldername & mytempname&".slw") Then
        Set myhandle = fs.OpenTextFile(myfoldername & mytempname&".slw",1,True)
        myname = myhandle.readline
        If InStr(1,myname,"Dateiname=") <> 0 Then
            
            myfilename = Right(myname, Len(myname)-10) & extension
        End If
        myhandle.close
    End If
    If fs.fileexists(datei) Then
        fs.CopyFile datei, strPfadTemp&myfilename  
    End If
    
    If Err.Number <> 0 Then
        objWshShell.LogEvent 2, "bitfarm-Archiv Fehler beim Umkopieren der zip/rar-Datei"&vbCrLf&datei&vbCrLf&strPfadTemp&myfilename &vbCrLf& Err.Number&vbCrLf&Err.description
    End If
    
End If



newtempname=""
mycounter=0
myextension=""
Set folder = fs.GetFolder(strPfadTemp)



For Each file In folder.files	
    erlaubt = False		
    
    myextension = fs.GetExtensionName(file)
    myextension = "."&LCase(myextension)&"."
    
    If zipwhite="" And zipblack="" Then
        erlaubt = True
    Else
        If InStr(1,zipwhite,myextension) <> 0 Or zipwhite = "" Then
            erlaubt = True
        End If
        If InStr(1,zipblack,myextension) <> 0  Then
            erlaubt = False
        End If
    End If
    
    If myextension = "" And zipacceptnoextension = True Then
        erlaubt = True
    End If
    
    If myextension = "" And zipacceptnoextension = False Then
        erlaubt = False
    End If
    
    If erlaubt = False Then
        fs.DeleteFile file.path , True
    Else
        
        mycounter=mycounter+1
    End If
    
Next

Set folder=Nothing
WScript.sleep 20

' hier die referenzen auslesen  


erfolg=readjob(mytempname)



If linkzaehler > 0 Or mycounter >1 Then
    linkspeicher(linkzaehler) = mylink
    linkzaehler = linkzaehler +1
End If



If dokdate="" Then
    dokdate=setdokdate()
End If

If username="" Then
    username="System"
End If

Set folder = fs.GetFolder(strPfadTemp)

For Each file In folder.files
    newtempname=""
    Err.clear
    myname=file.name
    myextension=fs.GetExtensionName(myname)
    
    'Msgbox "myname" & myname
    'Msgbox "mytempname" & mytempname
    
    erfolg=rejob(mytempname)
    
    
    fs.copyfile file, newtempname&"."&myextension, True
    If Err.number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv bfa_unzip: Kann Dateien nicht in queue kopieren: "&file
        WScript.quit
    End If
    
    
    copyschlagwort()
    
    
    'If fs.fileexists(queue&mytempname&".slw") Then
    '	fs.copyfile queue&mytempname&".slw", newtempname&".slw", true
    'End If
    '
    'If fs.fileexists(queue&mytempname&".swd") Then
    '	fs.copyfile queue&mytempname&".swd", newtempname&".swd", true
    'End If
    
    If fs.fileexists(queue&mytempname&".vtx") Then
        fs.copyfile queue&mytempname&".vtx", newtempname&".vtx", True
    End If
    
    If fs.fileexists(queue&mytempname&".ftx") Then
        fs.copyfile queue&mytempname&".ftx", newtempname&".ftx", True
    End If
    
    
    Set myhandle = fs.OpenTextFile(newtempname&".slw",1,True)
    kette=""
    
    Do Until myhandle.atendofstream
        strinput = myhandle.readline
        If InStr(1,strinput,"Dateiname=") <> 0 Then
            strinput = "Dateiname=" & Replace(myname,"." & myextension,"")
        End If
        
        kette=kette & strinput & vbCrLf
    Loop
    
    myhandle.close
    
    Set myhandle = fs.OpenTextFile(newtempname&".slw",2,True)
    
    myhandle.writeline kette
    
    myhandle.close
    Set myhandle=Nothing
    WScript.sleep 50
    
    'Msgbox "Schlagwortdatei kopiert: " & newtempname&".slw"
    
Next

Set folder =Nothing
WScript.sleep 20



If cleanup=True Then
    Err.clear
    Set folder = fs.GetFolder(strPfadTemp)
    For Each file In folder.files
        fs.deletefile file, True
        If Err.number<>0 Then
            objWshShell.LogEvent 1,"bitfarm-Archiv bfa_unzip: kann Datei nicht lschen: "&file
            WScript.quit
        End If
    Next
    Set folder=Nothing
    WScript.sleep 50
    strPfadTemp=Left(strPfadTemp,Len(strPfadTemp)-1)
    
    fs.deletefolder strPfadTemp, True
    If Err.number<>0 Then
        objWshShell.LogEvent 1,"bitfarm-Archiv bfa_unzip: kann Ordner nicht lschen: "&strPfadTemp
        WScript.quit
    End If
End If


Set fs = Nothing




WScript.Quit






'################################################################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################
'################################################################################


Function Zufallszahl(von, bis)
    On Error Resume Next
    anzahl = bis-von+1
    Randomize
    Zufallszahl = Fix(Rnd*(anzahl))+von
End Function


Function rejob(oldbase)
    On Error Resume Next
    
    rejob = True
    Err.clear
    
    newtempname = getfifo(queue,"temp-zip")	
    
    If scriptdebug = True Then
        objWshShell.LogEvent 4,"bitfarm-Archiv: bfa_unzip.vbs"&vbCrLf&"oldbase=" & oldbase &vbCrLf& "newtempname=" & newtempname
    End If
    
    
    If rejob=True Then	
        Set quelljobfile = fs.OpenTextFile(queue&oldbase&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Kann alte Jobdatei nicht zum lesen ffnen."
            objWshShell.LogEvent 1, errortxt
            rejob=False
            
        End If 
    End If
    
    If rejob=True Then
        If fs.FileExists(newtempname&".tmp") Then
            fs.DeleteFile(newtempname& ".tmp")
            If Err.number Then
                Err.clear
                errortxt="bitfarm-Archiv bfa_unzip: Zwischendatei fr Jobdatei existierte noch, kann diese aber nicht lschen."
                objWshShell.LogEvent 1, errortxt
                rejob=False
                quelljobfile.close
                Set quelljobfile=Nothing
            End If 
            
        End If	
    End If
    
    If rejob=True Then
        Set zieljobfile = fs.OpenTextFile(newtempname&".job",8,True)
        If Err.number Then
            Err.clear
            errortxt="Kann Jobdatei nicht zum schreiben ffnen."
            objWshShell.LogEvent 1, errortxt
            rejob=False
            quelljobfile.close
            Set quelljobfile=Nothing
        End If 
    End If
    
    
    
    If rejob = True Then
        'Termin=Date()
        'Alarm=Date()+7
        stopflag=False
        ersatzstring=""	
        Do While quelljobfile.AtEndOfStream <> True
            kette=quelljobfile.readline
            
            ersatzstring=""
            
            
            If (InStr(1,kette,"[Referenz]",1)<>0) And (quelljobfile.AtEndOfStream <> True) Then
                abbruch=False
                Do While abbruch=False 
                    kette=quelljobfile.readline
                    If quelljobfile.AtEndOfStream = True Then
                        abbruch=True
                    End If
                    If (InStr(1,kette,"Referenz",1)=0) And (InStr(1,kette,"Anzahl",1)=0) Then
                        abbruch = True
                    End If
                Loop
                zieljobfile.writeline("[Referenz]")
                zieljobfile.writeline("Anzahl="&linkzaehler)
                x=0
                Do While x < linkzaehler
                    zieljobfile.writeline("Referenz"&x+1&"="&linkspeicher(x))
                    x=x+1
                    
                Loop
                
            End If
            ersatzstring=""
            
            
            If (InStr(1,kette,"Titel=",1)<>0) Then
            	If zipuseoriname = True Then
                	ersatzstring="Titel="& Replace(myname,"." & myextension,"")
                Else
                	ersatzstring="Titel=Dokument"
                End If
            End If
            
            If (Username<>"") And (InStr(1,kette,"Benutzer=",1)<>0) Then
                ersatzstring="Benutzer="&Username
            End If	
            
            If (dokDate<>"") And (InStr(1,kette,"Datum=",1)<>0) Then
                ersatzstring="Datum="&DokDate
            End If
            
            If (Typ<>"") And (InStr(1,kette,"OCR_Typ=",1)<>0) Then
                ersatzstring="OCR_Typ="&Typ
            End If
            
            
            'If (InStr(1,kette,"Quelle=",1)<>0) Then
            '	ersatzstring="Quelle="&mychangedoc
            'End If
            If InStr(1,kette,"Schlagworte=",1)<>0 Then
                
                ersatzstring="Schlagworte="
                
            End If
            
            If Left(kette,8) = "gdoc_id=" Then
                ersatzstring="gdoc_id="
            End If 
            
            
            'If (dokDate<>"") and (InStr(1,kette,"Datum=",1)<>0) Then
            '	ersatzstring="Datum="
            'End If
            '
            'If (dokID4<>"") and (InStr(1,kette,"DOCID=",1)<>0) Then
            '	
            '	
            '	ersatzstring="DOCID="&dokID4
            '	
            'End If
            
            If Left(kette,8)="ZusTitel" Then
                
                For x=1 To limit
                    
                    
                    If InStr(1,kette,"ZusTitel"&x&"=",1)<>0 Then
                        
                        If x<10 Then
                            wert=GetString(kette,InStr(1,kette,"ZusTitel"&x,1)+9)
                        Else
                            wert=GetString(kette,InStr(1,kette,"ZusTitel"&x,1)+10)
                        End If
                        
                        For w=0 To limit
                            
                            If LCase(Zusatzfeldname(w))=LCase(wert) Then
                                
                                ersatzstring="ZusWert"&x&"="&Zusatzfeld(w)
                                
                            End If
                        Next
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                        
                        zieljobfile.writeline(kette)
                        kette=quelljobfile.readline
                        
                    End If
                Next
                
                
            End If
            
            If ersatzstring<>"" Then
                zieljobfile.writeline(ersatzstring)
            Else
                zieljobfile.writeline(kette)
            End If
            
        Loop
        quelljobfile.close
        Set quelljobfile = Nothing
        zieljobfile.close
        Set zieljobfile=Nothing
        WScript.sleep 50
        
        Err.clear
        
    End If
    
    
End Function


'***************************************************************************************
'***************************************************************************************
'***************************************************************************************


Function readjob(tempname)
    On Error Resume Next
    readjob=True
    Err.clear
    
    If Not fs.FileExists(queue&tempname&".job") Then
        Err.clear
        errortxt=tempname&".job Datei nicht vorhanden oder nicht lesbar."
        objWshShell.LogEvent 1, errortxt
        readjob=False
        Err.clear
    End If
    
    If readjob=True Then	
        Set jobfile = fs.OpenTextFile(queue&tempname&".job",1)
        If Err.number Then
            Err.clear
            errortxt="Jobdatei nicht vorhanden oder nicht lesbar."
            objWshShell.LogEvent 1, errortxt
            
            readjob=False
            
        End If 
    End If
    
    
    If readjob = True Then
        
        Do While jobfile.AtEndOfStream <> True
            kette=jobfile.readline
            If Left(kette,1)<>";" Then
                
                
                
                If InStr(1,kette,"Referenz1=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz1=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz2=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz2=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz3=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz3=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If linkspeicher(linkzaehler)<>"" Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                
                If InStr(1,kette,"Referenz4=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz4=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz5=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz5=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz6=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz6=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz7=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz7=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz8=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz8=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz9=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz9=",1)+9))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz10=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz10=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz11=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz11=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz12=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz12=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz13=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz13=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz14=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz14=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz15=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz15=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz16=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz16=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                
                If InStr(1,kette,"Referenz17=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz17=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz18=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz18=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz19=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz19=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                If InStr(1,kette,"Referenz20=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Referenz20=",1)+10))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        linkspeicher(linkzaehler) = Trim(wert)
                        
                        If (linkspeicher(linkzaehler)<>"") And (LCase(Left(linkspeicher(linkzaehler),7))<>"doclink") Then
                            checkOCR=False
                        End If
                        linkzaehler=linkzaehler+1
                    End If
                End If
                
                
                
                
                If InStr(1,kette,"Profil=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Profil=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Profil = wert
                    End If
                End If
                
                If InStr(1,kette,"OCR_Typ=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"OCR_Typ=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        
                        Typ = wert
                    Else
                        Typ = "MAN"	
                    End If
                End If
                
                If InStr(1,kette,"Name=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Name=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        laenge=Len(kette)+1
                        pos1=InStr(1,kette,"Name=",1)+5
                        wert=Mid(kette,pos1,laenge-pos1)
                        Tabelle = wert
                    End If
                    
                End If 
                
                If InStr(1,kette,"Filter=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Filter=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Filtermakro = LCase(wert)
                        If InStr(1,LCase(wert),"color",1)<>0 Then
                            'Filtermakro=""
                            Filtermakro=Replace(Filtermakro,"color","")			
                            
                            color=True
                        End If
                        If InStr(1,LCase(wert),"highres",1)<>0 Then
                            Filtermakro=Replace(Filtermakro,"highres","")
                            
                            'Filtermakro=""
                            hires=True
                        End If
                    End If
                    
                End If
                
                If InStr(1,kette,"Datum=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Datum=",1)+6)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        laenge=Len(kette)+1
                        pos1=InStr(1,kette,"Datum=",1)+6
                        wert=Mid(kette,pos1,laenge-pos1)
                        dokdate = wert
                    End If
                    
                End If 
                
                
                
                If InStr(1,kette,"DOCID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"DOCID=",1)+5)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        dokID = wert
                    End If
                End If
                
                If InStr(1,kette,"Titel=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Titel=",1)+5))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        myname = wert
                    End If
                End If
                
                If InStr(1,kette,"Benutzer=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Benutzer=",1)+8))
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        username = wert
                    End If
                End If
                
                If InStr(1,kette,"Tabelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Tabelle=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        folderID = wert
                    End If
                End If
                
                If InStr(1,kette,"Quelle=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Quelle=",1)+6))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        quelle = wert
                    End If
                End If
                
                If InStr(1,kette,"Orginal=",1)<>0 Then
                    wert=Right(kette,Len(kette)-(InStr(1,kette,"Orginal=",1)+7))
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Orginal = wert
                    End If
                End If
                
                
                If InStr(1,kette,"Status=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Status=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        oldstatus = wert
                    End If
                End If
                
                If InStr(1,kette,"clientID=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"clientID=",1)+8)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        clientID = wert
                    End If
                End If
                
                If InStr(1,kette,"Felder=",1)<>0 Then
                    wert=GetString(kette,InStr(1,kette,"Felder=",1)+7)
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        'Msgbox "wert:" & wert
                        Zusatzfelder = strconvert(wert)
                        If Zusatzfelder > 29 Then
                            errortxt="Jobdatei: mehr als "&limit&" Zusatzfelder werden nicht untersttzt."
                            objWshShell.LogEvent 1, errortxt
                            readjob=False
                        End If
                        'If Zusatzfelder > 0 Then
                        '	checkOCR=false
                        'End If
                    End If
                End If
                
                
                If InStr(1,kette,"ZusTitel",1)<>0 Then
                    wert=getstring(kette,InStr(1,kette,"ZusTitel",1)+10)
                    gefunden=False
                    x=0
                    Do While gefunden=False
                        If Zusatzfeldname(x)="" Then
                            gefunden=True
                            Zusatzfeldname(x)=wert
                            
                        End If
                        If gefunden=False Then
                            x=x+1
                        End If
                    Loop
                    
                End If
                
                If InStr(1,kette,"ZusWert",1)<>0 Then
                    wert=getstring(kette,InStr(1,kette,"ZusWert",1)+9)
                    
                    pos1=InStr(1,kette,wert,1)
                    If wert="" Then
                        pos1=0
                    End If
                    If pos1>3 Then
                        wert=Right(kette,Len(kette)-pos1+1)
                    Else
                        wert=""
                    End If
                    
                    If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                        Zusatzfeld(x)=wert
                        
                        checkOCR=False
                    End If
                    
                End If
                
                
            End If
            
            
        Loop
        jobfile.close
        Set jobfile = Nothing
        
    End If
    
    
End Function



Function copyschlagwort()
    On Error Resume Next
    datei1=queue&mytempname
    datei2=newtempname
    Set zieldatei=fs.opentextfile(datei2&".slw",8,1)
    
    If fs.fileexists(datei1&".slw") Then
        Set quelldatei=fs.opentextfile(datei1&".slw",1)
        Do While quelldatei.atendofstream=False
            kette=quelldatei.readline
            zieldatei.writeline(kette)
        Loop
        quelldatei.close
        Set quelldatei=Nothing
    End If
    
    If fs.fileexists(datei1&".swd") Then
        Set quelldatei=fs.opentextfile(datei1&".slw",1)
        Do While quelldatei.atendofstream=False
            kette=quelldatei.readline
            zieldatei.writeline(kette)
        Loop
        quelldatei.close
        Set quelldatei=Nothing
    End If
    
    
    
    zieldatei.close
    Set zieldatei=Nothing
    
End Function






Private Function makedate(mydate)
    On Error Resume Next
    myday="01"
    mymonth="01"
    myyear="1900"
    myhour="12"
    myminute="00"
    mysecond="00"
    
    Err.clear
    On Error Resume Next
    makedate="Error"
    mydate=Trim(mydate)
    datetype=0
    varlaenge=Len(mydate)
    compdate=""
    For o=1 To varlaenge
        If Mid(mydate,o,1)<>" " Then
            compdate=compdate&Mid(mydate,o,1)
        End If
    Next
    compdate=LCase(compdate)
    
    
    ReDim chararray(60)
    ReDim chartype(60)
    For x=0 To 60
        chararray(x)=""
        chartype(x)=0
    Next
    mycharstring=""
    varlaenge=Len(compdate)
    For x=1 To varlaenge
        a=Asc(Mid(compdate,x,1))
        
        chararray(x)=a
        If (a>=48) And (a<=57) Then 'Zahlen
            chartype(x)=1
        End If
        If (a>=97) And (a<=122) Then 'Buchstaben
            chartype(x)=2
        End If
        If (a>=228) And (a<=231) Then 'Buchstaben Umlaute
            chartype(x)=2
        End If
        If (a=47) Or (a=92) Then ' /
            chartype(x)=3
        End If
        If (a=46) Then ' .
            chartype(x)=3
        End If
        
        mycharstring=mycharstring&chartype(x)
    Next
    
    
    If (chartype(1)=1) And (chartype(2)=1) And (chartype(3)=3) And (chartype(4)=2) And (chartype(5)=2) And (chartype(6)=2) And (chartype(varlaenge)=1) And (chartype(varlaenge-1)=1) And (chartype(varlaenge-2)=1) And (chartype(varlaenge-3)=1) And (chartype(varlaenge-4)=2) And (chartype(varlaenge-5)=2) And (chartype(varlaenge-6)=2) Then
        datetype=2
    End If
    
    
    If Right(mydate,2)="UT" Then
        datetype=1
    End If
    
    
    If datetype=1 Then
        
        myday=Left(mydate,2)
        mymonth=Mid(mydate,4,3)
        myyear=Mid(mydate,8,4)
        myhour=Mid(mydate,13,2)
        myminute=Mid(mydate,16,2)
        mysecond=Mid(mydate,19,2)
        
        If LCase(mymonth)="dec" Then
            mymonth="12"
        ElseIf LCase(mymonth)="nov" Then
            mymonth="11"
        ElseIf LCase(mymonth)="oct" Then
            mymonth="10"
        ElseIf LCase(mymonth)="sep" Then
            mymonth="09"
        ElseIf LCase(mymonth)="aug" Then
            mymonth="08"
        ElseIf LCase(mymonth)="jul" Then
            mymonth="07"
        ElseIf LCase(mymonth)="jun" Then
            mymonth="06"
        ElseIf LCase(mymonth)="may" Then
            mymonth="05"
        ElseIf LCase(mymonth)="apr" Then
            mymonth="04"
        ElseIf LCase(mymonth)="mar" Then
            mymonth="03"
        ElseIf LCase(mymonth)="feb" Then
            mymonth="02"
        ElseIf LCase(mymonth)="jan" Then
            mymonth="01"
        Else
            mymonth="01"
        End If
        
        
        'makedate=myyear&"-"&mymonth&"-"&myday&" "&myhour&":"&myminute&":"&mysecond
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
    
    
    
    If datetype=2 Then
        myyear=Right(compdate,4)
        myday=Left(compdate,2)
        mymonth=Mid(compdate,4,varlaenge-7)
        If mymonth="januar" Then
            mymonth="01"
        End If
        If mymonth="februar" Then
            mymonth="02"
        End If
        If mymonth="mrz" Then
            mymonth="03"
        End If
        If mymonth="april" Then
            mymonth="04"
        End If
        If mymonth="mai" Then
            mymonth="05"
        End If
        If mymonth="juni" Then
            mymonth="06"
        End If
        If mymonth="juli" Then
            mymonth="07"
        End If
        If mymonth="august" Then
            mymonth="08"
        End If
        If mymonth="september" Then
            mymonth="09"
        End If
        If mymonth="oktober" Then
            mymonth="10"
        End If
        If mymonth="november" Then
            mymonth="11"
        End If
        If mymonth="dezember" Then
            mymonth="12"
        End If
        
        'makedate=myyear&"-"&mymonth&"-"&myday&" "&myhour&":"&myminute&":"&mysecond
        makedate=myday&"."&mymonth&"."&myyear
        
    End If
    
    
    If Err.number<>0 Then
        makedate="Error"
    End If
    
End Function


Function setdokdate()
    On Error Resume Next
    Jahr = DatePart("yyyy",Date)
    Monat = DatePart("m",Date)
    Tag = DatePart("d",Date)
    Stunde = DatePart("h",Time)
    Minuten = DatePart("n",Time)
    Sekunde = DatePart("s", Time)
    If Len(Monat)=1 Then 
        monat="0"&monat
    End If
    If Len(tag)=1 Then 
        tag="0"&tag
    End If
    If Len(stunde)=1 Then 
        stunde="0"&stunde
    End If
    If Len(minuten)=1 Then 
        minuten="0"&minuten
    End If
    If Len(sekunde)=1 Then 
        sekunde="0"&sekunde
    End If
    setdokdate = Jahr&"-" & Monat & "-" & Tag & " " & Stunde & ":" & Minuten & ":" & Sekunde
End Function


Private Function GetString(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (zeichen<>"	") And (index<80)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,pos+index,1)
        index=index+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    Trim(ergebnis)
    GetString=ergebnis
End Function

Private Function GetWord(kette,pos)
    On Error Resume Next
    zeichen=""
    ergebnis=""
    index1=pos
    'Msgbox(Len(kette)&":"&pos)
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    Do While (zeichen<>" ") And (zeichen<>"	") And (charwert<>13) And (index1>1)
        index1=index1-1
        zeichen=Mid(kette,index1,1)
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
            If charwert=13 Then
                
                index1=index1+1
            End If
        End If
        
    Loop
    'Msgbox(index1)
    zeichen=""
    index2=0
    charwert=0
    If Len(zeichen)=1 Then
        charwert=Asc(zeichen)
    End If
    
    maxindex2=Len(kette)-index1+2
    Do While (zeichen<>" ") And (zeichen<>vbCrLf) And (charwert<>13) And (zeichen<>"	") And (index2<maxindex2)
        ergebnis=ergebnis+zeichen
        zeichen=Mid(kette,index1+index2,1)
        index2=index2+1
        If Len(zeichen)=1 Then
            charwert=Asc(zeichen)
        End If
        If ((zeichen=" ") Or (zeichen="	") Or (zeichen="=") Or (charwert=13)) And (ergebnis="") Then
            zeichen=""
        End If
        
    Loop
    'Msgbox(index)
    Trim(ergebnis)
    
    GetWord=normstring(ergebnis)
End Function




Function inilesen()
    On Error Resume Next
    Err.clear
    Set inifile = fs.OpenTextFile(programm&"scripts.ini",1)
    If Err.number Then
        objWshShell.LogEvent 1, "scripts.ini nicht im Scriptpfad vorhanden oder nicht lesbar."
        Err.clear
        WScript.Quit
    End If 
    
    kette=inifile.readline
    Scriptsflag=InStr(1,kette,"[Scripts]")
    Do While Scriptsflag = 0
        kette=inifile.readline
        Scriptsflag=InStr(1,kette,"[Scripts]")
        If inifile.AtEndOfStream = True Then
            inifile.close
            objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - falsche Formatierung."
            WScript.Quit
        End If
    Loop
    
    
    Do While inifile.AtEndOfStream <> True
        kette=inifile.readline
        If Left(kette,1)<>";" Then
            
            
            
            If InStr(1,kette,"zippath",1)<>0 Then
                'wert=GetString(kette,InStr(1,kette,"zippath",1)8)
                wert = Right(kette,Len(kette) -8)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    zippath=Trim(wert)
                End If
            End If
            
            
            If InStr(1,kette,"deletezipafterdecomp",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"deletezipafterdecomp",1)+21)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        deletezip=True
                    End If
                End If
            End If
            
            If InStr(1,kette,"zipacceptnoextension",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"zipacceptnoextension",1)+21)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        zipacceptnoextension=True
                    End If
                End If
            End If
            
            
            
            If InStr(1,kette,"zipwhitelistextensions",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"zipwhitelistextensions",1)+23)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    
                    zipwhite=Trim(LCase(wert))&"."
                    
                End If
            End If
            
            
            
            If InStr(1,kette,"zipuseoriname",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"zipuseoriname",1)+14)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="false" Then
                        zipuseoriname=False
                    End If
                End If
            End If
            
            If InStr(1,kette,"zipblacklistextensions",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"zipblacklistextensions",1)+23)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    
                    zipblack=Trim(LCase(wert))&"."
                End If
            End If
            
            If InStr(1,kette,"extractrecursive",1)<>0 Then
                wert=GetString(kette,InStr(1,kette,"extractrecursive",1)+17)
                If (Len(wert)>0) And (wert<>" ") And (wert<>"	") Then
                    If LCase(wert)="true" Then
                        extractrecursive=True
                    End If
                End If
            End If            
            
            
            
            
        End If
        
    Loop
    inifile.close
    Set inifile = Nothing
    If programm="" Then
        objWshShell.LogEvent 1, "Fehler beim Lesen der scripts.ini - kein Programmpfad."
        WScript.Quit
    End If
    
    
End Function




'########################################   Garbage ###############################################


Function GetGarbage(jobname)
    On Error Resume Next
    'If changeling=false Then
    errorlog(jobname)
    i=0
    garbagename=garbagepath&"temp"&i
    flag10=False
    If (fs.FileExists(garbagename&".bmp")) Or (fs.FileExists(garbagename&".gif")) Or (fs.FileExists(garbagename&".jpg")) Or (fs.FileExists(garbagename&".ps")) Or (fs.FileExists(garbagename&".tif")) Or (fs.FileExists(garbagename&".job")) Then
        flag10=False
    Else
        flag10=True
    End If
    
    Do While flag10=False
        i = i + 1
        garbagename=garbagepath&"temp"&i
        If (fs.FileExists(garbagename&".ps")) Or (fs.FileExists(garbagename&".tif")) Or (fs.FileExists(garbagename&".job")) Then
            flag10=False
        Else
            flag10=True
        End If
    Loop
    
    If fs.fileexists(jobname & ".log") Then
        Err.clear
        fs.CopyFile jobname&".log", garbagename&".log", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".job") Then
        Err.clear
        fs.CopyFile jobname&".job", garbagename&".job", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".tif") Then
        Err.clear
        fs.CopyFile jobname&".tif", garbagename&".tif", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & "-OCR.tif") Then
        Err.clear
        fs.CopyFile jobname&"-OCR.tif", garbagename&"-OCR.tif", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & "-OCR.jpg") Then
        Err.clear
        fs.CopyFile jobname&"-OCR.jpg", garbagename&"-OCR.jpg", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & "-archiv.tif") Then
        Err.clear
        fs.CopyFile jobname&"-archiv.tif", garbagename&"-archiv.tif", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    
    If fs.fileexists(jobname & ".bmp") Then
        Err.clear
        fs.CopyFile jobname&".bmp", garbagename&".bmp", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".jpg") Then
        Err.clear
        fs.CopyFile jobname&".jpg", garbagename&".jpg", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".ftx") Then
        Err.clear
        fs.CopyFile jobname&".ftx", garbagename&".ftx", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    
    If fs.fileexists(jobname & ".bar") Then
        Err.clear
        fs.CopyFile jobname&".bar", garbagename&".bar", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    
    If fs.fileexists(jobname & "-bc.bar") Then
        Err.clear
        fs.CopyFile jobname&"-bc.bar", garbagename&"-bc.bar", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & "-bc.tif") Then
        Err.clear
        fs.CopyFile jobname&"-bc.tif", garbagename&"-bc.tif", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    
    If fs.fileexists(jobname & ".htm") Then
        Err.clear
        fs.CopyFile jobname&".htm", garbagename&".htm", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".html") Then
        Err.clear
        fs.CopyFile jobname&".html", garbagename&".html", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".eml") Then
        Err.clear
        fs.CopyFile jobname&".eml", garbagename&".eml", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".msg") Then
        Err.clear
        fs.CopyFile jobname&".msg", garbagename&".msg", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".var") Then
        Err.clear
        fs.CopyFile jobname&".var", garbagename&".var", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".zwd") Then
        Err.clear
        fs.CopyFile jobname&".zwd", garbagename&".zwd", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".ztd") Then
        Err.clear
        fs.CopyFile jobname&".ztd", garbagename&".ztd", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".gif") Then
        Err.clear
        fs.CopyFile jobname&".gif", garbagename&".gif", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".pdf") Then
        Err.clear
        fs.CopyFile jobname&".pdf", garbagename&".pdf", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".ps") Then
        Err.clear
        fs.CopyFile jobname&".ps", garbagename&".ps", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".doc") Then
        Err.clear
        fs.CopyFile jobname&".doc", garbagename&".doc", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".xls") Then
        Err.clear
        fs.CopyFile jobname&".xls", garbagename&".xls", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".rtf") Then
        Err.clear
        fs.CopyFile jobname&".rtf", garbagename&".rtf", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".dbf") Then
        Err.clear
        fs.CopyFile jobname&".dbf", garbagename&".dbf", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".ocr") Then
        Err.clear
        fs.CopyFile jobname&".ocr", garbagename&".ocr", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".ppt") Then
        Err.clear
        fs.CopyFile jobname&".ppt", garbagename&".ppt", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".pps") Then
        Err.clear
        fs.CopyFile jobname&".pps", garbagename&".pps", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".dwg") Then
        Err.clear
        fs.CopyFile jobname&".dwg", garbagename&".dwg", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".dxf") Then
        Err.clear
        fs.CopyFile jobname&".dxf", garbagename&".dxf", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".txt") Then
        Err.clear
        fs.CopyFile jobname&".txt", garbagename&".txt", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".xjf") Then
        Err.clear
        fs.CopyFile jobname&".xjf", garbagename&".xjf", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".swd") Then
        Err.clear
        fs.CopyFile jobname&".swd", garbagename&".swd", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".slw") Then
        Err.clear
        fs.CopyFile jobname&".slw", garbagename&".slw", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".tpl") Then
        Err.clear
        fs.CopyFile jobname&".tpl", garbagename&".tpl", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & ".err") Then
        Err.clear
        fs.CopyFile jobname&".err", garbagename&".err", True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    
    If fs.fileexists(jobname & extension) Then
        Err.clear
        fs.CopyFile jobname&extension, garbagename&extension, True
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next
            objWshShell.LogEvent 1, "bfa_unzip: Garbage lsst sich nicht verschieben."&Err.number
            
        End If
    End If
    'End If
    
    aufraeumen(jobname)
    
    'Unlock(programm&lockdatei)
    'WScript.Quit
End Function





Function aufraeumen(name1)
    On Error Resume Next
    '******************* kurz noch warten, vielleicht ist Ausdruck noch nicht fertig bergeben ******
    WScript.sleep 500
    '************************************************************************************************
    flagerr=False
    errfile=""
    
    Err.clear
    If fs.fileexists(name1 & ".job") Then
        fs.DeleteFile(name1 & ".job")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".job"
        End If
    End If
    
    If fs.fileexists(name1 & ".log") Then
        fs.DeleteFile(name1 & ".log")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".log"
        End If
    End If
    
    If fs.fileexists(name1 & ".err") Then
        fs.DeleteFile(name1 & ".err")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".err"
        End If
    End If
    
    If fs.fileexists(name1 & ".ocr") Then
        fs.DeleteFile(name1 & ".ocr")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".ocr"
        End If
    End If
    
    
    If fs.fileexists(name1 & ".pdf") Then
        fs.DeleteFile(name1 & ".pdf")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".pdf"
        End If
    End If
    
    If fs.fileexists(name1 & ".doc") Then
        fs.DeleteFile(name1 & ".doc")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".doc"
        End If
    End If
    
    If fs.fileexists(name1 & ".ftx") Then
        fs.DeleteFile(name1 & ".ftx")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".ftx"
        End If
    End If
    
    If fs.fileexists(name1 & ".bar") Then
        fs.DeleteFile(name1 & ".bar")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".bar"
        End If
    End If
    
    If fs.fileexists(name1 & "-bc.bar") Then
        fs.DeleteFile(name1 & "-bc.bar")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "-bc.bar"
        End If
    End If
    
    If fs.fileexists(name1 & "-bc.tif") Then
        fs.DeleteFile(name1 & "-bc.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "-bc.tif"
        End If
    End If
    
    If fs.fileexists(name1 & ".zwd") Then
        fs.DeleteFile(name1 & ".zwd")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".zwd"
        End If
    End If
    
    If fs.fileexists(name1 & ".ztd") Then
        fs.DeleteFile(name1 & ".ztd")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".ztd"
        End If
    End If
    
    If fs.fileexists(name1 & ".dbf") Then
        fs.DeleteFile(name1 & ".dbf")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".dbf"
        End If
    End If
    
    If fs.fileexists(name1 & ".xls") Then
        fs.DeleteFile(name1 & ".xls")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".xls"
        End If
    End If
    
    If fs.fileexists(name1 & ".rtf") Then
        fs.DeleteFile(name1 & ".rtf")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".rtf"
        End If
    End If
    
    If fs.fileexists(name1 & ".ppt") Then
        fs.DeleteFile(name1 & ".ppt")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".ppt"
        End If
    End If
    
    If fs.fileexists(name1 & ".pps") Then
        fs.DeleteFile(name1 & ".pps")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".pps"
        End If
    End If
    
    If fs.fileexists(name1 & ".dwg") Then
        fs.DeleteFile(name1 & ".dwg")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".dwg"
        End If
    End If
    
    If fs.fileexists(name1 & ".dxf") Then
        fs.DeleteFile(name1 & ".dxf")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".dxf"
        End If
    End If
    
    If fs.fileexists(name1 & ".pid") Then
        fs.DeleteFile(name1 & ".pid")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".pid"
        End If
    End If
    
    If fs.fileexists(name1 & ".htm") Then
        fs.DeleteFile(name1 & ".htm")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".htm"
        End If
    End If
    
    If fs.fileexists(name1 & ".html") Then
        fs.DeleteFile(name1 & ".html")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".html"
        End If
    End If
    
    If fs.fileexists(name1 & ".eml") Then
        fs.DeleteFile(name1 & ".eml")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".eml"
        End If
    End If
    
    If fs.fileexists(name1 & ".msg") Then
        fs.DeleteFile(name1 & ".msg")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".msg"
        End If
    End If
    
    If fs.fileexists(name1 & ".var") Then
        fs.DeleteFile(name1 & ".var")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".var"
        End If
    End If
    
    
    If fs.fileexists(name1 & ".tif") Then
        fs.DeleteFile(name1 & ".tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".tif"
        End If
    End If
    
    If fs.fileexists(name1 & ".bmp") Then
        fs.DeleteFile(name1 & ".bmp")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".bmp"
        End If
    End If
    
    If fs.fileexists(name1 & ".jpg") Then
        fs.DeleteFile(name1 & ".jpg")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".jpg"
        End If
    End If
    
    If fs.fileexists(name1 & ".gif") Then
        fs.DeleteFile(name1 & ".gif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".gif"
        End If
    End If
    
    If fs.fileexists(name1 & "-archiv.tif") Then
        fs.DeleteFile(name1 & "-archiv.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "-archiv.tif"
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.tif") Then
        fs.DeleteFile(name1 & "-OCR.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "-OCR.tif"
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.jpg") Then
        fs.DeleteFile(name1 & "-OCR.jpg")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "-OCR.jpg"
        End If
    End If
    
    If fs.fileexists(name1 & ".xjf") Then
        fs.DeleteFile(name1 & ".xjf")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".xjf"
        End If
    End If
    
    If fs.fileexists(name1 & ".swd") Then
        fs.DeleteFile(name1 & ".swd")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".swd"
        End If
    End If
    
    
    
    If fs.fileexists(name1 & "_0.dat") Then
        fs.DeleteFile(name1 & "_0.dat")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "_0.dat"
        End If
    End If
    
    
    
    If fs.fileexists(name1 & ".txt") Then
        fs.DeleteFile(name1 & ".txt")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".txt"
        End If
    End If
    
    If fs.fileexists(name1 & ".tmp.txt") Then
        fs.DeleteFile(name1 & ".tmp.txt")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".tmp.txt"
        End If
    End If
    
    If fs.fileexists(name1 & ".pnm") Then
        fs.DeleteFile(name1 & ".pnm")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".pnm"
        End If
    End If
    
    If fs.fileexists(name1 & ".slw") Then
        fs.DeleteFile(name1 & ".slw")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".slw"
        End If
    End If
    
    
    
    If fs.fileexists(programm&"out10.bmp") Then
        fs.DeleteFile(programm&"out10.bmp")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=programm&"out10.bmp"
        End If
    End If
    
    
    
    If fs.fileexists(programm&"out20.bmp") Then
        fs.DeleteFile(programm&"out20.bmp")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=programm&"out20.bmp"
        End If
    End If
    
    
    
    If fs.fileexists(programm&"out30.bmp") Then
        fs.DeleteFile(programm&"out30.bmp")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=programm&"out30.bmp"
        End If
    End If
    
    
    If fs.fileexists(name1 & ".ps") Then
        fs.DeleteFile(name1 & ".ps")
        If Err.number<>0 Then
            oerr.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".ps"
        End If
    End If
    
    If fs.fileexists(name1 & ".tpl") Then
        fs.DeleteFile(name1 & ".tpl")
        If Err.number<>0 Then
            oerr.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & ".tpl"
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR_0.dat") Then
        fs.DeleteFile(name1 & "-OCR_0.dat")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "-OCR_0.dat"
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.xjf") Then
        fs.DeleteFile(name1 & "-OCR.xjf")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "-OCR.xjf"
        End If
    End If
    
    If fs.fileexists(name1 & "-OCR.txt") Then
        fs.DeleteFile(name1 & "-OCR.txt")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & "-OCR.txt"
        End If
    End If
    
    If fs.fileexists(name1 & extension) Then
        fs.DeleteFile(name1 & extension)
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=name1 & extension
        End If
    End If
    
    If fs.fileexists(queue&"cut1.tif") Then
        fs.DeleteFile(queue&"cut1.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"cut1.tif"
        End If
    End If
    
    If fs.fileexists(queue&"cut2.tif") Then
        fs.DeleteFile(nqueue&"cut2.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"cut2.tif"
        End If
    End If
    
    
    If fs.fileexists(queue&"cut3.tif") Then
        fs.DeleteFile(queue&"cut3.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"cut3.tif"
        End If
    End If
    
    If fs.fileexists(queue&"cut4.tif") Then
        fs.DeleteFile(queue&"cut4.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"cut4.tif"
        End If
    End If
    
    
    If fs.fileexists(queue&"cut5.tif") Then
        fs.DeleteFile(queue&"cut5.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"cut5.tif"
        End If
    End If
    
    If fs.fileexists(queue&"cut6.tif") Then
        fs.DeleteFile(queue&"cut6.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"cut6.tif"
        End If
    End If
    
    If fs.fileexists(queue&"OCR.xwf") Then
        fs.DeleteFile(queue&"OCR.xwf")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"OCR.xwf"
        End If
    End If
    If fs.fileexists(queue&"OCR.tif") Then
        fs.DeleteFile(queue&"OCR.tif")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"OCR.tif"
        End If
    End If
    If fs.fileexists(queue&"OCR.txt") Then
        fs.DeleteFile(queue&"OCR.txt")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"OCR.txt"
        End If
    End If
    If fs.fileexists(queue&"OCR.pdf") Then
        fs.DeleteFile(queue&"OCR.pdf")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"OCR.pdf"
        End If
    End If
    If fs.fileexists(queue&"OCR.jpg") Then
        fs.DeleteFile(queue&"OCR.jpg")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"OCR.jpg"
        End If
    End If
    If fs.fileexists(queue&"OCR.bmp") Then
        fs.DeleteFile(queue&"OCR.bmp")
        If Err.number<>0 Then
            Err.clear
            On Error Resume Next	
            flagerr=True
            errfile=queue&"OCR.bmp"
        End If
    End If
    
    
    If flagerr=True Then
        objWshShell.LogEvent 1, "bitfarm-Archiv: Fehler beim Aufrumen. Konnte Datei nicht lschen: "&errfile
    End If
    
    
    
    '********************* alle tifs aus temp lschen *******
    
    Err.clear
    Set tempfolder = fs.GetFolder(programm&"temp")
    For Each datei In tempfolder.files
        If LCase(Right(datei,3))="tif" Then
            fs.deletefile datei,True
        End If
    Next
    Set tempfolder=Nothing
    If Err.number <> 0 Then
        Err.clear
        On Error Resume Next
        errortxt="Fehler beim aufrumen aller tif-dateien aus dem temp-Ordner."	
        objWshShell.LogEvent 1, errortxt
        
        WScript.Quit
    End If
    
    
End Function



Function errorlog(tempname)
    On Error Resume Next
    Err.clear
    
    Set errfile = fs.CreateTextFile(tempname&".err",True)
    If Err.number<>0 Then
        Err.clear	
        objWshShell.LogEvent 1, "Panik: kann kein Errorlog schreiben."&Err.number
        Unlock(programm&lockdatei)
        WScript.Quit
    End If
    errfile.WriteLine(errortxt)
    errfile.close
    Set errfile=Nothing
    
End Function

Private Function StrConvert(String)
    On Error Resume Next
    wert1=0
    l = Len(String)
    
    For x = 1 To l
        wert1=wert1+((Asc(Mid(String,x,1))-48)*(10^(l-x)))
    Next
    StrConvert=wert1
End Function



'################################################ GetFifo #######################################################



Function getfifo(fifopath,fifoname)
    On Error Resume Next
    If fs.fileexists(programm & "queue\Thumbs.db") Then
        fs.deletefile programm & "queue\Thumbs.db", True
        If Err.number<>0 Then
            objWshShell.LogEvent 2, "Archivspooler: konnte Thums.db nicht lschen"
            
        End If 
        
    End If
    
    Dim fifofile
    Dim fifofolder
    Beginn = Timer
    tempnumber=""
    fifoname=LCase(fifoname)
    
    highest = 0
    
    
    fifofile = GetLastFile(programm & "queue", fifoname&"*.*")
    If fifofile<>"" Then
        strfifo = fs.GetBaseName(fifofile)
        If InStr(1,strfifo,"_0") <> 0 Then
            strfifo = Replace(strfifo,"_0","")
        End If
        If InStr(1,strfifio,"-archiv") <> 0 Then
            strfifo = Replace(strfifo,"-archiv","")
        End If
        If InStr(1,strfifio,"-temp") <> 0 Then
            strfifo = Replace(strfifo,"-temp","")
        End If
        strnumber = Right(strfifo,5)
        If IsNumeric(strnumber) Then
            highest= strConvert(strnumber)
        Else
            'Achtung ermittelter Dateiname hat keinen 5 stelligen Index. So eine datei hat hier nichts verloren.
            'wir suchen den letzten job
            fifofile = GetLastFile(programm & "queue", fifoname&"*.job")
            If fifofile<>"" Then
                strfifo = fs.GetBaseName(fifofile)
                strnumber = Right(strfifo,5)
                If IsNumeric(strnumber) Then
                    highest= strConvert(strnumber)
                End If		
                
                
            Else
                'es gibt keinen job
                
            End If
            
        End If
        
        
        If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
            If fifoname = "prio" Then
                
                objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                
                Set fifofolder = Nothing
                WScript.Quit
            Else
                fifoname = "prio"
                
                getfifo = getfifo(fifopath,fifoname)
                
                Exit Function
            End If
        End If
        
    End If
    
    
    tempnumber = MakeFifoString(highest +1)
    
    WScript.Sleep 200
    
    
    fifofile = GetLastFile(programm & "queue",fifoname&"*.*")
    strfifo = fs.GetBaseName(fifofile)
    
    
    If strfifo = fifoname& tempnumber Then
        If scriptdebug = True Then
            objWshShell.LogEvent 2, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
        End If
        
        getfifo = getfifo(fifopath,fifoname)
        
        Exit Function
    End If
    
    'vielleicht wurde aus unbekannten grnden doch ein schon vergebener name ermittelt
    
    If fs.FileExists(fifopath & fifoname& tempnumber & extension) Then
        highest = highest + 1
        tempnumber = MakeFifoString(highest +1)
        
        Do While fs.FileExists(fifopath & fifoname& tempnumber & extension) And highest <99999
            highest = highest + 1
            tempnumber = MakeFifoString(highest +1)
        Loop
        
    End If
    
    
    If tempnumber<>"" Then
        getfifo = fifopath & fifoname & tempnumber
    Else
        'alternativ alte routine
        highest = 0
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            strfifo = fs.GetBaseName(fifofile)
            If InStr(1,strfifo,"_0") <> 0 Then
                strfifo = Replace(strfifo,"_0","")
            End If
            If InStr(1,strfifio,"-archiv") <> 0 Then
                strfifo = Replace(strfifo,"-archiv","")
            End If
            If InStr(1,strfifio,"-temp") <> 0 Then
                strfifo = Replace(strfifo,"-temp","")
            End If
            'msgbox "strfifo="& strfifo
            ' Bedingung Basename = fifoname+ 5 stellige Zahl
            
            If Len(strfifo) = Len(fifoname)+5 Then
                If LCase(Left(strfifo,Len(strfifo)-5)) = fifoname Then
                    
                    strnumber = Right(strfifo,5)
                    If IsNumeric(strnumber) Then
                        strnumber= strConvert(strnumber)
                        'MsgBox "strnumber=" & strnumber		
                    End If
                    If strnumber> highest Then
                        highest =  strnumber
                    End If
                End If
            End If
            
            'msgbox "highest=" & highest
            
            If highest = 99999 Then       ' zahlenbereich fr diesen dateinamen voll, umbenennen
                If fifoname = "prio" Then
                    
                    objWshShell.LogEvent 1,"bitfarm-Archiv: Achtung Totaler Overflow - Queue vollgelaufen !"&vbCrLf&"Es werden keine Dokumente mehr gespoolt"
                    
                    Set fifofolder = Nothing
                    WScript.Quit
                Else
                    fifoname = "prio"
                    
                    getfifo = getfifo(fifopath,fifoname)
                    'msgbox "overflow-getfifo=" & getfifo	
                    'Set fifofolder = Nothing
                    'Set fifofile = Nothing
                    Exit Function
                End If
            End If
            
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        
        tempnumber = MakeFifoString(highest +1)
        
        WScript.Sleep 1000
        'MsgBox "checkfifo - nochmals nachsehen ob in der zwischenzeit der name von woanders her besetzt wurde"
        
        Set fifofolder = fs.GetFolder(fifopath)
        
        For Each fifofile In fifofolder.Files
            
            
            
            strfifo = fs.GetBaseName(fifofile)
            
            If strfifo = fifoname& tempnumber Then
                'MsgBox "doch gefunden, die routine nochmals aufrufen"
                If scriptdebug = True Then
                    objWshShell.LogEvent 2, "Archivierung.vbs" &vbCrLf& "Slot schon besetzt, Routine wird nochmals aufgerufen" &vbCrLf& tempnumber &vbCrLf& jetzt
                End If
                
                getfifo = getfifo(fifopath,fifoname)
                Set fifofolder = Nothing
                Set fifofile = Nothing
                Exit Function
            End If
            
        Next 
        Set fifofolder = Nothing
        Set fifofile = Nothing
        
        getfifo = fifopath & fifoname & tempnumber
        
        
    End If
    Ende = Timer
    'MsgBox "Getfifo in : " & ende - beginn
    If scriptdebug = True Then
        objWshShell.LogEvent 4, "Archivspooler: ermittelter tempname=" & getfifo
    End If 
    
End Function


Function MakeFiFoString(nummer) 
    On Error Resume Next
    
    If Len(nummer) = 1 Then MakeFiFoString = "0000" & nummer
    If Len(nummer) = 2 Then MakeFiFoString = "000" & nummer
    If Len(nummer) = 3 Then MakeFiFoString = "00" & nummer
    If Len(nummer) = 4 Then MakeFiFoString = "0" & nummer
    If Len(nummer) = 5 Then MakeFiFoString = "" & nummer
    
End Function


Function GetFirstFile(folder,mask)
    On Error Resume Next
    
    GetFirstFile=""
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34) & " " & folder & " " & mask & " -lf")
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetFirstFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function


Function GetLastFile(folder,mask)
    On Error Resume Next
    
    GetLastFile=""
    
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34) & " " & folder & " " & mask & " -ll")
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname=Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        
        'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
        GetLastFile=strname
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function



Function CountFiles(folder,mask)
    On Error Resume Next
    
    CountFiles=0
    If fs.FileExists(programm&"countfiles.exe") Then
        Set oExec    = objWSHShell.Exec(Chr(34)&programm&"countfiles.exe"&Chr(34)&" "& folder & " " & mask)
        
        'Do While Not oExec.StdOut.AtEndOfStream
        ' strinput = strinput & oExec.StdOut.Read(1)	
        'Loop
        
        
        strinput = oExec.StdOut.ReadAll
        
        
        durch = False
        schleife = 0
        Do While schleife < 5000
            If oExec.Status = 1 Then 
                durch = True
                Exit Do
            End If
            
            WScript.Sleep 1
            schleife = schleife +1
        Loop
        timer4 = Timer
        
        strname = strinput
        strname = Right(strinput,Len(strinput)-InStrRev(strinput,Chr(13),Len(strinput)-2)-1)
        strname = Left(strname,InStr(strname,Chr(13))-1)
        
        If InStr(strname,"Anzahl:") Then
            strname = Right(strname,Len(strname)-7)
            
            'MsgBox oExec.ExitCode & vbtab & timer4-timer3 & vbTab & schleife & vbCrLf  & ">>" & strname
            CountFiles = Strconvert(strname)
        End If
        
        Set oExec = Nothing
    Else
        objWSHShell.LogEvent 1, "Archivierung.vbs: " & programm&"countfiles.exe nicht gefunden"
    End If
    
End Function


Function recursive_extract(zipdatei)
    
    Set tempf = fs.CreateFolder(zipdatei.ParentFolder&"\temp")
    
    returncode = objWSHShell.Run(Chr(34)&zippath &Chr(34)& " e " & Chr(34)&zipdatei &Chr(34)& " -aou -o" &Chr(34)& tempf &Chr(34)& " -r -y", 0, False)	
    
    durch = False
    zrunning = True
    Do While zrunning=True
        zrunning = check7zip	
        WScript.Sleep 1000  
    Loop
    
    If returncode <> 0 Then
        errortxt = "bitfarm-Archiv bfa_unzip: Fehler beim Zip-Entpacken, keine Dateien entpackt " & vbCrLf & "ExitCode von 7Zip: " & oExec.ExitCode & vbCrLf & "Durchlauf (200max): " & schleife
        objWshShell.LogEvent 1, errortxt
        
        
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
        strQuery = "Select * from Win32_Process where Name='7z.exe'"
        Set colItems = objWMIService.ExecQuery(strQuery,,48)
        z=0
        For Each objItem In colItems
            objItem.Terminate()
            z=z+1
        Next
        If z>0 Then
            objWshShell.LogEvent 2, "bitfarm-Archiv Exception-Handling: Terminierte 7z.exe-Instanzen: "&z
        End If
        
        Set colItems = Nothing
        Set objWMIService = Nothing
        
        deletezip = False	
        erfolg = False
    Else
    	erfolg=True
    End If
   	
    
    
    
    If erfolg = True Then
        Set tmpfolder = fs.GetFolder(tempf)	
        For Each tmpfile In tmpfolder.files
            tmpextension=fs.GetExtensionName(tmpfile)
            If LCase(tmpextension) = "rar" Or LCase(tmpextension) = "zip" Then
                recursive_extract tmpfile
            Else
                tmpname = mainzipfolder & "\" & tmpfile.Name
                i = 0
                Do While fs.fileexists(tmpname)
                    tmpname = mainzipfolder & "\" & fs.GetBaseName(tmpfile) & "_" & i & "." & fs.GetExtensionName(tmpfile)
                    i = i + 1
                Loop
                fs.MoveFile tmpfile, tmpname
            End If
        Next
        fs.deletefile zipdatei
        fs.deletefolder tmpfolder
    End If	
End Function


Function check7zip()
	check7zip=False
	Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = '7z'")
    WScript.Sleep 50
    oldcounter=0
    newcounter=0
    old1counter=0
    new1counter=0
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        oldcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        old1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    WScript.Sleep 2000
    Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\.\root\cimv2")
    WScript.Sleep 50
    Set colProcesses = objWMIService.ExecQuery _
    ("SELECT * FROM Win32_PerfRawData_PerfProc_Process where Name = '7z'")
    WScript.Sleep 50
    
    kette=""
    For Each strProcess In colProcesses
        kette=strProcess.IOReadBytesPerSec&vbCrLf
        newcounter=strProcess.IOReadOperationsPerSec
        kette=kette&strProcess.IOWriteBytesPerSec&vbCrLf
        new1counter=strProcess.IOWriteOperationsPerSec
        kette=kette&IOOtherBytesPerSec&vbCrLf
        kette=kette&strProcess.IOOtherOperationsPerSec&vbCrLf
        kette=kette&"Prozessorzeit"&strProcess.PercentProcessorTime
    Next
    Set colProcess=Nothing
    Set objWMIService=Nothing
    
    If (oldcounter <> newcounter) Then      
        check7zip=True
    End If
    
    If (old1counter <> new1counter) Then
        check7zip=True
    End If
End Function
